$(function() {
	$.t = {
		UIDelete: "删除",
		UISubmit: "确定",
		UISearch: "搜索",
		UISearchLoading: "搜索中..",
		UIComplete: "完成",
		UIClear: "清除",
		UICancel: "取消",
		UIDay: "日",
		UIWeek: "周",
		UIYear: "年",
		UIMonth: "月",
		UIHour: "时",
		UIMinute: "分",
		UINumber: ["一", "二", "三", "四", "五", "六", "七", "八", "九", "十"]
	};
	$.jsUrl = "../js/global/";
	$.cssUrl = "../css/";
	$.jsCssLoader = function(options, callback) {
		var settings = {
			"links": [],
			"scripts": []
		};
		$.extend(settings, options);
		var self = this;
		var count_links = settings.links.length;
		var count_scripts = settings.scripts.length;
		var count_links_complete = 0;
		var count_scripts_complete = 0;

		function hasurl(url) {
			if($("link[href='" + url + "'],script[src='" + url + "']").length > 0) {
				return true;
			} else {
				return false;
			}
		}
		$.each(settings.links, function(i) {
			if(hasurl(settings.links[i]) == false) {
				var tag = document.createElement("link");
				tag.href = settings.links[i];
				tag.rel = "stylesheet";
				tag.type = "text/css";
				tag.setAttribute("tag_complete", "no");
				document.getElementsByTagName("head")[0].appendChild(tag);
				if(tag.readyState) {
					tag.onreadystatechange = function() {
						if(this.readyState == "loaded" || this.readyState == "complete") {
							this.onreadystatechange = null;
							tag.setAttribute("tag_complete", "yes");
						}
					};
				} else {
					if(tag.onload) {
						tag.onload = function() {
							tag.setAttribute("tag_complete", "yes");
						};
					} else {
						tag.setAttribute("tag_complete", "yes");
					}
				}
			} else {
				if($("link[href='" + settings.links[i] + "']:not([tag_complete])").length > 0) {
					count_links--;
				}
			}
		});
		$.each(settings.scripts, function(i) {
			if(hasurl(settings.scripts[i]) == false) {
				var tag = document.createElement("script");
				tag.src = settings.scripts[i];
				tag.type = "text/javascript";
				tag.setAttribute("tag_complete", "no");
				document.getElementsByTagName("head")[0].appendChild(tag);
				if(tag.readyState) {
					tag.onreadystatechange = function() {
						if(this.readyState == "loaded" || this.readyState == "complete") {
							this.onreadystatechange = null;
							tag.setAttribute("tag_complete", "yes");
						}
					};
				} else {
					tag.onload = function() {
						tag.setAttribute("tag_complete", "yes");
					};
				}
			} else {
				if($("script[src='" + settings.scripts[i] + "']:not([tag_complete])").length > 0) {
					count_scripts--;
				}
			}
		});
		var timer = setInterval(function() {
			$.each(settings.links, function(i) {
				if($("link[href='" + settings.links[i] + "'][tag_complete]").attr("tag_complete") == "yes")
					count_links_complete++;
			});
			$.each(settings.scripts, function(i) {
				if($("script[src='" + settings.scripts[i] + "'][tag_complete]").attr("tag_complete") == "yes")
					count_scripts_complete++;
			});
			if(count_links_complete >= count_links && count_scripts_complete >= count_scripts) {
				clearInterval(timer);
				callback && callback.call(self);
			}
		}, 1000);
	};
	$.getRandom = function() {
		var d = new Date();
		return d.getTime() + parseInt(Math.random() * 100, 10);
	};
	$.trimDeep = function(str) {
		str = str + "";
		if(str != "") {
			str = $.trim(str.replace(/  */g, ""));
		}
		return str
	};
	$.UILoading = function() {
		var args = arguments;
		var selector = {
			self: "[m-role='UILoading']"
		};
		var _private = {
			_init: function() {
				_private._events();
			},
			_events: function() {
				setTimeout(function() {
					$(selector.self).bind("scrollstart", function() {
						return false
					})
				}, 300);
			},
			_html: function() {
				return ["<div m-role=\"UILoading\">", "<div class=\"UILoadingContent\">", " <div class='UILoadingIco'>", "  <div class='UILoadingIcoTop'></div>", "  <div class='UILoadingIcoMain'></div>", "  <div class='UILoadingIcoBtm'></div>", " </div>", " <div class=\"UILoadingContentText\"></div>", "</div>", "</div>"].join("")
			},
			_fn: {
				_html: function() {
					if($(selector.self).length == 0) {
						$("body").append(_private._html());
					}
				}
			}
		};
		_private._init();
		var public = {
			show: function() {
				var args = arguments[0];
				_private._fn._html();
				$(".UILoadingContent").css("opacity", "0");
				$(selector.self).find(".UILoadingContentText").html(args[1] || "");
				$(selector.self).removeClass("UILoadingMin");
				$(selector.self).show();
				$(".UILoadingContent").css({
					"opacity": 1
				})
			},
			showMin: function() {
				var args = arguments[0];
				_private._fn._html();
				$(selector.self).addClass("UILoadingMin");
				$(selector.self).find(".UILoadingContentText").html(args[1] || "");
				$(selector.self).show();
			},
			hide: function() {
				var args = arguments[0];
				var this_self = this;
				$(selector.self).hide();
				setTimeout(function() {
					$(selector.self).remove();
					clearInterval(window.LoadingCanvas)
				}, 10);
				args[1] && args[1].call(this_self);
			}
		};
		public[args[0]](args);
	};
	$.UIPopupTimer = 2000;
	$.UIPopup = function(options, callback) {
		$("[m-role='UIPopup']").remove();
		var self = this;
		var settings = {
			"html": "",
			"timer": $.UIPopupTimer
		}
		if(typeof(options) == "string" || $.isArray(options)) {
			settings.html = options
		} else {
			$.extend(settings, options);
		};
		$("body").append("<div m-role=\"UIPopup\">" + settings.html + "</div>");
		var p = $("[m-role='UIPopup']");
		var l = -p.outerWidth() / 2;
		var t = -p.outerHeight() / 2;
		p.css({
			"margin-left": l,
			"margin-top": t,
			"top": "50%",
			"left": "50%"
		})
		p.animate({
			"opacity": 1
		}, 200).delay(settings.timer).animate({
			"opacity": 0
		}, 200, function() {
			$(this).remove();
			callback && callback.call(self);
		})
	};
	$.fn.UIPopOption = function() {
		var args = arguments;
		var pluginName = "UIPopOption";
		this.each(function() {
			var $self = $(this);
			if($self.data("UIPopOption") == undefined) {
				var title = (args[0] && args[0].title) || "请选择";
				var $btn = $("<div m-role=\"cell\" m-align=\"center\" m-valign=\"middle\" class=\"complete\"><div><b>" + title + "</b></div></div>");
				var $table = $self.find("[m-role='UITableView']");
				var main = {
					_private: {
						show: false,
						init: function() {
							$table.parent().before($btn);
							$self.data("UIPopOption", main);
							this.events();
							$self.hide();
						},
						events: function() {
							$self.get(0).addEventListener('webkitTransitionEnd', function() {
								if(false == main._private.show) {
									$self.hide();
								}
							}, false);
							$table.UITableView("mark", function(mid) {
								if(mid.length > 0) {
									if(typeof mid == "string") {
										main.public.change_callback.call(this, mid);
									}
									if(typeof mid == "array") {
										main.public.change_callback.call(this, mid[0]);
									}
								}
								main.public.close();
							});
							$btn.bind("tap", function() {
								var mid = $table.UITableView("marked");
								if(mid.length > 0) {
									if(typeof mid == "string") {
										main.public.change_callback.call(this, mid);
									}
									if(typeof mid == "array") {
										main.public.change_callback.call(this, mid[0]);
									}
								}
								main.public.close();
							});
						}
					},
					public: {
						open: function() {
							if(document.activeElement.nodeName == "INPUT") {
								$("input").blur();
								setTimeout(function() {
									show();
								}, 800);
							} else {
								$("input").blur();
								show();
							}

							function show() {
								$self.show();
								setTimeout(function() {
									main._private.show = true;
									if($(".shade-box").length == 0) {
										$("body").append("<div class=\"shade-box\"></div>")
									}
									$(".shade-box").bind("tap", function() {
										main.public.close();
										return false;
									})
									$self.addClass("on");
									$(".shade-box").addClass("on");
								}, 50);
							}
						},
						close: function() {
							main._private.show = false;
							$(".shade-box").unbind("tap");
							$self.removeClass("on");
							$(".shade-box").removeClass("on");
						},
						change: function() {
							var args = arguments[0];
							main.public.change_callback = args[1];
						},
						select: function() {
							var args = arguments[0];
							$table.UITableView("doMark", args[1]);
						}
					}
				};
				main._private.init();
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $self.data("UIPopOption");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		})
	};
	$.UIConfirm = function(options, callback) {
		$.UIComfirm(options, callback)
	};
	$.UIComfirm = function(options, callback) {
		var self = this;
		if($("[m-role='UIComfirm']").length > 0)
			return;
		var settings = {
			"html": "",
			"submitText": $.t.UISubmit,
			"submitStyle": "confirm",
			"cancelText": $.t.UICancel,
			"cancelStyle": "confirm"
		}
		if(typeof(options) == "string") {
			settings.html = options
		} else {
			$.extend(settings, options);
		};
		var layout = ["<div m-role=\"UIComfirm\">", "<div class=\"UIComfirmContent\">", "<div m-role=\"cell\" m-mode=\"y\">", "<div m-role=\"cell\" m-align=\"center\" class=\"font-16\" class='font-weight:bold;'>提示</div>", "<div m-role=\"cell\" class=\"UIComfirmContentHtml\">", settings.html, "</div>", "<div m-role=\"cell\" m-mode=\"x-equal\" class=\"UIConfirmBtns\">", "<div m-role=\"cell\" m-layout=\"fit\">", "<div m-role=\"UIButton\" m-style=\"" + settings.cancelStyle + "\" m-size=\"min\" m-layout=\"fit\" class=\"UIComfirmCancel\">" + settings.cancelText + "</div>", "</div>", "<div m-role=\"cell\" m-layout=\"fit\">", "<div m-role=\"UIButton\" m-style=\"" + settings.submitStyle + "\" m-size=\"min\" m-layout=\"fit\" class=\"UIComfirmSubmit\">" + settings.submitText + "</div>", "</div>", "</div>", "</div>", "</div>", "</div>"].join("")
		$("body").append(layout);
		var c = $("[m-role='UIComfirm']")
		var p = $(".UIComfirmContent");
		var l = -p.outerWidth() / 2;
		var t = -p.outerHeight() / 2;
		p.css({
			"margin-left": l,
			"margin-top": t,
			"top": "50%",
			"left": "50%"
		});
		setTimeout(function() {
			p.bind("scrollstart", function() {
				return false
			})
		}, 300);
		$(".UIComfirmSubmit").bind("tap", function() {
			callback && callback.call(self, "yes");
			c_hide();
			return false;
		});
		$(".UIComfirmCancel").bind("tap", function() {
			callback && callback.call(self, "no");
			c_hide();
			return false;
		});

		function c_hide() {
			c.hide();
			setTimeout(function() {
				c.remove()
			}, 200)
		}
	};
	$.UIAlert = function(options, callback) {
		var self = this;
		if($("[m-role='UIAlert']").length > 0)
			return;
		var settings = {
			"html": "",
			"buttonText": $.t.UISubmit,
			"buttonStyle": "alert"
		}
		if(typeof(options) == "string") {
			settings.html = options
		} else {
			$.extend(settings, options);
		};
		var layout = ["<div m-role=\"UIAlert\">", "<div class=\"UIAlertContent\">", "<div m-role=\"cell\" m-mode=\"y\">", "<div m-role=\"cell\" m-align=\"center\" class=\"font-16\" class='font-weight:bold;'>提示</div>", "<div m-role=\"cell\" class=\"UIAlertContentHtml\">", settings.html, "</div>", "<div m-role=\"cell\">", "<div m-role=\"UIButton\" m-style=\"" + settings.buttonStyle + "\" m-size=\"min\" m-layout=\"fit\" class=\"UIAlertSubmit\">" + settings.buttonText + "</div>", "</div>", "</div>", "</div>", "</div>"].join("")
		$("body").append(layout);
		var c = $("[m-role='UIAlert']")
		var p = $(".UIAlertContent");
		var l = -p.outerWidth() / 2;
		var t = -p.outerHeight() / 2;
		p.css({
			"margin-left": l,
			"margin-top": t,
			"top": "50%",
			"left": "50%"
		});
		setTimeout(function() {
			p.bind("scrollstart", function() {
				return false
			})
		}, 1000);
		$(".UIAlertSubmit").bind("tap", function() {
			callback && callback.call(self, "yes");
			c_hide();
			return false;
		});

		function c_hide() {
			c.hide();
			setTimeout(function() {
				c.remove()
			}, 200)
		}
	};
	$.UIBubble = function() {
		var args = arguments;
		var selector = {
			self: "[m-role='UIBubble']"
		};
		var settings = {
			"etarget": $("body"),
			"width": 100,
			"height": 200,
			"html": "",
			"beforeshow": function() {},
			"aftershow": function() {},
			"afterhide": function() {}
		}
		var _private = {
			_init: function() {
				_private._events();
			},
			_events: function() {
				$(window).bind("resize", function() {
					_private._fn._set_pos();
				})
			},
			_html: function(html) {
				return ["<div m-role=\"UIBubble\" >", "<div class=\"UIBubbleContent\">" + html + "</div>", "<div m-icon=\"arrowbubble\"></div>", "</div>"].join("")
			},
			_fn: {
				_html: function(html) {
					if($(selector.self).length == 0) {
						$("body").append(_private._html(html));
					}
				},
				_set_pos: function() {
					settings.width = parseInt(settings.width, 10)
					settings.height = parseInt(settings.height, 10)
					var offset = settings.etarget.offset();
					var arrow = $(selector.self).find(">[m-icon='arrowbubble']");
					var w = settings.etarget.outerWidth();
					var h = settings.etarget.outerHeight();
					var arrow_h = arrow.outerHeight();
					var l = offset.left + (w - settings.width) / 2;
					var t = offset.top + arrow_h + h;
					var arrow_l = settings.width / 2;
					var win_w = $(window).width();
					var win_h = $(window).height();
					if(offset.top - $(document).scrollTop() > win_h / 2) {
						$(selector.self).addClass("UIBubbleDown")
					} else {
						$(selector.self).removeClass("UIBubbleDown")
					}
					if(l <= 0) {
						l = 5;
						arrow_l = w / 2 + offset.left
					}
					if(l + settings.width > win_w) {
						l = win_w - settings.width - 5;
						arrow_l = offset.left + w / 2 - l
					}
					if($(selector.self).hasClass("UIBubbleDown")) {
						t = t - h - 2 * arrow_h - settings.height;
					}
					$(selector.self).css({
						"left": l,
						"top": t
					});
					arrow.css({
						"left": arrow_l
					});
				}
			}
		};
		_private._init();
		var public = {
			show: function() {
				var args = arguments[0];
				$.extend(settings, args[1]);
				if($("[m-role='UIBubble']").length > 0) {
					return;
				}
				_private._fn._html(settings.html);
				$(selector.self).css({
					"width": settings.width,
					"height": settings.height
				});
				_private._fn._set_pos();
				settings.beforeshow && settings.beforeshow.call(this);
				$(selector.self).animate({
					"opacity": 1
				}, 100, function() {
					$(selector.self).show();
					settings.aftershow && settings.aftershow.call(this);
				});
				setTimeout(function() {
					$(document).one("vmousedown.UIBubble", function() {
						$.UIBubble("hide", function() {
							settings.afterhide && settings.afterhide.call(this);
						});
					});
				}, 500)
				$(selector.self).bind("vmousedown.UIBubble", function() {
					return false
				});
				var UISelectionStyleSelector = ["[m-role='UIButton']:not([m-selectionstyle='no'])", "[m-role='UITableView'] dd:not([m-selectionstyle='no'])", ".UIKeyboardKey>li:not([m-selectionstyle='no'])", ".UIKeyboardKeySubmit", ".UIKeyboardKeyCancel", ".UIKeyboardKeyClear", ".UIKeyboardKeyBackspace", ".UISelectMenuView ul li"].join(",")
				$(selector.self).UISelectionStyle({
					"selector": UISelectionStyleSelector
				});
			},
			hide: function() {
				var args = arguments[0];
				var this_self = this;
				$(selector.self).attr("m-show", "no");
				$(selector.self).animate({
					"opacity": 0
				}, 100, function() {
					$(selector.self).hide();
					setTimeout(function() {
						$(selector.self).remove()
					}, 200);
					args[1] && args[1].call(this_self);
				});
				$(document).unbind("vmousedown.UIBubble")
			}
		};
		public[args[0]](args);
	};
	$.fn.UICountdown = function(options, callback) {
		var args = arguments;
		var $val, $return = this.each(function() {
			var self = this;
			if($(self).data("UICountdown") == undefined) {
				if(typeof(options) == "string")
					return;
				var rel = "";
				var selector = {};
				var main = {
					settings: {
						"time": 5,
						"afterStop": function() {}
					},
					_private: {
						_init: function() {
							$.extend(main.settings, options);
							$(self).html(main.settings.time);
							main._private._fn._settings_time = main.settings.time;
							main._private._events();
						},
						_events: function() {},
						_html: {},
						_fn: {
							_cd: function() {
								main._private._fn._cd_timer = setTimeout(function() {
									$(self).text(--main._private._fn._settings_time);
									if(main._private._fn._settings_time <= 0) {
										main.settings.afterStop && main.settings.afterStop.call(self);
										return;
									}
									main._private._fn._cd();
								}, 1000)
							}
						}
					},
					public: {
						start: function() {
							main._private._fn._cd();
						},
						pause: function() {},
						stop: function() {},
						clear: function() {
							clearTimeout(main._private._fn._cd_timer)
						},
						destroy: function() {
							$(self).removeData("UICountdown");
						},
						reset: function() {
							$(self).html(main.settings.time);
							main._private._fn._settings_time = main.settings.time;
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UICountdown", main);
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $(self).data("UICountdown");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		});
		if($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UICheckBox = function(options, callback) {
		var args = arguments;
		var $val, $return = this.each(function() {
			var self = this;
			if($(self).data("UICheckBox") == undefined) {
				if(typeof(options) == "string")
					return;
				var rel = $(self).attr("m-name");
				var selector = {
					checkboxes: "[m-name='" + rel + "']"
				};
				var main = {
					settings: {
						"data": {}
					},
					_private: {
						_init: function() {
							$.extend(main.settings, options);
							main._private._events();
						},
						_events: function() {
							$(self).bind("tap.UICheckBox", function() {
								if($(this).attr("m-checked") == "yes") {
									$(this).removeAttr("m-checked")
								} else {
									$(this).attr("m-checked", "yes")
								}
								main.public.tapEvent && main.public.tapEvent.call(this, {
									value: $(this).attr("m-checked")
								});
							})
						},
						_html: {},
						_fn: {}
					},
					public: {
						destroy: function() {
							$(self).removeData("UICheckBox");
						},
						value: function() {
							var arr = [];
							$(selector.checkboxes + "[m-checked='yes']").each(function() {
								arr.push($(this).attr("m-value"));
							});
							main.public.get_value = arr;
						},
						reset: function() {
							$(selector.checkboxes + "[m-checked='yes']").each(function() {
								$(self).removeAttr("m-checked")
							})
						},
						change: function() {
							main.public.tapEvent = arguments[0][1];
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UICheckBox", main);
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $(self).data("UICheckBox");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		});
		if($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UIRadio = function(options, callback) {
		var args = arguments;
		var $val,
			$return = this.each(function() {
				var self = this;
				if ($(self).data("UIRadio") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = $(self).attr("m-name");
					var selector = {
						radios: "[m-name='" + rel + "']"
					};
					var main = {
						settings: {
							"data": {}

						},
						_private: {
							_init: function() {
								$.extend(main.settings, options);
								main._private._events();
							},
							_events: function() {
								$(self).bind("tap.UIRadio", function() {
									var $this = $(this);
									var old_state = $this.attr("m-checked");
									$(selector.radios).removeAttr("m-checked");
									$this.attr("m-checked", "yes");
									if (old_state != "yes") {
										main.public.tapEvent && main.public.tapEvent.call(this, {
											value: $this.attr("m-value"),
											key: $this.html()
										});
									}
								})
							},
							_html: {},
							_fn: {}

						},
						public: {
							destroy: function() {
								$(self).removeData("UIRadio");
							},
							value: function() {
								main.public.get_value = $(selector.radios + "[m-checked='yes']").attr("m-value");
							},
							key: function() {
								main.public.get_value = $(selector.radios + "[m-checked='yes']").html();
							},
							change: function() {
								main.public.tapEvent = arguments[0][1];
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UIRadio", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIRadio");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UICalendarField = function(options, callback) {
		var args = arguments;
		var $val,
			$return = this.each(function() {
				var self = this;
				if ($(self).data("UICalendarField") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = $(self).attr("UICalendarField");
					var selector = {};
					var main = {
						settings: {
							theme: 'ios',
							accent: ' ',
							dateFormat: "yy-mm-dd",
							lang: 'zh',
							display: 'bubble',
							animate: ' ',
							controls: ['calendar'],
							marked: {}

						},
						_private: {
							_init: function() {
								$.extend(main.settings, options);
								$(self).append(main._private._html._input());
								var value = $(self).attr("m-value") || $(self).attr("value");
								if (value == undefined) {
									value = ""
								}
								$(self).attr({
									"m-value": value,
									"value": value
								});
								$(self).find("input").val(value);
								if ($(self).attr("m-display")) {
									main.settings.display = $(self).attr("m-display");
								}
								if ($(self).attr("m-marked")) {
									var date = $(self).attr("m-marked").split(",");
									var date_arr = [];
									$.each(date, function(i, v) {
										v = v.split("-");
										var d = new Date(v[0], v[1] - 1, v[2]);
										date_arr.push(d)
									});
									main.settings.marked = {
										"dates": date_arr
									};
								}
								var jscssurl = {
									"links": [$.cssUrl + "mobiscroll.custom-2.5.0.min.css"],
									"scripts": [$.jsUrl + "mobiscroll.calendarmarked-2.5.0.js"]
								};
								$.jsCssLoader(jscssurl, function() {
									$(self).mobiscroll().calendar(main.settings);
									var today = $(self).attr("m-today");
									$("[data-full='" + today + "']").addClass("UICalendarFieldToday");
									main._private._events();
								})
							},
							_events: function() {
								$(self).on("input change keyup", "input", function() {
									main._private._fn._change();
								});
								$(document).on("tap.UICalendarField", ".dw-calendar .dw-cal-day:has(.dw-cal-day-m)", function() {
									main.public.markTap_callback && main.public.markTap_callback.call(this, $(self).attr("m-value"))
								})
							},
							_html: {
								_input: function() {
									return ["<input type=\"text\" value=\"" + ($(self).attr("m-value") || "") + "\" />", "<div class=\"UICalendarFieldHandler\"></div>", "<div m-icon=\"calendar\"></div>"].join("");
								}
							},
							_fn: {
								_change: function() {
									var v = $(self).find("input").val();
									main.public.change_callback && main.public.change_callback.call(this, v);
									$(self).attr({
										"m-value": v,
										"value": v
									});
								}
							}
						},
						public: {
							destroy: function() {
								$(self).removeData("UICalendarField");
							},
							change: function() {
								var args = arguments[0];
								main.public.change_callback = args[1];
							},
							clear: function() {
								$(self).find("input").val("");
								$(self).attr({
									"m-value": "",
									"value": ""
								});
							},
							markTap: function() {
								var args = arguments[0];
								main.public.markTap_callback = args[1];
							},
							value: function() {
								var args = arguments[0];
								var args_length = args.length;
								if (args_length == 1) {
									main.public.get_value = $(self).find("input").val();
								}
								if (args_length == 2) {
									$(self).find("input").val(args[1]);
									$(self).attr({
										"m-value": args[1],
										"value": args[1]
									});
									main._private._fn._change();
								}
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UICalendarField", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UICalendarField");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UIDateField = function(options, callback) {
		var args = arguments;
		var $val, $return = this.each(function() {
			var self = this;
			if($(self).data("UIDateField") == undefined) {
				if(typeof(options) == "string")
					return;
				var rel = $(self).attr("UIDateField");
				var selector = {};
				var main = {
					settings: {
						dateFormat: "yy-mm-dd",
						dateOrder: "yyMMdd",
						timeWheels: 'HHii',
						timeFormat: 'HH:ii',
						theme: "ios",
						setText: $.t.UIComplete,
						cancelText: $.t.UICancel,
						monthNames: ["1" + $.t.UIMonth, "2" + $.t.UIMonth, "3" + $.t.UIMonth, "4" + $.t.UIMonth, "5" + $.t.UIMonth, "6" + $.t.UIMonth, "7" + $.t.UIMonth, "8" + $.t.UIMonth, "9" + $.t.UIMonth, "10" + $.t.UIMonth, "11" + $.t.UIMonth, "12" + $.t.UIMonth],
						dayNames: [$.t.UIWeek + $.t.UIDay, $.t.UIWeek + $.t.UINumber[0], $.t.UIWeek + $.t.UINumber[1], $.t.UIWeek + $.t.UINumber[2], $.t.UIWeek + $.t.UINumber[3], $.t.UIWeek + $.t.UINumber[4], $.t.UIWeek + $.t.UINumber[5]],
						dayUnit: $.t.UIDay,
						yearUnit: $.t.UIYear,
						mode: "scroller",
						display: "bubble",
						preset: 'date',
						monthText: $.t.UIMonth,
						dayText: $.t.UIDay,
						yearText: $.t.UIYear,
						hourText: $.t.UIHour,
						minuteText: $.t.UIMinute,
						minDate: new Date(new Date().getFullYear() - 100, 0, 0, 0, 0),
						maxDate: new Date(new Date().getFullYear() + 100, 0, 0, 0, 0),
						stepMinute: 1
					},
					_private: {
						_init: function() {
							var that = this;
							$.extend(main.settings, options);
							if($(window).width() <= 400) {
								main.settings.display = "bottom";
							}
							$(self).append(main._private._html._input());
							var value = $(self).attr("m-value") || $(self).attr("value");
							if(value == undefined) {
								value = ""
							}
							$(self).attr({
								"m-value": value,
								"value": value
							});
							$(self).find("input").val(value);
							if($(self).attr("m-min")) {
								var min_date = $(self).attr("m-min").split("-");
								main.settings.minDate = new Date(min_date[0], min_date[1] - 1, min_date[2], 0, 0)
							}
							if($(self).attr("m-max")) {
								var max_date = $(self).attr("m-max").split("-");
								main.settings.maxDate = new Date(max_date[0], max_date[1] - 1, max_date[2], 0, 0)
							}
							if($(self).attr("m-preset")) {
								main.settings.preset = $(self).attr("m-preset");
								if(main.settings.preset == "time") {
									main.settings.maxDate = "";
									main.settings.minDate = ""
								}
							}
							if($(self).attr("m-stepminute")) {
								main.settings.stepMinute = parseInt($(self).attr("m-stepminute"), 10);
							}
							var jscssurl = {
								"links": [$.cssUrl + "mobiscroll.custom-2.5.0.min.css"],
								"scripts": [$.jsUrl + "mobiscroll.datetime-2.5.0.js"]
							};
							main.settings.onCancel = main._private._fn._cancel;
							$.jsCssLoader(jscssurl, function() {
								that.mdt = $(self).mobiscrollDatatime(main.settings);
								main._private._events();
							})
						},
						_events: function() {
							$(self).on("input change keyup", "input", function() {
								main._private._fn._change();
							});
						},
						_html: {
							_input: function() {
								return ["<input type=\"text\" value=\"" + ($(self).attr("m-value") || "") + "\"  placeholder=\"" + ($(self).attr("m-placeholder") || "") + "\"/>", "<div class=\"UIDateFieldHandler\"></div>", "<div m-icon=\"calendar\"></div>"].join("");
							}
						},
						_fn: {
							_change: function() {
								var v = $(self).find("input").val();
								main.public.change_callback && main.public.change_callback.call(this, v);
								$(self).attr({
									"m-value": v,
									"value": v
								});
							},
							_cancel: function(v, inst) {
								main.public.cancel_callback && main.public.cancel_callback.call(this, v);
								$(self).attr({
									"m-value": v,
									"value": v
								});
							}
						}
					},
					public: {
						reset: function() {
							var args = arguments[0];
							var args_length = args.length;
							if(args_length == 2) {
								var resetObj = args[1];
								if(resetObj.minDate) {
									var min_date = resetObj.minDate.split("-");
									main.settings.minDate = new Date(min_date[0], min_date[1] - 1, min_date[2], 0, 0);
								}
								if(resetObj.maxDate) {
									var max_date = resetObj.maxDate.split("-");
									main.settings.maxDate = new Date(max_date[0], max_date[1] - 1, max_date[2], 0, 0);
								}
								$(self).mobiscrollDatatime("option", main.settings);
							}
						},
						hide: function() {
							var inst = $(self).mobiscrollDatatime("getInst");
							inst && inst.hide(true);
						},
						demo: function() {
							var args = arguments[0];
							main.public.demo_callback = args[1];
						},
						destroy: function() {
							$(self).removeData("UIDateField");
						},
						clear: function() {
							$(self).find("input").val("");
							$(self).attr({
								"m-value": "",
								"value": ""
							});
						},
						cancel: function() {
							var args = arguments[0];
							main.public.cancel_callback = args[1];
						},
						change: function() {
							var args = arguments[0];
							main.public.change_callback = args[1];
						},
						value: function() {
							var args = arguments[0];
							var args_length = args.length;
							if(args_length == 1) {
								main.public.get_value = $(self).find("input").val();
							}
							if(args_length == 2) {
								$(self).find("input").val(args[1]);
								$(self).attr({
									"m-value": args[1],
									"value": args[1]
								});
								main._private._fn._change();
							}
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UIDateField", main);
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $(self).data("UIDateField");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		});
		if($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UISelectionStyle = function(options, callback) {
		var args = arguments;
		var $val, $return = this.each(function() {
			var self = this;
			if($(self).data("UISelectionStyle") == undefined) {
				if(typeof(options) == "string")
					return;
				var rel = $(self).attr("UISelectionStyle");
				var selector = {};
				var main = {
					settings: {
						"selector": "dd:not([UISelectionStyle='no'])",
						"data": {}
					},
					_private: {
						_init: function() {
							$.extend(main.settings, options);
							main._private._events();
						},
						_events: function() {
							var click_light;
							var light = "UISelectionStyle";
							$(self).on("vmousedown.UISelectionStyle", main.settings.selector, function(e) {
								var self = $(this);
								if($(e.target).attr("m-icon") == "arrowbutton") {
									return false
								}
								click_light = setTimeout(function() {
									self.addClass(light)
								}, 30);
							});
							$(self).on("vmousemove.UISelectionStyle vmouseup.UISelectionStyle", main.settings.selector, function() {
								clearTimeout(click_light);
								$(this).removeClass(light);
							});
							$(self).on("tap.UISelectionStyle", main.settings.selector, function() {
								setTimeout(function() {
									$(this).removeClass(light)
								}, 10);
							});
						},
						_html: {},
						_fn: {}
					},
					public: {
						destroy: function() {
							$(self).removeData("UISelectionStyle");
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UISelectionStyle", main);
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $(self).data("UISelectionStyle");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		});
		if($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UISwitch = function(options, callback) {
		var args = arguments;
		var $val, $return = this.each(function() {
			var self = this;
			if($(self).data("UISwitch") == undefined) {
				if(typeof(options) == "string")
					return;
				var rel = $(self).attr("UISwitch");
				var selector = {};
				var main = {
					settings: {
						"data": {}
					},
					_private: {
						_init: function() {
							$.extend(main.settings, options);
							var value = $(self).attr("m-value") || $(self).attr("value");
							var texton = $(self).attr("m-on") || "";
							var textoff = $(self).attr("m-off") || "";
							if(value == undefined) {
								value = 0
							}
							value = parseInt(value, 10);
							$(self).find(".UISwitchHiddenInput").attr("name", $(self).attr("name"));
							$(self).attr({
								"m-value": value,
								"value": value
							});
							$(self).html(main._private._html._layout(texton, textoff));
							$(self).append(main._private._html._hidden_input(value));
							var init_val = 1;
							if(value == 1) {
								init_val = 0
							}
							main._private._fn._set_state(init_val, "init");
							main._private._events();
						},
						_events: function() {
							var has_drag = false;
							var btn = $(self).find(".UISwitchButton");
							var texton = $(self).find(".UISwitchOn");
							var textoff = $(self).find(".UISwitchOff");
							var self_w = $(self).width();
							var btn_w = btn.outerWidth();
							$(self).bind("tap.UISwitch", tap_switch);

							function initWidth() {
								self_w = $(self).width();
								btn_w = btn.outerWidth();
							}

							function tap_switch() {
								main._private._fn._set_state($(self).attr("m-value"));
								return false
							}
							$(self).bind("touchstart.UISwitch", function(event) {
								initWidth();
								var point = {
									start: function(event) {
										var data = event.originalEvent.touches ? event.originalEvent.touches[0] : event;
										return {
											coords: [data.pageX, data.pageY],
											origin: $(event.target)
										};
									},
									stop: function(event) {
										var data = event.originalEvent.touches ? event.originalEvent.touches[0] : event;
										return {
											coords: [data.pageX, data.pageY]
										};
									}
								};
								var start = point.start(event);
								var scrolling = false;
								var begin = false;
								var btn_left = parseInt(btn.css("left"), 10);
								var t_on_s_w = texton.width();
								$(self).bind("touchmove.UISwitch", function(event) {
									var stop = point.stop(event);
									if(Math.abs(start.coords[1] - stop.coords[1]) > 5 && begin == false) {
										scrolling = true
									}
									if(Math.abs(start.coords[0] - stop.coords[0]) > 0 && scrolling == false) {
										begin = true;
										has_drag = true;
										$(self).unbind("tap.UISwitch", tap_switch);
										var d = stop.coords[0] - start.coords[0];
										var set_left = btn_left + d;
										if(set_left >= 1 && set_left <= self_w - btn_w - 1) {
											btn.css("left", set_left);
											if(t_on_s_w == 0) {
												texton.width(btn_w + d);
												textoff.width(self_w - d);
											} else {
												texton.width(self_w + d);
												textoff.width(btn_w - d);
											}
										}
										event.preventDefault();
									}
								});
								$(self).one("touchend.UISwitch", function(event) {
									$(self).unbind("touchmove.UISwitch");
									if(has_drag == true) {
										var left = parseInt(btn.css("left"), 10) + btn_w / 2;
										if(left >= self_w / 2) {
											main._private._fn._set_state(0);
										} else {
											main._private._fn._set_state(1);
										}
										setTimeout(function() {
											$(self).bind("tap.UISwitch", tap_switch)
										}, 200);
										has_drag = false;
									}
								})
							})
						},
						_html: {
							_layout: function(texton, textoff) {
								return ["<div class=\"UISwitchOn\"><span>" + texton + "</span></div>", "<div class=\"UISwitchOff\"><span>" + textoff + "</span></div>", "<div class=\"UISwitchButton\"></div>"].join("");
							},
							_hidden_input: function(value) {
								return "<input class=\"UISwitchHiddenInput\" type=\"hidden\" value=\"" + value + "\" />"
							}
						},
						_fn: {
							_set_state: function(value, init) {
								var texton = $(self).find(".UISwitchOn");
								var textoff = $(self).find(".UISwitchOff");
								var btn = $(self).find(".UISwitchButton");
								var old_value = $(self).attr("m-value");
								var btn_w = btn.outerWidth();
								var self_w = $(self).width() || parseInt($(self).css("min-width"));
								if(value == 0) {
									$(self).bind("touchstart.UISwitch.a", function() {
										return false
									});
									if(init != "init") {
										texton.stop().animate({
											"width": "100%"
										}, 200);
										textoff.stop().animate({
											"width": 0
										}, 200);
										btn.stop().animate({
											"left": self_w - btn_w - 1
										}, 200, function() {
											if(init != "stopEvent") {
												changeCallback();
											}
											$(self).unbind("touchstart.UISwitch.a");
										})
									} else {
										texton.css({
											"width": "100%"
										});
										textoff.css({
											"width": 0
										});
										btn.css({
											"left": self_w - btn_w - 1
										});
										$(self).unbind("touchstart.UISwitch.a");
									}
									$(self).find(".UISwitchHiddenInput").val(1);
									$(self).attr({
										"m-value": 1,
										"value": 1
									});
								} else {
									$(self).bind("touchstart.UISwitch.a", function() {
										return false
									});
									texton.stop().animate({
										"width": btn_w
									}, 200, function() {
										$(this).width(0)
									});
									textoff.stop().animate({
										"width": "100%"
									}, 200);
									$(self).find(".UISwitchHiddenInput").val(0);
									$(self).attr({
										"m-value": 0,
										"value": 0
									});
									btn.stop().animate({
										"left": 1
									}, 200, function() {
										if(init != "stopEvent") {
											changeCallback();
										}
										$(self).unbind("touchstart.UISwitch.a");
									})
								}

								function changeCallback() {
									if(old_value != $(self).attr("m-value") && init != "init") {
										main.public.change_callback && main.public.change_callback.call(self, $(self).attr("m-value"));
									}
								}
							}
						}
					},
					public: {
						change: function() {
							var args = arguments[0];
							main.public.change_callback = args[1];
						},
						destroy: function() {
							$(self).removeData("UISwitch");
						},
						state: function() {
							var args = arguments[0];
							if(args[1] == "on") {
								if($(self).attr("value") == 1) {
									return
								}
								var value = 0
							}
							if(args[1] == "off") {
								if($(self).attr("value") == 0) {
									return
								}
								var value = 1
							}
							main._private._fn._set_state(value, args[2]);
						},
						value: function() {
							main.public.get_value = ($(self).attr("value") == 1) ? "on" : "off";
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UISwitch", main);
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $(self).data("UISwitch");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		});
		if($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UISelectField = function(options, callback) {
		var args = arguments;
		var $val, $return = this.each(function() {
			var self = this;
			if($(self).data("UISelectField") == undefined) {
				if(typeof(options) == "string")
					return;
				var rel = "";
				var selector = {};
				var main = {
					settings: {
						"data": {}
					},
					_private: {
						_init: function() {
							$.extend(main.settings, options);
							$(self).append(main._private._html._select_icon());
							$(self).append(main._private._html._select_text());
							main._private._events();
						},
						_events: function() {
							$(self).on("change", "select", function() {
								var v = $(self).find("select").val();
								$(self).find(".UISelectFieldText").html($(self).find("select option:selected").text());
								main.public.change_callback && main.public.change_callback.call(this, v)
							});
						},
						_fn: {
							_set_text: function() {
								$(self).find(".UISelectFieldText").html($(self).find("select option:selected").text());
							}
						},
						_html: {
							_select_icon: function() {
								return "<div m-icon=\"arrowdown\"></div>";
							},
							_select_text: function() {
								return "<div m-role=\"cell\"  class=\"UISelectFieldText\">" + $(self).find("select option:selected").text() + "</div>";
							}
						}
					},
					public: {
						change: function() {
							var args = arguments[0];
							main.public.change_callback = args[1];
						},
						destroy: function() {
							$(self).removeData("UISelectField");
						},
						selectLimit: function() {},
						value: function() {
							var args = arguments[0];
							var args_length = args.length;
							if(args_length == 1) {
								main.public.get_value = $(self).find("select").val() || "";
							}
							if(args_length == 2) {
								$(self).find("select").val(args[1]);
								main._private._fn._set_text();
							}
						},
						text: function() {
							main.public.get_value = $(self).find("option:selected").text() || ""
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UISelectField", main);
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $(self).data("UISelectField");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		});
		if($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UITextField = function(options, callback) {
		var args = arguments;
		var $val, $return = this.each(function() {
			var self = this;
			if($(self).data("UITextField") == undefined) {
				if(typeof(options) == "string")
					return;
				var rel = "";
				var selector = {};
				var main = {
					settings: {
						"data": {}
					},
					_private: {
						_init: function() {
							$.extend(main.settings, options);
							$(self).append(main._private._html._input());
							if($(self).attr("m-type") == "search" || $(self).attr("m-type") == "autocomplete") {
								$(self).append(main._private._html._search_icon());
							}
							var value = $(self).attr("m-value") || $(self).attr("value");
							if(value == undefined) {
								value = ""
							}
							$(self).attr({
								"m-value": value,
								"value": value
							});
							$(self).find("input").val(value);
							if($(self).attr("m-type")) {
								var mTypeArr = $(self).attr("m-type").split(",");
								if(mTypeArr.length > 1) {
									if(mTypeArr[0] == "number") {
										$(self).UIKeyboard({
											"leftButton": mTypeArr[1] || "",
											"rightButton": mTypeArr[2] || ""
										});
									}
									if(mTypeArr[0] == "money") {
										$(self).UIKeyboard({
											"leftButton": mTypeArr[1] || "",
											"rightButton": mTypeArr[2] || "",
											"type": "money"
										});
									}
									if(mTypeArr[0] == "password") {
										$(self).UIKeyboard({
											"leftButton": mTypeArr[1] || "",
											"rightButton": mTypeArr[2] || "",
											"type": "password"
										});
									}
									$(self).UIKeyboard("set", function() {
										main.public.blur_callback && main.public.blur_callback.call(self);
									});
									$(self).UIKeyboard("change", function(v) {
										main.public.change_callback && (function(self, v) {
											for(var i in main.public.change_callback) {
												main.public.change_callback[i].call(self, v);
											}
										})(self, v);
									})
								}
							}
							main._private._fn._check_null();
							$(self).find(".UITextFieldClear").hide();
							main._private._events();
						},
						_events: function() {
							var timer;
							var input = $(self).find("input");
							$(self).on("blur", "input", function() {
								$(self).find(".UITextFieldClear").hide();
							});
							$(self).on("focus", "input", function() {
								main._private._fn._check_null();
							});
							$(self).on("tap", "input", function() {
								main._private._fn._check_null();
							});
							$(self).on("input change", "input", function() {
								main._private._fn._check_null();
								var v = $(self).find("input").val();
								main.public.change_callback && (function(self, v) {
									for(var i in main.public.change_callback) {
										main.public.change_callback[i].call(self, v);
									}
								})(self, v);
								return false;
							});
							$(self).on("vmousedown", ".UITextFieldClear", function() {
								input.val("");
								$(self).attr({
									"m-value": "",
									"value": ""
								});
								$(this).hide();
								input.focus();
								main._private._fn._check_null();
								var v = $(self).find("input").val();
								main.public.change_callback && (function(self, v) {
									for(var i in main.public.change_callback) {
										main.public.change_callback[i].call(self, v);
									}
								})(self, v);
								$.UIBubble("hide");
								return false
							});
							$(self).find("input").bind("focus", function() {
								main.public.focus_callback && main.public.focus_callback.call(self);
								return false
							});
							$(self).find("input").bind("blur", function() {
								if(!$(this).parent().hasClass('input-nofix')){//有输入框的页面不用跳动到顶部的话就加这个class
									setTimeout(function(){
										window.scrollTo(0, document.body.scrollTop + 1);
										document.body.scrollTop >= 1 && window.scrollTo(0, document.body.scrollTop - 1);
									}, 10);
								}
								main.public.blur_callback && main.public.blur_callback.call(self);
								return false
							});
						},
						_fn: {
							_auto_complete: function(html) {
								$(".UITextFieldAutoCompleteContent").html(html);
								main.public.autoComplete_callback && main.public.autoComplete_callback.call(self);
								$(".UITextFieldAutoComplete").UIScrollView("refresh")
							},
							_check_null: function() {
								var clear_btn = $(self).find(".UITextFieldClear");
								var v = $(self).find("input").val();
								$(self).attr({
									"m-value": v,
									"value": v
								});
								$(self).find(".UIKeyboardText").html(v);
								if(v != "") {
									clear_btn.show();
								} else {
									$(self).find("input").show();
									clear_btn.hide();
								}
							},
							_check_maxlength: function() {
								var v = $(self).find("input").val();
								if(v != "") {
									var tmax = $(self).attr("m-maxlength") || 500;
									var vl = v.length;
									if(vl > tmax) {
										v = v.substring(0, tmax);
									}
								}
								$(self).attr({
									"m-value": v,
									"value": v
								});
								$(self).find("input").val(v);
							}
						},
						_html: {
							_input: function() {
								var $self = $(self);
								var type = $self.attr("m-type");
								var maxlength = "";
								var value = $self.attr("m-value") || "";
								var placeholder = $self.attr("m-placeholder");
								if(!type || type == "" || type == "search") {
									type = "text";
								}
								if(type == "tel") {
									maxlength = "11";
								} else {
									maxlength = $self.attr("m-maxlength") || "";
								}
								return ["<input maxlength=\"" + maxlength + "\" type=\"" + type + "\" value=\"" + value + "\" placeholder=\"" + placeholder + "\"/>", "<div class=\"UITextFieldClear\" m-icon=\"clear\"></div>"].join("");
							},
							_search_icon: function() {
								return "<div m-icon=\"search\"></div>";
							}
						}
					},
					public: {
						clear: function() {
							var $input = $(self).find("input");
							var $self = $(self);
							$input.val("");
							$self.attr("m-value", "");
							$self.find(".UITextFieldClear").hide();
							main._private._fn._check_null();
							$self.find("input[type='text']").show();
							$input.trigger("change");
						},
						change: function() {
							var args = arguments[0];
							if(main.public.change_callback) {
								main.public.change_callback.push(args[1]);
							} else {
								main.public.change_callback = [args[1]];
							}
						},
						destroy: function() {
							$(self).removeData("UITextField");
						},
						search: function() {
							var args = arguments[0];
							main.public.search_callback = args[1];
						},
						autoComplete: function() {
							var args = arguments[0];
							main.public.autoComplete_callback = args[2];
							main._private._fn._auto_complete(args[1]);
							$(".UITextFieldAutoComplete").UIScrollView("refresh");
						},
						value: function() {
							var args = arguments[0];
							var args_length = args.length;
							var $input = $(self).find("input");
							if(args_length == 1) {
								main.public.get_value = $input.val();
							}
							if(args_length == 2) {
								$(self).find("input").val(args[1]);
								$(self).attr({
									"m-value": args[1],
									"value": args[1]
								});
								$input.trigger("change");
								$(self).find(".UITextFieldClear").hide();
							}
						},
						blur: function() {
							var args = arguments[0];
							main.public.blur_callback = args[1];
						},
						focus: function() {
							var args = arguments[0];
							main.public.focus_callback = args[1];
						},
						placeholder: function() {
							var args = arguments[0];
							$(self).find("input").attr("placeholder", args[1]);
							$(self).attr({
								"m-placeholder": args[1]
							});
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UITextField", main);
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $(self).data("UITextField");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		});
		if($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UITextarea = function (options, callback) {
		var args = arguments;
		var $val, $return = this.each(function () {
			var self = this;
			if ($(self).data("UITextarea") == undefined) {
				if (typeof(options) == "string") {
					return
				}
				var rel = "";
				var selector = {};
				var main = {
					settings: {"data": {}}, _private: {
						_init: function () {
							$.extend(main.settings, options);
							var self_html = $(self).html();
							$(self).html(main._private._html._textarea());
							$(self).find("textarea").val(self_html);
							main._private._fn._check();
							$(self).find(".UITextareaClear,.UITextareaMax").hide();
							main._private._events()
						}, _events: function () {
							var textarea = $(self).find("textarea");
							$(self).on("blur", "textarea", function () {
								$(self).find(".UITextareaClear,.UITextareaMax").hide()
							});
							$(self).on("focus", "textarea", function () {
								main._private._fn._check()
							});
							$(self).on("input change keyup", "textarea", function () {
								main._private._fn._check()
							});
							$(self).on("vmousedown", ".UITextareaClear", function () {
								textarea.val("");
								$(this).hide();
								textarea.focus();
								main._private._fn._check();
								return false
							})
						}, _fn: {
							_check: function () {
								var clear_btn = $(self).find(".UITextareaClear");
								var text_max = $(self).find(".UITextareaMax");
								var v = $(self).find("textarea").val();
								main.public.change_callback && main.public.change_callback.call(this, v);
								if (v != "") {
									var tmax = $(self).attr("m-max") || $(self).attr("m-maxlength") || 200;
									var vl = v.length;
									if (vl <= tmax) {
										$(self).find(".UITextareaMax").text(tmax - vl);
									} else {
										$(self).find("textarea").val(v.substring(0, tmax));
									}
									text_max.show();
									clear_btn.show();
								} else {
									text_max.hide();
									clear_btn.hide();
								}
							}
						}, _html: {
							_textarea: function () {
								return ["<textarea  placeholder=\"" + ($(self).attr("m-placeholder") || "") + "\"></textarea>", "<div class=\"UITextareaClear\" m-icon=\"clear\"></div>", "<div class=\"UITextareaMax\">" + ($(self).attr("m-max") || $(self).attr("m-maxlength") || "") + "</div>"].join("")
							}
						}
					}, public: {
						clear: function () {
							$(self).find("textarea").val("");
							$(self).find(".UITextareaClear,.UITextareaMax").hide();
							main._private._fn._check()
						}, change: function () {
							var args = arguments[0];
							main.public.change_callback = args[1]
						}, destroy: function () {
							$(self).removeData("UITextarea")
						}, value: function () {
							var args = arguments[0];
							var args_length = args.length;
							if (args_length == 1) {
								main.public.get_value = $(self).find("textarea").val()
							}
							if (args_length == 2) {
								$(self).find("textarea").val(args[1]);
								main._private._fn._check();
								$(self).find(".UITextareaClear,.UITextareaMax").hide()
							}
						}, blur: function () {
							$(self).find("textarea").blur()
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UITextarea", main)
			} else {
				if (typeof(args[0]) != "string") {
					return
				}
				var main = $(self).data("UITextarea");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined
			}
		});
		if ($val != undefined) {
			$return = $val
		}
		return $return
	};
	$.fn.UIBottomBar = function(options, callback) {
		var args = arguments;
		var $val, $return = this.each(function() {
			var self = this;
			if($(self).data("UIBottomBar") == undefined) {
				if(typeof(options) == "string")
					return;
				var rel = "";
				var selector = {};
				var main = {
					settings: {
						"data": {}
					},
					_private: {
						_init: function() {
							$.extend(main.settings, options);
							$(self).wrapInner(main._private._html._room());
							var left_n = $(self).find("[m-role='left']").length;
							var right_n = $(self).find("[m-role='right']").length;
							if(left_n > 0 && right_n == 0) {
								$(self).find(".UIBottomBarRoom").append(main._private._html._right())
							}
							if(left_n == 0 && right_n > 0) {
								$(self).find(".UIBottomBarRoom").prepend(main._private._html._left())
							}
							var left = $(self).find("[m-role='left']");
							var right = $(self).find("[m-role='right']");
							var left_w = left.width();
							var right_w = right.width();
							if(left_w > right_w) {
								right.width(left_w);
							} else {
								left.width(right_w);
							}
						},
						_events: function() {},
						_html: {
							_room: function() {
								return "<div class=\"UIBottomBarRoom\"></div>"
							},
							_left: function() {
								return "<div m-role=\"left\"></div>"
							},
							_right: function() {
								return "<div m-role=\"right\"></div>"
							}
						}
					},
					public: {
						destroy: function() {
							$(self).removeData("UIBottomBar");
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UIBottomBar", main);
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $(self).data("UIBottomBar");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		});
		if($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UINavigationBar = function(options, callback) {
		var args = arguments;
		var $val, $return = this.each(function() {
			var self = this;
			if($(self).data("UINavigationBar") == undefined) {
				if(typeof(options) == "string")
					return;
				var rel = "";
				var selector = {};
				var main = {
					settings: {
						"data": {}
					},
					_private: {
						_init: function() {
							$.extend(main.settings, options);
							var left_n = $(self).find("[m-role='left']").length;
							var right_n = $(self).find("[m-role='right']").length;
							if(left_n > 0 && right_n == 0) {
								$(self).find(".UINavigationBarRoom").append(main._private._html._right());
							}
							if(left_n == 0 && right_n > 0) {
								$(self).find(".UINavigationBarRoom").prepend(main._private._html._left());
							}
							var left = $(self).find("[m-role='left']");
							var right = $(self).find("[m-role='right']");
							var left_w = left.width() == 0 ? 50 : left.width();
							var right_w = right.width();
							if(left_w > right_w) {
								right.width(left_w);
							} else {
								left.width(right_w);
							}
						},
						_events: function() {},
						_html: {
							_room: function() {
								return "<div class=\"UINavigationBarRoom\"></div>";
							},
							_left: function() {
								return "<div m-role=\"left\"></div>";
							},
							_right: function() {
								return "<div m-role=\"right\"></div>";
							}
						}
					},
					public: {
						destroy: function() {
							$(self).removeData("UINavigationBar");
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UINavigationBar", main);
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $(self).data("UINavigationBar");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		});
		if($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UITableView = function(options, callback) {
		var args = arguments;
		var $val, $return = this.each(function() {
			var self = this;
			if($(self).data("UITableView") == undefined) {
				if(typeof(options) == "string")
					return;
				var rel = "";
				var selector = {};
				var main = {
					settings: {
						"data": {}
					},
					_private: {
						_init: function() {
							$.extend(main.settings, options);
							$(self).append(main._private._html._init());
							$(self).find("dd[m-type='mark']").append(main._private._html._mark());
							$(self).find("dd[m-marked='yes']").addClass("UITableViewMarked");
							$(self).find("dd[m-type='arrow']").append(main._private._html._arrow());
							$(self).find("dd[m-type='arrowbutton']").append(main._private._html._arrow_button());
							main._private._events._delete_button();
							if($(self).attr("m-section") == "fix" && $(self).attr("m-style") != "grouped") {
								$(self).append(main._private._html._section_header());
								main._private._events._section_header();
							}
							$(self).find(".UITableViewInitHtml").remove();
						},
						_events: {
							_delete_button: function() {
								$(document, self).on("swipe.UITableView", "dd[m-edit='delete']", function() {
									var this_item = $(this);
									if($(".UITableViewMask").length > 0)
										return;
									this_item.append(main._private._html._delete_button());
									this_item.append(main._private._html._mask());
									var close_button = $(self).find(".UITableViewItemDeleteButton");
									var w = close_button.width();
									close_button.width(0);
									var this_mask = this_item.find(".UITableViewMask");
									var this_btn = this_item.find(".UITableViewItemDeleteButton");
									this_mask.bind("scrollstart swipe", function() {
										return false
									});
									$(".UITableViewItemDeleteButton").width(0);
									this_btn.stop().animate({
										"width": w
									}, 300, function() {
										this_mask.bind("vmousedown.UITableView", function() {
											this_btn.stop().animate({
												"width": 0
											}, 300, function() {
												this_mask.remove();
												this_btn.remove();
											});
											return false;
										});
									});
								});
								$(self).on("tap", ".UITableViewItemDeleteButton", function() {
									var dd = $(this).parent("dd");
									var item_id = dd.attr("m-id");
									main.public.swipeDelete_callback && main.public.swipeDelete_callback.call(this, item_id);
								});
								$(self).on("tap", ".UITableViewArrowButtonWrap", function() {
									var dd = $(this).parent("dd");
									var item_id = dd.attr("m-id");
									main.public.arrowButtonTap_callback && main.public.arrowButtonTap_callback.call(this, item_id);
								});
								$(self).on("tap", ".UITableViewMarkWrap", function() {
									var dd = $(this).parent("dd");
									var item_id = dd.attr("m-id");
									if(main.public.markLimit_n) {
										if(dd.attr("m-marked") == "yes") {
											dd.removeAttr("m-marked");
											dd.removeClass("UITableViewMarked");
										} else {
											if($(self).find("[m-marked='yes']").length == main.public.markLimit_n) {
												main.public.mark_callback && (function(dd, context) {
													for(var i in main.public.mark_callback) {
														main.public.mark_callback[i].call(dd, context);
													}
												})(this, item_id);
											} else {
												dd.attr("m-marked", "yes");
												dd.addClass("UITableViewMarked");
												main.public.mark_callback && (function(dd, context) {
													for(var i in main.public.mark_callback) {
														main.public.mark_callback[i].call(dd, context);
													}
												})(this, item_id);
											}
										}
									} else {
										$(self).find("dd").removeAttr("m-marked");
										$(self).find("dd").removeClass("UITableViewMarked");
										dd.attr("m-marked", "yes");
										dd.addClass("UITableViewMarked");
										main.public.mark_callback && (function(dd, context) {
											for(var i in main.public.mark_callback) {
												main.public.mark_callback[i].call(dd, context);
											}
										})(this, item_id);
									}
									return false;
								});
								$(self).on("tap", ".UITableViewCheckWrap", function() {
									var dd = $(this).parent("dd");
									var item_id = dd.attr("m-id");
									if(dd.attr("m-checked") == "yes") {
										dd.removeClass("UITableViewChecked").removeAttr("m-checked");
									} else {
										dd.addClass("UITableViewChecked").attr("m-checked", "yes");
										main.public.check_callback && main.public.check_callback.call(this, item_id);
									}
									return false;
								});
								if($(self).find("[m-role='header']").length == 0 && $(self).attr("m-cache") == "yes") {
									$(self).addClass("UITableViewHideItems");
									$(self).find("dd").slice(0, main._private._cache._q).addClass("m-show");
									main._private._cache._first = $(self).find("dd").index($(self).find("dd.m-show").first()) + 1;
									main._private._cache._last = $(self).find("dd").index($(self).find("dd.m-show").last()) + 1;
									$.UIPullDown(function() {
										main._private._cache._down();
									});
									$.UIPullUp(function() {
										main._private._cache._up();
									});
								}
							},
							_section_header: function() {
								var section_header = $(self).find(".UITableViewSectionHeader");
								var m_fix = parseInt($(self).attr("m-fix"), 10);
								section_header.css("top", m_fix).hide();
								var self_top = $(self).offset().top;
								$(document).bind("vmousemove.UITableViewSectionHeader  scroll.UITableViewSectionHeader", function() {
									if($(self).is(":visible") == false)
										return;
									var scrolltop = $(this).scrollTop();
									if(scrolltop < self_top - m_fix || scrolltop >= self_top + $(self).outerHeight() - m_fix - section_header.outerHeight()) {
										section_header.hide()
									} else {
										section_header.show()
									}
									$(self).find("[m-role='header']").each(function() {
										var text = $(this).text();
										var dl = $(this).next("dl");
										var height = $(this).outerHeight() + dl.outerHeight();
										var top = $(this).offset().top;
										var lim_top = top - m_fix;
										var lim_bottom = height + top + m_fix;
										if(scrolltop >= lim_top && scrolltop <= lim_bottom) {
											section_header.find(".UITableViewSectionHeaderText").html(text);
											return
										}
									});
								})
							}
						},
						_cache: {
							_first: 0,
							_last: 0,
							_n: 30,
							_q: 60,
							_up: function() {
								var old_size = $(self).find("dd.m-show").length;
								var h = 0;
								var f = main._private._cache._first - main._private._cache._n - 1;
								if(f < 0) {
									f = 0
								}
								var dd_domslice = $(self).find("dd").slice(f, main._private._cache._first - 1);
								if(dd_domslice.length == 0)
									return;
								$(self).find("dd").slice(f, main._private._cache._first - 1).each(function() {
									h = h + $(this).outerHeight();
									$(this).addClass("m-show");
								});
								var new_size = $(self).find("dd.m-show").length;
								$(self).find("dd").slice(main._private._cache._last - (new_size - old_size), main._private._cache._last).removeClass("m-show");
								$(document).scrollTop($(document).scrollTop() + h);
								main._private._cache._first = $(self).find("dd").index($(self).find("dd.m-show").first()) + 1;
								main._private._cache._last = $(self).find("dd").index($(self).find("dd.m-show").last()) + 1;
							},
							_down: function() {
								var old_size = $(self).find("dd.m-show").length;
								$(self).find("dd").slice(main._private._cache._last, main._private._cache._last + main._private._cache._n).addClass("m-show");
								var new_size = $(self).find("dd.m-show").length;
								var h = 0;
								var dd_show_domslice = $(self).find("dd.m-show").slice(0, new_size - old_size);
								if(dd_show_domslice.length == 0)
									return;
								dd_show_domslice.each(function() {
									h = h + $(this).outerHeight();
									$(this).removeClass("m-show");
								});
								$(document).scrollTop($(document).scrollTop() - h);
								main._private._cache._first = $(self).find("dd").index($(self).find("dd.m-show").first()) + 1;
								main._private._cache._last = $(self).find("dd").index($(self).find("dd.m-show").last()) + 1;
							}
						},
						_html: {
							_init: function() {
								return "<dl class=\"UITableViewInitHtml\"><dt></dt><dd></dd></dl>";
							},
							_delete_button: function() {
								return "<div class=\"UITableViewItemDeleteButton\"><span  m-role=\"UIButton\" m-style=\"style-2\" m-size=\"min\">" + $.t.UIDelete + "</span></div>"
							},
							_mask: function() {
								return "<div class=\"UITableViewMask\"></div>"
							},
							_section_header: function() {
								return ["<div class=\"UITableViewSectionHeader\">", "<div class=\"UITableViewSectionHeaderText\"></div>", "</div>"].join("");
							},
							_no_data: function(text) {
								return "<div class=\"UITableViewNoData\">" + text + "</div>"
							},
							_check: function() {
								return ["<div class=\"UITableViewCheckWrap\">", "<div class=\"UITableViewCheck\" m-icon=\"checkbox\"></div>", "</div>"].join("");
							},
							_arrow: function() {
								return "<div class=\"UITableViewArrow\" m-icon=\"arrow\"></div>"
							},
							_arrow_button: function() {
								return ["<div class=\"UITableViewArrowButtonWrap\">", "<div class=\"UITableViewArrowButton\" m-icon=\"arrowbutton\"></div>", "</div>"].join("");
							},
							_mark: function() {
								return ["<div class=\"UITableViewMarkWrap\">", "<div class=\"UITableViewMark\" m-icon=\"mark\"></div>", "</div>"].join("");
							}
						}
					},
					public: {
						refresh: function() {
							$(self).find("dd[m-type]").each(function() {
								if($(this).attr("m-marked") == "yes") {
									$(this).addClass("UITableViewMarked")
								}
								if($(this).attr("m-type") == "mark" && $(this).find(".UITableViewMarkWrap").length == 0) {
									$(this).append(main._private._html._mark());
								}
								if($(this).attr("m-type") == "arrow" && $(this).find(".UITableViewArrow").length == 0) {
									$(this).append(main._private._html._arrow());
								}
								if($(this).attr("m-type") == "arrowbutton" && $(this).find(".UITableViewArrowButtonWrap").length == 0) {
									$(this).append(main._private._html._arrow_button());
								}
							})
						},
						addItem: function() {
							var args = arguments[0];
							$(self).find(">dl:last-child").append(args[1]);
							if($(self).find("[m-role='header']").length == 0 && $(self).attr("m-cache") == "yes") {
								main._private._cache._down();
							}
						},
						deleteItem: function() {
							var args = arguments[0];
							main.public.swipeDelete_callback = args[1];
						},
						check: function() {
							var args = arguments[0];
							main.public.check_callback = args[1];
						},
						checked: function() {
							var arr = [];
							$(self).find("[m-checked='yes']").each(function() {
								arr.push($(this).attr("m-id"));
							});
							main.public.get_value = arr;
						},
						mark: function() {
							var args = arguments[0];
							if(main.public.mark_callback) {
								main.public.mark_callback.push(args[1]);
							} else {
								main.public.mark_callback = [args[1]];
							}
						},
						markLimit: function() {
							var args = arguments[0];
							main.public.markLimit_n = args[1];
							main.public.markLimit_callback = args[2];
						},
						marked: function() {
							var arr = [];
							$(self).find("[m-marked='yes']").each(function() {
								arr.push($(this).attr("m-id"));
							});
							main.public.get_value = arr;
						},
						doMark: function() {
							var args = arguments[0];
							$(self).find("dd[m-id='" + args[1] + "']").find(".UITableViewMarkWrap").trigger('tap');
						},
						arrowButtonTap: function() {
							var args = arguments[0];
							main.public.arrowButtonTap_callback = args[1];
						},
						noData: function() {
							var args = arguments[0];
							$(self).html(main._private._html._no_data(args[1]))
						},
						checkState: function() {
							var args = arguments[0];
							var args_length = args.length;
							var dd = $(self).find("dd[m-type='check']");
							$(self).find("dd[m-checked='yes']").addClass("UITableViewChecked");
							if(args[1] == "on") {
								if(dd.find(".UITableViewCheckWrap").length > 0)
									return;
								dd.append(main._private._html._check());
								dd.addClass("UITableViewCheckState")
							}
							if(args[1] == "off") {
								dd.removeClass("UITableViewCheckState");
								var wrap = $(self).find(".UITableViewCheckWrap");
								wrap.hide();
								dd.removeClass("UITableViewChecked").removeAttr("m-checked");
								setTimeout(function() {
									wrap.remove();
								}, 200);
							}
						},
						destroy: function() {
							$(self).removeData("UITableView");
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UITableView", main);
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $(self).data("UITableView");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		});
		if($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UISegment = function(options, callback) {
		var args = arguments;
		var $val, $return = this.each(function() {
			var self = this;
			if($(self).data("UISegment") == undefined) {
				if(typeof(options) == "string")
					return;
				if($(self).attr("m-id") == undefined) {
					$(self).attr("m-id", "mid_" + $.getRandom())
				}
				var rel = $(self).attr("m-id");
				var selector = {
					hidden_input: "[m-role='UISegment'][m-id='" + rel + "'] input[type='hidden']",
					tabs_container: "[m-role='UISegment'][m-id='" + rel + "']",
					contents: "[m-for='" + rel + "']",
					tabs: "[m-role='UISegment'][m-id='" + rel + "'] li"
				};
				var main = {
					settings: {
						"data": {}
					},
					_private: {
						_init: function() {
							$.extend(main.settings, options);
							$(self).append(main._private._html._hidden_input());
							$(selector.hidden_input).attr("name", $(self).attr("name"))
							main._private._active();
							main._private._events();
						},
						_events: function() {
							$(selector.tabs_container).on("tap.UISegment", "[m-id]", function() {
								var old_id = $(selector.tabs_container).find("[m-active='yes']").attr("m-id");
								$(selector.tabs).removeAttr("m-active");
								$(this).attr("m-active", "yes");
								$(selector.hidden_input).val($(this).attr("m-value"));
								main._private._active();
								var new_id = $(selector.tabs_container).find("[m-active='yes']").attr("m-id");
								if(old_id != new_id) {
									main.public.change_callback && main.public.change_callback.call(this, new_id)
								}
								return false
							})
						},
						_active: function() {
							var active_item = $(selector.tabs_container).find("[m-active='yes']");
							if(active_item.length == 0) {
								var o = $(selector.tabs).eq(0);
								o.attr("m-active", "yes");
								active_item = o;
							}
							var active_val = active_item.attr("m-value");
							$(selector.hidden_input).val(active_val);
							$(self).attr({
								"value": active_val,
								"m-value": active_val
							});
							var rel_id = active_item.attr("m-id");
							$(selector.contents).hide();
							$(selector.contents + "[m-id='" + rel_id + "']").show();
						},
						_html: {
							_hidden_input: function() {
								return "<input class=\"UISegmentHiddenInput\" type=\"hidden\" value=\"\" />"
							}
						}
					},
					public: {
						active: function() {
							var args = arguments[0];
							$(selector.tabs).removeAttr("m-active");
							$(self).find("[m-id='" + args[1] + "']").attr("m-active", "yes");
							main._private._active();
						},
						change: function() {
							var args = arguments[0];
							main.public.change_callback = args[1];
						},
						refresh: function() {
							main._private._active();
						},
						destroy: function() {
							$(self).removeData("UISegment");
						},
						value: function() {
							this.get_value = $(self).attr("m-value");
						}
					}
				};
				main._private._init();
				delete main.settings.data;
				$(self).data("UISegment", main);
			} else {
				if(typeof(args[0]) != "string")
					return;
				var main = $(self).data("UISegment");
				main.public[args[0]](args);
				$val = main.public.get_value;
				main = undefined;
			}
		});
		if($val != undefined) {
			$return = $val
		}
		return $return;
	};

	$.UIPopSelectNew = function (m) {
		var data = {};
		var mask = $("[class='mask-T']");
		var h1 = $('html').css("height");
		var glb = $('body,html');
		var _box = $("#UIPopSelect");
		var _boxTitle = $("#UIPopSelectTitle");
		return {
			show: function (id) {
				_box.show();
				mask.show();
				$("#" + id + "-box").show();
				_boxTitle.text(data[id].title);
				glb.css({"height": "100%", "overflow": "hidden"})
			}, hide: function () {
				_box.hide();
				mask.hide();
				$(".UIPopSelectBox").hide();
				glb.css({"height": "100%", "overflow": "visible"})
			}, add: function (obj) {
				data[obj.id] = obj;
				var boxid = obj.id + "-box";
				var that = this;
				$(".wrapper-box").append("<ul class='UIPopSelectBox' id='" + boxid + "' style='display: none;'></ul>");
				var lis = "";
				for (var j in obj.items) {
					var item = obj.items[j];
					if (item.value == obj.defaultValue) {
						obj.changeCallback(item, m)
					}
					lis += "<li value='" + item.value + "'><span>" + item.key + "</span><em class='flip-icon'></em></li>"
				}
				$("#" + boxid).empty().append(lis).find("li[value='" + obj.defaultValue + "']").addClass("flip-current");
				$("#" + boxid).on("tap", "li", function () {
					$t = $(this);
					var mValue = $t.attr("value");
					var certTypeName = $t.find("span").text();
					$t.addClass("flip-current").siblings().removeClass("flip-current");
					var id = $t.parent().attr('id').split("-box")[0];
					var reObj;
					for (var i in data[id].items) {
						var item = data[id].items[i];
						if (item.value == mValue) {
							reObj = item
						}
					}

					setTimeout(function () {
						that.hide()
						data[id].changeCallback && data[id].changeCallback(reObj, m);
					}, 200);
					return false
				});
				$("#UIPopSelectClose").off("tap").on("tap", function () {
					that.hide();
					return false
				})
			}, addWithNoData: function (obj) {
				var that = this;
				if (!!!data[obj.id]) {
					data[obj.id] = obj
				}
				;
				$("#UIPopSelectClose").off("tap").on("tap", function () {
					that.hide();
					return false
				})
			}
		}
	};
	$.UIPopSelect = function(id, opt, m) {
		var that = this;
		var obj = $(id);
		var h1 = $('html').css("height");
		var glb = $('body,html');
		var mask = $("[class='mask-T']");
		var curClass = "flip-current";
		for(var i in opt.data) {
			var index = opt.data[i];
			var li = "";
			var box = $(index.box);
			for(var j in index.items) {
				var item = index.items[j];
				if(item.value == index.defaultValue) {
					index.changeCallback(item, m);
				}
				li += "<li value='" + item.value + "'><span>" + item.key + "</span><em class='flip-icon'></em></li>";
			}
			var canEmpty = box.attr("canEmpty");
			if(canEmpty == "yes") {
				box.empty().append(li).find("li[value='" + index.defaultValue + "']").addClass("flip-current");
			}
		}
		this.setVal = function(box, val) {
			var target = $(box).find("li[value='" + val + "']");
			target.addClass("flip-current").siblings().removeClass("flip-current");
			for(var i in opt.data) {
				var index = opt.data[i];
				if(index.box == box) {
					index.changeCallback({
						key: target.find("span").text(),
						value: val
					}, m);
					return false;
				}
			}
		}
		this.getVal = function(box) {
			return $(box).find(".flip-current").get(0).getAttribute("value");
		}
		this.setCloseTap= function(func){
			obj.off("tap", ".flip_close").on("tap", ".flip_close",func);
		}
		this.initTap = function() {
			obj.off("tap", ".flip_close").on("tap", ".flip_close", function() {
				that.hide();
				return false;
			})
			obj.off("tap", "li").on("tap", "li", function() {
				$t = $(this);
				var mValue = $t.attr("value");
				var certTypeName = $t.find("span").text();
				$t.addClass("flip-current").siblings().removeClass("flip-current");
				var box = "." + $t.parent().attr('class');
				for(var i in opt.data) {
					var index = opt.data[i];
					if(index.box == box) {
						index.changeCallback && index.changeCallback({
							key: certTypeName,
							value: mValue
						}, m);
					}
				}
				setTimeout(function() {
					that.hide();
				}, 300);
				return false;
			})
		};
		this.initTap();
		this.show = function(box) {
			mask.show();
			obj.show();
			$(box).show();
			glb.css({
				"height": "100%",
				"overflow": "hidden"
			});
		}
		this.hide = function() {
			$("#password").UITextField("value", "");
			glb.css({
				"height": h1,
				"overflow": "visible"
			});
			obj.find("ul").hide();
			obj.hide();
			$(".flip_box").hide();
			mask.hide();
		}
		return this;
	};
	var hsm = {
		init: function() {
			setTimeout(scrollTo, 0, 0, 0)
			$("[m-role='UINavigationBar']").UINavigationBar();
			$("[m-role='UIBottomBar']").UIBottomBar();
			$("[m-role='UISwitch']").UISwitch();
			$("[m-role='UIRadio']").UIRadio();
			$("[m-role='UICheckBox']").UICheckBox();
			$("[m-role='UISelectField']").UISelectField();
			$("[m-role='UITextField']").UITextField();
			$("[m-role='UIDateField']").UIDateField();
			$("[m-role='UITextarea']").UITextarea();
			$("[m-role='UITableView']").UITableView();
			$("[m-role='UISegment']").UISegment();
			var UISelectionStyleSelector = ["[m-role='UIButton']:not([m-selectionstyle='no'])", "[m-role='UITableView']:not([m-style='grouped']) dd:not([m-selectionstyle='no'])", "[m-selectionstyle='yes']", "[m-role='UIGallery'] li .UIGalleryImgWrap", ".UITableViewArrowButton"].join(",")
			$(document).UISelectionStyle({
				"selector": UISelectionStyleSelector
			});
		}
	}
	hsm.init();
})
