define("pages/account-info-1", function() {
	return Backbone.View.extend({
		title: {
			center: {
				text: "个人信息"
			},
		},
		_private: {},
		el: "#account-info-1",
		riskDict : {
			"":"",
			"1":"保守型",
			"2":"稳健型",
			"3":"积极型"
		},
		certtypeDict : {
			"":"",
			"0":"身份证",
			"1":"护照",
			"2":"军官证",
			"3":"士兵证",
			"4":"港澳居民来往内地通行证",
			"8":"文职证",
			"5":"户口本 ",
			"9":"警官证",
			"A":"台胞证"
		},
		initialize: function(parent) {
			$.platform.initPage && $.platform.initPage();
			this.getUserInfo();
			this.parent = parent;
			var that = this;
			$.hsf.Event.addListener("account-info-modify-ok", function(result) {
				$("[col='"+result.propertyName+"']").next().html(result.newValue);
				that.getUserInfo();
			});
		},
		getUserInfo: function() {
			var that = this;
			$.hsf.startLoading();
			$.hsf.ajax.app("account/account/accountinfo", "", "userInfoCallBack", function(jsonResult) {
				if (jsonResult.successful) {
					var r = jsonResult.result;
					r.custrisk = that.riskDict[r.custrisk||""];
					r.certificatetype = that.certtypeDict[r.certificatetype||""];
					$.doTemplate("info-template", r, "refresh");
					$("[m-role='UITableView']").UITableView().UITableView("refresh");
					var riskenddate = jsonResult.result.riskenddate;	//风险过期日期
					var validDate = jsonResult.result.validdate;		//证件有效期
					var myDate = $.hsf.hsTools.getCurrentDay();

					if(parseFloat(myDate) > parseFloat(riskenddate)){
						console.log("风险评测已过期");
						$("#riskValid").show();
					}else{
						$("#riskValid").hide();
					}
					if(parseFloat(myDate) > parseFloat(validDate)){
						$("#certidValid").show();
						$("#certid").attr("class","m-color-r");
					}else {
						$("#certidValid").hide();
						$("#certid").attr("class","m-color-6");
					}
					that.uiEvents();
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		events : {
			"tap #risk-test" : "risktest"
		},
		risktest : function(event){
			this.inprofit(event, "risk-test.html");
		},
		uiEvents : function () {
			var that = this;
			$("#modify-table>dl>dd").bind("tap", function() {
				that.inprofit(this);
			})
		},
		inprofit : function(event, html){
			var that = this;
			$.platform.getCache("logininfo", function(result) {
				if (result) {
					var custtype = result.custtype;
					if(custtype == "1"){//代销用户
						$.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
							if (o == "yes") {
								$.hsf.hsOpen("account-openAcco-gdbdx.html");
							}
						});
					}else{
						if(html){
							$.hsf.hsOpen(html);
						}else{
							that.modify(event);
						}
					}
				}else{
					$.hsf.ajax.app("account/account/accountinfo","","checkLoginCode",function(jsonResult) {
						if (jsonResult.successful) {
							var custtype = jsonResult.result.custtype;
							$.platform.removeCache("logininfo");
							$.platform.putCache("logininfo", jsonResult.result);
							if(custtype == "1"){
								$.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
									if (o == "yes") {
										$.hsf.hsOpen("account-openAcco-gdbdx.html");
									}
								});
							}else{
								if(html){
									$.hsf.hsOpen(html);
								}else {
									that.modify(event);
								}
							}
						}else{
							$.hsf.callFailProcess(jsonResult);
						}
					});
				}
			});
		},
		modify : function(event) {
			var $col = $(event).find("div[col]");
			this.parent.setParam("property", {"name":$col.attr("col"), "txt":$col.html(), "value": $.trim($col.next().html())});
			window.location.hash = "account-info-2";
			return false;
		}
	});
});
define("pages/account-info-2", function() {
	return Backbone.View.extend({
		title: {
			center: {
				text: ""
			}
		},
		el : "#account-info-2",
		_private : {},
		initialize: function(parent) {
			this.parent = parent;
		},
		events : {
			"tap #saveBtn[m-state!='disabled']" :  "modify",
			"tap #allBtn" : "setEverValidate"
		},
		modify : function() {
			var p = this._private;
			var name = p.propertyName;
			var validResult = false;
			var fg;
			var value;
			var returnValue;
			if (name=="validdate") {
				value = this.$modifyVal.UIDateField("value");
				if (value == "长期有效") {
					value = "23591231";
					returnValue = "长期有效";
				} else {
					returnValue = value;
					value = value.replace(/-/g,'');
				}
				validResult = true;
			} else {
				returnValue = value = this.$modifyVal.UITextField("value");
				var testPattern = "empty";
				switch (name) {
					case "mobileno":
						testPattern = "mobile";break;
					case "email":
						testPattern = "email";break;
					case "postcode":
						testPattern = "zip";break;
				}
				var vf = $.validForm().add(testPattern, value, "请输入"+p.propertyTxt);
				validResult = vf.valid();
			}
			if (validResult) {
				var fg = $.formGenerate().add(p.propertyName, value);
				var that = this;
				$.hsf.startLoading();
				$.hsf.ajax.app("account/account/modifyInfo", fg.generate(), "modifyInfoCallback", function(jsonResult) {
					if (jsonResult.successful) {
						$.hsf.stopLoading();
						$("#saveBtn").attr("m-state", "disabled");
						$.UIPopup("修改成功", function() {
							that._private.newValue = returnValue;
							$.hsf.Event.trigger("account-info-modify-ok", null, that._private);
							$.hsf.hsBack();
						});
					} else {
						$.hsf.callFailProcess(jsonResult);
					}
				});
			}
		},
		afterSwitchView : function() {
			var p = this.parent.getParam("property");
			var that = this;
			this._private = {propertyName: p.name, propertyTxt: p.txt, oldValue : p.value};
			this.parent.changeTitle(p.txt);
			$.doTemplate("input-template", this._private, "refresh");
			this.$modifyVal = $("#modifyVal");
			if (this._private.propertyName == "validdate") {
				this.$modifyVal.UIDateField();
				this.$modifyVal.UIDateField("value", p.value);
				this.$validdateSwitch = $("#validdateSwitch");
				this.$validdateSwitch.UISwitch();
				this.$modifyVal.bind("tap.date", function() {
					that.setShortValidate();
				});
				this.$validdateSwitch.UISwitch("change", function(value) {
					if (that.$validdateSwitch.UISwitch("value") == "on") {
						that.$modifyVal.UIDateField("value","长期有效");
					} else {
						that.setShortValidate();
					}
				});
			} else {
				$('[m-role="UITextField"]').UITextField();
			}
			$.checkNullGroup([$("#modifyVal")], $("#saveBtn"));
		},
		setEverValidate : function() {
			this.$modifyVal.UIDateField("value","长期有效");
		},
		setShortValidate : function() {
			this.$modifyVal.UIDateField("value","");
			this.$validdateSwitch.UISwitch("state","0");
		}
	});
});
define("pages/account-info", function() {
	return {
		init : function() {
			$.bone("account-info-1");
		}
	}
})
