define(["global", "Backbone"], function(G) {
	return Backbone.View.extend({
		el : "#account-openAcco-2",
		$cardTypeBox : $("#idTypeBox"),
		$custname : $("#custname"),
		$idNo : $("#idNo"),
		_private : {},
		validForm : $.validForm(),
		initialize: function(parent) {
			this.parent = parent;
			$.checkNullGroup([this.$custname, this.$cardTypeBox, this.$idNo], this.$el.find(".nextBtn"));
			this.validForm = $.validForm();
			this.uiEvent();
			this.$cardTypeBox.UIPopOption("select", "0|身份证");
		},
		beforeHideView : function() {
			this.$cardTypeBox.UIPopOption("close");
		},
		afterSwitchView: function() {},
		toggleIdType : function() {
			this.$cardTypeBox.UIPopOption("open");
		},
		next : function() {
			var custname = this.$custname.UITextField("value");
			var idNo = this.$idNo.UITextField("value");
			var idType = $("#idType").attr("idcard-id");
			this.validForm.add("empty", custname).add("cerfiticate", idNo);
			if (this.validForm.valid()) {
				$.hsf.startLoading();
				var f = $.formGenerate().add("certno", idNo).add("certtype", idType);
				var that = this;
				$.hsf.ajax.app("account/openacco/authentication", f.generate(), "authenticationCallback", function(jsonResult) {
					$.hsf.stopLoading();
					var isOpened = false;
					if (jsonResult.successful) {
						if (jsonResult.result.data[0]) {
							var ctype = jsonResult.result.data[0].cust_type;
							if (ctype == "0" || ctype == "2") {
								isOpened = true;
							}
						}
					} else if(jsonResult.code == "NETWORK_ERROR") {
						$.hsf.callFailProcess(jsonResult);
					}
					if (isOpened) {
						$.UIConfirm("您已是我们的客户,请直接登录", function(o) {
							if (o == "yes") {
								that.parent.finish();
							}
						});
					} else {
						that.parent.setParam("idNo", idNo).setParam("idType", idType).setParam("custname", custname);
						window.location.hash = "account-openAcco-3";
					}	
				});
			}
		},
		events : {
			"tap #idTypeDD" : "toggleIdType",
			"tap .nextBtn[m-state!='disabled']" : "next"
		},
		uiEvent : function() {
			var that = this;
        	this.$cardTypeBox.UIPopOption();
			this.$cardTypeBox.UIPopOption("change", function(mid) {
				var idType = mid.split("|")[0];
				var idText = mid.split("|")[1];
				$("#idType").html(idText).attr("idcard-id", idType);
			});
        }
	});
});