define(["global", "Backbone"], function(G) {
	return Backbone.View.extend({
		el : "#account-openAcco-3",
		$cardTypeBox : $("#cardTypeBox"),
		$mobile : $("#bankmobile"),
		$cardNo : $("#cardNo"),
		$verifyBankCode : $("#verify-bank-code"),
		$verifyBankMoney : $("#verify-bank-money"),
		$bankname : $("#bankname"),
		_private : {},
		validForm : $.validForm(),
		initialize: function(parent) {
			this.parent = parent;
			this.sandclock1 = this.sandclock("send-bank-code");
			this.validForm = $.validForm();
			this.loadBankList();
			this.uiEvents();
			$.checkNullGroup([this.$cardNo, this.$mobile, this.$verifyBankCode, this.$cardTypeBox.find("[m-role='UITableView']")], $("#verifyBankCodeNextBtn"));
		},
		loadBankList : function() {
			var that = this;
			$.hsf.startLoading();
			$.hsf.ajax.app("account/openacco/bankForm", "", "bankSwiftAuthCallback", function(jsonResult) {
				$.hsf.stopLoading();
				if (jsonResult.successful) {
					$.doTemplate("banklist-template", jsonResult.result.data);
					$("[m-role='UITableView']").UITableView("refresh");
					that._private.bankData = jsonResult.result.data;
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		beforeHideView : function() {
			this.$cardTypeBox.UIPopOption("close");
		},
		afterSwitchView: function() {
			this.$el.find("[m-role='UITextField']").UITextField("clear");
		},
		sandclock :  function(id) {
			var counter = 0;
			var $btn = $("#"+id);
			return {
				start : function() {
					var run = function() {
						if (counter == 0) {
							$btn.attr("m-state","").html("获取");
						} else {
							$btn.html("剩余"+(counter--)+"秒");
							setTimeout(run, 1000);
						}
					}
					counter = 60;
					$btn.attr("m-state","disabled").html("剩余"+(counter--)+"秒");
					setTimeout(run, 1000);
				},
				readyStart : function() {
					if (counter == 0) {
						return true;
					} else {
						false;
					}
				}
			}
		},
		sendBankCodeAuthCode : function(event) {
			if (this.sandclock1.readyStart()) {
				$.hsf.startLoading();
				var that = this;
				var mobile = this.$mobile.UITextField("value");
				var cardNo = this.$cardNo.UITextField("value");
				var servicename = "MsgSend";
				var idType = this.parent.getParam("idType");
				var idNo = this.parent.getParam("idNo");
				var custname = this.parent.getParam("custname");
				this.validForm.add("mobile", mobile).add("empty", this._private.channelid, "请选择银行").add("empty", cardNo, "请输入银行卡号");
				if (this.validForm.valid()) {
					var data = "servicename="+servicename
								+"&channelid="+this._private.channelid
								+"&depositacct="+cardNo
								+"&certificatetype="+idType
								+"&certificateno="+idNo
								+"&mobileno="+mobile
								+"&custname="+custname;
					$.hsf.ajax.app("capital/bank/bankSwiftAuth", data, "sendMobileAuthcodeCallback", function(jsonResult) {
						$.hsf.stopLoading();
						if (jsonResult.successful) {
							$("#send-bank-code-mobileFix").html(mobile.substr(0,3)+"****"+mobile.substr(7,4));
							$("#send-bank-code-notice").show();
							that.sandclock1.start();
						} else {
							$.hsf.callFailProcess(jsonResult)
						}
					});
				} else {
					$.hsf.stopLoading();
				}
			}
			return false;
		},
		nextBeforeCode : function() {
			var that = this;
			var mobile = this.$mobile.UITextField("value");
			var cardNo = this.$cardNo.UITextField("value");
			var servicename = "MsgCheck";
			var verifyCode = this.$verifyBankCode.UITextField("value");
			this.validForm.add("mobile", mobile).add("empty", cardNo, "请输入银行卡号");
            that._private.moblieno = mobile;
			if (this.validForm.valid()) {
				$.hsf.startLoading();
				var data = "servicename="+servicename
							+"&channelid="+this._private.channelid
							+"&depositacct="+cardNo
							+"&certificatetype="+ this.parent.getParam("idType")
							+"&certificateno="+ this.parent.getParam("idNo")
							+"&mobileno="+ mobile
							+"&custname="+ this.parent.getParam("custname")
							+"&verificationcode="+verifyCode;
				$.hsf.ajax.app("capital/bank/bankSwiftVerify", data, "bankSwiftVerifyCallback", function(jsonResult) {
					$.hsf.stopLoading();
					if (jsonResult.successful) {
						that.parent.setParam("cardNo", cardNo);
						that.parent.setParam("channelid", that._private.channelid);
						that.parent.setParam("channelname", that._private.channelname);
						that.parent.setParam("bankname", that._private.bankname);
						that.parent.setParam("custbelongto", jsonResult.result.custbelongto);
                        that.parent.setParam("mobileno", that._private.mobileno);
						if(jsonResult.result.custbelongto == "1"){
							window.location.hash = "account-openAcco-5";
						}else{
							window.location.hash = "account-openAcco-4";
						}
					} else {
						$.hsf.callFailProcess(jsonResult)
					}
				});
			}
		},
		events : {
			"tap #cardTypeDD" : "openCardList",
			"tap .m-select-box-opt" : "cardTypeSelectComplete",
			"tap #verifyBankCodeNextBtn[m-state!='disabled']" : "nextBeforeCode",
			"tap #send-bank-code" : "sendBankCodeAuthCode"
		},
		openCardList : function() {
			this.$cardTypeBox.UIPopOption("open");
		},
		uiEvents : function() {
			var that = this;
			this.$cardTypeBox.UIPopOption({title:"请选择银行卡"});
			this.$cardTypeBox.UIPopOption("change", function(id) {
				that.changeBankCard(id);
			});
		},
		changeBankCard : function(id) {
			this._private.channelid = this._private.bankData[id].channelid;
			this._private.bankname = this._private.bankData[id].bankname;
			this._private.channelname = this._private.bankData[id].channelname;
			$("#selectedBankIcon").removeAttr("class").addClass("bank-logo-min bank-"+this._private.bankData[id].alias);
			$("#bankname").html(this._private.bankData[id].bankname);
		}
	});
});