define([$.hsf.platform()], function(platform) {
	var action = {
		constant : {
			merorderid : null,
			bankMap : {
				"303" : {
					name : "光大银行",
					serial : "303",
					logo : "bank-ceb"
				},
				"005" : {
					name : "建设银行",
					serial : "005",
					logo : "bank-ccb"
				},
				"015" : {
					name : "中信银行",
					serial : "015",
					logo : "bank-ecitic"
				},
				"016" : {
					name : "广发银行",
					serial : "016",
					logo : "bank-cgbc"
				},
				"014" : {
					name : "民生银行",
					serial : "014",
					logo : "bank-cmbc"
				}
			}
		},
		init : function() {
			action.keyboard = action.passwordKeyboard(".keyboard", action.merOpenAcco);
			action.addChinapaySuccListener();
			action.initBankList();
			action.events();
		},
		initBankList : function() {
			$.doTemplate("banklistTemplate", action.constant.bankMap);
			$("#bankTableView").UITableView("refresh");
		},
		events: function() {
			$("#smscodebtn").on("tap", function() {
				if (this.getAttribute("m-state") != "disabled") {
					var telephone = $("#telephone").UITextField("value").trim();
					var reg = /^(\d{15}|\d{18}|\d{17}[a-zA-Z]{1})$/;
					var handsetReg = /^[0-9]{11}$/;
					if(""==telephone){
						$.UIAlert("请输入手机号码！");
						return false;
					}
					if(!handsetReg.test(telephone)){
						$.UIAlert("请输入11位手机号！");
						return false;
					}
					var data = "sendintent=openacco&mobile="+telephone
					$.hsf.startLoading("正在获取...");
					$.hsf.ajax.app("account/mobile/sendCode", data, "sendbankauthcodeCallback", function(jsonResult) {
						$.hsf.stopLoading();
						if(jsonResult && jsonResult.successful){
							action.constant.telephone = telephone;
							$.UIAlert("手机验证码已发送！请注意查收短信！");	
							action.sandclock.start();
						} else {
							$.hsf.callFailProcess(jsonResult);
						}
					});
				}
				return false;
			});
			$("#bankcardList").on("tap", "dd", function() {
				var result = $(this).attr("m-id");
				$(".selectedBankName").html(action.constant.bankMap[result].name);
				$(".selectedBankcardIcon").removeAttr("class").addClass("selectedBankcardIcon bank-logo "+action.constant.bankMap[result].logo);
				$("#bankcardPage").hide();
				$("#first").show();
				action.constant.bankserial = result;
				action.constant.bankname = action.constant.bankMap[result].name;
				return false;
			});
			$("#bankcardSelect").bind("tap", function() {
				$("#first").hide();
				$("#bankcardPage").show();
				return false;	
			});
			$("#submitBtn").bind("tap", function() {
				/*
				if (!action.constant.bankserial || action.constant.bankserial == "") {
					$.UIPopup("请选择银行");
					return false;
				}
				if(!action.constant.telephone || action.constant.telephone){
	            	$.UIPopup("请输入手机号码并验证！");
	            	return false;
	        	}*/
	        	action.constant.telephone =  $("#telephone").UITextField("value").trim();
				$("#mobile2").html(action.constant.telephone);
				$("#first").hide();
				$("#second").show();
				/*
				var data = "mobile="+action.constant.telephone+"&mobileauthcode="+authcode;
				$.hsf.startLoading();
				$.hsf.ajax.app("account/bank/fastAuthor", data, "sendbankauthcodeCallback", function(jsonResult) {
					$.hsf.stopLoading();
					if (jsonResult && jsonResult.success) {
						$.hsf.stopLoading();
						if (action.validateForm1()) {
							$("#first").hide();
							$("#second").show();
							return false;
						}
					} else if (jsonResult.code == "ETS-1BQ08") {
						$.UIPopup("验证码失效,请重新获取");
						$("#first").hide();
						$("#second").show();
					} else {
						$.hsf.callFailProcess(jsonResult);
					}
				});*/
				return false;
			});
			$("#secondBtn").bind("tap", function() {
				$("#second").hide();
				$("#first").show();
				return false;
			});
			$("#submitBtn2").bind("tap", function() {
				action.doSubmit();
				return false;
			});
			$("#submitBtn4").bind("tap", function() {
				$.platform.succBack();
				return false;
			})
			$("#thirdBackBtn").bind("tap", function() {
				$("#third").hide();
				$("#second").show();
				return false;
			})
		},
		passwordKeyboard :  function(id, succ) {
			var password = "";
			var password2 = "";
			var keyValues = []; 
			var $board = $(id),
			pswPlace = 6, 
			psw, 
			repsw, 
			inputNotice = $("#input-notice"),
			pswBlock = $(".psw-block"), 
			dot = pswBlock.find(".psw-dot");
			$board.on('tap', '.kb-btn', function() {
				var obj = $(this), keyValue = obj.attr('key-value'), resetPsw;
				obj.addClass('active');
				setTimeout(function() {
					obj.removeClass('active');
				}, 200);
				if (obj.hasClass('kb-del')) {
					keyValues.pop();
					dot.each(function(idx) {
						if (idx == keyValues.length) $(this).hide();
					});
				} else if (obj.hasClass('kb-reset')) {
					if (keyValues.length != pswPlace) {
						keyValues = [];
						dot.hide();
					}
				} else {
					if (keyValues.length > pswPlace - 1) {
						return false;
					}
					dot.each(function(idx) {
						if (idx < keyValues.length + 1) {
							$(this).show();
						}
					});
					keyValues.push(keyValue);
					if (keyValues.length == pswPlace) {
						if (psw) {
							repsw = keyValues.join('');
							if(psw == repsw){// 密码对比正确
								succ(repsw);
							}else{// 密码对比错误
								pswBlock.addClass('error');
								setTimeout(function(){
									pswBlock.removeClass('error');
									inputNotice.removeClass('flick').text('请设置交易密码');
									keyValues = [];
									psw='';
									dot.hide();
								},2000);
							}
						} else {
							psw = keyValues.join('');
							setTimeout(function(){
								inputNotice.text('请再次输入').addClass('flick');
								keyValues = [];
								dot.hide();
							}, 200);
						}
					}
				}
				$board.data('password', keyValues);
				return false;
			});
			return {
				reset : function() {
					psw = repsw = null; 
					keyValues = [];
					dot.hide();
					inputNotice.removeClass('flick').text('请设置交易密码');
					$board.removeData('password');
				}
			}
		},
		sandclock :  {
			run : function() {
				if (action.constant.counter == 0) {
					$("#smscodebtn").attr("m-state","");
					$("#smscodebtn").html("获取");
				} else {
					$("#smscodebtn").html((action.constant.counter--)+"秒");
					setTimeout("action.sandclock.run()", 1000);
				}
			},
			start : function() {
				action.constant.counter = 120;
				$("#smscodebtn").attr("m-state","disabled");
				$("#smscodebtn").html((action.constant.counter--)+"秒");
				setTimeout("action.sandclock.run()", 1000);
			}
		},
		validateForm1 : function() {
			var bankserial = action.constant.bankserial;
			if (!bankserial) {
				$.UIAlert("请选择银行");
				return false;
			}
			return true;
		},
		validateForm : function() {
			var identitytype = $("#identitytype").UISelectField("value").trim();
			var identityno = $("#identityno").UITextField("value");
			var capitalmode = "r";
			var bankacco = $("#bankacco").UITextField("value").trim();
			var customername = $("#custname").UITextField("value").trim();
			var sex = $.trim($("#sexSel_div").UISelectField("value")); //性别
			var communicationaddr = $.trim($("#communicationaddr").UITextField("value"));//通讯地址
			var isvalidopenacco = "0";
			var busintype = "OPENACCO";
			var reg = /^(\d{15}|\d{18}|\d{17}[a-zA-Z]{1})$/;
			var handsetReg = /^[0-9]{11}$/;
			var numReg = /^\d+$/;
			if ("" == identityno) {
				$.UIAlert("请输入证件号码！");
				return false;
			}
			if ("0" == identitytype && !reg.test(identityno)) {
				$.UIAlert("请输入正确的身份证号码！");
				return false;
			}
			if ("" == bankacco) {
				$.UIAlert("请输入银行卡号！");
				return false;
			}
			if ("" == custname) {
				$.UIAlert("请输入您的真实姓名！");
				return false;
			}
			if ("" == identityno) {
				$.UIAlert("请输入您的证件号码！");
				return false;
			}
			if (!numReg.test(bankacco)) {
				$.UIAlert("银行卡号必须为数字！");
				return false;
			}
			if (communicationaddr == "") {
            	$.UIPopup("通讯地址不能为空");
            	return false;
            }
			var data = "capitalmode="+capitalmode+"&bankacco=" + bankacco + "&customerappellation=" + customername + "&identitytype=" + identitytype + "&identityno=" + identityno + "&bankserial=" + action.constant.bankserial + "&sex=" + sex + "&isvalidopenacco=" + isvalidopenacco + "&busintype=" + busintype +
			"&bankname="+action.constant.bankname;
			return data;
		},
		doSubmit: function() {
			var data = action.validateForm();
			if (data) {
				$.hsf.startLoading();
				$.hsf.ajax.app("capital/chinapay/openaccoOrder", data, "doChinapayOpenaccoOrderCallback", function(jsonResult) {
					if (jsonResult && jsonResult.successful) {
						var charactercode = jsonResult.orderResult.charactercode; //特征码
						var merid = jsonResult.orderResult.merid; //商户号
						var merorderid = action.constant.accoreqserial = jsonResult.orderResult.merorderid; //商户订单号
						var merordertime = jsonResult.orderResult.merordertime; //下单时间
						var sign = jsonResult.orderResult.sign; //签名
						var url = "http://140.206.112.245/CPPayWeb/trans!merchantOrderCheck.ac?"
						+ "sign="+sign
						+ "&merchantId=" + merid
						+ "&merchantOrderId=" + merorderid 
						+ "&merchantOrderTime="+ merordertime
						+ "&orderKey=" + charactercode 
						+ "&pgRetUrl=" + $.hsf.appBaseUrl+"capital/chinapay/chinapayHtmlCallBack"
						action.loadChinapay(url);
						$.hsf.stopLoading();
					} else {
						$.hsf.stopLoading();
						$.hsf.callFailProcess(jsonResult);
					}
				});
			}
		},
		loadChinapay : function(url) {
			$.hsf.ajax.html("../pages/chinapay-view.html", function(html) {
				$("body").prepend(html);
				require(["pages/chinapay-view"], function(m) {
					param = {
						accoreqserial : action.constant.accoreqserial,
						identitytype : $("#identitytype").UISelectField("value").trim(),
						identityno : $("#identityno").UITextField("value"),
						customername : $("#custname").UITextField("value").trim(),
						url : url
					}
					m.init(param);
				});
			});
		},
		addChinapaySuccListener : function() {
			$.hsf.Event.addListener("chinapaySucc", function(obj) {
				$("#second").hide();
				$("#third").show();
			});
		},
		//调用商户级别开户
        merOpenAcco : function(tradepassword) {
        	var identitytype = $("#identitytype").UISelectField("value").trim();
			var identityno = $("#identityno").UITextField("value");
			var bankacco = $("#bankacco").UITextField("value").trim();
			var customername = $("#custname").UITextField("value").trim();
            var sex = "1" || $("#sexSel_div").UISelectField("value");//性别
            var birthday = ""//生日
            birthday = birthday.replace(/\-/g,"");
            var workcode = "08";
            var communicationaddr = $.trim($("#communicationaddr").UITextField("value"));//通讯地址
            var zipcode = "000000";  //$.trim($("#zipcode").UITextField("value"));//邮编
            var data = "accoreqserial="+action.constant.accoreqserial
            	+	"&bankname="+action.constant.bankname
            	+	"&bankserial="+action.constant.bankserial//银行编号
                +	"&capitalmode=r"//资金方式
                +	"&handset="+action.constant.telephone//手机号码
                +	"&customerappellation="+customername//姓名
                +	"&bankacco="+bankacco//银行账号
                +	"&identityno=" +identityno//证件号码
                +	"&identitytype=" +identitytype//证件类型
                +	"&tradepassword="+tradepassword//交易密码
                +	"&sex="+sex//性别
                +	"&birthday="+birthday//生日
                +	"&workcode="+workcode//职业代码
                +	"&communicationaddr="+communicationaddr//通讯地址
                +	"&zipcode="+zipcode//邮编
                +	"&detailcapitalmode=01"//明细资金方式
                +	"&reckoningsendtype=1"//对账单寄送方式
                +	"&reckoningmailtype=2"//对账单寄送途径
                +	"&invalidate=99991231"//默认永久有效
                +	"&nationality2=156"//国籍默认中国
                +	"&riskability=2";//风险承受能力,默认保守型
                console.log(data);
            $.hsf.startLoading("正在提交...");
            $.hsf.ajax.app("account/openacco/openacco",decodeURI(data), "openaccocallback", action.meropenaccoCallback);
        },
        meropenaccoCallback : function(jsonResult) {
        	$.hsf.stopLoading();
            if(jsonResult && jsonResult.successful) {
            	var account = $.hsf.hsTools.getParam("identityno"),
					accountType = $.hsf.hsTools.getParam("identitytype"),
					platformApi = $.hsf.getModuleAPI(platform, "login-view");
				var logindata = "certificatetype=" + accountType + "&lognumber=" + account + "&password=" + tradepassword + "&channel="+platformApi.channel+"&bindwx=1";
				$.hsf.ajax.app(platformApi.loginUrl, logindata, "checkLoginCode", function(jsonResult) {
					$.hsf.stopLoading();
					if (jsonResult.successful) {
						var question = "accoreqserial=ISNULL&qnoandanswer={\"00001\":\"001\",\"00002\":\"001\",\"00003\":\"001\",\"00004\":\"001\",\"00005\":\"001\",\"00006\":\"001\",\"00007\":\"001\",\"00008\":\"001\",\"00009\":\"001\",\"00010\":\"001\"}";
						$.hsf.ajax.app("account/risk/modifyRisk", question, "checkLoginCode", function(jsonResult) {
							$("#third").hide();
							$("#four").show();
						});
					} else {
						$("#third").hide();
						$("#four").show();
					}
				});
				$("#third").hide();
				$("#four").show();
            } else{
            	action.keyboard.reset();
                $.hsf.callFailProcess(jsonResult);
            }
        },
        validate2 : function(){
            var tradepassword = $.trim($("#tradepassword").UITextField("value"));
            var tradepassword2 = $.trim($("#tradepassword2").UITextField("value"));
            var birthday = action.constant.birthday ||$("#birthday_dateField").UIDateField("value");//生日
            birthday = birthday.replace(/\-/g,"");
            var mobile = action.constant.mobile || $("#mobile").UITextField("value");//手机号码
            var zipcodeReg = /^[0-9]{6}$/;
            var mobileReg = /^[1]\d{10}$/;
            if(""==birthday){
               $.UIPopup("请输入您的生日！");
				return false;
            }
            if("" == mobile){
               $.UIPopup("请输入手机号码！");
                return false;
            }
            if(!mobileReg.test(mobile)){
               $.UIPopup("请输入正确的手机号码！");
            	return false;
            }
            if(""==tradepassword){
               $.UIPopup("请输入8位数字交易密码！");
                return false;
            }else if(tradepassword.length!=8){
               $.UIPopup("密码需要8位有效数字！");
                return false;
            }
            if(tradepassword!=tradepassword2){
               $.UIPopup("两次密码输入不一致！");
                return false;
            }
            return true;
        }
	}
	window.action = action;
	return action;

})