define([$.hsf.platform()], function(platform){
	var openAcco = {
		init:function(){
			openAcco.events();
		},
		events: function() {
			$("#submitBtn").on("tap",function(){
				if(false==openAcco.validate()){
					return;
				}else{
					openAcco.merOpenAcco();//调用商户级别开户
				}
			});
			$("#pwMaxLength").html($.hsf.pwLength);
		},
		dictCallback:function(jsonResult){
			$.hsf.stopLoading();
			if(jsonResult && "true"==jsonResult.successful){
				var list = jsonResult.results.items.list;
				if(null!=list&&list.length>0){
					var html = "";
					for(var item in list){
						var dictObj = list[item];
						html+="<option value='"+dictObj.key+"'>"+dictObj.value+"</option>"
					}
					if(""!=html){
						$("#workcodeSel").html(html);
					}
				}
			} 
		},
		//调用商户级别开户
		merOpenAcco:function(){
			var identityno = $.hsf.hsTools.getParam("identityno");
			var birthday = openAcco.getBirthdayFromCard(identityno);//从身份证中获取生日
			var sex = openAcco.getSexFromCard(identityno);//从身份证中获取性别
			var workcode = $("#workcode").UISelectField("value");
			var tradepassword = $("#tradepassword").UITextField("value");
			var communicationaddr = $("#communicationaddr").UITextField("value");
			var zipcode = $("#zipcode").UITextField("value");
			var data = decodeURI(window.location.search).substring(1);
			data += "&tradepassword="+tradepassword
				 +	"&sex="+sex
				 +	"&birthday="+birthday
				 +	"&workcode="+workcode
				 +	"&communicationaddr="+communicationaddr
				 +	"&zipcode="+zipcode
				 +	"&reckoningsendtype=1&reckoningmailtype=2"//对账单默认不寄送
				 +	"&invalidate=99991231"//默认永久有效
				 +	"&nationality2=156";//国籍默认中国
			$.hsf.startLoading("正在提交...");
			$.hsf.ajax.app("account/openacco/openacco",data, "merOpenCallback", openAcco.merOpenCallback);
		},
		//商户级别开户
		merOpenCallback:function(jsonResult){
			if(jsonResult.successful){
				var account = $.hsf.hsTools.getParam("identityno"),
					pw = $("#tradepassword").UITextField("value"),
					accountType = $.hsf.hsTools.getParam("identitytype"),
					data = "certificatetype=" + accountType + "&lognumber=" + account + "&password=" + pw + "&channel=weixin&bindwx=1";
				$.hsf.ajax.app(platform.loginUrl, data, "checkLoginCode", function(jsonResult) {
					$.hsf.stopLoading();
					if (jsonResult.successful) {
						var question = "accoreqserial=ISNULL&qnoandanswer={\"00001\":\"001\",\"00002\":\"001\",\"00003\":\"001\",\"00004\":\"001\",\"00005\":\"001\",\"00006\":\"001\",\"00007\":\"001\",\"00008\":\"001\",\"00009\":\"001\",\"00010\":\"001\"}";
						$.hsf.ajax.app("account/risk/modifyRisk", question, "checkLoginCode", function(jsonResult) {
							$.UIAlert("开户成功!", function() {
								$.hsf.hsOpen("index.html");
							});
						});
					} else {
						$.UIAlert("开户成功！请重新登录", function() {
							$.hsf.hsOpen("login.html");
						});
					}
				});
			} else{
				$.hsf.callFailProcess(jsonResult);
			}
		},
		
		//从身份中获取生日
		getBirthdayFromCard:function (identityno){
			var year=2000;
			var month=12;
			var day=31;
			if(identityno.length==15){
				year = "19"+identityno.substr(6,2);
				month = identityno.substr(8,2);
				day= identityno.substr(10,2);
			}else if(identityno.length==18){
				year = identityno.substr(6,4);
				month = identityno.substr(10,2);
				day= identityno.substr(12,2);
			}
			return year+"-"+month+"-"+day;
		},
		//从身份中获取性别
		getSexFromCard:function(identityno){
			var sex=0;
			if(identityno.length==15){
				sex = identityno.substr(13,1);
			}else if(identityno.length==18){
				sex = identityno.substr(16,1);
			}
			return sex%2;
		},
		validate:function(){
			var communicationaddr = $("#communicationaddr").UITextField("value");
			var email = $("#email").UITextField("value");
			var zipcode = $("#zipcode").UITextField("value");
			var tradepassword = $("#tradepassword").UITextField("value");
			var tradepassword2 = $("#tradepassword2").UITextField("value");
			
			var zipcodeReg = /^[0-9]{6}$/;	
			var emailReg = /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/;
			
			if(!""==email && !emailReg.test(email)){
				$.UIAlert("请输入正确的email地址！");
				return false;
			}
			
			if(!""==zipcode && !zipcodeReg.test(zipcode)){
				$.UIAlert("请输入正确的邮编！");
				return false;
			}
			if(""==tradepassword){
				$.UIAlert("请输入交易密码！");
				return false;
			}
			if (!(/^[0-9,a-z]*$/.test(tradepassword) && tradepassword.length >= 6)) {
				$.UIAlert("交易密码必须大于6位数字！");
				return false;
			}
			if(tradepassword!=tradepassword2){
				$.UIAlert("两次密码输入不一致！");
				return false;
			}
			return true;
		}
		
	};
	return openAcco;
});
