define(["global", "Backbone"], function(G) {
	return Backbone.View.extend({
		el : "#account-openAcco-new-2",
		$cardTypeBox : $("#idTypeBox"),
		$custname : $("#custname"),
		$idNo : $("#idNo"),
		_private : {},
		validForm : $.validForm(),
		initialize: function(parent) {
			this.parent = parent;
            this.parent.setParam("custtype", $.hsf.hsTools.getParam("custtype"));
            this.parent.setParam("mobile",  $.hsf.hsTools.getParam("mobile"));
            this.parent.setParam("userid",  $.hsf.hsTools.getParam("userid"));
			$.checkNullGroup([this.$custname, this.$cardTypeBox, this.$idNo], this.$el.find(".nextBtn"));
			this.validForm = $.validForm();
			this.uiEvent();
			this.$cardTypeBox.UIPopOption("select", "0|身份证");
		},
		beforeHideView : function() {
			this.$cardTypeBox.UIPopOption("close");
		},
		afterSwitchView: function() {},
		toggleIdType : function() {
			this.$cardTypeBox.UIPopOption("open");
		},
		next : function() {
			var custname = this.$custname.UITextField("value");
			var idNo = this.$idNo.UITextField("value");
			var idType = $("#idType").attr("idcard-id");
			this.validForm.add("empty", custname).add("cerfiticate", idNo);
			if (this.validForm.valid()) {
				$.hsf.startLoading();
				var f = $.formGenerate()
					.add("certificateno", idNo)
                    .add("certificatetype", idType)
                    .add("invtp", "1")
					.add("custname", custname);
				var that = this;
				$.hsf.ajax.app("/account/account/queryCustInfo", f.generate(), "authenticationCallback", function(jsonResult) {
					$.hsf.stopLoading();
					var isOpened = false;
					var cust_type = "3";
					var isbinding = 0;
					if (jsonResult.successful) {
                        if(jsonResult.result.code=="0000"){
                            cust_type = jsonResult.result.custtype;
                            if(cust_type=="2"){
                                cust_type = "0";
							}
                            isbinding = jsonResult.result.isbinding;
						}
					} else if(jsonResult.code == "NETWORK_ERROR") {
						$.hsf.callFailProcess(jsonResult);
					}
                    // that.parent.setParam("custno", jsonResult.result.custno);
                    that.parent.setParam("idNo", idNo).setParam("idType", idType).setParam("custname", custname);
					if (cust_type=="0"&& isbinding==1) {
                        window.location.hash = "account-openAcco-new-8";//联系客服
					} else if(cust_type=="0"){
                        that.parent.setParam("custno", jsonResult.result.custno);
						window.location.hash = "account-openAcco-new-7";//交易密码
					}else {
                        window.location.hash = "account-openAcco-new-3";//增卡
					}
				});
			}
		},
		events : {
			"tap #idTypeDD" : "toggleIdType",
			"tap .nextBtn[m-state!='disabled']" : "next"
		},
		uiEvent : function() {
			var that = this;
        	this.$cardTypeBox.UIPopOption();
			this.$cardTypeBox.UIPopOption("change", function(mid) {
				var idType = mid.split("|")[0];
				var idText = mid.split("|")[1];
				$("#idType").html(idText).attr("idcard-id", idType);
			});
        }
	});
});