define(["global", "Backbone", $.hsf.platform()], function (G, B, platform) {
    return Backbone.View.extend({
        $tredepw : $("#tredepw"),
        el: "#account-openAcco-new-7",
        _private: {},
        initialize: function (parent, platformApi) {
            var that = this;
            $.platform.getCache("deviceId", function (deviceId) {
                that.parent = parent;
                that.platformApi = platformApi;
                that.formGenerate = $.formGenerate();
                that._private.deviceId = deviceId;
            });
        },

        login: function () {
            var that = this;
            $.platform.getCache("ps", function(result) {
                if (result) {
                    var idNo = that.parent.getParam("idNo");
                    var idType = that.parent.getParam("idType");
                    var pw = result.value;
                    var g = that.formGenerate;
                    var loginApi = $.hsf.getModuleAPI(platform, "login-view");
                    g.add("certificatetype", idType);
                    g.add("certificateno", idNo);
                    g.add("lpasswd", pw);
                    g.add("channel", that.platformApi.channel);
                    g.add("accttype", "1");
                    g.add("bindwx", "1");
                    g.add("deviceId", that._private.deviceId);
                    $.hsf.startLoading();
                    $.hsf.ajax.app(loginApi.loginUrl, g.generate(), "checkLoginCode", function(jsonResult) {
                        if (jsonResult && jsonResult.successful) {
                            $.platform.removeCache("logininfo");
                            $.platform.putCache("logininfo", jsonResult.result);
                        }else{
                            $.platform.removeCache("logininfo");
                        }
                        $.platform.triggerRefresh&&$.platform.triggerRefresh();
                        $(".finishAndBack").trigger('tap');
                        $.hsf.stopLoading();
                        return false;
                    });
                }
            });
        },

        binding: function () {
            var that = this;
            var idNo = this.parent.getParam("idNo");
            var idType = this.parent.getParam("idType");
            $.platform.getCache("logininfo", function(result) {
                var data = "certificatetype=" + idType +
                    "&certificateno=" + idNo +
                    "&custtype=" + result.custtype +
                    "&userid=" + result.userid +
                    "&mobile=" + result.Mobile;
                $.hsf.startLoading();
                $.hsf.ajax.app("account/register/binding", data, "binding", function (jsonResult) {
                    $.hsf.stopLoading();
                    if (jsonResult.successful) {
                        window.location.hash = "account-openAcco-new-6";
                        // that.login();
                    } else {
                        $.hsf.callFailProcess(jsonResult);
                    }
                });
            });
        },

        chcekTradePw :function () {
            var that = this;
            var code = this.$tredepw.UITextField("value");
            if (code.length == 0) {
                $.UIPopup("交易密码不能为空!");
                return false;
            }

            var idNo = this.parent.getParam("idNo");
            var idType = this.parent.getParam("idType");
            var custno = this.parent.getParam("custno");

            var data = "tpasswd=" + code+"&custno=" + custno ;
            $.hsf.startLoading();
            $.hsf.ajax.app("account/pwd/checkTradePwd", data, "checkTradePwd", function (jsonResult) {
                $.hsf.stopLoading();
                if (jsonResult.successful) {
                    that.binding();
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },

        events: {
            "tap #verifyBtn": "chcekTradePw"
        }
    });
});