define(["global", "Backbone"], function(G) {
	var AddBankCardView = Backbone.View.extend({
		el : "#add-bankcard-3",
		$cardTypeBox : $("#cardTypeBox"),
		$mobile : $("#bankmobile"),
		$cardNo : $("#cardNo"),
		$verifyBankCode : $("#verify-bank-code"),
		$bankname : $("#bankname"),
		_private : {},
		validForm : $.validForm(),
		initialize: function(parent) {
			var that = this;
			this.parent = parent;
			this.sandclock1 = this.sandclock("send-bank-code");
			this.validForm = $.validForm();
			this.form = $.formGenerate();
			this.uiEvents();
			$.when(this.loadBankList(), this.loadUserInfo()).then(function(r1, r2) {
				that.loadBankListProcess(r1[0]);
				that.loadUserInfoProcess(r2[0]);
			});
			$.checkNullGroup([this.$cardNo, this.$mobile, this.$verifyBankCode, this.$cardTypeBox.find("[m-role='UITableView']")], $("#verifyBankCodeNextBtn"));
		},
		loadBankList : function() {
			return $.hsf.ajax.app("account/tradeacco/addCardForm", "", "loadBankListCallback", function(jsonResult) {});
		},
		loadBankListProcess : function(jsonResult) {
			if (jsonResult.successful) {
				$.doTemplate("banklist-template", jsonResult.result.data);
				$("[m-role='UITableView']").UITableView("refresh");
				this._private.bankData = jsonResult.result.data;
			} else {
				$.hsf.callFailProcess(jsonResult);
			}
		},
		loadUserInfo : function() {
			return $.hsf.ajax.app("account/account/accountinfo", "", "loadUserInfoCallback", function(jsonResult) {});
		},
		loadUserInfoProcess : function(jsonResult) {
			if (jsonResult.successful) {
				this._private.userInfo = jsonResult.result;
			} else {
				$.hsf.callFailProcess(jsonResult);
			}
		},
		beforeHideView : function() {
			this.$cardTypeBox.UIPopOption("close");
		},
		afterSwitchView: function() {},
		sandclock :  function(id) {
			var counter = 0;
			var $btn = $("#"+id);
			return {
				start : function() {
					var run = function() {
						if (counter == 0) {
							$btn.attr("m-state","").html("获取");
						} else {
							$btn.html("剩余"+(counter--)+"秒");
							setTimeout(run, 1000);
						}
					}
					counter = 60;
					$btn.attr("m-state","disabled").html("剩余"+(counter--)+"秒");
					setTimeout(run, 1000);
				},
				readyStart : function() {
					if (counter == 0) {
						return true;
					} else {
						false;
					}
				}
			}
		},
		sendBankCodeAuthCode : function(event) {
			if (this.sandclock1.readyStart()) {
				$.hsf.startLoading();
				var that = this;
				var mobile = this.$mobile.UITextField("value");
				var cardNo = this.$cardNo.UITextField("value");
				var u = this._private.userInfo;
				this.validForm.add("mobile", mobile).add("empty", this._private.channelid, "请选择银行")
				if(mobile.length!=11){
					$.UIPopup("请输入11位手机号码");
					$.hsf.stopLoading();
					return false;
				}
				if (this.validForm.valid()) {
					this.form.add("servicename", "MsgSend")
					.add("channelid", this._private.channelid)
					.add("depositacct", cardNo)
					.add("certificatetype", u.certificatetype)
					.add("certificateno", u.certificateno)
					.add("mobileno", mobile)
					.add("custname", u.custname);
					$.hsf.ajax.app("capital/bank/bankSwiftAuth", this.form.generate(), "sendMobileAuthcodeCallback", function(jsonResult) {
						$.hsf.stopLoading();
						if (jsonResult.successful) {
							$("#send-bank-code-mobileFix").html(mobile.substr(0,3)+"****"+mobile.substr(7,4));
							$("#send-bank-code-notice").show();
							that.sandclock1.start();
						} else {
							$.hsf.callFailProcess(jsonResult)
						}
					});
				} else {
					$.hsf.stopLoading();
				}
			}
			return false;
		},
		nextBeforeCode : function() {
			var that = this;
			var mobile = this.$mobile.UITextField("value");
			var cardNo = this.$cardNo.UITextField("value");
			var verifyCode = this.$verifyBankCode.UITextField("value");
			var u = this._private.userInfo;
			if(mobile.length!=11){
				$.UIPopup("请输入11位手机号码");
				return false;
			}
			this.validForm.add("mobile", mobile);

			if (this.validForm.valid()) {
				$.hsf.startLoading();
				this.form.add("servicename", "MsgCheck")
					.add("channelid", this._private.channelid)
					.add("depositacct", cardNo)
					.add("certificatetype", u.certificatetype)
					.add("certificateno", u.certificateno)
					.add("mobileno", mobile)
					.add("custname", u.custname)
					.add("verificationcode", verifyCode);
				if(verifyCode.length!=6){
					$.UIPopup("请输入6位验证码");
					$.hsf.stopLoading();
					return false;
				};

				$.hsf.ajax.app("capital/bank/bankSwiftVerify", this.form.generate(), "bankSwiftVerifyCallback", function(jsonResult) {
					if (jsonResult.successful) {
						that._private.cardNo = cardNo;
						that.addCard();
					} else {
						$.hsf.callFailProcess(jsonResult)
					}
				});
			}
		},
		addCard : function() {
			this.form.add("depositacct", this._private.cardNo)
				.add("channelid", this._private.channelid)
				.add("channelname", this._private.channelname);
			$.hsf.ajax.app("account/tradeacco/addCard", this.form.generate(), "addCardCallback", function(jsonResult) {
				$.hsf.stopLoading();
				if (jsonResult.successful) {
					$.UIPopup("增卡成功", function() {
						$.platform.triggerSucc && $.platform.triggerSucc();
						$.hsf.hsBack();
					});
				} else {
					$.hsf.callFailProcess(jsonResult)
				}
			});
		},
		events : {
			"tap #cardTypeDD" : "openCardList",
			"tap .m-select-box-opt" : "cardTypeSelectComplete",
			"tap #verifyBankCodeNextBtn[m-state!='disabled']" : "nextBeforeCode",
			"tap #send-bank-code" : "sendBankCodeAuthCode"
		},
		openCardList : function() {
			this.$cardTypeBox.UIPopOption("open");
		},
		uiEvents : function() {
			var that = this;
			this.$cardTypeBox.UIPopOption({title:"请选择银行卡"});
			this.$cardTypeBox.UIPopOption("change", function(id) {
				that.changeBankCard(id);
			});
		},
		changeBankCard : function(id) {
			this._private.channelid = this._private.bankData[id].channelid;
			this._private.bankname = this._private.bankData[id].bankname;
			this._private.channelname = this._private.bankData[id].channelname;
			$("#selectedBankIcon").removeAttr("class").addClass("bank-logo-min bank-"+this._private.bankData[id].alias);
			$("#bankname").html(this._private.bankData[id].bankname);
		}
	});
	return {init : function(){
		new AddBankCardView();
	}}
});