define([$.hsf.platform()], function(platform) {
	var action = {
		constant : {
			pageNo : 1,
			totalNum : 0,
			loadedNum : 0,
			oneTimeRecord : 20,
			fundcode : $.hsf.hsTools.getParam("fundcode")
		},
		init: function() {
			action.initRequestForm();
			$.hsf.Event.addListener("trade", function() {
				action.initRequestForm(false);
			});
			$("[m-role='title']").html($.hsf.hsTools.getParam("fundname"));
			// if($.hsf.hsTools.getParam("fundcode") == "888888" || $.hsf.hsTools.getParam("fundcode") == "001973"){
			// 	$("#detailBtn").hide();
			// }else {
			$("#detailBtn").attr("m-href", "fund-detail.html?fundcode=" + $.hsf.hsTools.getParam("fundcode"));
			// }
			$.platform.initPage && $.platform.initPage();
		},
		initRequestForm : function(){
			var p = $.hsf.hsTools.getParam;
			var param = {
				fundcode: p("fundcode"),
				fundname: p("fundname"),
				datasource: p("datasource"),
				sharemode: p("sharemode"),
				tradeAccountid:p("tradeAccountid")
			};
			var f = $.formGenerate().add("fundcode", param.fundcode).add("datasource", param.datasource).add("sharemode", param.sharemode);
			$.hsf.startLoading();
			$.hsf.ajax.app("query/share/shareDetail", f.generate(), "shareDetailCallback", function(jsonResult) {
				if (jsonResult.successful) {
					var result = jsonResult.result = $.extend(jsonResult.result, param);
					console.log("result",result);
					action.constant.data = jsonResult.result.data;
					action.constant.p = param;
					$.hsf.fundtypeDict.forEach(function(item) {
						if (item.key == result.fundstate.fundtype) {
							result.fundstate.fundtypestr = item.value;
						}
					});
					if (param.datasource == "dc") {
						var filtData = {};
						var data = jsonResult.result.data;
						for (var index in data) {
							if (filtData[data[index].XSRMC]) {
								filtData[data[index].XSRMC].DQFE += data[index].DQFE;
								filtData[data[index].XSRMC].ZCGZ += data[index].ZCGZ;
							} else {
								filtData[data[index].XSRMC] = {"XSRMC" : data[index].XSRMC, "DQFE": data[index].DQFE, "ZCGZ":data[index].ZCGZ};
							}
						}
						jsonResult.result.data = [];
						for (var i in filtData) {
							jsonResult.result.data.push(filtData[i]);
						};
					}
					if (action.constant.data.length>0){
						$.doTemplate("fundArea-template", result, "refresh");
						$.doTemplate("bottombar-template", result, "refresh");
						$.doTemplate("tip-template", result);
					}
					$("[m-role='UITableView']").UITableView();
					action.events();
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
			if(param.datasource == "ds"){
				$("#tradeList").show();
				action.applyPackForm();
			}else{
				$("#tradeList").hide();
			}
		},
		applyPackForm : function(){
			var data = "fundcode="+action.constant.fundcode+"&pageno="+action.constant.pageNo+"&pagesize=10";
			$.hsf.ajax.app("query/tradeapply/tradeapply", data, "tradeApplyCallback", function(jsonResult) {
				if (jsonResult.successful) {
					var result = jsonResult.result.data;
					result.forEach(function(item) {
						if (item.applicationamount > 0){
							item.apply = item.applicationamount+"元";
						}else if(item.confirmedamount > 0){
							item.apply = item.confirmedamount + "元";
						}else if (item.applicationvol > 0) {
							item.apply = item.applicationvol+"份";
						} else {
							item.apply  = "--";
						}
						if (item.businesscode == "36" && item.businesskind == "j" && item.tradeway== "06") {
							item.businessstr = "赎回";
							item.fundcode = item.targetfundcode;
							item.fundname = item.targetfundname;
							item.tradeway = "";
						}
						item.confirmflagstr = action.dictValue(item.confirmflag, {"0":"确认成功", "1":"待确认", "2":"确认失败"});
						item.businessstr = item.businessstr||item.businesscode;
						item.operdate = $.hsf.hsTools.yyyy_mm_dd(item.operdate);
					});
					$.doTemplate("tradeList-template", result, "repeat");
					action.constant.pageNo++;
					action.constant.loadedNum += result.length;
					if (action.constant.loadedNum >= jsonResult.result.totalpages) {
						$("#moreBtn").hide();
					} else {
						$("#moreBtn").show();
					}
				}else{
					$("#moreBtn").hide();
				}
			});
		},
		dictValue : function(key, dict) {
			for (var index in dict) {
				if (index == key) {
					return dict[index];
				}
			}
			return "";
		},
		events: function() {
			var $saleBtn = $("#saleBtn");
			var $transBtn = $("#transBtn");
			$("#tradionList").UITableView("mark", function(mid) {
				var trade = action.constant.data[mid];
				$("#col1").html($.hsf.hsTools.formatMoney(trade.DQFE));
				$("#col2").html($.hsf.hsTools.formatMoney($.hsf.hsTools.decimal2(trade.useableshare)));
				$("#col3").html($.hsf.hsTools.formatMoney(trade.ZCGZ));
				if (parseFloat(trade.useableshare) <= 0) {
					$("#saleBtn,#transBtn").addClass("disabled");
				}else{
					$("#saleBtn,#transBtn").removeClass("disabled");
				}
				return false;
			});
			$("#saleBtn,#transBtn").bind("tap", function() {
				var $t = $(this);
				if (false == $t.hasClass("disabled")) {
					var mid = $("#tradionList").UITableView("marked");
					var go = $t.attr("go");
					var tradeObj = action.constant.data[mid];
					$.hsf.hsOpen(go+"&transactionaccountid="+tradeObj.JYZH+"&sharemode="+action.constant.p.sharemode);
				}
			});
			$("#moreBtn").bind("tap", function(){
				action.applyPackForm();
			});
		}
	};
	return action;
});