define(["global", "Backbone", "iscroll-probe"], function() {
	return Backbone.View.extend({
		el : "#asset",
		parent : null,
		myScroll : null,
		title : {
			left : {
				show : true
			}, 
			center : {
				text : "资产"
			},
			right : {
				show :  true,
				text : "交易记录",
				url : "trade-history.html"
			},
			border : {
				show : false
			}
		},
		scrollTop : -1, 
		initialize : function(parent, platformApi) {
			var that = this;
			this.parent = parent;
			this.platformApi = platformApi;
			this.isLoginOrNot();
			this.inprofit();
			$.hsf.Event.addListener("logout", function() {
				that.resetPage();
			}).addListener("trade", function() {
				//请求持有基金资产
				that.initAsset();
				//请求现金宝
				that.initMoneyFundInfo();
			}).addListener("eyeChange", function(r) {
				if (r.o != "asset") {
					that.changeEye();
				}
			});
			$.platform.getCache("assetEye", function(result) {
				if (result && result.value) {
					that.setEye(result.value);
				} else {
					that.setEye(true);
				}
			}, "local");
			this.requestManager = $.hsf.requestManager(this);
			this.requestManager.add(this.initAsset, 60*60*1);
			this.requestManager.add(this.initMoneyFundInfo,60*60*1);
			// this.initMoneyFundInfo();
			// $("#moneyArea").hide();
			this.platformApi.initPage(this);
			this.uiEvent();

			setTimeout(function () {
				// this.getLoginInfo();
				$.platform.getCache("logininfo",function (result) {
					if(result && result.riskenddate2){
						var riskenddate = result.riskenddate;	//风险过期日期
						var validDate = result.validdate;		//证件有效期
						var myDate = $.hsf.hsTools.getCurrentDay();

						if(parseFloat(myDate) > parseFloat(riskenddate)){
							$.UIConfirm("您的风险测评有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
								if (o == "yes") {
									$.hsf.hsOpen("account-info.html");
								}
							});
						}else if(parseFloat(myDate) > parseFloat(validDate)){
							$.UIConfirm("您的证件有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
								if (o == "yes") {
									$.hsf.hsOpen("account-info.html");
								}
							});
						}else {
							console.log("都没过期");
						}
					}else {
						$.hsf.ajax.app("account/account/accountinfo","","checkLoginCode",function(jsonResult) {
							if (jsonResult.successful) {
								var custtype = jsonResult.result.custtype;
								$.platform.removeCache("logininfo");
								$.platform.putCache("logininfo", jsonResult.result);
								var riskenddate = jsonResult.result.riskenddate;	//风险过期日期
								var validDate = jsonResult.result.validdate;		//证件有效期
								var myDate = $.hsf.hsTools.getCurrentDay();

								if(parseFloat(myDate) > parseFloat(riskenddate)){
									$.UIConfirm("您的风险测评有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
										if (o == "yes") {
											$.hsf.hsOpen("account-info.html");
										}
									});
								}else if(parseFloat(myDate) > parseFloat(validDate)){
									$.UIConfirm("您的证件有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
										if (o == "yes") {
											$.hsf.hsOpen("account-info.html");
										}
									});
								}else {
									console.log("都没过期");
								}
							}
						});
					}
				});
			},1000);

		},
		inprofit : function(){
			$.platform.getCache("logininfo", function(result) {
				if (result) {
					var custtype = result.custtype;
					if(custtype == "1"){//代销用户
						$("#fhfs").hide();
						$("#jyjl").hide();
					}else{
						$("#fhfs").show();
						$("#jyjl").show();
					}
				}else{
					$.hsf.ajax.app("account/account/accountinfo","","checkLoginCode",function(jsonResult) {
						if (jsonResult.successful) {
							$.hsf.stopLoading();
							var custtype = jsonResult.result.custtype;
							$.platform.removeCache("logininfo");
							$.platform.putCache("logininfo", jsonResult.result);
							if(custtype == "1"){//代销用户
								$("#fhfs").hide();
								$("#jyjl").hide();
							}else{
								$("#fhfs").show();
								$("#jyjl").show();
							}
						}else{
							$.hsf.stopLoading();
							$.hsf.callFailProcess(jsonResult);
						}
					});
				}
			});
		},
		isLoginOrNot : function (opt) {
			var checkLoginNotExist = function() {
				return document.getElementById("login") == null;
			};
			var login = function() {
				if (checkLoginNotExist()) {//内外两次判断可能会优化减少一次连接
					$.hsf.ajax.html("../pages/login-view.html", function(html) {
						if (checkLoginNotExist()) {//如果login界面已经弹出则不加载
							$("body").prepend(html);
							require(["pages/login-view"], function(m) {
								m.init();
								opt && opt.disableHistoryBack && m.disableHistoryBack();
							})
						} else {
							return;
						}
					});
				}
			};
			if ($.hsf.platform() == "platform/weixinapi") {
				$.hsf.ajax.app("account/weixinlogin/islogin", "", "loginCallback", function(jsonResult) {
					if (jsonResult.successful) {
						if (jsonResult.isBinded == "0") {
							setTimeout(login, 100);
						}
					} else if (jsonResult.code == "APP-5BP0012") {
						$.UIAlert("您的请求的页面已过期。请返回微信", function() {
							require(["wx"], function(wx) {
								typeof wx != "undefined" && wx.closeWindow();
							})
						});
					}
				});
			}
		},
		tapEye : function() {
			this.setEye(!this.getEye());
			this.changeEye();
			$.platform.putCache("assetEye", {"value": this.getEye()}, "local");
			$.hsf.Event.trigger("eyeChange", null, {o: "asset"});
			return false;
		},
		getEye : function() {
			// alert(this.parent.getParam("assetEye").value);
			return this.parent.getParam("assetEye").value;
		},
		setEye : function(value) {
			var result = {value: value}
			this.parent.setParam("assetEye", result);
			$.platform.putCache("assetEye", result, "local");
		},
		changeEye : function() {
			var result = this.getEye();
			if (result) {
				$(".eye-data").each(function() {
					var $t = $(this);
					var value = $t.html();
					var attrValue = $t.attr("value");
					if(value == "******") {
						$t.html(attrValue);
					}
				});
				$(".eye-data").show();
				this.$el.find(".psw-visible-ico2").addClass("on");
			} else {
				$(".eye-data").each(function() {
					var $t = $(this);
					var value = $t.html();
					$t.attr("value", value).html("******");
				});
				$(".eye-data").show();
				this.$el.find(".psw-visible-ico2").removeClass("on");
			}
			return false;
		},
		initAsset : function(loading) {
			var that = this;
			this.parent.lockNavigate();
			if (loading !== false) {
//				$.hsf.startLoading();	
			}
			$.hsf.ajax.app("query/share/shareQuery", "", "standShareList", function(jsonResult) {
				if (jsonResult.successful) {
                    $.hsf.stopLoading();
					that.loadAssetlist(jsonResult);
					that.parent.unlockNavigate();
					that.myScroll.enable();
					that.myScroll.refresh();
					that.myScroll.scrollTo(0,0, 100);
				} else {
                    $.hsf.stopLoading();
					if (that.myScroll) {
						that.myScroll.enable();
						that.myScroll.refresh();
						that.myScroll.scrollTo(0,0, 100);
					}
					that.requestManager.resetTime(that.initAsset);
					$.hsf.callFailProcess(jsonResult, function() {
						that.parent.unlockNavigate();
					});	
				}
			});
		},
		initMoneyFundInfo : function(){
			var that = this;
			this.parent.lockNavigate();
            $.hsf.startLoading();
			$.hsf.ajax.app("home/homepage/homePage","","homePageCallback",function (jsonResult) {
				if(jsonResult.successful){
					$.hsf.stopLoading();
					$("#moneyArea").show();
					var moneyValue = jsonResult.supercapital;

					$("#yqbMarketValue").html($.hsf.hsTools.formatMoney($.hsf.hsTools.decimal2(moneyValue)));
					// $("#yqbArea").show();
					// $.doTemplate('moneyArea', jsonResult, "refresh");
				}else {
					$.hsf.stopLoading();
				}
			});
		},
 		resetPage : function() {
			$.doTemplate('renderArea', null, "recover");
			$.doTemplate('renderArea2', null, "recover");
			//$.doTemplate('moneyArea',null,"recover");
			this.requestManager.resetTime(this.initAsset);
			this.requestManager.resetTime(this.initMoneyFundInfo);
		},
		sortUp : function(list) {
			list.sort(function(a, b) {
				return (a.ZCGZ < b.ZCGZ) ? 1 : -1
			})
		},
		loadAssetlist : function(jsonResult) {
			this.sortUp(jsonResult.dcList);
			this.sortUp(jsonResult.dsList);
			jsonResult.dcshareList = jsonResult.dcList;
			jsonResult.dsshareList = jsonResult.dsList;
			$.doTemplate('renderArea', jsonResult, "refresh");
			$.doTemplate('renderArea2', jsonResult, "refresh");
			var bodyHeight = document.documentElement.clientHeight;
			var height = (bodyHeight - ($("#renderArea").height()+44+50+200+38))/2+20;
			$("#empty-div").css({"position":"absolute","left": "0px", "right":"0px", "top":"220px"})
			this.changeEye();
			this.initScroll();
		},
		events : {
			"tap .zc-tab" : "switchZZC",
			"tap #yqb-eye" : "tapEye",
			"tap #renderArea" : "stoptouchmove",
			"tap #fhfs" : "fhfs"
		},
		fhfs : function(){
			$.hsf.hsOpen("fund-bonus.html");
		},
		uiEvent : function() {
			$(document).on("touchmove", "#renderArea", function() {
				return false;
			});
		},
		switchZZC : function(e) {
			$(".zc-tab").toggleClass("on");
			$(".totalcaptitalSpan").toggle();
		},
		gotoBuy : function(e) {
			$.hsf.hsOpen("fund-list.html");
		},
		afterSwitchView : function() {
			$('body').scrollTop(0);
			// this.initAsset();
			// this.initMoneyFundInfo();
			// this.uiEvent();
			if (false == this.requestManager.invoke(this.initAsset)) {
				if(this.myScroll) {
					this.myScroll.refresh();
				} else if (this.renderAreaHeight == 0){
					this.initScroll();
				}
			}
			if (false == this.requestManager.invoke(this.initMoneyFundInfo)) {
				if(this.myScroll) {
					this.myScroll.refresh();
				} else if (this.renderAreaHeight == 0){
					this.initScroll();
				}
			}
		},
		initRenderArea : function() {
			
		},
		initScroll : function() {
			$(".pullDown").show();
			var date = $.hsf.hsTools.getNowFormatDate();
			$("#refreshTip").html("下拉刷新..."+date);
			var $s = $("#swiperArea");
			var that = this;
			if (this.myScroll) {
				this.myScroll.enable();
				this.myScroll.refresh();
				this.myScroll.scrollTo(0,0,100);
			} else {
				this.renderAreaHeight = $("#renderArea").height();
				if (this.renderAreaHeight == 0) return;
				var scrollTop = this.renderAreaHeight;
				$("#scroll1").css("top", scrollTop+"px");
				$s.css({"min-height": document.documentElement.clientHeight- 40 -scrollTop});
				window.myScroll = this.myScroll = new IScroll("#scroll1", {probeType:1});
				this.myScroll.on('scroll', function() {
					if (parseFloat(this.y) > 45) {
						that.myScroll.refreshFlag = true;
						$(".pullDown").addClass("flip");
						var date = $.hsf.hsTools.getNowFormatDate();
						$("#refreshTip").html("释放刷新"+date);
					};
				});
				$("#scroll1").bind("touchmove", function (event) {
					event.preventDefault();
				});
				$("#scroll1").bind("touchend", function (event) {
					if (that.myScroll.refreshFlag) {
						var x = function() {
							setTimeout(function() {
								var scrollY = parseFloat($s.css("transform").split(", ")[5]);
								if (scrollY <= 45 && that.myScroll.disable) {
									$(".pullDown").removeClass("flip").addClass("loading");
									var date = $.hsf.hsTools.getNowFormatDate();
									$("#refreshTip").html("正在刷新..."+date);
									$s.css({"webkitTransform":'translate( 0px,' + (scrollY) + 'px) translateZ(0) '});
									that.initAsset();
									// that.initMoneyFundInfo();
									that.myScroll.refreshFlag = false;
									$.hsf.Event.muteTrigger("pullRefresh");
								} else {
									x();
								}
							}, 10);
						};
						x();
					}
				});
			}
		}
	});
});
