/**
 * Created by apple on 15/6/23.
 */

define(['echart'],function(echart){
   var action = {
       constant : {
         portfoliocode : $.hsf.hsTools.getParam("portfoliocode"),
         transactionaccountid:$.hsf.hsTools.getParam("transactionaccountid"),
         dateList:[],
         valueList:[],
           gsValueList:[]
       },
       init : function(){

         action.initAssetList();
         action.requestChartData();
       },
       events : function () {
       var option = {
           grid:{
             show:true,
             borderColor:"transparent",
             backgroundColor:'#7baffb',
             top:'10%',
             left: '2%',
             right: '10%',
             bottom: '15%',
             containLabel: true
           },
           xAxis: {
             type: 'category',
             boundaryGap: false,
             data:action.constant.dateList,
             splitLine:{show: false},//去除网格线
             axisLabel : {//坐标轴刻度标签的相关设置。
                 interval:action.constant.dateList.length > 2 ? (action.constant.dateList.length-2) : 0,
               show: true,
               textStyle: {
                 color: '#7b7b7b',
                 fontSize:10
               }
             },
             "axisLine":{       //y轴
               "show":false
             },
             "axisTick":{       //y轴刻度线
               "show":false
             }
           },
           tooltip: {
             trigger: 'axis',
             axisPointer: {
               lineStyle : {
                 color : '#fff',
                 width:1
               }
             }
           },
           yAxis: {
             type: 'value',
             splitLine:{show: false},//去除网格线
               max:1,
               min:0,
             axisLabel: {
               show: true,
                 formatter : function(params){
                   var par=(parseFloat(params)*100);
                     return par.toFixed(2)+"%";
                 },
               textStyle: {
                 color: '#7b7b7b',
                 fontSize:10
               }
             },
             "axisLine":{       //y轴
               "show":false
             },
             "axisTick":{       //y轴刻度线
               "show":false
             }
           },
           series: [
               {
                   name: '固收',
                   data: action.constant.gsValueList,
                   type: 'line',
                   itemStyle : {
                       normal : {
                           color:'#fff',
                           areaStyle : {
                               type : 'default',
                               //渐变色实现
                               color :'#237af9' //'#7baffb'
                           },
                           lineStyle : {  //线的颜色
                               color : '#fff'
                           }
                       }
                   },
                   areaStyle : {}
           }
           ]
         };
         //初始化echarts实例
         var myChart = echart.init(document.getElementById('chartArea'));
         //使用制定的配置项和数据显示图表
         myChart.setOption(option);
       },
       initAssetList:function(){
         $.platform.getCache("BAO_ASSET_DETAIL_INFO",function (infoData) {
             var dataList=infoData.detaiList;
             var allMarketvalue=0;
             for (var i = 0; i < dataList.length; i++) {
                 var data=dataList[i];
                 allMarketvalue=allMarketvalue+parseFloat(data.marketvalue);
             }

             var  allPercentage=0;
             for (var i = 0; i < dataList.length; i++) {
                 var data=dataList[i];
                 var percentageNum=(parseFloat(data.marketvalue)/allMarketvalue)*100;
                 if (i==(dataList.length-1)) {
                     var nowPer=100-allPercentage;
                     data.percentage=action.toDecimal2(nowPer,2);
                     data.marketvalue=$.formatNum(data.marketvalue);
                 }else {
                     data.percentage=action.toDecimal2(percentageNum,2);
                     data.marketvalue=$.formatNum(data.marketvalue);
                     allPercentage=allPercentage+parseFloat(data.percentage);
                 }


             }
             $.doTemplate("dataListID",dataList);

         });

       },
       requestChartData:function () {
           $.hsf.startLoading();
         this.formGenerate = $.formGenerate();
         var g = this.formGenerate.
         add("portfoliocode",action.constant.portfoliocode).
         add("transactionaccountid",action.constant.transactionaccountid);

         action.constant.valueList.splice(0);
         action.constant.dateList.splice(0);

         $.hsf.ajax.appEncrypt("query/combportfolio/assetRatio",g.generate(),"assetRatio",function (jsonResult) {
           if (jsonResult.successful==true){
               $.hsf.stopLoading();
             var result=jsonResult.result;
             var data=result.data;
             var dataList=data.dataList;

             dataList=dataList.sort(function (a, b) { return parseFloat(a.changedate)-parseFloat(b.changedate) });


             for (var i = 0; i < dataList.length; i++) {
               var model=dataList[i];
               action.constant.valueList.push(model.equityassetpercent);//权益
               action.constant.gsValueList.push(model.fixedassetpercent);//固收
               var str = model.changedate;
               model.changedate = str = str.substr(0,4)+"."+str.substr(4,2)+"."+str.substr(6,2);
               action.constant.dateList.push(model.changedate);
             }

             action.events();
           }else {
               $.hsf.callFailProcess(jsonResult);
           }
         });

       },
      toDecimal2:function(num,s) {//保留s位小数
       var time=Math.pow(10,s);
       var des=num*time+0.5;
       des=parseInt(des,10)/time;
       return des +'';
     }
   } ;
    return action;
});
