/**
 * Created by apple on 15/6/23.
 */

define(['echart'],function(echart){
  var action = {
    constant : {
      portfoliocode:$.hsf.hsTools.getParam("portfoliocode"),
      portfolioshowtype:'',//$.hsf.hsTools.getParam("portfolioshowtype")
      portfolioname:'',//产品名称
      dateArr:[],
      BDataArr:[],
      ZDataArr:[],
    },
    init : function(){
      action.tab();
      action.initialize();
      // $("#shareID").hide();//分享隐藏

    },
    events : function () {
      var option = {
        grid:{
          top:'10%',
          left: '5%',
          right: '10%',
          bottom: '15%',
          containLabel: true
        },
        xAxis: {
          type: 'category',//category
          boundaryGap: false,
          data:action.constant.dateArr ,//['2017-12-08','2017-12-09','2017-12-10','2017-12-11','2017-12-12']
          splitLine:{show: false},//去除网格线
          axisLabel : {//坐标轴刻度标签的相关设置。
            show: true,
            interval:action.constant.dateArr.length>2?(action.constant.dateArr.length-2):0,
            textStyle: {
              color: 'rgb(172,179,191)',
              fontSize:10
            }
          },
          "axisLine":{       //y轴
            "show":false
          },
          "axisTick":{       //y轴刻度线
            "show":false
          }
        },
        tooltip: {
          trigger: 'axis',
          axisPointer: {
            lineStyle : {
              color : '#237af9',
              width:1
            }
          }
        },
        yAxis: {
          type: 'value',
          splitLine:{
            show: true,
            lineStyle:{
              type:'dashed',
              color:'#F7F7F7'
            }
          },//去除网格线
          axisLabel: {
            show: true,
            interval: 'auto',
            formatter: function(params){
              return params.toFixed(2)+"%";
            },
            textStyle: {
              color: 'rgb(172,179,191)',
              fontSize:10
            }
          },
          "axisLine":{       //y轴
            "show":false
          },
          "axisTick":{       //y轴刻度线
            "show":false
          }
        },
        series: [
          {
            name: action.constant.portfolioname,
            data: action.constant.ZDataArr,//[820, 932, 901, 934, 1290, 1330, 1320]
            type: 'line',
            symbol:'circle',
            symbolSize:4,
            itemStyle : {
              normal : {
                color:'#237af9',
                // areaStyle : {
                //   type : 'default',
                //   //渐变色实现
                //   color : '#e4efff'
                // },
                lineStyle : {  //线的颜色
                  color : '#237af9'
                }
              }
            },
            areaStyle : {}
          },
          {
            name: '比较基准',
            type: 'line',
            symbol:'circle',
            symbolSize: 4,   //拐点圆的大小
            data:action.constant.BDataArr ,//[800, 300, 500, 800, 300, 600, 500]
            smooth: false,   //关键点，为true是不支持虚线的，实线就用true
            itemStyle: {
              normal: {
                color:'#ff870c',
                lineStyle: {
                  width: 1,
                  type: 'solid',  //'dotted'虚线 'solid'实线
                  color: '#ff870c'  //折线条的颜色
                }
              }
            }
          }]
      };
      //初始化echarts实例
      var myChart = echart.init(document.getElementById('chartArea'));
      //使用制定的配置项和数据显示图表
      myChart.setOption(option);
    },
    tab:function (){
      $('.chart-infor-time-item').on('tap',function (){
        $(this).addClass('on').siblings().removeClass('on')
      })},
    initialize:function(){
      $.hsf.startLoading();
      var param='portfolioshowtype='+action.constant.portfolioshowtype+"&portfoliocode="+action.constant.portfoliocode;
      $.hsf.ajax.appEncrypt("product/product/combPortfolioInfo", param, "combPortfolioInfo",
          function (jsonResult){
            $.hsf.stopLoading();
            if (jsonResult.successful == true) {
              var result=jsonResult.result.data;
              var dataList=result.dataList;
              var data=dataList[0];

              if (typeof data=="undefined"||data==null||data=="") {//判断非空
                return;
              }
              if (data.purchaserateinfo!=undefined&&data.purchaserateinfo.length>0) {
                $("#chargID").html("买入"+data.purchaserateinfo);
              }else {
                $("#chargID").hide();
              }

              var portfolioFundList=data.portfolioFundList;
              for (var i = 0; i <portfolioFundList.length ; i++) {
                var model=portfolioFundList[i];
                if (model.fundratio){
                  model.fundratio=(parseFloat(model.fundratio)*100).toFixed(2)+"%";
                } else {
                  model.fundratio="--";
                }
              }

              var incomeratemonth=(100*parseFloat(data.incomeratemonth)/30).toFixed(2);//近一个月收益率
              var incomeratethreemonth=(100*parseFloat(data.incomeratethreemonth)/90).toFixed(2);//近三个月收益率
              var incomeratehalfyear=(100*parseFloat(data.incomeratehalfyear)/180).toFixed(2);//近六个月收益率
              var incomerateyear=(100*parseFloat(data.incomerateyear)/365).toFixed(2);//近一年收益率
              var incomeratetwoyear=(100*parseFloat(data.incomeratetwoyear)/730).toFixed(2);//近俩年收益率
              var incomeratethreeyear=(100*parseFloat(data.incomeratethreeyear)/1095).toFixed(2);//近3年收益率
              var incomeratefiveyear=(100*parseFloat(data.incomeratefiveyear)/1825).toFixed(2);//近5年收益率

              var incomerateList=[incomeratemonth,incomeratethreemonth,incomeratehalfyear,incomerateyear,incomeratetwoyear
                ,incomeratethreeyear,incomeratefiveyear];


              var vule1=(100*parseFloat(data.incomeratemonth)).toFixed(2);
              var vule2=(100*parseFloat(data.incomeratethreemonth)).toFixed(2);
              var vule3=(100*parseFloat(data.incomeratehalfyear)).toFixed(2);
              var vule4=(100*parseFloat(data.incomerateyear)).toFixed(2);
              var vule5=(100*parseFloat(data.incomeratetwoyear)).toFixed(2);
              var vule6=(100*parseFloat(data.incomeratethreeyear)).toFixed(2);
              var vule7=(100*parseFloat(data.incomeratefiveyear)).toFixed(2);

              var rateValueList=[vule1,vule2,vule3,vule4,vule5,vule6,vule7];




              var namelist=['近一月历史年化','近三月历史年化','近六月历史年化','近一年历史年化','近两年历史年化',
                '近三年历史年化','近五年历史年化'];

              var index=0;
              var maxValue='0';
              for (var i = 0; i < incomerateList.length; i++) {
                var incomerateValue=incomerateList[i];
                if (parseFloat(incomerateValue)>parseFloat(maxValue)){
                  //取出最大
                  maxValue=incomerateValue;
                  index=i;
                }
                if (parseFloat(incomerateValue)==parseFloat(maxValue)){
                  //取出等于
                  maxValue=incomerateValue;
                  index=i;
                }
              }

              //历史年化
              var incomerMax=rateValueList[index];



              if (!incomerMax||incomerMax=="NaN"){
                $("#incomerateytdID").html("--");
              }else {
                $("#incomerateytdID").html(incomerMax+"%"); //年化
              }
              $("#nameID").html(namelist[index]);


              //基金列表明细
              $.doTemplate("FundList", portfolioFundList);
              $.doTemplate("dataID",data);
              action.constant.portfoliocode=data.portfoliocode;

              $("#titleID").html(data.portfolioname);

              action.constant.portfolioname=data.portfolioname;

              $("#pronameID").html(data.portfolioname);

              if (data.dailydecline){
                $("#dayForRoseValueID").html((parseFloat(data.dailydecline)*100).toFixed(2)+"%");//日涨幅
                if (parseFloat(data.dailydecline)<0){
                  $("#dayForRoseValueID").removeClass("m-color-pick");
                  $("#dayForRoseValueID").addClass("m-color-green");
                } else {
                  $("#dayForRoseValueID").removeClass("m-color-pick");
                  $("#dayForRoseValueID").addClass("m-color-pick");
                }
              } else {
                $("#dayForRoseValueID").html("--");
              }


              $("#riskLeveValueID").html(action.getRiskStr(data.portfoliorisklevel));//风险水平

              $("#minbalacneValueID").html($.formatNum(data.minbalacne)+"元");//起投金额


              $("#tradeInfoId").on("click",function () {//跳转交易须知
                $.platform.hsOpen("bao-rule.html?portfoliocode="+data.portfoliocode+
                    "&portfolioshowtype="+action.constant.portfolioshowtype);
              });
              // var buyhtml=document.getElementById("buyID");
              // if (data.portfoliotradestatus=="0") {
              //   buyhtml.setAttribute("m-style","style-buy");
              //   $("#buyID").html("买入");
              // }else{
              //   buyhtml.setAttribute("m-style","disabled-bottom");
              //   $("#buyID").html("暂停买入");
              // }

              $("#buyID").on('tap',function () {//买入登录判断
                window.location.href="https://a.app.qq.com/o/simple.jsp?pkgname=com.epf.hsetrading";
              });




              //调仓点击
              $("#jumpRepositoryID").on("tap",function () {
                $.platform.hsOpen("bao-warehouse-record.html?portfoliocode="+data.portfoliocode);
              });

              action.onClickTime();
              action.requestTrend(data.portfoliocode,"0");//请求走势图数据

            }else {
              $.hsf.callFailProcess(jsonResult);
            }

          });
    },
    requestTrend:function (portfoliocode,datetype) {
      $.hsf.startLoading();
      var param='datetype='+datetype+'&portfoliocode='+portfoliocode;
      $.hsf.ajax.appEncrypt("product/product/incomeRateTrend", param, "incomeRateTrend",
          function (jsonResult){
            $.hsf.stopLoading();
            if (jsonResult.successful == true) {
              var result=jsonResult.result.data;
              var dataList=result.dataList;
              if (action.constant.BDataArr.length>0){
                action.constant.BDataArr.splice(0);
              }
              if (action.constant.ZDataArr.length>0){
                action.constant.ZDataArr.splice(0);
              }
              if (action.constant.dateArr.length>0) {
                action.constant.dateArr.splice(0);
              }

              var centerNum=parseInt(dataList.length/2+"");
              for (var i = 0; i <dataList.length ; i++) {

                var data=dataList[i];
                var str = data.navdate;
                data.navdate = str = str.substr(0,4)+"-"+str.substr(4,2)+"-"+str.substr(6,2);
                action.constant.dateArr.push(data.navdate);
                var decline=(parseFloat(data.compdailydecline)*100).toFixed(2);
                action.constant.BDataArr.push(decline);

                var dailydecline=(parseFloat(data.dailydecline)*100).toFixed(2);
                action.constant.ZDataArr.push(dailydecline);
              }
              action.events();
              action.requestCommend(action.constant.portfoliocode);
            }else {

            }

          });
    },
    //讨论区数据
    requestCommend:function(portfoliocode){
      var parmas ='fundcode='+portfoliocode+'&count=1';
      $.hsf.ajax.appEncrypt("query/redbags/hotCardQuery",parmas,"hotCardQuery",function (jsonResult) {
        if (jsonResult.successful==true){
          $("#commendID").off().on("click",function () {
            var results=jsonResult.results;
            var url=results.url;
            $.platform.hsOpenOutLink(url,"false");
          });
        }
      });
    },
    //分享请求
    requestShareData:function(){
      var form=$.formGenerate();
      // @{@"functionCode":@"1047",@"originalId":@"app",@"adsGroup":@"home"};
      var g=form.add("functionCode","1047").add("originalId","app").add("adsGroup","combinationShare");

      $.hsf.ajax.app("wxzt/m",g.generate(),"wxzt",function (jsonResult) {
        if (jsonResult.successful==true){

          var message=jsonResult.message;
          var model=JSON.parse(message);
          var result=model.result;
          var data=result.list[0];

          var filename=data.filename;//分享标题
          var pic_url=data.pic_url;//分享图标
          var  url=data.url;//分享内容;

          //分享显示与隐藏

          // if ($.hsf.platform() == "platform/weixinapi"){
          //   $("#shareID").hide();
          //
          // }else if ($.hsf.platform() == "platform/pcapi") {
          //   $("#shareID").hide();
          // }else {
          //   $("#shareID").show();
          //   $("#shareID").on('tap',function () {
          //     $.platform.share(filename,pic_url,"www.baidu.com",url);
          //   });
          // }

        }
      });
    },
    //业绩走势近1月 近3月 近6月。。。。
    onClickTime :function(){
      $("#monthFor1ID").on("click",function () {
        action.requestTrend(action.constant.portfoliocode,"0")
      });
      $("#monthFor2ID").on("click",function () {
        action.requestTrend(action.constant.portfoliocode,"1")
      });
      $("#monthFor3ID").on("click",function () {
        action.requestTrend(action.constant.portfoliocode,"2")
      });
      $("#monthFor4ID").on("click",function () {
        action.requestTrend(action.constant.portfoliocode,"3")
      });
      $("#monthFor5ID").on("click",function () {
        action.requestTrend(action.constant.portfoliocode,"4")
      });
    },
    getRiskStr:function (portfoliorisklevel) {

      portfoliorisklevel=portfoliorisklevel.substr(1,1);//组合风险等级
      if (portfoliorisklevel == "1") {
        return "低风险";
      }
      else if (portfoliorisklevel == "2") {
        return "中低风险";
      }
      else if (portfoliorisklevel == "3") {
        return  "中风险";
      }
      else if (portfoliorisklevel == "4") {
        return  "中高风险";
      }
      else if (portfoliorisklevel == "5") {
        return "高风险";
      }
      else {
        return "低风险";
      }
    }

  } ;
  return action;
});
