/**
 * Created by apple on 15/6/23.
 */

define(['echart'],function(echart){
  var action = {
    constant : {
      data:null,
      earnValue1:null,
      earnValue2:null
    },
    init : function(){

      action.initData();
    },
    events : function () {
      var optionpie = {
        tooltip: {
          trigger: 'item',
          formatter: "{a} <br/>{b}: {d}%"
        },
        legend: {
          data:[]
        },
        series: [
          {
            name:'资产配置比例',
            type:'pie',
            radius: ['50%', '70%'],
            labelLine:{
              normal:{
                length:15
              }
            },
            label: {
              normal: {
                formatter: '{d}%\n {b}',
                textStyle: {
                  color: '#4d4d4d',
                  fontSize:12
                },
              }
            },
            data:[
              {value:action.constant.earnValue1, name:'权益',itemStyle:{
                normal:{
                  color: new echart.graphic.LinearGradient(1, 0, 0, 0, [{
                    //颜色渐变函数 前四个参数分别表示四个位置依次为左、下、右、上
                    offset: 0,
                    color: '#0038ff'
                  }, {
                    offset: 1,
                    color: '#009dff'
                  }])
                }
              }},
              {value:action.constant.earnValue2, name:'固收',itemStyle:{
                normal:{
                  color: new echart.graphic.LinearGradient(0, 1,1, 1, [{
                    //颜色渐变函数 前四个参数分别表示四个位置依次为左、下、右、上
                    offset: 0,
                    color: '#ff3a5d'
                  }, {
                    offset: 1,
                    color: '#ff6b4d'
                  }])
                }
              }}
            ]
          }
        ]
      };
      //初始化echarts实例
      var myChartpie = echart.init(document.getElementById('chartpie'));

      //使用制定的配置项和数据显示图表
      myChartpie.setOption(optionpie);
    },
    initData:function () {
      $.platform.getCache("BAO_REPOSITORT_RECODE_INFO",function (infoData) {
        action.constant.data=infoData;
        var data=action.constant.data;

        if (data.specification.length>150){
          //有详情显示
          var showText=data.specification.substr(0,150);
          $("#recordReasonID").html(showText+"...");
          $("#showOrHideID").html("详情");

        } else {
          //无详情显示
          $("#recordReasonID").html(data.specification);
          $("#showOrHideID").hide();
        }


        $("#showOrHideID").on('tap',function () {
          if ($("#showOrHideID").html()=="详情"){
            $("#showOrHideID").html("收起");
            $("#recordReasonID").html(data.specification);
          } else {
            $("#showOrHideID").html("详情");
            var showText=data.specification.substr(0,150);
            $("#recordReasonID").html(showText+"...");
          }
        });


        var  earnValue2=0;
         var  earnValue1=0;
        var detailList=data.detailList;

        for (var i = 0; i < detailList.length; i++) {
          var detailData=detailList[i];
          if (detailData.adjustmentratiobefore==detailData.adjustmentratioafter) {
            detailData.changeState="balance";
          }else if(detailData.adjustmentratiobefore>detailData.adjustmentratioafter){
            detailData.changeState="down";
          }else{
            detailData.changeState="up";
          }
          if (detailData.fundtype=="2"||detailData.fundtype=="1"){
            earnValue2=earnValue2 +parseFloat(detailData.adjustmentratioafter)*100;
          }else{
            earnValue1=+parseFloat(detailData.adjustmentratioafter)*100+earnValue1;
          }
          detailData.adjustmentratiobefore=action.toDecimal2((parseFloat(detailData.adjustmentratiobefore)*100).toString())+"%";
          detailData.adjustmentratioafter=action.toDecimal2((parseFloat(detailData.adjustmentratioafter)*100).toString())+"%";
        }
        action.constant.earnValue2=earnValue2.toFixed(2);
        action.constant.earnValue1=earnValue1.toFixed(2);

        action.events();
        $.doTemplate("detailListID",detailList);

      });
    },
    toDecimal2:function(x) {
      var f = parseFloat(x);
      if (isNaN(f)) {
        return "";
      }
      var f = Math.round(x*100)/100;
      var s = f.toString();
      var rs = s.indexOf('.');
      if (rs < 0) {
        rs = s.length;
        s += '.';
      }
      while (s.length <= rs + 2) {
        s += '0';
      }
      return s;
    }
  };

  return action;
});
