/**
 * Created by apple on 15/6/23.
 * jiangsl
 */

define([],function(){
   var action = {
       portfoliocode : $.hsf.hsTools.getParam("portfoliocode"),//组合代码
       portfolioshowtype : $.hsf.hsTools.getParam("portfolioshowtype"),//组合类型
       transactionaccountid : $.hsf.hsTools.getParam("transactionaccountid"),//交易账号
       userRisk : "",//用户风险等级
       portfoliorisklevel : "05",//组合风险等级
       redeemforceflag : 0,//惩罚性费率强制赎回标志：强制传1、否则传0
       buyflag : 0,//强制购买标志：风险匹配传0、强制传1
       ipw : 0,//密码输入个数，等于6的时候自动提交
       init : function(){
           action.events();
           action.getZuheFunds();
       },
       events : function () {
           //调仓按钮
           $(".sure-btn").on("tap",function(){
               $.UIComfirm({html: "确认调仓后不能撤销，是否继续？", submitText: "继续操作", cancelText: "取消"}, function (result) {
                   if (result == "yes") {
                       setTimeout(function () {
                           action.punishFeeCheck();
                       },500);

                   }
               });
           });
           //忘记密码
           $(".forget-psd").bind("tap",function(){
               $.platform.hsOpenForgetpassword();
           });
           //关闭密码浮层
           $(".psd_close").click(function(){
               $(".psd_box").hide();
               action.clearPw();
           });
           //密码阴影显示/隐藏
           $(".xiaq_tb").click(function(){
               $(".numb_box").slideUp(500);
           });
           $(".mm_box").click(function(){
               $(".numb_box").slideDown(500);
           });
           //密码键盘事件
           $(".nub_ggg li .zf_num").on('touchstart',function(){
               if(action.ipw<6){
                   $(".mm_box li").eq(action.ipw).addClass("mmdd");
                   $(".mm_box li").eq(action.ipw).attr("data",$(this).text());
                   action.ipw++;
                   if (action.ipw==6) {
                       setTimeout(function(){
                           var data = "";
                           $(".mm_box li").each(function(){
                               data += $(this).attr("data");
                           });
                           /*$(".psd-hold").hide();
                            $(".psd-no").show();*/
                           action.adjust(data);//执行调仓
                       },100);
                   }
               }
           });
           $(".nub_ggg li .zf_del").on('touchstart',function(){
               if(action.ipw>0){
                   action.ipw--;
                   $(".mm_box li").eq(action.ipw).removeClass("mmdd");
                   $(".mm_box li").eq(action.ipw).attr("data","");
               }
           });
           $(".nub_ggg li .zf_empty").click(function(){
               action.clearPw();
           });
       },
       //清空密码
       clearPw : function(){
           $(".mm_box li").removeClass("mmdd");
           $(".mm_box li").attr("data","");
           action.ipw = 0;
       },
       //惩罚性费率检查
       punishFeeCheck : function(){
           $.hsf.startLoading();
           var data = $.formGenerate()
               .add("portfoliocode", action.portfoliocode)
               .add("transactionaccountid",action.transactionaccountid);
           $.hsf.ajax.appEncrypt("trade/combportfolio/punishFeeCheck", data.generate(), "punishFeeCheckCallback", function(jsonResult) {
               $.hsf.stopLoading();
               if (jsonResult.successful) {
                   if(jsonResult.result.data.punishflag=="1"){
                       $.UIComfirm({html: "7天内调仓可能收取1.5%的转换费用，是否继续？", submitText: "继续操作", cancelText: "取消"}, function (result) {
                           if (result == "yes") {
                               action.redeemforceflag = 1;
                               setTimeout(function () {
                                   action.checkRisk();
                               },500);

                           }
                       });
                   }else{
                       action.checkRisk();
                   }
               } else {
                   $.hsf.callFailProcess(jsonResult);
               }
           });
       },
       //检查适当性
       checkRisk : function(){
           //调原生获取用户风险等级
           $.platform.getAppUserInfo(function (ob) {
               if(!!ob){
                   action.userRisk = ob.custrisk;
               }

               if (action.userRisk=="" || action.userRisk=="1") {
                   $.UIComfirm({html: "该产品的风险等级超出您的风险承受能力，目前暂无法买入，请确认您的风险承受能力", submitText: "我的风险等级", cancelText: "取消"}, function (result) {
                       if (result == "yes") {
                           //跳转原生查看风险等级
                           $.platform.hsOpenRisk();
                       }
                   });
                   return false;
               } else if (parseInt(action.portfoliorisklevel) > parseInt(action.userRisk)||action.portfoliorisklevel=="5") {
                   $.UIComfirm({html: "该产品的风险等级超出您的风险承受能力，如继续操作，视为您自愿承担该产品风险，是否继续？", submitText: "继续操作", cancelText: "取消"}, function (result) {
                       if (result == "yes") {
                           action.buyflag = 1;
                           $(".psd_box").show();//显示密码层
                       }
                   });
                   return false;
               }else{
                   action.buyflag = 0;
                   $(".psd_box").show();//显示密码层
               }
           });

       },
       //执行调仓
       adjust : function(pw){
           $.hsf.startLoading();
           var data = $.formGenerate()
               .add("tradepassword", pw)
               .add("portfoliocode", action.portfoliocode)
               .add("transactionaccountid",action.transactionaccountid)
               .add("redeemforceflag",action.redeemforceflag)//惩罚性费率强制赎回标志：强制传1、否则传0
               .add("buyflag",action.buyflag)//强制购买标志：风险匹配传0、强制传1
               .add("highriskwarnflag",1)//高风险产品风险揭示书签署标志：0未签署、1已签署
               .add("riskwarnflag",1);//普通投资者阅读风险警示标志：0未签署、1已签署
           $.hsf.ajax.appEncrypt("trade/combportfolio/adjust", data.generate(), "adjustCallback", function(jsonResult) {
               $.hsf.stopLoading();
               action.clearPw();//清空密码
               if (jsonResult.successful) {
                   $(".psd_box").hide();//隐藏密码层
                   $.UIAlert({html: "申请调仓成功！预计"+$.hsf.hsTools.dateToch2(jsonResult.result.data.transactioncfmdate)+"确认调仓结果，您可在交易记录里查询调仓详情", buttonText: "我知道了"}, function () {
                       $.hsf.hsBack();
                   });
               } else {
                   $.hsf.callFailProcess(jsonResult);
               }
           });
       },
       //获取组合信息
       getZuheFunds : function() {
           var that = this;
           $.hsf.startLoading();
           var data = $.formGenerate()
               .add("portfoliocode", action.portfoliocode)//组合代码, 不传查全部
               .add("portfolioshowtype", action.portfolioshowtype);
           $.hsf.ajax.appEncrypt("product/product/combPortfolioInfo", data.generate(), "combPortfolioInfoCallback", function(jsonResult) {
               $.hsf.stopLoading();
               if (jsonResult.successful) {
                   var dataList = jsonResult.result.data.dataList;
                   if(dataList.length>0) {
                       $("#backimageID").attr("src",dataList[0].adjustmenturl);
                       // $("#wpageFrame").attr("src",dataList[0].adjustmenturl).height(document.documentElement.clientHeight);
                       var portfoliorisklevel=dataList[0].portfoliorisklevel;

                       action.portfoliorisklevel = portfoliorisklevel.substr(1,1);//组合风险等级;

                       //调原生获取用户风险等级
                       $.platform.getAppUserInfo(function (ob) {
                           if(!!ob){
                               action.userRisk = ob.custrisk;
                               if (ob.custrisk==""){
                                   action.userRisk="1";
                               }
                           }
                           if (parseInt(action.portfoliorisklevel) > parseInt(action.userRisk)) {
                               setTimeout(function () {
                                   $.UIComfirm({html: "该产品的风险等级超出您的风险承受能力，如继续操作，视为您自愿承担该产品风险", submitText: "继续操作", cancelText: "取消"},function(result){
                                       if (result == "yes") {
                                       }else {
                                           $.platform.hsBack();
                                       }
                                   });

                               },500);

                           }
                       });


                   }
               } else {
                   $.hsf.callFailProcess(jsonResult);
               }
           });
       }
   } ;
    return action;
});
