define('pages/bind-mobile-unbind', function() {
	return Backbone.View.extend({
		el: "#bind-mobile-unbind",
		$verifyCode: $("#unbind-verifyCode"),
		_private: {},
		validForm: $.validForm(),
		succ : false,
		initialize: function(parent, platformApi) {
			this.parent = parent;
            this.platformApi = platformApi;
            this.parent.changeTitle("解绑手机号");
			this.sandclock = $.sandclock("unbind-send-code");
			this.validForm = $.validForm();
			this.form = $.formGenerate();
			this.init();
			$.checkNullGroup([this.$verifyCode], $("#unbindBtn"));
		},
		init: function() {
			$("#unbind-mobile").html($.hsf.hsTools.maskMobile(this.parent.getParam("mobileBinded")));
		},
		afterSwitchView: function() {
			this.sandclock.reset();
		},
		sendAuthCode: function(event) {
			if (this.sandclock.readyStart()) {
				$.hsf.startLoading();
				var mobile = this.parent.getParam("mobileBinded");
				var that = this;
				$.hsf.ajax.app("account/mobile/sendMobileAuthcode", "mobileno=" + mobile + "&sendintent=bindmobile", "sendMobileAuthcodeCallback", function(jsonResult) {
					$.hsf.stopLoading();
					if (jsonResult.successful) {
						that._private.verifyCode = jsonResult.result;
						that.$el.find(".unbind-mobileFix").html($.hsf.hsTools.maskMobile(mobile));
						that.$el.find(".unbind-send-msg-notice").show();
						that.sandclock.start();
					} else {
						$.hsf.callFailProcess(jsonResult)
					}
				});
			} else {
				$.hsf.stopLoading();
			}
			return false;
		},
		nextBeforeCode: function() {
			var that = this;
			var mobile = this.parent.getParam("mobileBinded");
			var verifyCode = this.$verifyCode.UITextField("value");
			this.validForm.add("mobile", mobile);
			this.validForm.add("verifyCode", verifyCode, "验证码");
			if (!this._private.verifyCode) {
				$.UIPopup("请先进行短信验证");
				return false;
			}
			if (this.validForm.valid()) {
				var data = "mobileno=" + mobile + "&sno=" + this._private.verifyCode.sno + "&chkmsg=" + verifyCode + "&operdate=" + this._private.verifyCode.operdate
				$.hsf.startLoading();
				$.hsf.ajax.app("account/mobile/verifyMobileAuthcode", data, "sendMobileAuthcodeCallback", function(jsonResult) {
					$.hsf.stopLoading();
					if (jsonResult.successful) {
						that.parent.setParam("mobile", mobile);
						that.unbindMobile(mobile);
					} else {
						$.hsf.callFailProcess(jsonResult);
					}
				});
			}
		},
		unbindMobile : function(mobile) {
			if (this.succ) {
				window.location.hash = "bind-mobile-1";
			} else {
				var that = this;
				var g = $.formGenerate().add("mobileno", this.parent.getParam("mobileBinded")).add("opertype", "1");
				$.hsf.ajax.app("account/mobile/mobileBindModify", g.generate(), "sendMobileAuthcodeCallback", function(jsonResult2) {
					$.hsf.stopLoading();
					if (jsonResult2.successful) {
						that.succ = true;
                        that.platformApi.triggerRefresh && that.platformApi.triggerRefresh();
						window.location.hash = "bind-mobile-1";
					} else {
						$.hsf.callFailProcess(jsonResult2);
					}
				});
			}
		},
		events: {
			"tap #unbindBtn[m-state!='disabled']": "nextBeforeCode",
			"tap #unbind-send-code": "sendAuthCode"
		}
	});
});
define('pages/bind-mobile-1', function() {
	return Backbone.View.extend({
		el: "#bind-mobile-1",
		$mobile: $("#mobile"),
		$verifyCode: $("#verifyCode"),
		_private: {},
		validForm: $.validForm(),
		initialize: function(parent,platformApi) {
			this.parent = parent;
            this.platformApi = platformApi;
            this.parent.changeTitle("绑定手机号");
			this.sandclock = $.sandclock("send-code");
			this.validForm = $.validForm();
			this.form = $.formGenerate();
			this.init();
			$.checkNullGroup([this.$verifyCode, this.$mobile], $("#verifyBankCodeNextBtn"));
		},
		init: function() {
		},
		afterSwitchView: function() {},
		sendAuthCode: function(event) {
			var mobile = this.$mobile.UITextField("value");
			var that = this;
			$.hsf.startLoading();
			$.hsf.ajax.app("account/mobile/queryBindMobile", "mobileno=" + mobile, "sendMobileAuthcodeCallback", function(jsonResult) {
				$.hsf.stopLoading();
				if (jsonResult.result.mobileno == "") {
					if (that.sandclock.readyStart()) {
						var mobile = that.$mobile.UITextField("value");
						that.validForm.add("mobile", mobile);
						if (that.validForm.valid()) {
							$.hsf.startLoading();
							$.hsf.ajax.app("account/mobile/sendMobileAuthcode", "mobileno=" + mobile + "&sendintent=bindmobile", "sendMobileAuthcodeCallback", function(jsonResult) {
								$.hsf.stopLoading();
								if (jsonResult.successful) {
									that._private.verifyCode = jsonResult.result;
									that.$el.find(".mobileFix").html(mobile.substr(0, 3) + "****" + mobile.substr(7, 4));
									that.$el.find(".send-msg-notice").show();
									that.sandclock.start();
								} else {
									$.hsf.callFailProcess(jsonResult)
								}
							});
						}
					}
				} else {
					$.UIPopup(jsonResult.result.mobileno+"已被绑定");
				}
			});
			return false;
		},
		nextBeforeCode: function() {
			var that = this;
			var mobile = this.$mobile.UITextField("value");
			var verifyCode = this.$verifyCode.UITextField("value");
			this.validForm.add("mobile", mobile);
			this.validForm.add("verifyCode", verifyCode, "验证码");
			if (!this._private.verifyCode) {
				$.UIPopup("请先进行短信验证");
				return false;
			}
			if (this.validForm.valid()) {
				var data = "mobileno=" + mobile + "&sno=" + this._private.verifyCode.sno + "&chkmsg=" + verifyCode + "&operdate=" + this._private.verifyCode.operdate
				$.hsf.startLoading();
				$.hsf.ajax.app("account/mobile/verifyMobileAuthcode", data, "sendMobileAuthcodeCallback", function(jsonResult) {
					$.hsf.stopLoading();
					if (jsonResult.successful) {
						that.parent.setParam("mobile", mobile);
						that.bindMobile(mobile);
					} else {
						$.hsf.callFailProcess(jsonResult);
					}
				});
			}
		},
		bindMobile : function(mobile) {
			var that = this;
			var g = $.formGenerate().add("mobileno", mobile).add("opertype", "0");
			$.hsf.ajax.app("account/mobile/mobileBindModify", g.generate(), "sendMobileAuthcodeCallback", function(jsonResult) {
				$.hsf.stopLoading();
				if (jsonResult.successful) {
					$.UIAlert(mobile+"绑定成功", function() {
                        that.platformApi.triggerRefresh && that.platformApi.triggerRefresh();
						that.parent.finish();
					});
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		events: {
			"tap #verifyBankCodeNextBtn[m-state!='disabled']": "nextBeforeCode",
			"tap #send-code": "sendAuthCode"
		}
	});
});

define('pages/bind-mobile', function() {
	$.hsf.startLoading();
	$.hsf.ajax.app("account/mobile/queryBindMobile", "", "sendMobileAuthcodeCallback", function(jsonResult) {
		$.hsf.stopLoading();
		if (jsonResult.result.mobileno != "") {
			return $.bone('bind-mobile-unbind', {param : {mobileBinded: jsonResult.result.mobileno}});
		} else {
			return $.bone('bind-mobile-1');
		}
	});
	return {init: function(){}};
});