define([$.hsf.platform()], function(platform) {
	var platformApi = $.hsf.getModuleAPI(platform, "chinapay-view");
	var action = {
		constant : {
		},
		init : function(url) {
			action.initFrame(url);
			action.events();
		},
		initFrame :function(param) {
			action.constant = param;
			$("#chinapayFrame").attr("src", action.constant.url).height(document.documentElement.clientHeight);
		},
		destroy : function() {
			$("div[m-role='page']").not("#chinapay").show();
			setTimeout(function() {
				$("#chinapay").bind("webkitAnimationEnd.popdown", function() {
					$("#chinapay").remove();
				})
				.removeClass("pop-up")
				.addClass("pop-down");
           }, 200);
		},
		events : function() {
			var postMessageProcess = function(e) {console.log(e);
				if (e.origin== ($.hsf.origin || $.hsf.appBaseUrl.substring(0,$.hsf.appBaseUrl.length-11))) {
					if (e.data.respCode == "1001") {
						action.checkChinapay();
						window.removeEventListener("message", postMessageProcess);
						return false;
					}	
				}
				$.UIAlert("认证错误,请重试", function() {
					action.destroy();
				});
				return false;
			};
			window.addEventListener('message', postMessageProcess, false);
			$("#chinapay-backBtn").bind("tap", function() {
				$.UIConfirm({"html":"如果您已验证完成，请点击下方的'返回商户'<br/> 继续则重新验证","submitText":"重新验证","submitStyle":"style-2","cancelText":"取消","cancelStyle":"style-9"},function(result){
					if(result == "yes") {
						action.destroy();
					}
				});
				return false;
			});
			$("#chinapay").bind("webkitAnimationEnd.popup", function() {
				$("div[m-role='page']").not("#chinapay").hide();
				$(this).unbind("webkitAnimationEnd.popup");
			});
		},
		checkChinapay : function() {
			$.hsf.startLoading();
			var data = "accoreqserial="+action.constant.accoreqserial
						+"&identitytypebank="+action.constant.identitytype+"&identitynobank="+action.constant.identityno
						+"&custname="+action.constant.customername+"&busitype=OPENACCO";
			$.hsf.ajax.app("capital/chinapay/openaccoRsQuery", data, "doChinapayOpenaccoOrderCallback", function(jsonResult) {
				$.hsf.stopLoading();
				if(jsonResult.successful ) {
					if (jsonResult.state == "01") {
						$.hsf.Event.trigger("chinapaySucc", function() {
							action.destroy();
						}, jsonResult);
					} else {
						$.UIAlert("验证失败,请重新验证", function() {
							action.destroy();
						});	
					}
				} else if(jsonResult.code = "ETS-5BA00015") {
					$.UIPopup("验证正处理,请稍候点击'验证完成'", function() {
						
					})
				} else {
					$.hsf.callFailProcess();
				}
			});
		}
	}
	return action;
});

