define(["flot", "flot_pie"],function(){
    var action = {
    	constant : {
    		fundcode : $.hsf.hsTools.getParam("fundcode"),
    		fundtype : $.hsf.hsTools.getParam("fundtype")
    	},
		init: function() {
		    if(action.constant.fundtype=="2"){
		        $("#title").html("十大债券持仓");
		    }else{
                $("#title").html("五大债券持仓");
		    }

			action.accordion();
			action.loadAssetItem();
			action.loadIndustryItem();
			action.loadStockItem();
			action.loadDebtItem();
        },
        accordion:function(){
            $(".ui-accordion").UIAccordion({
                type:1,     //折叠方式 1：展开自己内容时，同级内容收起。0：展开自己内容时，同级内容不受影响。
                expandId:1 //-1:默认都不展开；0：默认都展开；1：表示默认展开的第一个板块，第二板块为"2"，依此类推。
            });
        },
        loadAssetItem : function() {
			$.hsf.startLoading();
        	return $.hsf.ajax.appEncrypt("product/product/queryAssetitem", "fundcode="+action.constant.fundcode, "queryAssetitemCallback", function(jsonResult) {
        		if (jsonResult.successful) {
        			var data = [];
        			var color = ["#ff6000", "#6a93eb", "#ffc000","yellow", "limegreen", "mediumseagreen", "firebrick","cornflowerblue","chocolate", "coral"];
        			var i = 0;
        			if (jsonResult.result.data.length >0) {
						$("#enddata").html("数据更新时间："+jsonResult.result.data[0].enddate);
        				jsonResult.result.data.sort(function(i,j) {
        					return parseInt(i.percent) > parseInt(j.percent) ? -1: 1;
        				})
	        			jsonResult.result.data.forEach(function(obj) {
	        				if (obj.assetsitemsname == "合计") return;
	        				data.push({"data" : parseFloat(obj.percent), "color": color[i++], "info": obj});
	        			});
	        			var placeholder= $.plot('#asset-placeholder', data, {
						    series: {
						        pie: {
						            show: true,
						            innerRadius: 0.5,
						            label : {
							        	show : false
							        },
							        stroke : {
								    	width :0
							        }
						        }
						    },
						    legend: {
				               show :  false
						    }
						});
						$.doTemplate("asset-template", placeholder.getData());
						$.doTemplate("asset-list-template", placeholder.getData());
						$.hsf.stopLoading();
        			} else {
        				$("#asset-dashboard").html("&nbsp;&nbsp;暂无数据");
						$.hsf.stopLoading();
        			}
        		}
        	});
        },
        loadIndustryItem : function() {
			$.hsf.startLoading();
        	return $.hsf.ajax.appEncrypt("product/product/queryIndustryitems", "fundcode="+action.constant.fundcode, "queryIndustryCallback", function(jsonResult) {
        		if (jsonResult.successful) {
        			var data = [];
        			var color = ["#ff6000", "#6a93eb", "#ffc000","yellow", "limegreen", "mediumseagreen", "firebrick","cornflowerblue","chocolate", "coral"];
        			var i = 0;
        			if (jsonResult.result.data.length >0) {
        				jsonResult.result.data.sort(function(i,j) {
        					return parseInt(i.percent) > parseInt(j.percent) ? -1: 1;
	        			})
	        			jsonResult.result.data.forEach(function(obj) {
	        				if (obj.industryitemsname == "合计") return;
	        				data.push({"data" : parseFloat(obj.percent), "color": color[i++], "info": obj});
	        			});
	        			var placeholder= $.plot('#industry-placeholder', data, {
						    series: {
						        pie: {
						            show: true,
						            innerRadius: 0.5,
						            label : {
							        	show : false
							        },
							        stroke : {
								    	width :0
							        }
						        }
						    },
						    legend: {
				               show :  false
						    }
						});
						$.doTemplate("industry-template", placeholder.getData());
						//$.doTemplate("industry-list-template", placeholder.getData());
						$.hsf.stopLoading();
        			} else {
						$("#message").html("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;暂无数据");
        				$("#industry-dashboard").html("&nbsp;&nbsp;暂无数据");
        			}
					$.hsf.stopLoading();
        		}
        	});
        },
        loadStockItem : function() {
			$.hsf.startLoading();
        	return $.hsf.ajax.appEncrypt("product/product/queryStockItems", "fundcode="+action.constant.fundcode, "queryStockCallback", function(jsonResult) {
        		if (jsonResult.successful) {
					$.doTemplate("stock-template", jsonResult.result.data);
					$.hsf.stopLoading();
        		}
        	});
        },
        loadDebtItem : function() {
			$.hsf.startLoading();
        	return $.hsf.ajax.appEncrypt("product/product/queryDebtItems", "fundcode="+action.constant.fundcode, "queryDebtCallback", function(jsonResult) {
        		if (jsonResult.successful) {
					$.doTemplate("debt-template", jsonResult.result.data);
					$.hsf.stopLoading();
        		}
        	});
        }
    };
    window.action = action;
    return action;
});
