define(["global", "Backbone", "swiper", 'circliful','zepto_slider'], function(G) {
	return Backbone.View.extend({
		el: "#home",
		title: {
			left: {
				show: false
			},
			center: {
				text: "耀钱包"
			},
			border: {
				show: true
			}
		},
		_private: {},
		events: {
			"tap #loginBtn": "popLogin",
			"tap #goLoginBtn": "popLogin",
			"tap #yqb-eye" : "tapEye",
			"tap #inprofit" : "inprofit",
			"tap #avgr" : "avgr",
			"tap #moneyInfo" : "moneyInfo"
		},
		constant:{
			incomeratio:"",
			ztDict : {
				"dayinc":{key:"increase", value:"日涨跌"},
				"seasonhinc":{key:"mreturnrate3", value:"近3月收益"},
				"halfinc":{key:"mreturnrate6", value:"近6月收益"},
				"yearinc":{key:"yreturnrate1", value:"近1年收益"},
				"threeyearinc":{key:"yreturnrate3",value:"近3年收益"},
				"thisyearinc":{key:"yreturnrate", value:"今年以来收益"},
				"setupinc":{key:"returnrate", value:"成立以来收益"},
				"default" :{key:"mreturnrate3", value:"近3月收益"},
			}
		},
		initialize: function(parent, platform) {
			var that = this;
			this.parent = parent;
			this.platformApi = platform;
			$.platform.getCache("openId", function(openId) {
				that._private.openId = openId||"";
			});
			this.initBannerHeight();
			this.$el.css("min-height", document.documentElement.clientHeight-44);
			this.initBannerData();
			//请求推荐基金
			this.initRecommendFund();
			//this.isLoginOrNot();
			this.requestManager = $.hsf.requestManager(this);
			this.requestManager.add(this.initRequestForm(), 60 * 60 * 1);
			// this.initRequestForm();
			// $.hsf.Event.addListener("logout", function() {
			// 	that.initRequestForm(false);
			// }).addListener("trade", function() {
			// 	that.initRequestForm(false);
			// }).addListener("eyeChange", function(r) {
			// 	if (r.o != "home") {
			// 		that.changeEye();
			// 	}
			// }).addListener("pullRefresh", function() {
			// 	that.initRequestForm(false);
			// });
			// $.platform.getCache("assetEye", function(result) {
			// 	if (result && result.value) {
			// 		that.setEye(result.value);
			// 	} else {
			// 		that.setEye(true);
			// 	}
			// }, "local");
			this.platformApi.initPage(this);
			this.notice(); //通知中心
			// $('.single-slider-yellow').zptSlider({
			// 	from: 0,
			// 	to: 100,
			// 	step: 1,
			// 	scale: [0, 25, 50, 75, 100],
			// 	format: '%s',
			// 	width: 250,
			// 	showLabels: true,
			// 	showScale: true,
			// 	theme: 'theme-yellow'
			// });
			$('.single-slider').jRange({
				from: 0,
				to: 200000,
				// theme:'theme-blue',
				step: 10000,
				scale: [0,50000,100000,150000,200000],
				format: '%s',
				width: 300,
				showLabels: true,
				showScale: true,
				ondragend : drag,
				onbarclicked:drag,
				snap: true
			});
			function drag(result){
				console.log(result);
				$("#fundbuynum").html(result);	//转入
				$("#bankbuynum").html(result);	//银行
				var incomeratio = $("#incomeratio").html();
				var fundprofit = result*incomeratio*30/365/100;
				var bankprofit = result*(0.35)*30/365/100;
				$("#fundprofit").html(fundprofit.toFixed(2));
				$("#bankprofit").html(bankprofit.toFixed(2));
			}

			setTimeout(function () {
				// this.getLoginInfo();
				$.platform.getCache("logininfo",function (result) {
					if(result && result.riskenddate2){
						var riskenddate = result.riskenddate;	//风险过期日期
						var validDate = result.validdate;		//证件有效期
						var myDate = $.hsf.hsTools.getCurrentDay();

						if(parseFloat(myDate) > parseFloat(riskenddate)){
							$.UIConfirm("您的风险测评有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
								if (o == "yes") {
									$.hsf.hsOpen("account-info.html");
								}
							});
						}else if(parseFloat(myDate) > parseFloat(validDate)){
							$.UIConfirm("您的证件有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
								if (o == "yes") {
									$.hsf.hsOpen("account-info.html");
								}
							});
						}else {
							console.log("都没过期");
						}
					}else {
						$.hsf.ajax.app("account/account/accountinfo","","checkLoginCode",function(jsonResult) {
							if (jsonResult.successful) {
								var custtype = jsonResult.result.custtype;
								$.platform.removeCache("logininfo");
								$.platform.putCache("logininfo", jsonResult.result);
								var riskenddate = jsonResult.result.riskenddate;	//风险过期日期
								var validDate = jsonResult.result.validdate;		//证件有效期
								var myDate = $.hsf.hsTools.getCurrentDay();

								if(parseFloat(myDate) > parseFloat(riskenddate)){
									$.UIConfirm("您的风险测评有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
										if (o == "yes") {
											$.hsf.hsOpen("account-info.html");
										}
									});
								}else if(parseFloat(myDate) > parseFloat(validDate)){
									$.UIConfirm("您的证件有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
										if (o == "yes") {
											$.hsf.hsOpen("account-info.html");
										}
									});
								}else {
									console.log("都没过期");
								}
							}
						});
					}
				});
			},1000);


		},

		initRequestForm: function() {
			var that = this;
			$.hsf.startLoading();
			$.when(this.isLogin(), this.homepageForm()).done(function(r1, r2) {
				if(r1 && r1[0].isBinded == "0"){
					r2[0].isnotlogin = true;
				}
				that.initMoneyFundInfo(r2[0]);
			}).always(function() {
				$.hsf.stopLoading();
			});
		},
		initRecommendFund:function () {
			var that = this;
			$.hsf.startLoading();
			$.hsf.ajax.app("product/product/findPage","","fundCallback",function (jsonResult) {
				$.hsf.stopLoading();
				var decimal2 = $.hsf.hsTools.decimal2;
				if(jsonResult.successful){
					if(jsonResult.recommendList){
						jsonResult.recommendList.sort(function(a, b) {
							if(a.status != b.status){
								return a.status < b.status ? 1 : -1;
							}else{
								if (a.risklevel == b.risklevel) {
									return a.yreturnrate1 < b.yreturnrate1 ? 1 : -1;
								} else {
									return a.risklevel < b.risklevel ? 1 : -1;
								}
							}
						});
						for ( var j = 0; j < jsonResult.recommendList.length; j++) {
							var recd = jsonResult.recommendList[j];
							if (recd.risklevel == "01") {
								recd.risklevelStyle = 'e-blue-list';
							} else if (recd.risklevel == "02" || recd.risklevel == "03") {
								recd.risklevelStyle = 'e-yellow-list';
							} else if (recd.risklevel == "04" || recd.risklevel == "05") {
								recd.risklevelStyle = 'e-orange-list';
							}

							var rateGD = that.constant.ztDict[recd.incInterval];
							if (rateGD) {
								recd.rate = rateGD;
							} else {
								recd.rate = that.constant.ztDict["default"];
							}
							if (recd[recd.rate.key]) {
								recd[recd.rate.key] = decimal2(recd[recd.rate.key]);
								if (parseFloat(recd[recd.rate.key])>0) {
									recd.color = "fund-up"
								} else {
									recd.color = "fund-down";
								}
							} else {
								recd[recd.rate.key] = "--";
							}
							if (!recd.tags) {
								recd.tags = [];
							}
							if(recd.detailurl){
								var search = recd.detailurl.split("?")[1];
								if(search){
									var url = that.urlSplit(search);
									var data = "&fundcode="+url.fundcode + "&goflag=" + url.goflag + "&btnName=" + (url.btnName||"按钮");
									if (recd.detailurl.startsWith("local://")) {
										recd.htmlUrl = recd.detailurl.substr(8);
									} else if (recd.detailurl.startsWith("http://")) {
										recd.htmlUrl = "wpage.html?title="+url.tjTitle + data+"&src="+encodeURIComponent(recd.detailurl);
									} else if (recd.detailurl.startsWith("https://")) {
										recd.htmlUrl = "wpage.html?title="+url.tjTitle + data+"&src="+encodeURIComponent(recd.detailurl);
									}
								}else{
									if (recd.detailurl.startsWith("local://")) {
										recd.htmlUrl = recd.detailurl.substr(8);
									} else if (recd.detailurl.startsWith("http://")) {
										recd.htmlUrl = "wpage.html?title="+recd.fundname+"&src="+encodeURIComponent(recd.detailurl);
									} else if (recd.detailurl.startsWith("https://")) {
										recd.htmlUrl = "wpage.html?title="+recd.fundname+"&src="+encodeURIComponent(recd.detailurl);
									}
								}
							}else{
								if($.trim(recd.status)=="1"){
									recd.htmlUrl = "trade-buy.html?fundcode="+recd.fundcode+"&fundname="+recd.fundname;
								}else{
									recd.htmlUrl = "fund-detail.html?fundcode="+recd.fundcode;
								}
							}
						}

					}
					$.doTemplate("recommendFundTemplate", jsonResult, "refresh");
					that.productSlide();

					$.hsf.stopLoading();
				}else {
					$.hsf.callFailProcess(jsonResult);
					$.hsf.stopLoading();
				}
			});
		},
		isLogin: function() {
			if($.hsf.platform() == "platform/weixinapi"){
				return $.hsf.ajax.app("account/weixinlogin/islogin", "", "loginCallback", function(jsonResult) {});
			}
		},
		homepageForm: function(func) {
			return $.hsf.ajax.app("home/homepage/homePage", "", "homePageCallback", func || function(jsonResult) {});
		},
		isLoginOrNot : function (jsonResult, opt) {
			var that = this;
			var checkLoginNotExist = function() {
				return document.getElementById("login") == null;
			};
			var login = function() {
				if (checkLoginNotExist()) {//内外两次判断可能会优化减少一次连接
					$.hsf.ajax.html("../pages/login-view.html", function(html) {
						if (checkLoginNotExist()) {//如果login界面已经弹出则不加载
							$("body").prepend(html);
							require(["pages/login-view"], function(m) {
								m.init();
								opt && opt.disableHistoryBack && m.disableHistoryBack();
							})
						} else {
							return;
						}
					});
				}
			};
			if (jsonResult.successful) {
				if (jsonResult.isBinded == "0") {
					setTimeout(login, 100);
				}
			} else if (jsonResult.code == "APP-5BP0012") {
				$.UIAlert("您的请求的页面已过期。请返回微信", function() {
					require(["wx"], function(wx) {
						typeof wx != "undefined" && wx.closeWindow();
					})
				});
			}
			/*if ($.hsf.platform() == "platform/weixinapi") {
				$.hsf.ajax.app("account/weixinlogin/islogin", "", "loginCallback", function(jsonResult) {
					if (jsonResult.successful) {
						if (jsonResult.isBinded == "0") {
							setTimeout(login, 100);
						}
					} else if (jsonResult.code == "APP-5BP0012") {
						$.UIAlert("您的请求的页面已过期。请返回微信", function() {
							require(["wx"], function(wx) {
								typeof wx != "undefined" && wx.closeWindow();
							})
						});
					}
				});
			}*/
		},
		avgr : function(){
			this.getLoginInfo("avgr");
		},
		inprofit : function(){
			this.getLoginInfo("inprofit");
		},
		////点击耀钱包模块,如果未登录,则打开七日年化,如果登录,跳转到money.html
		moneyInfo : function () {
			this.getLoginInfo("moneyInfo");
		},
		getLoginInfo : function(info){
			$.platform.getCache("logininfo", function(result) {
				if (result && result.custtype) {
					var custtype = result.custtype;
					if(custtype == "1"){//代销用户
						$.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
							if (o == "yes") {
								$.hsf.hsOpen("account-openAcco-gdbdx.html");
							}
						});
					}else{
						if(info == "avgr"){
							$.hsf.hsOpen("trade-avgr.html?saveplanflag=d");
						}else if(info == "inprofit"){
							$.hsf.hsOpen("trade-money-in.html");
						}else if(info == "moneyInfo"){
							$.hsf.hsOpen("money.html");
						}
					}
				}else{
					$.hsf.ajax.app("account/account/accountinfo","","checkLoginCode",function(jsonResult) {
						if (jsonResult.successful) {

							var custtype = jsonResult.result.custtype;
							$.platform.removeCache("logininfo");
							$.platform.putCache("logininfo", jsonResult.result);
							if(custtype == "1"){//代销用户
								$.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
									if (o == "yes") {
										$.hsf.hsOpen("account-openAcco-gdbdx.html");
									}
								});
							}else{
								if(info == "avgr"){
									$.hsf.hsOpen("trade-avgr.html?saveplanflag=d");
								}else if(info == "inprofit"){
									$.hsf.hsOpen("trade-money-in.html");
								}else if(info == "moneyInfo"){
									$.hsf.hsOpen("money.html");
								}
							}
						}else{
							if(info == "moneyInfo"){
								$.hsf.hsOpen("xjb-qrnh.html");
							}else {
								$.hsf.callFailProcess(jsonResult);
							}
						}
					});
				}
			});
		},
		notice: function(){
			var that = this;
			var data = "functionCode=1051&originalId=app";
			$.hsf.ajax.app("wxzt/m", data, "", function(jsonResult) {
				if (jsonResult.successful) {
					if (jsonResult.message) {
						var message = jsonResult.message;
						var json = eval("(" + message + ")");
						if(json.result !='' && json.result != undefined && json.result != null){
							var content = " ";
							var fundDict = json.result.list;
							for (var index in fundDict) {
								if (fundDict[index].status == "1") { //过滤掉未发布的公告,后续中台接口需要修改成支持传参的方式
									content += fundDict[index].content + "&nbsp;";
								}
							}
							//var list = json.result.list[0];
							var leng = $.hsf.hsTools.getLength(content.trim());
							if(leng < 1){
								$(".idx-notice-box").hide();
							}else if(leng < 40 && leng>0){
								var html = "<div style='line-height:28px;color:#C4776F;' align='center'>" + content + "</div>";
								$(".idx-notice").html(html);
								$(".idx-notice-box").show();
							}else{
								var html = "<font color='#C4776F'>" + content + "</font>";
								$(".marquee").html(html);
								$(".idx-notice-box").show();
								that.marquee(15);
							}

						}
					}
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		initBannerHeight : function() {
			var height = document.documentElement.clientHeight /736 * 200;
			if (height <= 130) {
				height = 130;
			}
			$("#banner").height(height);
		},
		initBannerData : function() {
			var data = "functionCode=1047&originalId=app&adsGroup=home";
			var that = this;
			$.hsf.ajax.app("wxzt/m", data, "mCallback", function(jsonResult) {
				function loadBanner(jsonResult) {
					var json = JSON.parse(jsonResult.message);
					if (json.errorCode != "error") {
						if (json.result && json.result.list) {
							json.result.list.forEach(function(item) {
								if (item.url) {
									if(item.url.split("#").length>1){
										//console.log(that.platformApi.channel);
										if(that.platformApi.channel == "android"){
											var url = item.url.split("#")[0];
											//url.replace("{wxname}",that._private.openId);
											item.url = "wpage.html?title="+item.filename +"&src="+encodeURIComponent(url.replace("{wxname}",that._private.openId));
										}else if(that.platformApi.channel == "iphone"){
											var url = item.url.split("#")[0];
											//url.replace("{wxname}",that._private.openId);
											item.url = "wpage.html?title="+item.filename +"&src="+encodeURIComponent(url.replace("{wxname}",that._private.openId));
										}else{
											/*var url = item.url.split("#")[1];
											item.url = "wpage.html?title="+item.filename +"&src="+encodeURIComponent(url);*/
											item.url = item.url.split("#")[1];
										}
									}else{
										var search = item.url.split("?")[1];
										if(search){
											var url = that.urlSplit(search);
											var data = "&fundcode="+url.fundcode + "&goflag=" + url.goflag + "&btnName="+ (url.btnName||"按钮");
											if (item.url.startsWith("local://")) {
												item.url = item.url.substr(8);
											} else if (item.url.startsWith("http://")) {
												item.url = "wpage.html?title="+item.filename+ data+"&src="+encodeURIComponent(item.url) ;
											} else if (item.url.startsWith("https://")) {
												item.url = "wpage.html?title="+item.filename + data+"&src="+encodeURIComponent(item.url);
											}
										}else{
											if (item.url.startsWith("local://")) {
												item.url = item.url.substr(8);
											} else if (item.url.startsWith("http://")) {
												item.url = "wpage.html?title="+item.filename+"&src="+encodeURIComponent(item.url);
											} else if (item.url.startsWith("https://")) {
												item.url = "wpage.html?title="+item.filename+"&src="+encodeURIComponent(item.url);
											}
										}
									}
								}
							});
							var height = document.documentElement.clientHeight /736 * 200;
							if (height <= 130) {
								height = 130;
							}
							json.result.height = height;
							$.doTemplate("banner-template", json.result,"refresh");
							this.resetSwiper();
							$("#index-banner-pager").show();
							$.platform.putCache("banner", jsonResult);
							// this.initScroll();

						}
					}
					this.initBannerDataComplete = true;
				}
				if (jsonResult.successful) {
					loadBanner.call(that, jsonResult);
				} else {
					if (jsonResult.code == "NETWORK_ERROR") {
						var cache = $.platform.getCache("banner", function(jsonResult) {
							if (jsonResult) {
								loadBanner.call(that, jsonResult);
							} else {
								jsonResult = {"successful":true,"code":"ETS-5BP00000","message":"{\"result\":{\"list\":[{\"pic_url\":\"../images/ad1.png\"}]}}"};
								loadBanner.call(that, jsonResult);
							}
						});
					}
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		urlSplit : function(url){
			var queryObject = {};
			var pairs = url.split('&');
			for(var i in pairs) {
				var pair = pairs[i];
				var keyAndValue = pair.split('=');
				var key = keyAndValue[0];
				var value = keyAndValue[1];
				queryObject[key] = value;
			}
			return queryObject;
		},

		initMoneyFundInfo: function(jsonResult, loading) {
			var that = this;
			if (loading !== false) {
				$.hsf.startLoading();	
			}
			if(jsonResult){
				if (jsonResult.successful) {
					$.hsf.stopLoading();
					$.doTemplate("moneyfund-template", jsonResult, "refresh");
					that.initScroll();
					//显示默认滑竿选择位置的耀钱包收益和银行收益。
					var incomeratio = jsonResult.growthrate;
					var fundprofit = 100000*incomeratio*30/365/100;
					var bankprofit = 100000*(0.35)*30/365/100;
					$("#fundprofit").html(fundprofit.toFixed(2));
					$("#bankprofit").html(bankprofit.toFixed(2));
					if (loading !== false) {
						$.hsf.stopLoading();
					}
					// if (jsonResult.isnotlogin) {
						// that.notLoginProcess(jsonResult);
						// $.platform.putCache("homeNotLogin", jsonResult);
					// } else {
					// 	that.loginProcess(jsonResult);
					// }
				} else {
					if (jsonResult.code == "NETWORK_ERROR") {
						var cache = $.platform.getCache("homeNotLogin", function(jsonResult) {
							if (jsonResult) {
								// that.notLoginProcess(jsonResult);
							}
						});
					}
					$.hsf.callFailProcess(jsonResult);
				}
			}
		},
		loginProcess: function(jsonResult) {
			var t = $.hsf.hsTools;
			jsonResult.supercapital= t.decimal2(jsonResult.supercapital);
			jsonResult.dayincome= t.decimal2(jsonResult.dayincome);
			jsonResult.totalincome= t.decimal2(jsonResult.totalincome);
			// $.doTemplate("moneyfund-template", jsonResult, "refresh");
			// $("#xjb-record").show();
			// this.changeEye(this.getEye());
			// this.countUp("xjbMoney",2).start();
			// $("#xjb-nologin").hide();
		},
		afterSwitchView: function() {
			if (this.initBannerDataComplete) {
				this.resetSwiper();	
			}
		},
		initBanner: function() {
			this.swiper = new Swiper('.index-swiper', {
				autoplay: 2500,
				loop: true,
				pagination: '.swiper-pagination',
				autoplayDisableOnInteraction : false
			});
		},
		productSlide:function(){
			this.swiper2 = new Swiper('.product-slide', {
				nextButton: '.swiper-button-next',
				prevButton: '.swiper-button-prev',
				autoplay:2500,
				loop:false
			});
		},
		resetSwiper: function() {
			if (!this.swiper) {
				this.initBanner();
			} else {
				this.swiper && (function(swiper) {
					swiper.destroy && swiper.destroy(false);
					swiper = null;
					swiper = new Swiper('.index-swiper', {
						autoplay: 2500,
						loop: true,
						pagination: '.swiper-pagination'
					});
				})(this.swiper);
			}

			if (!this.swiper2) {
				this.productSlide();
			} else {
				this.swiper2 && (function(swiper) {
					swiper = null;
					swiper = new Swiper('.product-slide', {
						nextButton: '.swiper-button-next',
						prevButton: '.swiper-button-prev',
						autoplay:2500,
						loop:true
					});
				})(this.swiper2);
			}
		},
		initScroll : function() {
			$(".pullDown").show();
			var date = $.hsf.hsTools.getNowFormatDate();
			$("#refreshTip").html("下拉刷新..."+date);
			var $s = $("#swiperArea");
			var that = this;
			if (this.myScroll) {
				this.myScroll.enable();
				this.myScroll.refresh();
				this.myScroll.scrollTo(0,0,100);
			} else {
				this.renderAreaHeight = $("#renderArea").height();
				if (this.renderAreaHeight == 0) return;
				var scrollTop = this.renderAreaHeight+44-40;
				$("#scroll2").css("top", scrollTop+"px");
				$s.css({"min-height": document.documentElement.clientHeight- 44-scrollTop});
				window.myScroll = this.myScroll = new IScroll("#scroll2", {probeType:1});
				this.myScroll.on('scroll', function() {
					if (parseFloat(this.y) > 45) {
						that.myScroll.refreshFlag = true;
						$(".pullDown").addClass("flip");
						var date = $.hsf.hsTools.getNowFormatDate();
						$("#refreshTip").html("释放刷新"+date);
					};
				});
				$("#scroll2").bind("touchmove", function (event) {
					event.preventDefault();
				});
				$("#scroll2").bind("touchend", function (event) {
					if (that.myScroll.refreshFlag) {
						var x = function() {
							setTimeout(function() {
								var scrollY = parseFloat($s.css("transform").split(", ")[5]);
								if (scrollY <= 45 && that.myScroll.disable) {
									$(".pullDown").removeClass("flip").addClass("loading");
									var date = $.hsf.hsTools.getNowFormatDate();
									$("#refreshTip").html("正在刷新..."+date);
									$s.css({"webkitTransform":'translate( 0px,' + (scrollY) + 'px) translateZ(0) '});
									that.initAsset(false);
									that.initMoneyFundInfo();
									that.applyPackForm();
									that.myScroll.refreshFlag = false;
									$.hsf.Event.muteTrigger("pullRefresh");
								} else {
									x();
								}
							}, 10);
						};
						x();
					}
				});
			}
		},
		roundUp: function(roundElem) {
			var requestAnimationFrame = function() {
				var lastTime = 0;
				return function(callback, element) {
					var currTime = new Date().getTime();
					var timeToCall = Math.max(0, 16 - (currTime - lastTime));
					var id = window.setTimeout(function() {
							callback(currTime + timeToCall);
						},
						timeToCall);
					lastTime = currTime + timeToCall;
					return id;
				};
			}();
			$('#'+roundElem).circliful({
				requestAnimationFrame: requestAnimationFrame
			});
		},
		marquee:function(dur,delay){

			var delay=delay||100;
			var dur=dur||5;//play time
			var marquee=$(".marquee"),width=marquee.children().length?marquee.children().outerWidth():marquee.outerWidth(),parentWidth=$(".idx-notice-box").outerWidth();

			var head=$("head");
			var style="<style>.marquee-animate{-webkit-animation: rollTxt "+dur+"s linear infinite ;animation: rollTxt "+dur+"s linear infinite ;}  @-webkit-keyframes rollTxt {0% {-webkit-transform: translate3d("+parentWidth+"px,0,0);} 100% {-webkit-transform: translate3d(-"+width+"px,0,0);}}</style>";
			head.append(style);

			marquee.addClass('marquee-animate')
		},
		countUp : function(countElem, decimal) {
			var requestAnimationFrame = function() {
				var lastTime = 0;
				return function(callback, element) {
					var currTime = new Date().getTime();
					var timeToCall = Math.max(0, 16 - (currTime - lastTime));
					var id = window.setTimeout(function() {
							callback(currTime + timeToCall);
						},
						timeToCall);
					lastTime = currTime + timeToCall;
					return id;
				};
			}();
			var countUp = function(target, startVal, endVal, decimals, duration, options) {
				// default options
				this.options = options || {
					useEasing: true, // toggle easing
					useGrouping: true, // 1,000,000 vs 1000000
					separator: ',', // character to use as a separator
					decimal: '.' // character to use as a decimal
				}
				window.cancelAnimationFrame = function(id) {
					clearTimeout(id);
				}
				if (this.options.separator == '') this.options.useGrouping = false;
				if (this.options.prefix == null) this.options.prefix = '';
				if (this.options.suffix == null) this.options.suffix = '';

				var self = this;

				this.d = (typeof target === 'string') ? document.getElementById(target) : target;
				this.startVal = Number(startVal);
				this.endVal = Number(endVal);
				this.countDown = (this.startVal > this.endVal) ? true : false;
				this.startTime = null;
				this.timestamp = null;
				this.remaining = null;
				this.frameVal = this.startVal;
				this.rAF = null;
				this.decimals = Math.max(0, decimals || 0);
				this.dec = Math.pow(10, this.decimals);
				this.duration = duration * 1000 || 2000;

				this.printValue = function(value) {
					var result = (!isNaN(value)) ? self.formatNumber(value) : '--';
					if (self.d.tagName == 'INPUT') {
						this.d.value = result;
					} else if (self.d.tagName == 'text') {
						this.d.textContent = result;
					} else {
						this.d.innerHTML = result;
					}
				}

				// Robert Penner's easeOutExpo
				this.easeOutExpo = function(t, b, c, d) {
					return c * (-Math.pow(2, -10 * t / d) + 1) * 1024 / 1023 + b;
				}
				this.count = function(timestamp) {
					if (self.startTime === null) self.startTime = timestamp;
					self.timestamp = timestamp;
					var progress = timestamp - self.startTime;
					self.remaining = self.duration - progress;
					// to ease or not to ease
					if (self.options.useEasing) {
						if (self.countDown) {
							var i = self.easeOutExpo(progress, 0, self.startVal - self.endVal, self.duration);
							self.frameVal = self.startVal - i;
						} else {
							self.frameVal = self.easeOutExpo(progress, self.startVal, self.endVal - self.startVal, self.duration);
						}
					} else {
						if (self.countDown) {
							var i = (self.startVal - self.endVal) * (progress / self.duration);
							self.frameVal = self.startVal - i;
						} else {
							self.frameVal = self.startVal + (self.endVal - self.startVal) * (progress / self.duration);
						}
					}
					// don't go past endVal since progress can exceed duration in the last frame
					if (self.countDown) {
						self.frameVal = (self.frameVal < self.endVal) ? self.endVal : self.frameVal;
					} else {
						self.frameVal = (self.frameVal > self.endVal) ? self.endVal : self.frameVal;
					}
					// decimal
					self.frameVal = Math.round(self.frameVal * self.dec) / self.dec;
					// format and print value
					self.printValue(self.frameVal);
					// whether to continue
					if (progress < self.duration) {
						self.rAF = requestAnimationFrame(self.count);
					} else {
						if (self.callback != null) self.callback();
					}
				}
				this.start = function(callback) {
					self.callback = callback;
					// make sure values are valid
					if (!isNaN(self.endVal) && !isNaN(self.startVal)) {
						self.rAF = requestAnimationFrame(self.count);
					} else {
						console.log('countUp error: startVal or endVal is not a number');
						self.printValue();
					}
					return false;
				}
				this.stop = function() {
					cancelAnimationFrame(self.rAF);
				}
				this.reset = function() {
					self.startTime = null;
					self.startVal = startVal;
					cancelAnimationFrame(self.rAF);
					self.printValue(self.startVal);
				}
				this.resume = function() {
					self.stop();
					self.startTime = null;
					self.duration = self.remaining;
					self.startVal = self.frameVal;
					requestAnimationFrame(self.count);
				}
				this.formatNumber = function(nStr) {
					nStr = nStr.toFixed(self.decimals);
					nStr += '';
					var x, x1, x2, rgx;
					x = nStr.split('.');
					x1 = x[0];
					x2 = x.length > 1 ? self.options.decimal + x[1] : '';
					rgx = /(\d+)(\d{3})/;
					if (self.options.useGrouping) {
						while (rgx.test(x1)) {
							x1 = x1.replace(rgx, '$1' + self.options.separator + '$2');
						}
					}
					return self.options.prefix + x1 + x2 + self.options.suffix;
				}
					// format startVal on initialization
				self.printValue(self.startVal);
			};
			var sevenValue = $("#"+countElem);
			var endValue = sevenValue.attr('m-change-value');
			var csv = new countUp(sevenValue[0], 0, endValue, decimal, .5);
			return csv;//csv.start();
		}
	});
});