define([$.hsf.platform()], function(platform) {
	var moduleapi = platform.api["login-view"];
	moduleapi["loginSuccess"] = function() {
		$.UIAlert("绑定成功", function() {
			$.hsf.hsOpen("index.html");
		});
	}
	$.platform = $.extend(moduleapi, platform.baseapi);
	var action = {
		init : function() {
			this.isLoginOrNot();
			$.platform.initPage && $.platform.initPage();
			this.events();
		},
		events : function() {
			$("#loginButton").bind("tap", function() {
				action.checkLoginCode();
				return false;
			});
			
			$("#accountNo").on("click",function(){
				var certificate = "";
				var accountNoHidden = $("#accountNoHidden").val();
				var accountInput = $("#accountNo").UITextField("value");
				if (accountNoHidden && accountNoHidden != "" && accountInput.indexOf("****") > 0) {
					certificate = accountNoHidden;
				} else {
					certificate = accountInput;
				};
				$("#accountNo").UITextField("value",certificate);
				return false;
			});
			$("#psw-visible").on('tap', function() {
				var self = $(this);
				obj = self.find('.psw-visible-ico'),
					psw = self.prev().find("input");
				if (obj.hasClass('on')) {
					obj.removeClass('on');
					psw.attr("type", "password");
				} else {
					obj.addClass('on');
					psw.attr("type", "text");
				}
			});
		},
		isLoginOrNot : function (opt) {
			if ($.hsf.platform() == "platform/weixinapi") {
				$.hsf.ajax.app("account/weixinlogin/islogin", "", "loginCallback", function(jsonResult) {
					if (jsonResult.successful) {
						if(jsonResult.isBinded == "1"){
							$.hsf.hsOpen("index.html");
						}
					} else if (jsonResult.code == "APP-5BP0012") {
						$.UIAlert("您的请求的页面已过期。请返回微信", function() {
							require(["wx"], function(wx) {
								typeof wx != "undefined" && wx.closeWindow();
							})
						});
					}
				});
			}
		},
		getAccountNo : function() {
			var accountNoHidden = $("#accountNoHidden").val();
			var accountInput = $("#accountNo").UITextField("value");
			if (accountNoHidden && accountNoHidden != "" && accountInput.indexOf("****") > 0) {
				return accountNoHidden;
			} else {
				return accountInput;
			}
		},
		checkLoginCode : function() {
			var account = action.getAccountNo().trim(), 
					pw = $("#pw").UITextField("value").trim(), 
					accountType = $("#accountType").UISelectField("value"), 
					verifycode = $("#verifycode").UITextField("value");
			//var checkContract = $("#checkContract").UICheckBox("value");
			if (account.length === 0) {
				$.UIPopup("请输入号码");
				return false;
			}
			if (pw.length === 0) {
				$.UIPopup("请输入密码");
				return false;
			}
			if (pw.length > $.hsf.pwLength) {
				$.UIPopup("密码长度不能超过" + $.hsf.pwLength + "位");
				return false;
			}
			if (accountType == "0") {
				if (account.length == 11 && account.startsWith("1") && /^\d+$/.test(account)) {
					action.accttype = "8";
				} else if (/^((11|12|13|14|15|21|22|23|31|32|33|34|35|36|37|41|42|43|44|45|46|50|51|52|53|54|61|62|63|64|65|71|81|82|91)\d{4})((((19|20)(([02468][048])|([13579][26]))0229))|((20[0-9][0-9])|(19[0-9][0-9]))((((0[1-9])|(1[0-2]))((0[1-9])|(1\d)|(2[0-8])))|((((0[1,3-9])|(1[0-2]))(29|30))|(((0[13578])|(1[02]))31))))((\d{3}(x|X))|(\d{4}))$/.test(account)) {
					action.accttype = "1";
				}  else if(account.length == 12 && account.startsWith("36")){//基金账号
					action.accttype = "0";
				}else {
					action.accttype = "4";
				}
			}
			/*if (checkContract != "yes") {
				$.UIPopup("请仔细阅读《用户注册协议》且同意接受条款。");
				return false;
			}*/
			data = "certificatetype=" + accountType
				 + "&certificateno=" + account
				 + "&lpasswd=" + pw
				 + "&channel="+$.platform.channel
				 + "&bindwx=1"
				 + "&accttype=" +action.accttype
				 + "&authcode=" +verifycode;
			$.hsf.startLoading();
			$.hsf.ajax.app($.platform.loginUrl, data, "checkLoginCode", this.loginCallback);
		},
		loginCallback : function(jsonResult) {
			$.hsf.stopLoading();
			if (jsonResult && jsonResult.successful) {
				$.platform.loginSuccess();
				$.platform.removeCache("logininfo");
				$.platform.putCache("logininfo", jsonResult.result);
			} else {
				if (jsonResult.needauthcode == "1") {
					$("#verifycodeDD").show();
					$("#verifycodeImg").attr("src", $.hsf.appBaseUrl+"/authcode.jpg");
				}
				$.hsf.callFailProcess(jsonResult);
			}
			return false;
		}
	};
	return action;
});

