define([$.hsf.platform()], function(platform) {
	var platformApi = $.hsf.getModuleAPI(platform, "login-view");
	var action = {
		historyBack : true,
		disableHistoryBack : function() {
			action.historyBack = false;
		},
		init : function() {
			var that = this;
			platformApi.getCache("deviceId", function(deviceId) {
				action.deviceId = deviceId||"";
				$("[m-role='UITextField']").UITextField();
				$("[m-role='UISelectField']").UISelectField();
				$("[m-role='UICheckBox']").UICheckBox();
				$("[m-role='UISwitch']").UISwitch();
				$.checkNullGroup([$("#accountNo"), $("#pw")], $("#loginButton"));
				that.events();
			});
			action.historyBack = true;
			platformApi.initPage && platformApi.initPage(action);
		},
		events : function() {
			$("#psw-visible").on('tap', function() {
                var self = $(this);
                obj = self.find('.psw-visible-ico'),
                    psw = self.prev().find("input");
                if (obj.hasClass('on')) {
                    obj.removeClass('on');
                    psw.attr("type", "password");
                } else {
                    obj.addClass('on');
                    psw.attr("type", "text");
                }
            });
			$(document).on("tap.login","#loginButton[m-state!='disabled']", function() {
				action.checkLoginCode();
			});
			$("#registButton").on("tap",function () {
				$.hsf.hsOpen("mobile-regist.html");
				return false;
			});
			$("#backBtn").bind("tap", function() {
				try {
					if($.hsf.hsTools.getParam("pageId") || window.location.hash.split("pageId").length > 1){
						WeixinJSBridge.call('closeWindow');
						return false;
					}
				} catch (e) {
					console.log(e);
				}
//				if ($.forgetGesturePassword) {
//					action.logout();
//				} else {
					action.back();
//				}
				return false;
			});
			$("#accountType").UISelectField("change", function(value) {
				$("#accountNo").UITextField("placeholder", $(this).find("option:selected").text());
			});
		},
		back : function() {
			$("input").blur();
			action.historyBack && $.hsf.hsBack();	
			action.popDown();
			platformApi.resetBackbutton && platformApi.resetBackbutton();
			return false;
		},
		getAccountNo : function() {
			return $("#accountNo").UITextField("value");
		},
		checkLoginCode : function() {
			var account = action.getAccountNo().trim(),
					pw = $("#pw").UITextField("value").trim(),
					accountType = $("#accountType").UISelectField("value"),
					verifycode = $("#verifycode").UITextField("value");
			action.accttype = "1";
			if (accountType == "0") {
				if (account.length == 11 && account.startsWith("1") && /^\d+$/.test(account)) {
					action.accttype = "8";
				} else if (/^((11|12|13|14|15|21|22|23|31|32|33|34|35|36|37|41|42|43|44|45|46|50|51|52|53|54|61|62|63|64|65|71|81|82|91)\d{4})((((19|20)(([02468][048])|([13579][26]))0229))|((20[0-9][0-9])|(19[0-9][0-9]))((((0[1-9])|(1[0-2]))((0[1-9])|(1\d)|(2[0-8])))|((((0[1,3-9])|(1[0-2]))(29|30))|(((0[13578])|(1[02]))31))))((\d{3}(x|X))|(\d{4}))$/.test(account)) {
					action.accttype = "1";
				} else if(account.length == 12 && account.startsWith("36")){
					action.accttype = "0";
				} else {
					action.accttype = "4";
				}
			}
          /*  /!**!/*/
            // action.accttype = "3";
			var data = "certificatetype=" + accountType
					+ "&certificateno=" + account 
					+ "&lpasswd=" + pw 
					+ "&channel="+platformApi.channel
					+ "&bindwx=1"
					+ "&accttype=" +action.accttype
					+ "&authcode="+verifycode
					+ "&deviceId="+action.deviceId;
			$.hsf.startLoading();
			$.hsf.ajax.app(platformApi.loginUrl, data, "checkLoginCode", this.loginCallback);
		},
		loginCallback : function(jsonResult) {
			if (jsonResult && jsonResult.successful) {
				var account = action.getAccountNo().trim(),
					pw = $("#pw").UITextField("value").trim(),
					accountType = $("#accountType").UISelectField("value"),
					verifycode = $("#verifycode").UITextField("value");
				platformApi.loginSuccess(account, accountType, pw, action.accttype);
				action.triggerSucc();
				$.platform.removeCache("logininfo");
				$.platform.putCache("logininfo", jsonResult.result);
                $.platform.removeCache("ps");
                $.platform.putCache("ps",  {"value":pw});
				window.location.reload();
				$.hsf.stopLoading();
			} else {
				$.hsf.callFailProcess(jsonResult);
			}
			return false;
		},
		triggerSucc : function() {
			$.hsf.Event.trigger("login", function() {
				setTimeout(function() {action.popDown()}, 1000);
			});
		},
		popDown : function() {
			$("#login").bind("webkitAnimationEnd", function() {
				$(document).off("tap.login");
				$("#login").remove();
			})
			.removeClass("pop-up")
			.addClass("pop-down");
		},
		autoLogin : function() {
			if (platformApi.autoLogin) {
				platformApi.autoLogin()
			} else {
				$.hsf.Event.muteTrigger("autoLoginFail");
			}
		},
		logout : function() {
//			$.UIConfirm("您将自动注销", function(result) {
//				if (result == "yes") {
//					$.hsf.ajax.app("account/login/logout","","logoutCallback",function(jsonResult){
//		                if(jsonResult.successful) {
//		                	$.forgetGesturePassword = false;
//		                    $.platformApi.removeCache("fundlist");
//		                    $.platformApi.removeCache("gestureStatus");
//		                    $.platformApi.removeCache("login");
//		                    $.platformApi.logoutRefresh && $.platformApi.logoutRefresh();
//		                    action.back();
//		                } else{
//		                    $.hsf.callFailProcess(jsonResult);
//		                    return false;
//		                }
//		            });
//				}
//			})
		}
	}
	window.action = action;
	return action;
});

