define(["global","chartjs","iscroll-probe"], function() {
    var action = {
        // events: {
        //     "tap #yqb-eye" : "tapEye",
        //     "tap #inprofit" : "inprofit",
        //     "tap #avgr" : "avgr"
        // },
        // _private: {},
        init: function() {
            var that = this;
            $.platform.getCache("openId", function(openId) {
                that.openId = openId||"";
            });
            $.platform.initPage();
            this.requestManager = $.hsf.requestManager(this);
            this.requestManager.add(this.initRequestForm(), 60 * 60 * 1);
            $.hsf.Event.addListener("logout", function() {
                that.initRequestForm(false);
            }).addListener("trade", function() {
                that.initRequestForm(false);
            }).addListener("eyeChange", function(r) {
                if (r.o != "home") {
                    that.setEye();
                }
            }).addListener("pullRefresh", function() {
                that.initRequestForm(false);
            });

            //获取缓存中眼睛的状态
            $.platform.getCache("assetEye", function(result) {
                if(result != null){
                    if(typeof (result.value) == undefined){
                        that.setEye("true");
                    }else {
                        that.setEye(result.value);
                    }
                }
            }, "local");
            //获取过去一段时间七日年化绘制曲线图
            action.profit(action.getPreMonthDay(1), action.getCurrentDay());

            action.events();
        },
        events:function(){

        },
        initRequestForm: function() {
            var that = this;
            $.hsf.startLoading();
            $.when(this.isLogin(), this.homepageForm()).done(function(r1, r2) {
                if(r1 && r1[0].successful == false){
                    r2[0].isnotlogin = true;
                }
                that.initMoneyFundInfo(r2[0]);
            }).always(function() {
                $.hsf.stopLoading();
            });
        },
        isLogin: function() {
            if($.hsf.platform() == "platform/weixinapi"){
                return $.hsf.ajax.app("account/weixinlogin/islogin", "", "loginCallback", function(jsonResult) {});
            }
        },
        //
        homepageForm: function(func) {
            return $.hsf.ajax.app("home/homepage/homePage", "", "homePageCallback", func || function(jsonResult) {});
        },

        avgr : function(){
            this.getLoginInfo("avgr");
        },
        inprofit : function(){
            this.getLoginInfo("inprofit");
        },
        //获取登录信息
        getLoginInfo : function(info){
            $.platform.getCache("logininfo", function(result) {
                if (result) {
                    var custtype = result.custtype;
                    if(custtype == "1"){//代销用户
                        $.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
                            if (o == "yes") {
                                $.hsf.hsOpen("account-openAcco-gdbdx.html");
                            }
                        });
                    }else{
                        if(info == "avgr"){
                            $.hsf.hsOpen("trade-avgr.html?saveplanflag=d");
                        }else if(info == "inprofit"){
                            $.hsf.hsOpen("trade-money-in.html");
                        }
                    }
                }else{
                    $.hsf.ajax.app("account/account/accountinfo","","checkLoginCode",function(jsonResult) {
                        if (jsonResult.successful) {
                            var custtype = jsonResult.result.custtype;
                            $.platform.removeCache("logininfo");
                            $.platform.putCache("logininfo", jsonResult.result);
                            if(custtype == "1"){//代销用户
                                $.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
                                    if (o == "yes") {
                                        $.hsf.hsOpen("account-openAcco-gdbdx.html");
                                    }
                                });
                            }else{
                                if(info == "avgr"){
                                    $.hsf.hsOpen("trade-avgr.html?saveplanflag=d");
                                }else if(info == "inprofit"){
                                    $.hsf.hsOpen("trade-money-in.html");
                                }
                            }
                        }else{
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            });
        },
        //请求最近七日年化
        profit : function(startDate, endDate) {
            $.hsf.startLoading();
            $.hsf.ajax.app("product/product/superfundinfo", "startdate=" + startDate + "&enddate=" + endDate + "&pageno=1&pagesize=7", "getTotalIncomeAnalysisCallback", function(jsonResult) {
                if (jsonResult.successful) {
                    var profitlist = jsonResult.result.data;
                    // if (profitlist.length > 0) {
                    //     var param = action.formatValue(profitlist);
                    //     $(".xjb-sy-list").html(action.renderHtml(profitlist, param.maxValue));
                    //     $(".xjb-level-content").html(parseFloat(param.averageValue).toFixed(4)+"%");
                    // }
                    var tools = $.hsf.hsTools;
                    if (profitlist.length > 0) {
                        if (profitlist[0].growthrate != null && typeof (profitlist[0].growthrate) != "undefined") {
                            // $("#qrnh").html(tools.decimal4(profitlist[0].growthrate*100)+"%");
                        }
                        if (profitlist[0].fundincomeunit != null && typeof (profitlist[0].fundincomeunit) != "undefined") {
                            // $("#wfsy").html(tools.decimal4(profitlist[0].fundincomeunit));
                        }
                    }else{
                        // $("#wfsy").html("--");
                        // $("#qrnh").html("--");
                    }
                    action.draw(profitlist);
                    $.hsf.stopLoading();
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        //绘制七日年化曲线
        draw : function(profitlist) {
            var lineChartData = {
                labels : [],
                datasets : [ {
                    label : "My First dataset",
                    fillColor : "rgba(255,34,51,0.1)",
                    strokeColor : "#ff404f",
                    pointColor : "#ff404f",
                    pointStrokeColor : "#ff404f",
                    pointHighlightFill : "white",
                    pointHighlightStroke : "#ff404f",
                    data : []
                } ]
            };
            if (profitlist.length <= 0) {
                lineChartData.labels.push('');
                lineChartData.datasets[0].data.push(0);
            }
            for (var index in profitlist) {
                if(index < 7){
                    var pattern = /(\d{4})(\d{2})(\d{2})/;
                    profitlist[index].date = profitlist[index].date.replace(pattern, '$1-$2-$3');

                    var m = profitlist[index].date.substr(5, 2);
                    var d = profitlist[index].date.substr(8, 2);
                    lineChartData.labels.push(m + "-" + d);
                    lineChartData.datasets[0].data.push(parseFloat(profitlist[index].growthrate*100).toFixed(4));
                }else{
                    break;
                }
            }
            lineChartData.labels = lineChartData.labels.reverse();
            lineChartData.datasets[0].data = lineChartData.datasets[0].data.reverse();
            var ctx = document.getElementById("myChart").getContext("2d");
            var myLine = new Chart(ctx).Line(lineChartData, {
                datasetStrokeWidth : 2,
                pointDot : false,
                showTooltips : false,
                tooltipFillColor : '#ff404f',
                tooltipFontColor : 'white',
                tooltipTemplate : "<%=value %>",
                pointDotOnlyEnd : true,// 只显示最后一个点
                pointDotStrokeWidth : 1,
            });
            $.hsf.stopLoading();
        },
        //获取当前月份
        getPreMonthDay : function(i) {
            var now = new Date();
            now.setDate(now.getDate()-i*30);
            var myyear = now.getFullYear();
            var mymonth = now.getMonth() + 1;
            var myweekday = now.getDate();
            if(mymonth < 10){
                mymonth = "0" + mymonth;
            }
            if(myweekday < 10){
                myweekday = "0" + myweekday;
            }
            return (myyear+"-"+mymonth + "-" + myweekday);
        },
        //获取当前日期
        getCurrentDay : function() {
            var now = new Date();
            var myyear = now.getFullYear();
            var mymonth = now.getMonth() + 1;
            var myweekday = now.getDate();
            if(mymonth < 10){
                mymonth = "0" + mymonth;
            }
            if(myweekday < 10){
                myweekday = "0" + myweekday;
            }
            return (myyear+"-"+mymonth + "-" + myweekday);
        },
        //url拆分
        urlSplit : function(url){
            var queryObject = {};
            var pairs = url.split('&');
            for(var i in pairs) {
                var pair = pairs[i];
                var keyAndValue = pair.split('=');
                var key = keyAndValue[0];
                var value = keyAndValue[1];
                queryObject[key] = value;
            }
            return queryObject;
        },
        //点击眼睛
        tapEye : function() {
            var eyeState = $("#yqb-eye").hasClass("on");
            this.setEye(!eyeState);
            $.platform.putCache("assetEye", {"value": !eyeState}, "local");
            // $.hsf.Event.trigger("eyeChange", null, {o: "home"});
            return false;
        },
        //获取眼睛状态
        getEye : function() {
            // return this.parent.getParam("assetEye").value;
            // return $("#yqb-eye").hasClass("on");
            $.platform.getCache("assetEye", function(result) {

                return result.value;

            }, "local");
        },
        //设置眼睛
        setEye : function(value) {
            var result = {value: value}
            //如果value是true,则显示眼镜张开,如果为false,则闭着眼睛。
            if(value){
                // alert("true");
                $("#yqb-eye").addClass("on");
                $("#xjbMoney").show();
                $("#xjbMoney-mask").hide();
            }else {
                // alert("false");
                $("#yqb-eye").removeClass("on");
                $("#xjbMoney").hide();
                $("#xjbMoney-mask").show();
            }
            // this.parent.setParam("assetEye", result);
            $.platform.putCache("assetEye", result, "local");

        },
        // //改变眼睛状态
        // changeEye : function() {
        //     var result = this.getEye();
        //     // alert(result);
        //     if (!result) {
        //         // this.$el.find(".psw-visible-ico").addClass("on");
        //         $("#yqb-eye").addClass("on");
        //         $("#xjbMoney").show();
        //         $("#xjbMoney-mask").hide();
        //     } else {
        //         // this.$el.find(".psw-visible-ico").removeClass("on");
        //         $("#yqb-eye").removeClass("on");
        //         $("#xjbMoney-mask").show();
        //         $("#xjbMoney").hide();
        //     }
        // },
        //登录成功后的处理
        loginProcess: function(jsonResult) {
            var t = $.hsf.hsTools;
            jsonResult.supercapital= t.decimal2(jsonResult.supercapital);
            //如果耀钱包资产为0,取出不可点。
            if(parseFloat(jsonResult.supercapital) == 0){
                $("#moneyOutBtn").removeAttr("m-href");
            }else {
                $("#moneyOutBtn").attr("m-href","trade-money-out.html");
            }
            jsonResult.dayincome= t.decimal2(jsonResult.dayincome);
            jsonResult.totalincome= t.decimal2(jsonResult.totalincome);
            $.doTemplate("xjb-login", jsonResult, "refresh");
            action.initScroll();
            $("#xjb-record").show();
            // this.setEye(this.getEye());
            this.countUp("xjbMoney",2).start();

            $("#inprofit").bind("tap",function () {
                action.inprofit();
            });
            $("#avgr").bind("tap",function () {
                action.avgr();
            });
            $("#yqb-eye").bind("tap",function () {
               action.tapEye();
            });
        },
        //请求持有现金宝的情况
        initMoneyFundInfo: function(jsonResult, loading) {
            var that = this;
            if (loading !== false) {
                $.hsf.startLoading();
            }
            if(jsonResult){
                if (jsonResult.successful) {
                    if (loading !== false) {
                        $.hsf.stopLoading();
                    }
                    if (jsonResult.isnotlogin) {
                        $.platform.putCache("homeNotLogin", jsonResult);
                        $.hsf.innerLogin();
                    } else {
                        that.loginProcess(jsonResult);
                    }
                } else {
                    if (jsonResult.code == "NETWORK_ERROR") {
                        var cache = $.platform.getCache("homeNotLogin", function(jsonResult) {
                            if (jsonResult) {
                                that.notLoginProcess(jsonResult);
                            }
                        });
                    }
                    $.hsf.callFailProcess(jsonResult);
                }
            }
        },

        roundUp: function(roundElem) {
            var requestAnimationFrame = function() {
                var lastTime = 0;
                return function(callback, element) {
                    var currTime = new Date().getTime();
                    var timeToCall = Math.max(0, 16 - (currTime - lastTime));
                    var id = window.setTimeout(function() {
                            callback(currTime + timeToCall);
                        },
                        timeToCall);
                    lastTime = currTime + timeToCall;
                    return id;
                };
            }();
            $('#'+roundElem).circliful({
                requestAnimationFrame: requestAnimationFrame
            });
        },
        countUp : function(countElem, decimal) {
            var requestAnimationFrame = function() {
                var lastTime = 0;
                return function(callback, element) {
                    var currTime = new Date().getTime();
                    var timeToCall = Math.max(0, 16 - (currTime - lastTime));
                    var id = window.setTimeout(function() {
                            callback(currTime + timeToCall);
                        },
                        timeToCall);
                    lastTime = currTime + timeToCall;
                    return id;
                };
            }();
            var countUp = function(target, startVal, endVal, decimals, duration, options) {
                // default options
                this.options = options || {
                        useEasing: true, // toggle easing
                        useGrouping: true, // 1,000,000 vs 1000000
                        separator: ',', // character to use as a separator
                        decimal: '.' // character to use as a decimal
                    }
                window.cancelAnimationFrame = function(id) {
                    clearTimeout(id);
                }
                if (this.options.separator == '') this.options.useGrouping = false;
                if (this.options.prefix == null) this.options.prefix = '';
                if (this.options.suffix == null) this.options.suffix = '';

                var self = this;

                this.d = (typeof target === 'string') ? document.getElementById(target) : target;
                this.startVal = Number(startVal);
                this.endVal = Number(endVal);
                this.countDown = (this.startVal > this.endVal) ? true : false;
                this.startTime = null;
                this.timestamp = null;
                this.remaining = null;
                this.frameVal = this.startVal;
                this.rAF = null;
                this.decimals = Math.max(0, decimals || 0);
                this.dec = Math.pow(10, this.decimals);
                this.duration = duration * 1000 || 2000;

                this.printValue = function(value) {
                    var result = (!isNaN(value)) ? self.formatNumber(value) : '--';
                    if (self.d.tagName == 'INPUT') {
                        this.d.value = result;
                    } else if (self.d.tagName == 'text') {
                        this.d.textContent = result;
                    } else {
                        this.d.innerHTML = result;
                    }
                }

                // Robert Penner's easeOutExpo
                this.easeOutExpo = function(t, b, c, d) {
                    return c * (-Math.pow(2, -10 * t / d) + 1) * 1024 / 1023 + b;
                }
                this.count = function(timestamp) {
                    if (self.startTime === null) self.startTime = timestamp;
                    self.timestamp = timestamp;
                    var progress = timestamp - self.startTime;
                    self.remaining = self.duration - progress;
                    // to ease or not to ease
                    if (self.options.useEasing) {
                        if (self.countDown) {
                            var i = self.easeOutExpo(progress, 0, self.startVal - self.endVal, self.duration);
                            self.frameVal = self.startVal - i;
                        } else {
                            self.frameVal = self.easeOutExpo(progress, self.startVal, self.endVal - self.startVal, self.duration);
                        }
                    } else {
                        if (self.countDown) {
                            var i = (self.startVal - self.endVal) * (progress / self.duration);
                            self.frameVal = self.startVal - i;
                        } else {
                            self.frameVal = self.startVal + (self.endVal - self.startVal) * (progress / self.duration);
                        }
                    }
                    // don't go past endVal since progress can exceed duration in the last frame
                    if (self.countDown) {
                        self.frameVal = (self.frameVal < self.endVal) ? self.endVal : self.frameVal;
                    } else {
                        self.frameVal = (self.frameVal > self.endVal) ? self.endVal : self.frameVal;
                    }
                    // decimal
                    self.frameVal = Math.round(self.frameVal * self.dec) / self.dec;
                    // format and print value
                    self.printValue(self.frameVal);
                    // whether to continue
                    if (progress < self.duration) {
                        self.rAF = requestAnimationFrame(self.count);
                    } else {
                        if (self.callback != null) self.callback();
                    }
                }
                this.start = function(callback) {
                    self.callback = callback;
                    // make sure values are valid
                    if (!isNaN(self.endVal) && !isNaN(self.startVal)) {
                        self.rAF = requestAnimationFrame(self.count);
                    } else {
                        console.log('countUp error: startVal or endVal is not a number');
                        self.printValue();
                    }
                    return false;
                }
                this.stop = function() {
                    cancelAnimationFrame(self.rAF);
                }
                this.reset = function() {
                    self.startTime = null;
                    self.startVal = startVal;
                    cancelAnimationFrame(self.rAF);
                    self.printValue(self.startVal);
                }
                this.resume = function() {
                    self.stop();
                    self.startTime = null;
                    self.duration = self.remaining;
                    self.startVal = self.frameVal;
                    requestAnimationFrame(self.count);
                }
                this.formatNumber = function(nStr) {
                    nStr = nStr.toFixed(self.decimals);
                    nStr += '';
                    var x, x1, x2, rgx;
                    x = nStr.split('.');
                    x1 = x[0];
                    x2 = x.length > 1 ? self.options.decimal + x[1] : '';
                    rgx = /(\d+)(\d{3})/;
                    if (self.options.useGrouping) {
                        while (rgx.test(x1)) {
                            x1 = x1.replace(rgx, '$1' + self.options.separator + '$2');
                        }
                    }
                    return self.options.prefix + x1 + x2 + self.options.suffix;
                }
                // format startVal on initialization
                self.printValue(self.startVal);
            };
            var sevenValue = $("#"+countElem);
            var endValue = sevenValue.attr('m-change-value');
            var csv = new countUp(sevenValue[0], 0, endValue, decimal, .5);
            return csv;//csv.start();
        },
        initScroll : function() {
            var $s = $("#swiperArea");
            var that = this;
            if (this.myScroll) {
                this.myScroll.enable();
                this.myScroll.refresh();
                this.myScroll.scrollTo(0,0,100);
            } else {
                this.renderAreaHeight = $("#renderArea").height();
                if (this.renderAreaHeight == 0) return;
                var scrollTop = this.renderAreaHeight+44-5;
                $("#scroll1").css("top", scrollTop+"px");
                $s.css({"min-height": document.documentElement.clientHeight- 44-scrollTop});
                window.myScroll = this.myScroll = new IScroll("#scroll1", {probeType:1});
                this.myScroll.on('scroll', function() {
                    if (parseFloat(this.y) > 45) {
                        that.myScroll.refreshFlag = true;
                        $(".pullDown").addClass("flip");
                        $("#refreshTip").html("释放刷新");
                    };
                });
                $("#scroll1").bind("touchmove", function (event) {
                    event.preventDefault();
                });
                $("#scroll1").bind("touchend", function (event) {
                    if (that.myScroll.refreshFlag) {
                        var x = function() {
                            setTimeout(function() {
                                var scrollY = parseFloat($s.css("transform").split(", ")[5]);
                                if (scrollY <= 45 && that.myScroll.disable) {
                                    $(".pullDown").removeClass("flip").addClass("loading");
                                    $("#refreshTip").html("正在刷新...");
                                    $s.css({"webkitTransform":'translate( 0px,' + (scrollY) + 'px) translateZ(0) '});
                                    // that.initAsset(false);
                                    that.initRequestForm();
                                    that.myScroll.refreshFlag = false;
                                    $.hsf.Event.muteTrigger("pullRefresh");
                                } else {
                                    x();
                                }
                            }, 10);
                        };
                        x();
                    }
                });
            }
        }

    };
    return action;
});
