define('pages/reset-mobile-getcode',[$.hsf.platform()], function (platform) {
    return Backbone.View.extend({
        el: "#reset-mobile-getcode",
        _private: {},
        initialize: function (parent, platformApi) {
            var that = this;
            this.platformApi = platformApi;
            this._private.custtype = $.hsf.hsTools.getParam("custtype");
            this._private.mobile = $.hsf.hsTools.getParam("mobile");
            if (this._private.custtype == "0" || this._private.custtype == "1" || this._private.custtype == "2") {
                $("#title").text("绑定手机号码");
                $("#is_mobile_no").show();
                $("#is_mobile").hide();
            } else if (this._private.custtype == "3") {
                $("#title").text("修改手机号码");
                $("#is_mobile_no").show();
                $("#is_mobile").hide();
            }
            $.platform.getCache("deviceId", function (deviceId) {
                that.parent = parent;
                that.platformApi = platformApi;
                that.formGenerate = $.formGenerate();
                that._private.deviceId = deviceId;
            });
        },
        events: {
            "tap #next": "next",
            "tap .recover-text": "recover"
        },
        next: function () {
            var that = this;
            var code = $(".mess-code").UITextField("value");
            var mobile = $(".phone").UITextField("value");
            var mobileMatch = /^1\d{10}$/;
            if (mobile.length == 0) {
                $.UIPopup("手机号不能为空!");
                return false;
            }
            if (mobile.length !=11) {
                $.UIPopup("请输入11位手机号码!!");
                return false;
            }
            if (!mobileMatch.test(mobile)) {
                $.UIPopup("手机号码格式不正确!");
                return false;
            }

            if(!this._private.operdate){
                $.UIPopup("请获取验证码");
                return false;
            }

            if (code.length == 0) {
                $.UIPopup("验证码不能为空!");
                return false;
            }
            if (code.length != 6) {
                $.UIPopup("请输入6位验证码!");
                return false;
            }
            var data = "chkmsg=" + code +
                "&mobileno=" + mobile +
                "&sno=" + this._private.sno +
                "&operdate=" + this._private.operdate + "&";

            if (this._private.mobile) {
                that.modifyBindMobile(data);
            } else {
                that.registerBinding(data);
            }
            return false;
        },
        recover: function () {
            this.isBindedUser();
            return false;
        },

        hasSpace: function (str) {
            var arr = str.split(" ");
            if (arr.length != 1) {
                return true;
            } else {
                return false;
            }
        },
        hasSimple: function (str) {
            var dataDictionary = [111111, 000000, 222222, 333333, 444444, 555555, 666666, 777777, 888888, 999999, 012345, 123456, 234567, 345678, 456789, 987654, 876543, 765432, 654321, 543210, 098765];
            for (var index = 0, len = dataDictionary.length; index < len; index++) {
                if (dataDictionary[index] == str) {
                    return false;
                }
            }
            return true;
        },
        getAuthcode: function () {
            var that = this;
            var mobile = $(".phone").UITextField("value");

            var reg = /^1\d{10}$/;


            if (!reg.test(mobile)) {
                $.UIPopup("手机号码格式不正确!");
                return false;
            }
            var code = $(".mess-code").UITextField("value");
            var mobile = $(".phone").UITextField("value");

            var data = "&Mobileno=" + mobile + "&sendintent=toNew";
            $.hsf.startLoading();
            $.hsf.ajax.app("account/mobile/sendMobileAuthcode", data, "getAuthcodeCallback", function (jsonResult) {
                if (jsonResult.successful) {
                    $.hsf.stopLoading();
                    that._private.sno = jsonResult.result.sno;
                    that._private.operdate = jsonResult.result.operdate;
                    $.UIAlert("手机验证码已发送！请注意查收短信！");

                    $(".remaining-text").removeClass("m-hide");
                    $(".count-text1").removeClass("m-hide");
                    $(".count-text2").removeClass("m-hide");
                    $(".recover-text").addClass("m-hide");
                    $("#countdown").UICountdown({
                        "time": 60, "afterStop": function () {
                            //$.UIPopup("结束");
                            $(".remaining-text").addClass("m-hide");
                            $(".recover-text").removeClass("m-hide");
                            $(".count-text1").addClass("m-hide");
                            $(".count-text2").addClass("m-hide");

                            $("[m-role='UICountdown']").UICountdown("reset");
                        }
                    });
                    $("#countdown").UICountdown("start");
                } else {

                    $(".remaining-text").removeClass("m-hide");
                    $(".count-text1").removeClass("m-hide");
                    $(".count-text2").removeClass("m-hide");
                    $(".recover-text").addClass("m-hide");
                    $("#countdown").UICountdown({
                        "time": 60, "afterStop": function () {
                            //$.UIPopup("结束");
                            $(".remaining-text").addClass("m-hide");
                            $(".recover-text").removeClass("m-hide");
                            $(".count-text1").addClass("m-hide");
                            $(".count-text2").addClass("m-hide");

                            $("#countdown").UICountdown("reset");
                        }
                    });

                    $("#countdown").UICountdown("start");

                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        isBindedUser: function () {
            var that = this;
            var mobile = $(".phone").UITextField("value");
            var mobileMatch = /^1\d{10}$/;
            if (mobile.length == 0) {
                $.UIPopup("手机号不能为空!");
                return false;
            }
            if (mobile.length !=11) {
                $.UIPopup("请输入11位手机号码!");
                return false;
            }
            if (!mobileMatch.test(mobile)) {
                $.UIPopup("手机号码格式不正确!");
                return false;
            }
            var data = "&Mobileno=" + mobile + "&accttype=0";
            $.hsf.startLoading();
            $.hsf.ajax.app("account/mobile/queryMobileBindCheck", data, "queryMobileBindCheck", function (jsonResult) {
                $.hsf.stopLoading();
                if (jsonResult.successful) {
                    if (jsonResult.result.userid == "") {
                        that.getAuthcode();
                    } else {
                        $.UIPopup("手机号码已被注册");
                    }
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
            return false;
        },
        modifyBindMobile: function (url) {
            var that = this;
            var mobile = $(".phone").UITextField("value");
            $.platform.getCache("logininfo", function (result) {
                if (result) {
                    var userid = result.userid;
                    var data = url + "Isbinding=" + result.Isbinding +
                        "&certificatetype=" + result.certificatetype +
                        "&certificateno=" + result.certificateno +
                        "&mobile=" + mobile +
                        "&oldmobile=" + that._private.mobile +
                        "&userid=" + result.userid;
                    $.hsf.startLoading();
                    $.hsf.ajax.app("account/mobile/modifyBindMobile", data, "modifyBindMobile", function (jsonResult) {
                        $.hsf.stopLoading();
                        if (jsonResult.successful) {
                            that.login();
                            $.UIPopup("修改成功!");
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            });
        },
        registerBinding: function (url) {
            var that = this;
            var mobile = $(".phone").UITextField("value");
            $.platform.getCache("ps", function (result) {
                if(result){
                    var pw = result.value;
                    $.platform.getCache("logininfo", function (result) {
                        if (result) {
                            var userid = result.userid;
                            var data = url + "certificatetype=" + result.certificatetype +
                                "&certificateno=" + result.certificateno +
                                "&mobile=" + mobile +
                                "&acctfrom=" + "003" +
                                "&lpasswd=" + pw +
                                "&custtype=" + result.custtype +
                                "&userid=" + result.userid;
                            $.hsf.startLoading();
                            $.hsf.ajax.app("account/register/registerBinding", data, "registerBinding", function (jsonResult) {
                                $.hsf.stopLoading();
                                if (jsonResult.successful) {
                                    that.login();
                                    $.UIPopup("绑定成功!");
                                } else {
                                    $.hsf.callFailProcess(jsonResult);
                                }
                            });
                        }
                    });
                }else{

                }

            });

        },
        login: function () {
            var that = this;
            $.platform.getCache("ps", function (result) {
                if (result) {
                    var pw = result.value;
                    var mobile = $(".phone").UITextField("value");
                    $.platform.getCache("logininfo", function (result) {
                        if (result) {
                            var idNo = mobile;
                            var idType = "0";
                            var accttype = "8";
                            if(result.Isbinding=="1"&&result.certificateno!=""){
                                idNo = result.certificateno;
                                idType = result.certificatetype;
                                accttype = "1";
                            }
                            var loginApi = $.hsf.getModuleAPI(platform, "login-view");
                            var g = that.formGenerate;
                            g.add("certificatetype", idType);
                            g.add("certificateno", idNo);
                            g.add("lpasswd", pw);
                            g.add("channel", that.platformApi.channel);
                            g.add("accttype", accttype);
                            g.add("bindwx", "1");
                            g.add("deviceId", that._private.deviceId);
                            $.hsf.startLoading();
                            $.hsf.ajax.app(loginApi.loginUrl, g.generate(), "checkLoginCode", function (jsonResult) {
                                if (jsonResult && jsonResult.successful) {
                                    $.platform.removeCache("logininfo");
                                    $.platform.putCache("logininfo", jsonResult.result);
                                    that.platformApi.triggerRefresh&&that.platformApi.triggerRefresh();
                                } else {
                                    $.platform.removeCache("logininfo");
                                }
                                $(".finishAndBack").trigger('tap');
                                $.hsf.stopLoading();
                                return false;
                            });
                        } else {
                            $(".finishAndBack").trigger('tap');
                        }
                    });
                } else {
                    $(".finishAndBack").trigger('tap');
                }

            });
        },
    });
});

define('pages/reset-mobile-0', function () {
    return Backbone.View.extend({
        el: "#reset-mobile-0",
        _private: {},
        initialize: function (parent) {
            this._private.custtype = $.hsf.hsTools.getParam("custtype");
            this._private.mobile = $.hsf.hsTools.getParam("mobile");
            $(".my-mobile").html($.hsf.hsTools.maskMobile(this._private.mobile));
            $("#title").text("修改手机号码");
        },
        events: {
            "tap #next-0": "next1",
            "tap .recover-text-0": "getAuthcode"
        },
        next1: function () {
            var code = $(".mess-code-0").UITextField("value");
            var mobile = this._private.mobile;
            var mobileMatch = /^1\d{10}$/;
            if (mobile.length == 0) {
                $.UIPopup("手机号不能为空!");
                return false;
            }
            if (!mobileMatch.test(mobile)) {
                $.UIPopup("手机号码格式不正确!");
                return false;
            }
            if(!this._private.operdate){
                $.UIPopup("请获取验证码");
                return false;
            }

            if (code.length == 0) {
                $.UIPopup("验证码不能为空!");
                return false;
            }if (code.length != 6) {
                $.UIPopup("请输入6位验证码!");
                return false;
            }
            var data = "chkmsg="+code +
                "&mobileno="+ mobile+
                "&sno="+this._private.sno+
                "&operdate="+this._private.operdate+"&";
            $.hsf.startLoading();
            $.hsf.ajax.app("account/mobile/verifyMobileAuthcode",data,"verifyMobileAuthcode",function(jsonResult){
                $.hsf.stopLoading();
                if (jsonResult.successful) {
                    window.location.hash = "reset-mobile-1";
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
            return false;
        },
        getAuthcode: function () {
            var that = this;
            var mobile = that._private.mobile;

            var reg = /^1\d{10}$/;
            if (!reg.test(mobile)) {
                $.UIPopup("手机号码格式不正确!");
                return false;
            }
            var code = $(".mess-code-0").UITextField("value");

            var data = "&Mobileno="+mobile+ "&sendintent=toNew";
            $.platform.getCache("logininfo", function(result) {
                if(result==null){
                    $.hsf.innerLogin();
                    return false;
                }else{
                    $.hsf.startLoading();
                    $.hsf.ajax.app("account/mobile/sendMobileAuthcode",data,"getAuthcodeCallback",function(jsonResult){
                        if (jsonResult.successful) {
                            $.hsf.stopLoading();
                            that._private.sno=jsonResult.result.sno;
                            that._private.operdate=jsonResult.result.operdate;
                            $.UIAlert("手机验证码已发送！请注意查收短信！");

                            $(".remaining-text-0").removeClass("m-hide");
                            $(".count-text1-0").removeClass("m-hide");
                            $(".count-text2-0").removeClass("m-hide");
                            $(".recover-text-0").addClass("m-hide");
                            $("#countdown-0").UICountdown({
                                "time": 60, "afterStop": function () {
                                    //$.UIPopup("结束");
                                    $(".remaining-text-0").addClass("m-hide");
                                    $(".recover-text-0").removeClass("m-hide");
                                    $(".count-text1-0").addClass("m-hide");
                                    $(".count-text2-0").addClass("m-hide");

                                    $("#countdown-0").UICountdown("reset");
                                }
                            });
                            $("#countdown-0").UICountdown("start");
                        } else {

                            $(".remaining-text-0").removeClass("m-hide");
                            $(".count-text1-0").removeClass("m-hide");
                            $(".count-text2-0").removeClass("m-hide");
                            $(".recover-text-0").addClass("m-hide");
                            $("#countdown-0").UICountdown({
                                "time": 60, "afterStop": function () {
                                    //$.UIPopup("结束");
                                    $(".remaining-text-0").addClass("m-hide");
                                    $(".recover-text-0").removeClass("m-hide");
                                    $(".count-text1-0").addClass("m-hide");
                                    $(".count-text2-0").addClass("m-hide");

                                    $("#countdown-0").UICountdown("reset");
                                }
                            });

                            $("#countdown-0").UICountdown("start");

                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            });


        },
    });
});

define('pages/reset-mobile-1', function () {
    return Backbone.View.extend({
        el: "#reset-mobile-1",
        _private: {},
        initialize: function (parent) {
            this._private.custtype = $.hsf.hsTools.getParam("custtype");
            this._private.mobile = $.hsf.hsTools.getParam("mobile");
            $("#title").text("交易密码验证");
        },
        events: {
            "tap #next-btn-1": "next",
            "tap #reset-trade-pw": "toResetPW"
        },
        next: function () {
            var code = $("#origin-code").UITextField("value");
            if (code.length == 0) {
                $.UIPopup("交易密码不能为空!");
                return false;
            }
            $.platform.getCache("logininfo", function(result) {
                if (result) {
                    var data = "tpasswd="+ code;
                    $.hsf.startLoading();
                    $.hsf.ajax.app("account/pwd/checkTradePwd",data,"checkTradePwd",function(jsonResult){
                        $.hsf.stopLoading();
                        if (jsonResult.successful) {
                            window.location.hash = "reset-mobile-getcode";
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            });

            return false;
        },
        toResetPW: function () {
            // window.location.hash = "reset-trade-pw";
            $.hsf.hsOpen("reset-trade-pw.html");
            return false;
        },
    });
});

define("pages/reset-mobile-2", ["global", "Backbone"], function (G) {
    return Backbone.View.extend({
        el: "#reset-mobile-2",
        $payPsw: $("#pay-psw"),
        $payRepeatPsw: $("#pay-repeat-psw"),
        _private: {},
        validForm: $.validForm(),
        initialize: function (parent) {
            this.parent = parent;
            this.uiEvent();
            this.validForm = $.validForm();
            $.checkNullGroup([this.$payRepeatPsw, this.$payPsw], $("#nextBtn5"));
        },
        afterSwitchView: function () {
        },
        next: function () {
            var payPsw = this.$payPsw.UITextField("value"),
                payRepeatPsw = this.$payRepeatPsw.UITextField("value"),
                that = this;
            var v = $.validForm().add("strlength", {value: payPsw, size: 6}, "请输入6位数字密码")
                .add("num", payPsw, "请输入6位数字密码")
                .add("equal", {origin: payPsw, target: payRepeatPsw}, "密码不一致");
            if (v.valid()) {
                $.hsf.startLoading();
                that._private.isbinding = that.parent.getParam("isbinding");
                that._private.accttype = that.parent.getParam("accttype");
                that._private.mobileno = that.parent.getParam("mobileno");
                that._private.userid = that.parent.getParam("userid");
                var f = $.formGenerate().add("newlpasswd", payPsw)
                    .add("Isbinding", that._private.isbinding)
                    .add("optflag", "0")
                    .add("moblie", that._private.mobileno)
                    .add("userid", that._private.userid );
                $.hsf.ajax.app("account/pwd/resetLoginPwd", f.generate(), "resetpwdCallback", function (jsonResult) {
                    $.hsf.stopLoading();
                    if (jsonResult.successful) {
                        $.UIAlert("登录密码重置成功，请五分钟后再登录", function () {
                            that.parent.finish();
                        });
                    } else {
                        $.hsf.callFailProcess(jsonResult)
                    }
                });
            }
        },
        events: {
            "tap #nextBtn5[m-state!='disabled']": "next",
        },
        uiEvent: function () {
            var that = this;
            $("#change-paypsw-visiable").UISwitch("change", function (value) {
                if (value == 1) {
                    that.$payPsw.find('input').attr("type", 'text');
                } else {
                    that.$payPsw.find('input').attr("type", 'password');
                }
            });
            $("#change-repeatpaypsw-visiable").UISwitch("change", function (value) {
                if (value == 1) {
                    that.$payRepeatPsw.find('input').attr("type", 'text');
                } else {
                    that.$payRepeatPsw.find('input').attr("type", 'password');
                }
            });
        },
    });
});

define('pages/reset-bind-mobile', function () {
    if($.hsf.hsTools.getParam("mobile")){
        if($.hsf.hsTools.getParam("custtype")=="0"||$.hsf.hsTools.getParam("custtype")=="2"){
            return $.bone('reset-mobile-0');
        }else{
            return $.bone('reset-mobile-getcode');
        }
    }else {
        return $.bone('reset-mobile-getcode');
    }
});
