define('pages/reset-trade-pw-1', function() {
	return Backbone.View.extend({
		el : "#reset-trade-pw-1",
		$cardTypeBox : $("#cardTypeBox"),
		$mobile : $("#bankmobile"),
		$cardNo : $("#cardNo"),
		$verifyBankCode : $("#verify-bank-code"),
		$bankname : $("#bankname"),
		_private : {},
		validForm : $.validForm(),
		initialize: function(parent) {
			this.parent = parent;
			this.sandclock1 = this.sandclock("send-bank-code");
			this.validForm = $.validForm();
			this.form = $.formGenerate();
			this.init();
			this.uiEvent();
			$.checkNullGroup([this.$mobile, this.$verifyBankCode], $("#verifyBankCodeNextBtn"));
		},
		init : function() {
			var that = this;
			$.hsf.startLoading();
			$.when(this.loadBankList(), this.loadUserInfo()).then(function(r1, r2) {
				that.loadBankListProcess(r1[0]);
				that.loadUserInfoProcess(r2[0]);
				$.hsf.stopLoading();
			});
		},
		loadBankList : function() {
			return $.hsf.ajax.app("account/pwd/resetpwdForm", "", "loadBankListCallback", function(jsonResult) {});
		},
		loadBankListProcess : function(jsonResult) {
			if (jsonResult.successful) {
				$.doTemplate("banklist-template", jsonResult.result.data);
				this._private.bankData = jsonResult.result.data;
				this.$cardTypeBox.find("[m-role='UITableView']").UITableView("refresh");
				if (this._private.bankData.length == 0) {
					$.UIPopup("您没有可验证的银行卡", function() {
						$.hsf.hsBack();
					});
				} else {
					this.changeSelectCard(0);
				}
			} else {
				$.hsf.callFailProcess(jsonResult);
			}
		},
		loadUserInfo : function() {
			return $.hsf.ajax.app("account/account/accountinfo", "", "loadUserInfoCallback", function(jsonResult) {});
		},
		loadUserInfoProcess : function(jsonResult) {
			if (jsonResult.successful) {
				this._private.userInfo = jsonResult.result;
			} else {
				$.hsf.callFailProcess(jsonResult);
			}
		},
		afterSwitchView: function() {},
		toggleCardType : function() {
			this.$cardTypeBox.UIPopOption("open");
		},
		cardTypeSelectComplete : function() {
		},
		changeSelectCard : function(id) {
			this._private.channelid = this._private.bankData[id].channelid;
			this._private.bankname = this._private.bankData[id].bankname;
			this._private.channelname = this._private.bankData[id].channelname;
			this._private.depositcard = this._private.bankData[id].depositcard;
			$("#selectedBankIcon").removeAttr("class").addClass("bank-logo-min bank-"+this._private.bankData[id].alias);
			$("#cardNo").html(this._private.bankData[id].depositcard);
			$("#bankname").html(this._private.bankData[id].bankname);
		},
		sandclock :  function(id) {
			var counter = 0;
			var $btn = $("#"+id);
			return {
				start : function() {
					var run = function() {
						if (counter == 0) {
							$btn.attr("m-state","").html("获取");
						} else {
							$btn.html("剩余"+(counter--)+"秒");
							setTimeout(run, 1000);
						}
					}
					counter = 60;
					$btn.attr("m-state","disabled").html("剩余"+(counter--)+"秒");
					setTimeout(run, 1000);
				},
				readyStart : function() {
					if (counter == 0) {
						return true;
					} else {
						false;
					}
				}
			}
		},
		sendBankCodeAuthCode : function(event) {
			if (this.sandclock1.readyStart()) {
				$.hsf.startLoading();
				var that = this;
				var mobile = this.$mobile.UITextField("value");
				var u = this._private.userInfo;
				if(mobile.length==0){
					$.UIPopup("手机号码不能为空");
					$.hsf.stopLoading();
					return false;
				}
				if(mobile.length!=11){
					$.UIPopup("请输入11位手机号码");
					$.hsf.stopLoading();
					return false;
				}
				this.validForm.add("mobile", mobile).add("empty", this._private.channelid, "请选择银行")
				if (this.validForm.valid()) {
					this.form.add("servicename", "MsgSend")
					.add("channelid", this._private.channelid)
					.add("depositacct", this._private.depositcard)
					.add("certificatetype", u.certificatetype)
					.add("certificateno", u.certificateno)
					.add("mobileno", mobile)
					.add("custname", u.custname);
					$.hsf.ajax.app("capital/bank/bankSwiftAuth", this.form.generate(), "sendMobileAuthcodeCallback", function(jsonResult) {
						$.hsf.stopLoading();
						if (jsonResult.successful) {
							$("#send-bank-code-mobileFix").html(mobile.substr(0,3)+"****"+mobile.substr(7,4));
							$("#send-bank-code-notice").show();
							that.sandclock1.start();
						} else {
							$.hsf.callFailProcess(jsonResult)
						}
					});
				} else {
					$.hsf.stopLoading();
				}
			}
			return false;
		},
		nextBeforeCode : function() {
			var that = this;
			var mobile = this.$mobile.UITextField("value");
			var verifyCode = this.$verifyBankCode.UITextField("value");
			var u = this._private.userInfo;
			if(mobile.length==0){
				$.UIPopup("手机号码不能为空");
				$.hsf.stopLoading();
				return false;
			}
			if(mobile.length!=11){
				$.UIPopup("请输入11位手机号码");
				$.hsf.stopLoading();
				return false;
			}
			this.validForm.add("mobile", mobile);
			if (this.validForm.valid()) {
				$.hsf.startLoading();
				this.form.add("servicename", "MsgCheck")
					.add("channelid", this._private.channelid)
					.add("depositacct", this._private.depositcard)
					.add("certificatetype", u.certificatetype)
					.add("certificateno", u.certificateno)
					.add("mobileno", mobile)
					.add("custname", u.custname)
				if(verifyCode.length!=6){
					$.UIPopup("请输入6位验证码");
					$.hsf.stopLoading();
					return false;
				};
				this.form.add("verificationcode", verifyCode);
				$.hsf.ajax.app("capital/bank/bankSwiftVerify", this.form.generate(), "bankSwiftVerifyCallback", function(jsonResult) {
					$.hsf.stopLoading();
					if (jsonResult.successful) {
						window.location.hash = "reset-trade-pw-2";
					} else {
						$.hsf.callFailProcess(jsonResult)
					}
				});
			}
		},
		events : {
			"tap #cardTypeDD" : "toggleCardType",
			"tap #verifyBankCodeNextBtn[m-state!='disabled']" : "nextBeforeCode",
			"tap #send-bank-code" : "sendBankCodeAuthCode"
		},
		uiEvent : function() {
			var that = this;
			this.$cardTypeBox.UIPopOption();
			this.$cardTypeBox.UIPopOption("change", function(mid) {
				that.changeSelectCard(mid);
			});	
		}
	});
});

define("pages/reset-trade-pw-2", ["global", "Backbone"], function(G) {
	return Backbone.View.extend({
		el : "#reset-trade-pw-2",
		$payPsw :$("#pay-psw"),
		$payRepeatPsw : $("#pay-repeat-psw"),
		_private : {},
		validForm : $.validForm(),
		initialize: function(parent) {
			this.parent = parent;
			this.uiEvent();
			this.validForm = $.validForm();
			this.form = $.formGenerate();
			$.checkNullGroup([this.$payRepeatPsw, this.$payPsw], $("#nextBtn5"));
		},
		afterSwitchView: function() {},
		next : function() {
			var payPsw = this.$payPsw.UITextField("value"),
            payRepeatPsw = this.$payRepeatPsw.UITextField("value"),
            that = this;
            this.validForm.add("strlength", {value: payPsw, size: 6} , "请输入6位数字密码，相邻4位不能连续且相邻3位不能相同");
            this.validForm.add("num", payPsw, "请输入6位数字密码，相邻4位不能连续且相邻3位不能相同"); 
            this.validForm.add("notasc4", payPsw, "请输入6位数字密码，相邻4位不能连续且相邻3位不能相同");
	        this.validForm.add("notrp3", payPsw, "请输入6位数字密码，相邻4位不能连续且相邻3位不能相同");
            this.validForm.add("equal", {origin:payPsw, target:payRepeatPsw}, "密码不一致");
            if (this.validForm.valid()) {
				$.hsf.startLoading();
				this.form.add("newpwd",payPsw).add("pwdtype","0");
	        	$.hsf.ajax.app("account/pwd/resetpwd", this.form.generate(), "resetpwdCallback", function(jsonResult) {
					$.hsf.stopLoading();
					if (jsonResult.successful) {
						$.UIPopup("交易密码重置成功", function() {
							that.parent.finish();
						});
					} else {
						$.hsf.callFailProcess(jsonResult)
					}
				});
            }
		},
		events : {
			"tap #nextBtn5[m-state!='disabled']" : "next",
		},
		uiEvent : function() {
			var that = this;
			$("#change-paypsw-visiable").UISwitch("change", function(value) {
                if (value == 1) {
                	that.$payPsw.find('input').attr("type", 'text');
                } else {
                    that.$payPsw.find('input').attr("type", 'password');
                }
            });
            $("#change-repeatpaypsw-visiable").UISwitch("change", function(value) {
                if (value == 1) {
                    that.$payRepeatPsw.find('input').attr("type", 'text');
                } else {
                    that.$payRepeatPsw.find('input').attr("type", 'password');
                }
            });
		},
	});
});

define('pages/reset-trade-pw', function() {
	return $.bone('reset-trade-pw-1');
});
