define("pages/risk-test-1", ["Backbone"], function(Backbone) {
	return Backbone.View.extend({
		_private :{},
		el : "#risk-test-1",
		initialize: function(parent, platform) {
			this.parent = parent;
			this.platformApi = platform;
			this.loadQuestion();
		},
		riskDict : {
			"":"",
			"1":"保守型",
			"2":"稳健型",
			"3":"积极型"
		},
		loadQuestion : function() {
			var that = this;
			this.validForm = $.validForm()
			$.hsf.startLoading();
            $.hsf.ajax.app("account/risk/riskForm","","riskCallBack", function (jsonResult){
                if(jsonResult.successful){
                	var data = jsonResult.result.data;
                	var question = [];
                	for (var index in data) {
                		var qname = data[index].questionname;
                		if(question[qname]) {
                			question[qname].push(data[index]);
                		} else {
                			question[qname] = [data[index]];
                		}
                	}
                    $.doTemplate("risk-form", question);
                    $("[m-role='UITableView']").UITableView();
                    that.initCheckNullGroup();
                    that._private.qNum = data.length;
                    $.hsf.stopLoading();
                }else{
                    $.hsf.callFailProcess(jsonResult);
                }
            });
		},
		initCheckNullGroup : function() {
			var that = this;
			this._private.questionTableView = [];
            $("[m-role='UITableView']").each(function(i,n) {
            	that._private.questionTableView.push($(n));
            })
            $.checkNullGroup(this._private.questionTableView, $("#riskSubmit"));
		},
		events : {
			"tap #riskSubmit":"riskSubmit",
		},
		riskSubmit : function() {
			var answer = [];
			var pointlist = [];
			var that = this;
			this._private.questionTableView.forEach(function(n) {
				var mid = n.UITableView("marked")[0];
				answer.push(mid.split("|")[0]);
				pointlist.push(mid.split("|")[1]);
			});
			$.hsf.startLoading();
			$.hsf.ajax.app("account/risk/riskAssessment","iscontinue=1&pointlist="+pointlist.join("|")+"&answer="+answer.join("|"),"riskAssessmentCallback", function (jsonResult){
				if (jsonResult.successful) {
					$.hsf.stopLoading();
					var custrisk = that.riskDict[jsonResult.result.custrisk];
					that.parent.setParam("custrisk", custrisk);
					that.platformApi.changeRisk && that.platformApi.changeRisk(custrisk); 
					window.location.hash = "risk-test-2";
				}
			});
		}
	});
});
define("pages/risk-test-2", ["Backbone"], function() {
	return Backbone.View.extend({
		title: {
			left: {
				show: false
			}
		},
		initialize : function(parent) {
			$.doTemplate("riskLevel-template", parent.getParam("custrisk"));
		}
	});
});
define("pages/risk-test", ["Backbone"], function() {
	return $.bone("risk-test-1");
});
