/**
 * Created by apple on 15/5/29.
 */
define(["Backbone"],function(Backbone) {
	return Backbone.View.extend({
		el : "#setting",
		title : {
			left : {
				show : false
			}, 
			center : {
				text : "设置"
			},
			border : {
				show :  false
			}
		},
		_private : {
			loginSucc : false	
		},
        initialize:function(parent, platformApi) {
        	var that = this;
			this.parent = parent;
			this.platformApi = platformApi;
			$.platform.getCache("openId", function(openId) {
				that._private.openId = openId||"";
				that.loadNotify();
			});
			this.isLoginOrNot();
			$.hsf.Event.addListener("logout", function() {
                that.renderNoLoginPage();
			/*}).addListener("notify", function(result) {
				that.showNotifyIcon(result);
			}).addListener("clearNotify", function(result) {
				that.showNotifyIcon(result);*/
			}).addListener("trade", function(result) {
				that.loadNotify(false);
				//that.showNotifyIcon(result);
			});
			//this.showNotifyIcon();
			this.loadUserInfo();
			this.platformApi.initPage(this);
			var $cardTypeBox = $("#cardTypeBox");
			$cardTypeBox.UIPopOption({title:"请选择联系方式"});
			$cardTypeBox.UIPopOption("change", function(mid) {
				if (mid == "1") {
					window.open("tel:4008202888");
				} else {
					that.platformApi.openChat();
				}
			});

			setTimeout(function () {
				// this.getLoginInfo();
				$.platform.getCache("logininfo",function (result) {
					if(result && result.riskenddate2){
						var riskenddate = result.riskenddate;	//风险过期日期
						var validDate = result.validdate;		//证件有效期
						var myDate = $.hsf.hsTools.getCurrentDay();

						if(parseFloat(myDate) > parseFloat(riskenddate)){
							$.UIConfirm("您的风险测评有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
								if (o == "yes") {
									$.hsf.hsOpen("account-info.html");
								}
							});
						}else if(parseFloat(myDate) > parseFloat(validDate)){
							$.UIConfirm("您的证件有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
								if (o == "yes") {
									$.hsf.hsOpen("account-info.html");
								}
							});
						}else {
							console.log("都没过期");
						}
					}else {
						$.hsf.ajax.app("account/account/accountinfo","","checkLoginCode",function(jsonResult) {
							if (jsonResult.successful) {
								var custtype = jsonResult.result.custtype;
								$.platform.removeCache("logininfo");
								$.platform.putCache("logininfo", jsonResult.result);
								var riskenddate = jsonResult.result.riskenddate;	//风险过期日期
								var validDate = jsonResult.result.validdate;		//证件有效期
								var myDate = $.hsf.hsTools.getCurrentDay();

								if(parseFloat(myDate) > parseFloat(riskenddate)){
									$.UIConfirm("您的风险测评有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
										if (o == "yes") {
											$.hsf.hsOpen("account-info.html");
										}
									});
								}else if(parseFloat(myDate) > parseFloat(validDate)){
									$.UIConfirm("您的证件有效期已失效,请尽快修改,否则将影响您的基金交易！", function(o){
										if (o == "yes") {
											$.hsf.hsOpen("account-info.html");
										}
									});
								}else {
									console.log("都没过期");
								}
							}
						});
					}
				});
			},1000);
        },
		loadNotify : function(){
			var that = this;
			$.hsf.startLoading();
			var data = "functionCode=1053&wx_username=" + this._private.openId + "&funcType=1";
			$.hsf.ajax.app("wxzt/m", data, "", function(jsonResult) {
				if (jsonResult.successful) {
					$.hsf.stopLoading();
					if (jsonResult.message) {
						var message = jsonResult.message;
						var json = eval("(" + message + ")");
						if(json.result && parseFloat(json.result) > 0){
							$("#notifyIcon").html(json.result).show();
						} else {
							$("#notifyIcon").hide();
						}
					}
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		isLoginOrNot : function (opt) {
			var checkLoginNotExist = function() {
				return document.getElementById("login") == null;
			};
			var login = function() {
				if (checkLoginNotExist()) {//内外两次判断可能会优化减少一次连接
					$.hsf.ajax.html("../pages/login-view.html", function(html) {
						if (checkLoginNotExist()) {//如果login界面已经弹出则不加载
							$("body").prepend(html);
							require(["pages/login-view"], function(m) {
								m.init();
								opt && opt.disableHistoryBack && m.disableHistoryBack();
							})
						} else {
							return;
						}
					});
				}
			};
			if ($.hsf.platform() == "platform/weixinapi") {
				$.hsf.ajax.app("account/weixinlogin/islogin", "", "loginCallback", function(jsonResult) {
					if (jsonResult.successful) {
						if (jsonResult.isBinded == "0") {
							setTimeout(login, 100);
						}
					} else if (jsonResult.code == "APP-5BP0012") {
						$.UIAlert("您的请求的页面已过期。请返回微信", function() {
							require(["wx"], function(wx) {
								typeof wx != "undefined" && wx.closeWindow();
							})
						});
					}
				});
			}
		},
        /*showNotifyIcon : function() {
        	$.platform.getCache("notify", function(result) {
        		result = result || {num:0};
        		if (result.num == 0) {
        			$("#notifyIcon").hide();	
        		} else {
        			$("#notifyIcon").html(result.num).show();
        		}
        		
        	})
        },*/
        renderNoLoginPage : function() {
        	this._private.loginSucc = false;
        	$.doTemplate("personInfo-tempalte", {}, "refresh");
        	$("#logoutBtn").hide();
        },
        renderLoginPage : function(result) {
        	this._private.loginSucc = true;
        	$.doTemplate("personInfo-tempalte", result, "refresh");
			if(this.platformApi.channel == "android"){
				$("#logoutBtn").show();
			}else if(this.platformApi.channel == "iphone"){
				$("#logoutBtn").show();
			}else{
				$("#logoutBtn").hide();
			}
        },
        loadUserInfo : function(){
        	var that = this;
			$.hsf.startLoading();
			$.hsf.ajax.app("account/account/accountinfo", "", "checkLoginCode", function(jsonResult) {
				if (jsonResult.successful) {
					jsonResult.result.islogin = !$.isEmptyObject(jsonResult.result);
					jsonResult.result.islogin ? that.renderLoginPage(jsonResult.result) : that.renderNoLoginPage();
					$.hsf.stopLoading();
				} else if (jsonResult.code == "ETS-5BP00001") {
					that.renderNoLoginPage();
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
        },
        goInfo : function() {
            var that = this;
            var url = "";
            $.platform.getCache("logininfo", function(result) {
                if (result) {
                    var custRole = result.custtype;
                    if(custRole == "1"){//代销用户
                        $.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
                            if (o == "yes") {
                                $.hsf.hsOpen("account-openAcco-gdbdx.html");
                            }
                        });
                    }else{
                        if(custRole=="3"){
                            url = "account-openAcco-new.html";
                            url = url+"?custtype="+custRole+"&mobile="+result.Mobile+"&userid="+result.userid;
                        }else{
                            url = "account-info.html";
                        }
                        that.loginThenGo(url);
                    }

                }else{
                    that.loginThenGo(url);
				}
            });
        	// this.loginThenGo("account-info.html");
           // this.loginThenGo("account-openAcco-new.html");
        	return false;
        },
        goAccountSafe : function() {
        	// $.hsf.hsOpen("reset-bind-mobile.html");
			this.inprofit("account-safe.html");
        	//this.loginThenGo("account-safe.html");
        	return false;
        },
		avgrList : function(){
			this.inprofit("avgr-list.html");
			return false;
		},
        goBankcard : function() {
            var that = this;
            var url = "";
            $.platform.getCache("logininfo", function(result) {


                if (result) {
                    var custRole = result.custtype;
                    if(custRole == "1"){//代销用户
                        $.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
                            if (o == "yes") {
                                $.hsf.hsOpen("account-openAcco-gdbdx.html");
                            }
                        });
                    }else{
                        if(custRole=="3"){
                            url = "account-openAcco-new.html";
                            url = url+"?custtype="+custRole+"&mobile="+result.Mobile+"&userid="+result.userid;
                        }else{
                            url = "bankcard.html";
                        }
                        that.loginThenGo(url);
                    }

                }else{
                    that.loginThenGo(url);
                }
            });
			// this.inprofit("bankcard.html");
        	// this.loginThenGo("bankcard.html");
        	return false;
        },
        loginThenGo : function(url) {
        	if (this._private.loginSucc) {
        		$.hsf.hsOpen(url);
        	} else {
        		$.hsf.innerLogin();
        	}
        },
        events:{"tap #signin" : "login",
            "tap #regist" : "regist",
        	"tap #personInfo" : "goInfo",
        	"tap #account-safe" : "goAccountSafe",
			"tap #avgr-list" : "avgrList",
        	"tap #bankcard" : "goBankcard",
        	"tap #logoutBtn" : "logout",
			"tap #share-btn" : "shareBtn",
			"tap #callServer" : "callServer"
		},
		callServer : function(){
			this.platformApi.openChat();
		},
		shareBtn : function(){
			this.platformApi.share("http://www.epf.com.cn/minisite/20160614/download/index.html", "下载光大保德信基金APP，申购0费率！", "下载APP体验“耀钱包”活期理财，随存随取，更可享全场基金购买0折起！", "http://www.epf.com.cn/webimages/upload2012/2016/08/23/095653078_294_ece2bb97-0e60-3f5a-b292-9af85f4700ad.png");
			return false;
		},
        login : function() {
    	    $.hsf.innerLogin();
            return false;
        },
        regist : function() {
             // $.hsf.hsOpen("mobile-regist.html");
			$.hsf.innerLogin();
			return false;
        },
		inprofit : function(url){
			var that = this;
			$.platform.getCache("logininfo", function(result) {
				if (result) {
					var custRole = result.custtype;
					if(custRole == "1"){//代销用户
						$.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
							if (o == "yes") {
								$.hsf.hsOpen("account-openAcco-gdbdx.html");
							}
						});
					}else{
                        if(result.Mobile){
                            url = url+"?custtype="+custRole+"&mobile="+result.Mobile;
                        }else{
                            url = url+"?custtype="+custRole;
						}
						that.loginThenGo(url);
					}
                   /* if(custRole=="3"){
                        url = url+"?custtype="+custRole+"&mobile="+result.Mobile;
                    }else{
                        url = url+"?custtype="+custRole;
                    }*/
                    // that.loginThenGo(url);
				}else{
					$.hsf.ajax.app("account/account/accountinfo","","checkLoginCode",function(jsonResult) {
						if (jsonResult.successful) {
							var custtype = jsonResult.result.custtype;
							$.platform.removeCache("logininfo");
							$.platform.putCache("logininfo", jsonResult.result);
							if(custtype == "1"){//代销用户
								$.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
									if (o == "yes") {
										$.hsf.hsOpen("account-openAcco-gdbdx.html");
									}
								});
							}else{
								that.loginThenGo(url);
							}
						}else{
							$.hsf.callFailProcess(jsonResult);
						}
					});
				}
			});
		},
        logout : function() {
        	$.UIConfirm({"html":"退出？","submitText":"确定","cancelText":"取消"},function(result){
                if(result == "yes") {
                	$.hsf.startLoading();
                    $.hsf.ajax.app("account/login/logout","","logoutCallback",function(jsonResult){
                        if(jsonResult.successful){
                        	$.hsf.stopLoading();
                            $.platform.removeCache("fundlist");
                            $.platform.removeCache("logininfo");
                            $.platform.removeCache("gestureStatus");
                            $.platform.removeCache("login");
                        	$.hsf.Event.trigger("logout", "");
                        } else{
                            $.hsf.callFailProcess(jsonResult);
                            return false;
                        }
                    });
                }
            })
        }
	});
});