﻿define("pages/trade-avgr-modify-1", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		el: "#trade-avgr-modify-1",
		$applysum : $("#applysum"),
		fundcode : $.hsf.hsTools.getParam("fundcode"),
		fundname : $.hsf.hsTools.getParam("fundname"),
		buyplanno : $.hsf.hsTools.getParam("buyplanno"),
		sellplanno : $.hsf.hsTools.getParam("sellplanno"),
		_private :{
			saveplanflag:1,
			operway:1
		},
		initialize: function(parent,platformApi) {
			var that = this;
			this.parent = parent;
			this.validForm = $.validForm();
            //lxf add start
            $.platform.getCache("logininfo", function(result) {
                if (result) {
                    var custRole = result.custtype;
                    if(custRole == "1"){//代销用户
                        $.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
                            if (o == "yes") {
                                $.hsf.hsOpen("account-openAcco-gdbdx.html");
                            }
                        });
                    }else{
                        if(custRole=="3"){
                            $.UIAlert("请先绑定一张银行卡", function(){
                                url = "account-openAcco-new.html";
                                url = url+"?custtype="+custRole+"&mobile="+result.Mobile+"&userid="+result.userid;
                                $.hsf.hsOpen(url);
                            });

                        }else{
                            that.packForm();
                            // this.initFundInfo();
                        }
                    }
                }else{

                }
            });
            $.platform.initPage&&$.platform.initPage();
            //lxf add end

			// this.packForm();   lxf delete

			//this.initFundInfo();
			this.formGenerate = $.formGenerate();
			this.platformApi = platformApi;
			$.checkNullGroup([this.$applysum], $("#purchaseBtn"));
			$.UIPasswordKeyboard("init", {
				paying : "正在修改，请稍候…",
				inputComplete : function(pw, succ, fail) {
					var param = that.getAvgrParam();
					var g = that.formGenerate.add("fundcode", that.fundcode)
					.add("operway", that._private.operway)
					.add("saveplanflag", that._private.saveplanflag)
					.add("investcycle", param[0])
					.add("investcyclevalue", param[1])
					.add("tpasswd", pw)
					.add("transactionaccountid", that._private.transactionaccountid);
					/*.add("buyplanno", that.buyplanno);*/
					if(that.sellplanno){
						g.add("sellplanno", that.sellplanno).add("sellvalue",that.getApplySum()).add("codeoftargetfund",that._private.codeoftargetfund);
						$.hsf.ajax.app("trade/fxiredeem/modifyFixRedeem", g.generate(), "modifyFixDeclareCallback", function(jsonResult) {
							if (jsonResult.successful) {
								succ();
								that.platformApi.triggerSucc && that.platformApi.triggerSucc();
								window.location.hash = "trade-avgr-modify-2";
							} else {
								fail(jsonResult.message);
							}
						});
					}else{
						g.add("buyplanno", that.buyplanno).add("continueinvestamount", that.getApplySum());
						$.hsf.ajax.app("trade/valuavgr/modifyFixDeclare", g.generate(), "modifyFixDeclareCallback", function(jsonResult) {
							if (jsonResult.successful) {
								succ();
								that.platformApi.triggerSucc && that.platformApi.triggerSucc();
								window.location.hash = "trade-avgr-modify-2";
							} else {
								fail(jsonResult.message);
							}
						});
					}
				}
			});
		},
		initFundInfo : function() {
			$.doTemplate("fundinfo-template", {fundcode: this.fundcode, fundname: this.fundname});
		},
		events : {
			"tap #purchaseBtn[m-state!='disabled']" : "inputPassword"
		},
		packForm : function() {
			var that = this;
			if(this.sellplanno){
				var f = $.formGenerate().add("fundcode", this.fundcode).add("operway", this._private.operway).add("sellplanno", this.sellplanno);
				$.hsf.startLoading();
				$.hsf.ajax.app("trade/fxiredeem/modifyFixRedeemFrom", f.generate(), "modifyFixRedeemFromCallback", function(jsonResult) {
					if (jsonResult.successful) {
						var protocol = jsonResult.result.data[0];
						that._private.saveplanflag = protocol.saveplanflag;
						that._private.transactionaccountid = protocol.transactionaccountid;
						$.doTemplate("periodStyle-template", that._private.saveplanflag);
						that.uiEvent();
						if (protocol.investcycle == "0") {
							$("#jyrq_0").UISelectField("value", protocol.investcyclevalue);
						} else {
							$("#jyrq_1").UISelectField("value", protocol.investcyclevalue);
						}
						$("[m-name='periodStyle'][m-value='"+protocol.investcycle+"']").tap();
						that.$applysum.UITextField("value", protocol.sellvalue);
						that._private.min = 0;
						$.doTemplate("tip1-template", "最少定投金额"+that._private.min+"元", "refresh");
						that._private.transfundlist = jsonResult.result.transfundlist;
						$("#selectedBankName").html("耀钱包");
						$("#selectedBankcardNo").html($.hsf.hsTools.maskCardCenter(protocol.depositacct));
						$("#selectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-xjb");
						$("#targetFundcodeList").show();
						that.packXjbPage(protocol);
						$.hsf.stopLoading();
					} else {
						$.hsf.callFailProcess(jsonResult);
					}
				});
			}else{
				$.doTemplate("fundinfo-template", {fundcode: that.fundcode, fundname: that.fundname});
				var f = $.formGenerate().add("fundcode", this.fundcode).add("operway", this._private.operway).add("buyplanno", this.buyplanno);
				$.hsf.startLoading();
				$.hsf.ajax.app("trade/valuavgr/modifyFixDeclareFrom", f.generate(), "modifyFixDeclareFromCallback", function(jsonResult) {
					if (jsonResult.successful) {
						var protocol = jsonResult.result.fixprotocol;
						that._private.saveplanflag = protocol.saveplanflag;
						$.doTemplate("periodStyle-template", that._private.saveplanflag);
						that.uiEvent();
						if (protocol.investcycle == "0") {
							$("#jyrq_0").UISelectField("value", protocol.investcyclevalue);
						} else {
							$("#jyrq_1").UISelectField("value", protocol.investcyclevalue);
						}
						$("[m-name='periodStyle'][m-value='"+protocol.investcycle+"']").tap();
						that.$applysum.UITextField("value", protocol.continueinvestamount);
						that._private.min = jsonResult.result.fundstate.per_min_39||0;
						$.doTemplate("tip1-template", "最少定投金额"+that._private.min+"元", "refresh");
						that._private.bankCards = jsonResult.result.data;
						that.packFirstPage(protocol);
						$.hsf.stopLoading();
					} else {
						$.hsf.callFailProcess(jsonResult);
					}
				});
			}

		},
		packXjbPage : function(protocol) {
			if (this._private.transfundlist.length > 0) {
				for (var index in this._private.transfundlist) {
					if (this._private.transfundlist[index].targetfundcode == protocol.codeoftargetfund) {
						this.changePay("1_"+ index);
						return;
					}
				}
				this.changePay("1_0");
			} else {
				$.UIConfirm({"html":"您还没有可以交易的银行卡，是否添加?", "submitText":"确定","cancelText":"取消"}, function(result) {
					if (result == "yes") {
						$.hsf.hsOpen("add-bankcard.html");
					} else {
						$.hsf.hsBack();
					}
				});
			}
		},
		changeBankCard : function(index) {
			var card = this._private.bankCards[index];
			this._private.transactionaccountid = card.transactionaccountid;
			$("#selectedBankName").html(card.bankname);
			$("#selectedBankcardNo").html($.hsf.hsTools.maskCardCenter(card.depositcard));
			$("#selectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-"+card.alias);
		},
		changeTargetFundcode : function(index) {
			var card = this._private.transfundlist[index];
			//this._private.transactionaccountid = card.transactionaccountid;
			this._private.codeoftargetfund = card.targetfundcode;
			$.doTemplate("fundinfo-template", {fundcode: card.targetfundcode, fundname: card.fundname});
			/*$("#targetFundName").html(card.fundname);
			$("#targetFundcode").html(card.targetfundcode);
			$("#targetFundcodeIcon").removeAttr("class").addClass("bank-logo bank-xjb");*/
		},
		changePay : function(mid) {
			var t = mid.split("_");
			if (t[0] == "0") {
				this.changeBankCard(t[1]);
			}else if(t[0] == "1"){
				this.changeTargetFundcode(t[1]);
			}
		},
		packFirstPage : function(protocol) {
			if (this._private.bankCards.length > 0) {
				$.doTemplate("banklist-template", this._private.bankCards);
				$("[m-role='UITableView']").UITableView("refresh");
				for (var index in this._private.bankCards) {
					if (this._private.bankCards[index].transactionaccountid == protocol.transactionaccountid) {
						this.changePay("0_"+ index);
						return;
					}
				}
				this.changePay("0_0");
			} else {
				$.UIConfirm({"html":"您还没有可以交易的银行卡，是否添加?", "submitText":"确定","cancelText":"取消"}, function(result) {
					if (result == "yes") {
						$.hsf.hsOpen("add-bankcard.html");
					} else {
						$.hsf.hsBack();
					}
				});
			}
		},
		getApplySum : function() {
			return $.hsf.hsTools.recoveryMoney(this.$applysum.UITextField("value"));
		},
		demical2ApplySum : function() {
			var value = this.$applysum.UITextField("value");
			if (!isNaN(parseFloat(value))) {
				this.$applysum.UITextField("value", parseFloat(value).toFixed(2));
			}
		},
        inputPassword : function() {
        	this.validForm.add("more", {origin: this.getApplySum(), target: 0}, "请输入金额");
        	this.validForm.add("moreEqual", {origin: this.getApplySum(), target: this._private.min}, "最少购买"+this._private.min+"元");
        	if (this.validForm.valid()) {
        		this.demical2ApplySum();
        		$.UIPasswordKeyboard("show", {
        			key: "金额:",
        			value : $.hsf.hsTools.formatMoney(this.getApplySum())+"元"
        		});
        	}
        	return false;
        },
        uiEvent : function() {
        	var that = this;
        	$("[m-name='periodStyle']").UIRadio();
			$("[m-name='periodStyle']").UIRadio("change", function(e) {
				if (e.value == "0") {
					$("#jyrq_1").hide();
					$("#jyrq_0").show();
				} else {
					$("#jyrq_0").hide();
					$("#jyrq_1").show();
				}
				return false;
			});
       },
       getAvgrParam : function() {
			var jyzq = $("[m-name='periodStyle']").UIRadio("value");
			if (jyzq == "0") {
				var jyrq = $("#jyrq_0").UISelectField("value");
				return ["0", jyrq];
			} else if(jyzq == "1") {
				var jyrq = $("#jyrq_1").UISelectField("value");
				return ["1", jyrq];
			}
		},
	});
});
define("pages/trade-avgr-modify-2", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		title : {
			left : {
				show : false
			},
			center : {
				text : "结果详情"
			}
		},
		initialize : function() {}
	});
});
define("pages/trade-avgr-modify", ['Backbone'], function(Backbone) {
	return $.bone('trade-avgr-modify-1');
});
