﻿define("pages/trade-avgr-1", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		el: "#trade-avgr-1",
		$cardTypeBox : $("#cardTypeBox"),
		$applysum : $("#applysum"),
		fundcode : $.hsf.hsTools.getParam("fundcode")||"",
		fundname : $.hsf.hsTools.getParam("fundname")||"",
		_private :{
			saveplanflag:$.hsf.hsTools.getParam("saveplanflag"),
			operway:0,
			xjbAccounts : []
		},
		initialize: function(parent,platformApi) {
			var that = this;
			this.parent = parent;
			this.validForm = $.validForm();
            $.platform.getCache("logininfo", function(result) {
                if (result) {
                    var custRole = result.custtype;
                    if(custRole == "1"){//代销用户
                        $.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
                            if (o == "yes") {
                                $.hsf.hsOpen("account-openAcco-gdbdx.html");
                            }
                        });
                    }else{
                        if(custRole=="3"){
                            $.UIAlert("请先绑定一张银行卡", function(){
                                url = "account-openAcco-new.html";
                                url = url+"?custtype="+custRole+"&mobile="+result.Mobile+"&userid="+result.userid;
                                $.hsf.hsOpen(url);
                            });

                        }else{
                            that.packForm();
                            that.initFundInfo();
                        }
                    }
                }else{
					// console.log("getCache logininfo failed");
					that.packForm();
					that.initFundInfo();
                }
            });
            $.platform.initPage&&$.platform.initPage();
			//this.initJyrqOption();
			// this.packForm();
			// this.initFundInfo();
			this.formGenerate = $.formGenerate();
			this.platformApi = platformApi;
			this.uiEvent();
			$.checkNullGroup([this.$applysum], $("#purchaseBtn"));
			$.UIPasswordKeyboard("init", {
				inputComplete : function(pw, succ, fail) {
					var param = that.getAvgrParam();
					var g = that.formGenerate.add("fundcode", that.fundcode)
					.add("operway", that._private.operway)
					.add("saveplanflag", that._private.saveplanflag)
					.add("investcycle", param[0])
					.add("investcyclevalue", param[1])
					.add("tpasswd", pw)
					.add("continueinvestamount", that.getApplySum())
					.add("transactionaccountid", that._private.transactionaccountid);
					if(that._private.flag == "1"){
						g.add("moneybuyotherfund","1");
					}
					$.hsf.ajax.app("trade/valuavgr/modifyFixDeclare", g.generate(), "modifyFixDeclareCallback", function(jsonResult) {
						if (jsonResult.successful) {
							succ();
							if(that._private.flag == "1"){
								that.parent.setParam("firstinvestdate", $.hsf.hsTools.yyyy_mm_dd(jsonResult.result.firstsale_date));
							}else{
								that.parent.setParam("firstinvestdate", $.hsf.hsTools.yyyy_mm_dd(jsonResult.result.firstinvestdate));
							}
							that.platformApi.triggerSucc && that.platformApi.triggerSucc();
							window.location.hash = "trade-avgr-2";
						} else {
							fail(jsonResult.message);
						}
					});
				}
			});
		},
		initJyrqOption : function() {
			$.doTemplate("periodStyle-template", this._private.saveplanflag);
		},
		initFundInfo : function() {
			$.doTemplate("fundinfo-template", {fundcode: this.fundcode, fundname: this.fundname});
		},
		events : {
			"tap #bankcardSelect" : "toggleCardType",
			"tap .m-select-box-opt" : "cardTypeSelectComplete",
			"tap #purchaseBtn[m-state!='disabled']" : "inputPassword"
		},
		toggleCardType : function() {
			$("input, select").blur();
			this.$cardTypeBox.UIPopOption("open");
		},
		packForm : function() {
			var that = this;
			var f = $.formGenerate().add("fundcode", this.fundcode).add("saveplanflag", this._private.saveplanflag).add("operway", this._private.operway);
			$.hsf.startLoading();
			$.hsf.ajax.app("trade/valuavgr/modifyFixDeclareFrom", f.generate(), "modifyFixDeclareFromCallback", function(jsonResult) {
				if (jsonResult.successful) {
					$("#fundcode").html(jsonResult.result.fundstate.fundcode);
					$("#fundname").html(jsonResult.result.fundstate.fundname);
					that._private.min = jsonResult.result.fundstate.per_min_39 || 100;
					that._private.max = jsonResult.result.fundstate.per_max_39;
					if(that._private.min){
						$("#applysum").attr("m-min", that._private.min);
					}else{
						$("#applysum").removeAttr("m-min");
					}
					if(that._private.max){
						$("#applysum").attr("m-max", that._private.max);
					}else{
						$("#applysum").removeAttr("m-max");
					}
					$.doTemplate("tip1-template", "最少定投金额"+that._private.min+"元", "refresh");
					that._private.bankCards = jsonResult.result.data;
					if(that.fundcode){
						that._private.xjbAccounts = jsonResult.result.moneydata.sort(function(a,b) {
							return (parseFloat(a.balfund) < parseFloat(b.balfund));
						});
					}
					that.packFirstPage();
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		changeBankCard : function(index) {
			var card = this._private.bankCards[index];
			this._private.capsource = "0";
			this._private.transactionaccountid = card.transactionaccountid;
			$("#selectedBankName").html(card.bankname);
			$("#selectedBankcardNo").html($.hsf.hsTools.maskCardCenter(card.depositcard));
			$("#selectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-"+card.alias);
			$.doTemplate("tip1-template", "最少定投金额"+this._private.min+"元", "refresh");
		},
		changePay : function(mid) {
			var t = mid.split("_");
			this._private.flag = t[0];
			if (t[0] == "0") {
				this.changeBankCard(t[1]);
			}else if(t[0] == "1"){
				this.changeXjbAccount(t[1]);
			}
			//$.doTemplate("periodStyle-template", {saveplanflag:this._private.saveplanflag,flag: this._private.flag});
			if(this._private.saveplanflag == "1" && this._private.flag == "0"){
				$("#weekly").show();
			}else{
				$("#weekly").removeAttr("m-checked").hide();
				$("#monthly").attr("m-checked", "yes");
				$("#jyrq_1").hide();
				$("#jyrq_0").show();
			}
		},
		changeXjbAccount : function(index) {
			var card = this._private.xjbAccounts[index];
			this._private.capsource = "1";
			this._private.transactionaccountid = card.transactionaccountid;
			this._private.balfund = card.balfund;
			//this._private.businesskind = this.isSubscribe() ? '2' : '6';
			//this._private.businesscode = this.isSubscribe()?'20':'22';
			this._private.channelid = card.channelid;
			$("#selectedBankName").html(card.bankname);
			$("#selectedBankcardNo").html($.hsf.hsTools.maskCardCenter(card.depositacct));
			$("#selectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-xjb");
			$.doTemplate("tip1-template", "耀钱包可用余额:&nbsp;"+card.balfund+"元", "refresh");
			$("#xjb-tip").show();
			/*if (this._private.min >= card.balfund) {
				$("#applysum").attr("m-min", card.balfund);
			} else {
				$("#applysum").attr("m-min", this._private.min);
			}
			$("#applysum").attr("m-max", card.balfund);*/
			$("#applysum input").trigger("change");
		},

		packFirstPage : function() {
			if (this._private.bankCards.length > 0) {
				$.doTemplate("banklist-template", this._private.bankCards);
				if (this._private.xjbAccounts.length >0) {
					$.doTemplate("moneylist-template", this._private.xjbAccounts);
				}
				$("[m-role='UITableView']").UITableView("refresh");
				if (this._private.xjbAccounts.length >0) {
					this.$cardTypeBox.UIPopOption("select", "1_0");
				}else{
					this.$cardTypeBox.UIPopOption("select", "0_0");
				}
			} else {
				$.UIConfirm({"html":"您还没有可以交易的银行卡，是否添加?", "submitText":"确定","cancelText":"取消"}, function(result) {
					if (result == "yes") {
						$.hsf.hsOpen("add-bankcard.html");
					} else {
						$.hsf.hsBack();
					}
				});
			}
		},
		getApplySum : function() {
			return $.hsf.hsTools.recoveryMoney(this.$applysum.UITextField("value"));
		},
		demical2ApplySum : function() {
			var value = this.$applysum.UITextField("value");
			if (!isNaN(parseFloat(value))) {
				this.$applysum.UITextField("value", parseFloat(value).toFixed(2));
			}
		},
        inputPassword : function() {
        	this.validForm.add("more", {origin: this.getApplySum(), target: 0}, "请输入金额");
        	this.validForm.add("moreEqual", {origin: this.getApplySum(), target: this._private.min}, "最少购买"+this._private.min+"元");
        	if (this.validForm.valid()) {
        		this.demical2ApplySum();
        		$.UIPasswordKeyboard("show", {
        			key: "金额:",
        			value : $.hsf.hsTools.formatMoney(this.getApplySum())+"元"
        		});
        	}
        	return false;
        },
        uiEvent : function() {
        	var that = this;
        	this.$cardTypeBox.UIPopOption({title:"请选择支付方式"});
			this.$cardTypeBox.UIPopOption("change", function(mid) {
				that.changePay(mid);
			});
			$("[m-name='periodStyle']").UIRadio();
			$("[m-name='periodStyle']").UIRadio("change", function(e) {
				if (e.value == "0") {
					$("#jyrq_1").hide();
					$("#jyrq_0").show();
				} else {
					$("#jyrq_0").hide();
					$("#jyrq_1").show();
				}
				return false;
			});
       },
       getAvgrParam : function() {
			var jyzq = $("[m-name='periodStyle']").UIRadio("value");
			if (jyzq == "0") {
				var jyrq = $("#jyrq_0").UISelectField("value");
				return ["0", jyrq];
			} else if(jyzq == "1") {
				var jyrq = $("#jyrq_1").UISelectField("value");
				return ["1", jyrq];
			}
		},
	});
});
define("pages/trade-avgr-2", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		title : {
			left : {
				show : false
			},
			center : {
				text : "结果详情"
			}
		},
		el: "#trade-avgr-2",
		initialize : function(parent) {
			$("#firstinvestdate").html(parent.getParam("firstinvestdate"));
		}
	});
});
define("pages/trade-avgr", ['Backbone'], function(Backbone) {
	return $.bone('trade-avgr-1');
});
