define("pages/trade-buy-1", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		el: "#trade-buy-1",
		$moneycardTypeBox : $("#moneycardTypeBox"),
		$bankcardTypeBox : $("#bankcardTypeBox"),

		$applysum : $("#applysum"),
		fundcode : $.hsf.hsTools.getParam("fundcode"),
		fundname : $.hsf.hsTools.getParam("fundname"),
        riskCut : 0,
		_private :{},
		initialize: function(parent,platformApi) {
			var that = this;
			this.parent = parent;
			this.validForm = $.validForm();
            $.platform.getCache("logininfo", function(result) {
                if (result) {
                    var custRole = result.custtype;
                    if(custRole == "1"){//代销用户
                        $.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
                            if (o == "yes") {
                                $.hsf.hsOpen("account-openAcco-gdbdx.html");
                            }
                        });
                    }else{
                        if(custRole=="3"){
                            $.UIAlert("请先绑定一张银行卡", function(){
                                url = "account-openAcco-new.html";
                                url = url+"?custtype="+custRole+"&mobile="+result.Mobile+"&userid="+result.userid;
                                $.hsf.hsOpen(url);
                            });
                        }else{
                            that.packForm();
                        }
                    }
                }else{

                }
            });
            $.platform.initPage&&$.platform.initPage();
			//this.initFundInfo();
			this.formGenerate = $.formGenerate();
			this.platformApi = platformApi;
			this.uiEvent();
			this.initMoney();
			// $.checkNullGroup([this.$applysum], $("#purchaseBtn"));
			$.UIPasswordKeyboard("init", {
				inputComplete : function(pw, succ, fail) {
					var g = that.formGenerate.add("fundcode", that.fundcode)
					.add("businesscode", that._private.businesscode)
					.add("transactionaccountid", that._private.transactionaccountid)
					.add("tpasswd", pw)
					.add("payflag", 0)
					.add("capsource", that._private.capsource)
					.add("applicationamount", that.getApplySum());
					//进行支付
					$.hsf.ajax.app("trade/buy/buy", g.generate(), "buyCallback", function(jsonResult) {
						if (jsonResult.successful) {
							succ();
							that.parent.setParam("confirmsum", that.getApplySum()+"元");
							that.parent.setParam("operdate",jsonResult.result.operdate);
							that.parent.setParam("confirmdate",jsonResult.result.confirmdate);
							that.platformApi.triggerSucc && that.platformApi.triggerSucc();
							window.location.hash = "trade-buy-2";
						} else {
							fail(jsonResult.message);
						}
					});
				}
			});
			$.hsf.Event.addListener("selectBank", function(selectBankIndex) {
				// that._private.selectCard = selectBankIndex;
				console.log("selectbank",selectBankIndex);
				// that.selectBankProcess(selectBankIndex);
				that.changePay(selectBankIndex);
			}).addListener("selectXjb",function (selectXjbIndex) {
				// that._private.selectCard = selectXjbIndex;
				console.log("selectbank",selectXjbIndex);
				// that.selectBankProcess(selectBankIndex);
				that.changePay(selectXjbIndex);
			});

		},
		initFundInfo : function() {
			$.doTemplate("fundinfo-template", {fundcode: this.fundcode, fundname: this.fundname});
		},
		initMoney : function() {
			this.changeMoney(true, 1000);
		},
		events : {
			"tap .m-select-box-opt" : "cardTypeSelectComplete",
			"tap #money-add" : "operAddMoneyBtn",
			"tap #money-reduce" : "operReduceMoneyBtn",
			"tap #applysum input" : "clearApplySum",
			"tap #purchaseBtn[m-state!='disabled']" : "inputPassword",
			"click #moneybankcardSelect" :"toggleMoneyCardType",
			"click #bankcardSelect" : "toggleBankCardType",
			"tap #moneybankcard" :"moneycardSelect",	//选择耀钱包
			"tap #bankcard" : "bankcardSelect",			//选择银行卡
			"tap #nomoneybankcardSelect" : "nomoneyCardClick"	//没有耀钱包账户
		},
		//切换现金宝
		toggleMoneyCardType : function() {
			// $("input").blur();
			// this.$moneycardTypeBox.UIPopOption("open");
			window.location.hash = "trade-buy-3";
		},
		//切换银行卡
		toggleBankCardType : function () {
			// $("input").blur();
			// this.$bankcardTypeBox.UIPopOption("open");
			$("#moneybankcard").removeAttr("style");
			$("#yaoqianbaoTitle").removeClass("m-font-bold");
			$("#yaoqianbaoTitle").addClass("m-color-9");	//置灰
			$("#yqbTitle").addClass("m-color-9");
			$("#moneyselectedBankName").addClass("m-color-9");
			$("#moneyselectedBankcardIcon").attr("style","-webkit-filter: grayscale(1);");

			//设置银行卡
			$("#selectedBankName").removeClass("m-color-9");
			$("#selectedBankcardNo").removeClass("m-color-9");
			$("#bankTitle").addClass("m-font-bold");		//加粗
			$("#bankTitle").removeClass("m-color-9");
			$("#selectedBankcardIcon").removeAttr("style");
			$("#bankcard").attr("style","border-top:1px solid #ff8e00;border-bottom:1px solid #ff8e00");

			window.location.hash = "trade-buy-4";
		},
		//没有耀钱包账户
		nomoneyCardClick : function () {
			$.UIConfirm({"html":"耀钱包余额不足,现在去存入耀钱包?","cancelText":"取消","submitText":"存入"},function(result){
				if(result != "yes") {
					return false;
				}else{
					$.hsf.hsOpen("trade-money-in.html");
				}
			});
		},
		//点击耀钱包
		moneycardSelect : function () {
            //设置银行卡
            $("#bankcard").removeAttr("style");
            $("#bankTitle").removeClass("m-font-bold");
            $("#bankTitle").addClass("m-color-9");	//置灰
            $("#selectedBankName").addClass("m-color-9");
            $("#selectedBankcardNo").addClass("m-color-9");
            $("#selectedBankcardIcon").attr("style","-webkit-filter: grayscale(1);");
            //设置耀钱包
            $("#yaoqianbaoTitle").addClass("m-font-bold");
            $("#yaoqianbaoTitle").removeClass("m-color-9");
            $("#moneyselectedBankName").removeClass("m-color-9");
            $("#yqbTitle").removeClass("m-color-9");
            $("#moneyselectedBankcardIcon").removeAttr("style");
            $("#moneybankcard").attr("style","border-top:1px solid #ff8e00;border-bottom:1px solid #ff8e00");
		},
		//点击银行卡
		bankcardSelect : function () {
			//设置耀钱包
			$("#moneybankcard").removeAttr("style");
			$("#yaoqianbaoTitle").removeClass("m-font-bold");
			$("#yaoqianbaoTitle").addClass("m-color-9");	//置灰
			$("#yqbTitle").addClass("m-color-9");
			$("#moneyselectedBankName").addClass("m-color-9");
			$("#moneyselectedBankcardIcon").attr("style","-webkit-filter: grayscale(1);");

			//设置银行卡
			$("#selectedBankName").removeClass("m-color-9");
			$("#selectedBankcardNo").removeClass("m-color-9");
			$("#bankTitle").addClass("m-font-bold");		//加粗
			$("#bankTitle").removeClass("m-color-9");
			$("#selectedBankcardIcon").removeAttr("style");
			$("#bankcard").attr("style","border-top:1px solid #ff8e00;border-bottom:1px solid #ff8e00");
		},
		//组装页面
		packForm : function() {
			var that = this;
			$.hsf.startLoading();
			//请求交易的银行卡和耀钱包账户列表
			$.hsf.ajax.app("trade/buy/bankForm", "fundcode="+this.fundcode, "moneyInFormCallback", function(jsonResult) {
				if (jsonResult.successful) {
					$.doTemplate("fundinfo-template", jsonResult.result.fundstate);
					var result = jsonResult.result;
                    var custrisk = result.custrisk;
                    var risklevel = result.fundstate.risklevel;
                    that.riskCut = risklevel - custrisk;
					that._private.status = result.fundstate.status;

					if (that.isDeclare()) {
						//如果是正在发行期
						that._private.min = result.fundstate.per_min_22;
						that._private.max = result.fundstate.per_max_22;
						$.doTemplate("tip1-template-3", "最少申购金额"+that._private.min+"元", "refresh");
					} else if (that.isSubscribe()) {
						//如果是可以认购的
						that._private.min = result.fundstate.per_min_20;
						that._private.max = result.fundstate.per_max_20;
						$.doTemplate("tip1-template-3", "最少认购金额"+that._private.min+"元", "refresh");
					} else {
						//暂停交易
						$.UIAlert("暂停交易", function() {
							$.hsf.hsBack();
						});
					}
					that._private.bankCards = result.data;
					//过滤耀钱包余额为0的
					// result.moneydata = that.filterZeroMoneyAccount(result.moneydata);
					that._private.xjbAccounts = result.moneydata.sort(function(a,b) {
						return (parseFloat(a.balfund) < parseFloat(b.balfund));
					});
					that.parent.setParam("banklist",that._private.bankCards);
					that.parent.setParam("moneylist",that._private.xjbAccounts);
					that.packFirstPage();
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		filterZeroMoneyAccount : function(moneydata) {
			var xjbAccounts = [];
			moneydata.forEach(function(item) {
				if (parseFloat(item.balfund) != 0) {
					xjbAccounts.push(item);
				}
			})
			return xjbAccounts;
		},
		isSubscribe : function() {
			return (this._private.status == "1");
		},
		isDeclare : function() {
			return (this._private.status == "0" || this._private.status == "6");
		},
		//切换银行卡
		changeBankCard : function(index) {
			var card = this._private.bankCards[index];
			this._private.capsource = "0";
			this._private.transactionaccountid = card.transactionaccountid;
			this._private.businesskind = '0';
			this._private.businesscode = this.isSubscribe()?'20':'22';
			this._private.channelid = card.channelid;
			$("#selectedBankName").html(card.bankname);
			$("#selectedBankcardNo").html($.hsf.hsTools.maskCardCenter(card.depositcard));
			$("#selectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-"+card.alias);
			$("#xjb-tip").hide();
			$("#applysum").attr("m-min", this._private.min);
			$("#applysum").attr("m-max", this._private.max);
			$("#applysum input").trigger("change");
			//切换银行卡
			this.bankcardSelect();
		},
		//切换耀钱包
		changeXjbAccount : function(index) {
			var card = this._private.xjbAccounts[index];
			//如果card是undefined,说明没有耀钱包账号
			if(typeof(card) == "undefined"){
				$("#yqbTitle").html("耀钱包");
				// $("#moneyselectedBankName").html(card.bankname+"("+cardstr+")");
				// $("#moneyselectedBankcardNo").html($.hsf.hsTools.maskCardCenter(card.depositacct));
				$("#moneyselectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-xjb");
				$("#remainMoney").html("  "+"0.00");
			}else {
				this._private.capsource = "1";
				this._private.transactionaccountid = card.transactionaccountid;
				this._private.balfund = card.balfund;
				this._private.businesskind = this.isSubscribe() ? '2' : '6';
				this._private.businesscode = this.isSubscribe()?'20':'22';
				this._private.channelid = card.channelid;
				var cardstr = card.depositacct;
				if(cardstr.length>8){
					cardstr = cardstr.substr(cardstr.length-4,4);
				}
				$("#yqbTitle").html("耀钱包");
				$("#moneyselectedBankName").html(card.bankname+"("+cardstr+")");
				// $("#moneyselectedBankcardNo").html($.hsf.hsTools.maskCardCenter(card.depositacct));
				$("#moneyselectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-xjb");
				$("#remainMoney").html("  "+card.balfund);

				// $.doTemplate("tip1-template", "耀钱包可用余额:&nbsp;"+card.balfund+"元", "refresh");
				$("#xjb-tip").show();
				if (this._private.min >= card.balfund) {
					$("#applysum").attr("m-min", card.balfund);
				} else {
					$("#applysum").attr("m-min", this._private.min);
				}
				$("#applysum").attr("m-max", card.balfund);
				$("#applysum input").trigger("change");
				this.moneycardSelect();
			}
		},
		//切换可用余额
		changeAvailableMoney : function() {
        	var bal = this.getAvailableMoney();
        	if (this._private.min >= bal) {
        		$("#applysum").attr("m-min", bal);
        		$.doTemplate("tip-template2", bal);
        	} else {
        		$("#applysum").attr("m-min", this._private.min);
        		$.doTemplate("tip-template2", this._private.min);
        	}
        	$("#applysum").attr("m-max", bal);
        },
		//切换耀钱包或者银行卡
		changePay : function(mid) {
			var t = mid.split("_");
			if (t[0] == "1") {
				this.changeXjbAccount(t[1]);
			} else {
				this.changeBankCard(t[1]);
			}
			this.tradeFare();
		},
		packFirstPage : function() {
			if (this._private.bankCards.length > 0) {
				// $.doTemplate("banklist-template", this._private.bankCards);
				this.changePay("0_0");
				this.changePay("1_0");

				if (this._private.xjbAccounts.length >0) {
					// $.doTemplate("moneylist-template", this._private.xjbAccounts);
					//有耀钱包账户
					// this.$moneycardTypeBox.UIPopOption("select", "1_0");
				}else{
					$("#nomoneybankcardSelect").show();
					$("#moneybankcardSelect").hide();
				}
				$("[m-role='UITableView']").UITableView("refresh");

				if (this._private.bankCards.length > 0){
					// this.$bankcardTypeBox.UIPopOption("select","0_0");
				}
				if (this._private.xjbAccounts.length >0) {
					// this.$moneycardTypeBox.UIPopOption("select", "1_0");
				} else {

				}
			} else {
				$.UIConfirm({"html":"您还没有可以交易的银行卡，是否添加?", "submitText":"确定","cancelText":"取消"}, function(result) {
					if (result == "yes") {
						$.hsf.hsOpen("add-bankcard.html");
					} else {
						$.hsf.hsBack();
					}
				});
			}
		},
		getApplySum : function() {
			return $.hsf.hsTools.recoveryMoney(this.$applysum.UITextField("value"));
		},
		demical2ApplySum : function() {
			var value = this.$applysum.UITextField("value");
			if (!isNaN(parseFloat(value))) {
				this.$applysum.find("input").val(parseFloat(value).toFixed(2));
			}
		},
		changeMoney : function(sign, changevalue){
            var tmpValue=0;
            var inputValue=  this.getApplySum() ==""? 0 :  this.getApplySum();
            if(sign){
                tmpValue=parseInt(inputValue,10)+parseInt(changevalue,10);
            }else{
                tmpValue=parseInt(inputValue,10)-parseInt(changevalue,10);
                tmpValue = tmpValue < 0 ? 0 : tmpValue;
            }
            this.formatApplySum(tmpValue);
        },
        clearApplySum : function() {
        	var money = "";
        	this.formatApplySum(money);
        },
        changeApplySum : function(tmpValue) {
        	var money = $("#applysum").UITextField("value");
        	this.formatApplySum(money);
        },
        formatApplySum : function(applysum) {
        	//$(".buy-big-write").html($.hsf.hsTools.chineseNum(applysum));
        	$("#applysum").UITextField("value", applysum);
        },
        operAddMoneyBtn : function(event) {
        	var _self = $(event.handleObj.selector);
			var changemoney = _self.find(".change-value").html();
			this.changeMoney(true , changemoney)
			return false;
        },
        operReduceMoneyBtn : function(event) {
        	var _self = $(event.handleObj.selector);
			var changemoney = _self.find(".change-value").html();
			this.changeMoney(false , changemoney)
			return false;
        },
		//开始进行购买
        inputPassword : function() {
            var p = this._private;
            var that = this;
            var input = function(){
                that.validForm.add("more", {origin: that.getApplySum(), target: 0}, "请输入金额");
                if (p.capsource == "1") {
					//如果耀钱包金额小于申购金额,则引导耀钱包充值
					// $.UIConfirm({"html":"耀钱包余额不足,现在去存入耀钱包?","cancelText":"取消","submitText":"存入"},function(result){
					// 	if(result != "yes") {
					// 		return false;
					// 	}else{
					// 		return false;
					// 	}
					// });

                    // that.validForm.add("lessEqual", {origin: that.getApplySum(), target: p.balfund}, "请不要大于耀钱包可用份额:&nbsp;"+p.balfund);
                }
                that.validForm.add("moreEqual", {origin: that.getApplySum(), target: p.min}, "最少购买"+p.min+"元");
                if (that.validForm.valid()) {
                    that.demical2ApplySum();
                    $.UIPasswordKeyboard("show", {key: "金额:&nbsp;",
                    value : $.hsf.hsTools.formatMoney(that.getApplySum())+"元"})
                }
                return false;
            }

			if(p.capsource == "1" && (parseFloat(p.balfund) < parseFloat(that.getApplySum()))){
				$.UIConfirm({"html":"耀钱包余额不足,现在去存入耀钱包?","cancelText":"取消","submitText":"存入"},function(result){
					if(result != "yes") {
						return false;
					}else{
						$.hsf.hsOpen("trade-money-in.html");
					}
				});
			}else {
				if(this.riskCut>1){
					$.UIConfirm({"html":"此只基金的风险等级超出了您所能承受的风险等级范围，是否继续购买","cancelText":"取消购买","submitText":"确定购买"},function(result){
						if(result != "yes")
							return false;
						else{
							input();
						}
					});

				} else {
					input();
				}
			}
            
        },
        tradeFare : function() {
        	$.doTemplate("tip2-template", {successful: false}, "refresh");
        	this._private.tradeFareTimes = this._private.tradeFareTimes || 0;
        	var that = this;
        	if (!this._private.requestTradeFare) {
        		this._private.requestTradeFare = setTimeout(function() {
        			that._private.requestTradeFare = null;
        			that.requestTradeFare();
        		}, this._private.tradeFareTimes > 0? 2200 : -1);
        	}
        },
        requestTradeFare : function() {
        	var p = this._private;
        	this.validForm.add("empty", p.channelid);
        	this.validForm.add("moreEqual", {origin:this.getApplySum(), target:1}, "");
        	if (this.validForm.valid()) {
        		var data = this.formGenerate
	        	.add("channelid", p.channelid)
	        	.add("businesskind", p.businesskind)
	        	.add("businesscode", p.businesscode)
	        	.add("applicationamount", this.getApplySum())
	        	.add("fundcode", this.fundcode);
				//请求交易费率
	        	$.hsf.ajax.app("common/common/tradeFare", data.generate(), "tradeFareCallback", function(jsonResult) {
	        		if (jsonResult.successful) {
	        			jsonResult.result.successful = true;
	        			$.doTemplate("tip2-template", jsonResult.result, "refresh");
	        		} else {
	        			$.doTemplate("tip2-template", {successful: false}, "refresh");
	        		}
	        	});
	        	this._private.tradeFareTimes++;
        	} else {
        		$.doTemplate("tip2-template", {successful: false}, "refresh");
        	}
        },
        uiEvent : function() {
        	var that = this;
			// this.$bankcardTypeBox.UIPopOption({title:"使用银行卡支付"});
			//切换银行卡
			// this.$bankcardTypeBox.UIPopOption("change",function (mid) {
			// 	that.changePay(mid);
			// });

        	// this.$moneycardTypeBox.UIPopOption({title:"使用耀钱包支付"});
			//切换耀钱包
			// this.$moneycardTypeBox.UIPopOption("change", function(mid) {
			// 	that.changePay(mid);
			// });
			//输入框一变,就请求交易费率
			this.$applysum.UITextField("change", function() {
				that.tradeFare();
			});

        }
	});
});
define("pages/trade-buy-2", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		title : {
			left : {
				show : false
			},
			center : {
				text : "结果详情"
			}
		},
		el: "#trade-buy-2",
		initialize : function(parent) {

			var operdate = parent.getParam("operdate");
			var confirmdate = parent.getParam("confirmdate");
			if(operdate != null){
				if(operdate.indexOf("-") != -1){
					$("#date1").html(operdate);
				}else {
					$("#date1").html($.hsf.hsTools.yyyy_mm_dd(parent.getParam("operdate")));
				}
			}
			if(confirmdate != null){
				if(confirmdate.indexOf("-") != -1){
					$("#date2").html(confirmdate);
				}else {
					$("#date2").html($.hsf.hsTools.yyyy_mm_dd(parent.getParam("confirmdate")));
				}
			}
			$("#confirmsum").html(parent.getParam("confirmsum"));
		}
	});
});
//选择耀钱包
define("pages/trade-buy-3",["require","Backbone"],function(require){
	return Backbone.View.extend({
		title:{
			left:{
				show:true
			},
			center:{
				text:"购买"
			}
		},
		el:"#trade-buy-3",
		$moneylist : $("#moneylist"),
		initialize: function (parent) {
			var moneylist = parent.getParam("moneylist");
			$.doTemplate("moneylisttemplate", moneylist);

			this.$moneylist.UITableView("refresh");
			this.parent = parent;
			this.uiEvent();
		},
		uiEvent : function() {
			this.$moneylist.UITableView("mark", function(result) {
				$.hsf.Event.trigger("selectXjb", null, result);
				$.hsf.hsBack();
				return false;
			});
		}

	});
});
//选择银行卡
define("pages/trade-buy-4",["require","Backbone"],function(require){
	return Backbone.View.extend({
		title:{
			left:{
				show:true
			},
			center:{
				text:"购买"
			}
		},
		el:"#trade-buy-4",
		$banklist : $("#banklist"),
		initialize: function (parent) {
			console.log("parent",parent);
			var banklist = parent.getParam("banklist");
			console.log("banklist",banklist);
			$.doTemplate("banklisttemplate", banklist);

			// this.$banklist.find("dd").first().attr("m-marked", "yes");
			this.$banklist.UITableView("refresh");
			this.parent = parent;
			this.uiEvent();
		},
		uiEvent : function() {
			this.$banklist.UITableView("mark", function(result) {
				$.hsf.Event.trigger("selectBank", null, result);
				$.hsf.hsBack();
				return false;
			});
		}

	});
});
define("pages/trade-buy", ['Backbone'], function(Backbone) {
	return $.bone('trade-buy-1');
});
