define("pages/trade-history-advanced-1", [], function() {
	return Backbone.View.extend({
		el: "#trade-history-advanced-1",
		_private :{},
		initialize: function(parent,platformApi) {
			this.parent = parent;
		},
		events :{
			"tap #queryBtn" : "goQuery",
			"tap .shortcut" : "selectBusin"
		},
		selectBusin : function(event) {
			var _self = event.currentTarget;
			$(".shortcut").attr("m-style", "style-3");
			$(_self).attr("m-style", "style-4");
			return false;
		},
		goQuery : function() {
			var value = $("div[m-role='UIButton'][m-style='style-4']").attr("value");
			var startDate = $("#startDate").UIDateField("value").replace(/-/g, "");
			var endDate = $("#endDate").UIDateField("value").replace(/-/g, "");
			var fundcode = $("#searchText").UITextField("value");
			this.parent.setParam("query", {"businesscode":value ,"fundcode": fundcode,
			"begindate": startDate,"enddate": endDate});
			window.location.hash = "trade-history-advanced-2";
			return false;
		},
		afterSwitchView : function() {
			$("body").removeClass("m-bg-3").addClass("m-white-bg");
		}
	});
});
define("pages/trade-history-advanced-2", [], function() {
	return Backbone.View.extend({
		el: "#trade-history-advanced-2",
		_private :{
			pageNo : 1,
			totalNum : 0,
			loadedNum : 0,
			oneTimeRecord : 20
		},
		tradeIcon : {
			"20" : "blue",
			"22" : "blue",
			"98" : "yellow",
			"24" : "yellow",
			"29" : "blue",
			"36" : "purple",
			"37" : "purple",
			"38" : "purple",
			"90" : "pink",
			"93" : "pink",
			"39" : "pink",
			"59" : "pink",
			"60" : "pink",
			"61" : "pink",
			"39" : "pink",
			"53" : "yellow"
		},
		initialize: function(parent,platformApi) {
			$.hsf.Event.addListener("withdrawSucc", function(result) {
				$("#"+result.no+"_confirmstat").html("已撤单");
			});
			this.parent = parent;
		},
		events : {
			"tap #moreBtn":"applyPackForm"
		},
		applyPackForm : function() {
			$.hsf.startLoading();
			var that = this;
			var fg = $.formGenerate().addObj(this.parent.getParam("query"))
			.add("pageno", this._private.pageNo)
			.add("pagesize", 10);
			return $.hsf.ajax.app("query/tradeapply/tradeapply", fg.generate(), "applyPackFormCallback", function(jsonResult) {
				if (jsonResult.successful) {
					if (!jsonResult.result.totalpages || jsonResult.result.totalpages == 0) {
						var top = (document.documentElement.clientHeight - 44-50-200-38)/2;
						$("#nodata").css({"top":top}).show();
					} else {
						var list = jsonResult.result.data;
						if (list.length > 0) {
							list.forEach(function(item) {
								that.formatItem(item);
							});
							$.doTemplate("template1", list, "repeat");
							that._private.pageNo++;
							that._private.loadedNum += list.length;
							if (that._private.loadedNum >= jsonResult.result.totalpages) {
								$("#moreBtn").hide();
							} else {
								$("#moreBtn").show();	
							}
							$("[m-role='UITableView']").UITableView("refresh");
							$.hsf.stopLoading();
						} else {
							$("#moreBtn").hide();
							$.UIPopup("没有记录了");
							$.hsf.stopLoading();
						}
					}
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		formatItem : function(item) {
			function dictValue(key, dict) {
				for (var index in dict) {
					if (index == key) {
						return dict[index];
					}
				}
				return "";
			}
			if (item.applicationamount > 0)
				item.apply = item.applicationamount+"元"
			else if (item.applicationvol > 0) {
				item.apply = item.applicationvol+"份"
			} else {
				item.apply  = "";
			}
			if (item.businesscode == "36" && item.businesskind == "j" && item.tradeway== "06") {
				item.businessstr = "赎回";
				item.fundcode = item.targetfundcode;
				item.fundname = item.targetfundname;
				item.tradeway = "";
			}
			item.confirmflagstr = dictValue(item.confirmflag, {"0":"确认成功", "1":"待确认", "9":"确认失败"});
			item.paystatus = dictValue(item.paystatus, {"00":"未支付", "01":"支付处理中", "02":"支付成功", "03":"支付失败"})
			item.tradeway = dictValue(item.tradeway, {"05":"耀钱包申购基金", "06":"基金赎回到耀钱包", "":""});
			item.businesskind = dictValue(item.businesskind, {"0":"普通业务","2":"耀钱包认购基金","j":"基金赎回到耀钱包", "6":"耀钱包申购基金"})
			item.businessstr = item.businessstr||item.businesscode;
			item.operdate = $.hsf.hsTools.yyyy_mm_dd(item.operdate);
			item.tradeIconClass = this.tradeIcon[item.businesscode] || "purple";
			if (item.businessstr.indexOf("T+0")>=0) {
				item.iconBusinflagstr = item.businessstr.replace("T+0","").substr(0,1);
			} else {
				item.iconBusinflagstr = item.businessstr.replace("基金","").substr(0,1);	
			}
		},
		afterSwitchView : function() {
			$("body").removeClass("m-white-bg").addClass("m-bg-3");
			$("#nodata").hide();
			$("body").scrollTop(0);
			this._private.pageNo = 1;
			this._private.totalNum = 0;
			this._private.loadedNum = 0;
			this.$el.find("dd").remove();
			$("#moreBtn").hide();
			this.applyPackForm();
		}
	});
});
define("pages/trade-history-advanced", [], function() {
	return {
		init : function() {
			$.platform.initPage && $.platform.initPage();
			$.bone("trade-history-advanced-1");
		}
	}
});