define([], function() {
	window.action = {
		constant : {
			apply : {
				pageNo : 1,
				loadedNum : 0,
				oneTimeRecord : 20
			},
			tradeIcon : {
				"20" : "blue",
				"22" : "blue",
				"98" : "yellow",
				"24" : "yellow",
				"29" : "blue",
				"36" : "purple",
				"37" : "purple",
				"38" : "purple",
				"90" : "pink",
				"93" : "pink",
				"39" : "pink",
				"59" : "pink",
				"60" : "pink",
				"61" : "pink",
				"39" : "pink",
				"53" : "yellow"
			}
		},
		init : function() {
			$.hsf.Event.addListener("withdrawSucc", function(result) {
				$("#"+result.no+"_confirmstat").html("已撤单");
			});
			$.platform.initPage && $.platform.initPage();
			action.applyPackForm();
			action.events();
		},
		refresh : function() {
			action.constant.apply.pageNo = 1;
			action.constant.apply.loadedNum = 0;
			action.constant.apply.oneTimeRecord = 20;
			$("#applyList").find("dd").remove();
			action.applyPackForm();
			$("#first").show({});
		},
		events : function() {
			$("#moreBtn").bind("tap", function() {
				action.applyPackForm();
				return false;
			});
		},
		applyPackForm : function(func) {
			$.hsf.startLoading();
			return $.hsf.ajax.app("query/tradeapply/tradeapply", "pagesize="+action.constant.apply.oneTimeRecord+"&pageno="+action.constant.apply.pageNo, "applyPackFormCallback", func || function(jsonResult) {
				if (jsonResult.successful) {
					if (!jsonResult.result.totalpages || jsonResult.result.totalpages == 0) {
						var top = (document.documentElement.clientHeight - 44-50-200-38)/2;
						$("#nodata").css({"top":top}).show();
					} else {
						var list = jsonResult.result.data;
						var $applyList = $("#applyList");
						var $applyListDl = $applyList.find("dl");
						if (list.length > 0) {
							list.forEach(function(item) {
								action.formatItem(item);
							});
							$.doTemplate("tempate1", list, "repeat");
							$applyList.UITableView("refresh");
							action.constant.apply.pageNo++;
							action.constant.apply.loadedNum += list.length;
							if (action.constant.apply.loadedNum >= jsonResult.result.totalpages) {
								$("#moreBtn").hide();
							} else {
								$("#moreBtn").show();	
							}
							$("[m-role='UITableView']").UITableView("refresh");
							$.hsf.stopLoading();
						} else {
							$("#moreBtn").hide();
							$.UIPopup("没有记录了");
							$.hsf.stopLoading();
						}
					}
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		formatItem : function(item) {
			function dictValue(key, dict) {
				for (var index in dict) {
					if (index == key) {
						return dict[index];
					}
				}
				return "";
			}
			if (item.applicationamount > 0)
				item.apply = item.applicationamount+"元"
			else if (item.applicationvol > 0) {
				item.apply = item.applicationvol+"份"
			} else {
				item.apply  = "";
			}
			if (item.businesscode == "36" && item.businesskind == "j" && item.tradeway== "06") {
				item.businessstr = "赎回";
				item.fundcode = item.targetfundcode;
				item.fundname = item.targetfundname;
				item.tradeway = "";
			}
			item.confirmflagstr = dictValue(item.confirmflag, {"0":"确认成功", "1":"待确认", "9":"确认失败"});
			item.paystatus = dictValue(item.paystatus, {"00":"未支付", "01":"支付处理中", "02":"支付成功", "03":"支付失败"})
			item.tradeway = dictValue(item.tradeway, {"05":"耀钱包申购基金", "06":"基金赎回到耀钱包", "":""});
			item.businesskind = dictValue(item.businesskind, {"0":"普通业务","2":"耀钱包认购基金","j":"基金赎回到耀钱包", "6":"耀钱包申购基金"})
			item.businessstr = item.businessstr||item.businesscode;
			item.operdate = $.hsf.hsTools.yyyy_mm_dd(item.operdate);
			item.tradeIconClass = action.constant.tradeIcon[item.businesscode] || "purple";
			if (item.businessstr.indexOf("T+0")>=0) {
				item.iconBusinflagstr = item.businessstr.replace("T+0","").substr(0,1);
			} else {
				item.iconBusinflagstr = item.businessstr.replace("基金","").substr(0,1);	
			}
		}
	};
	return action;
});