﻿define("pages/trade-money-in-1", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		el: "#trade-money-in-1",
		$cardTypeBox : $("#cardTypeBox"),
		$applysum : $("#applysum"),
		_private :{},
		initialize: function(parent,platformApi) {
			var that = this;
			this.parent = parent;
			this.initMoney();
			this.validForm = $.validForm();
            //lxf add start
            $.platform.getCache("logininfo", function(result) {
                if (result) {
                    var custRole = result.custtype;
                    if(custRole == "1"){//代销用户
                        $.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
                            if (o == "yes") {
                                $.hsf.hsOpen("account-openAcco-gdbdx.html");
                            }
                        });
                    }else{
                        if(custRole=="3"){
                            $.UIAlert("请先绑定一张银行卡", function(){
                                url = "account-openAcco-new.html";
                                url = url+"?custtype="+custRole+"&mobile="+result.Mobile+"&userid="+result.userid;
                                $.hsf.hsOpen(url);
                            });

                        }else{
                            that.packForm();
                            // this.initFundInfo();
                        }
                    }
                }else{

                }
            });
            $.platform.initPage&&$.platform.initPage();
            //lxf add end
            // this.packForm();  lxf delete
			this.formGenerate = $.formGenerate();
			this.platformApi = platformApi;
			this.uiEvent();
			$.checkNullGroup([this.$applysum], $("#purchaseBtn"));
			$.UIPasswordKeyboard("init", {
				inputComplete : function(pw, succ, fail) {
					var g = that.formGenerate;
					g.add("transactionaccountid", that._private.transactionaccountid);
					g.add("tpasswd", pw);
					g.add("applicationamount", that.getApplySum());
					$.hsf.ajax.app("super/moneyIn/moneyIn", g.generate(), "moneyInFormCallback", function(jsonResult) {
						if (jsonResult.successful) {
							succ();
							that.parent.setParam("confirmsum", that.getApplySum()+"元");
							that.parent.setParam("operdate",jsonResult.result.operdate);
							that.parent.setParam("startdate", jsonResult.result.startdate);
							that.parent.setParam("receivedate", jsonResult.result.receivedate);
							that.platformApi.triggerSucc && that.platformApi.triggerSucc();
							window.location.hash = "trade-money-in-2";
						} else {
							fail(jsonResult.message);
						}
					}, 60);
				}
			});
		},
		initMoney : function() {
			this.changeMoney(true, 1000);
		},
		events : {
			"tap #bankcardSelect" : "toggleCardType",
			"tap #money-add" : "operAddMoneyBtn",
			"tap #money-reduce" : "operReduceMoneyBtn",
			"blur #applysum input" : "changeApplySum",
			"tap #applysum input" : "clearApplySum",
			"tap #purchaseBtn[m-state!='disabled']" : "inputPassword"
		},
		toggleCardType : function() {
			$("input").blur();
			this.$cardTypeBox.UIPopOption("open");
		},
		packForm : function() {
			var that = this;
			$.hsf.startLoading();
			$.hsf.ajax.app("super/moneyIn/moneyInForm", "", "moneyInFormCallback", function(jsonResult) {
				if (jsonResult.successful) {
					that._private.bankCards = jsonResult.result.data;
					that.packFirstPage(that._private.bankCards);
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		changeBankCard : function(index) {
			var card = this._private.bankCards[index];
			this._private.transactionaccountid = card.transactionaccountid;
			$("#selectedBankName").html(card.bankname);
			$("#minlimit").html(card.perlimit);
			$("#selectedBankcardNo").html($.hsf.hsTools.maskCardCenter(card.depositcard));
			$("#selectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-"+card.alias);
		},
		packFirstPage : function(bankCards) {
			if (bankCards.length > 0) {
				$.doTemplate("banklist-template", this._private.bankCards);
				$("[m-role='UITableView']").UITableView("refresh");
				this.$cardTypeBox.UIPopOption("select", 0);
			} else {
				$.UIConfirm({"html":"您还没有可以交易的银行卡，是否添加?", "submitText":"确定","cancelText":"取消"}, function(result) {
					if (result == "yes") {
						$.hsf.hsOpen("add-bankcard.html");
					} else {
						$.hsf.hsBack();
					}
				});
			}
		},
		getApplySum : function() {
			return $.hsf.hsTools.recoveryMoney(this.$applysum.UITextField("value"));
		},
		demical2ApplySum : function() {
			var value = this.$applysum.UITextField("value");
			if (!isNaN(parseFloat(value))) {
				this.$applysum.UITextField("value", parseFloat(value).toFixed(2));
			}
		},
		changeMoney : function(sign, changevalue){
            var tmpValue=0;
            var inputValue=  this.getApplySum() ==""? 0 :  this.getApplySum();
            if(sign){
                tmpValue=parseInt(inputValue,10)+parseInt(changevalue,10);
            }else{
                tmpValue=parseInt(inputValue,10)-parseInt(changevalue,10);
                tmpValue = tmpValue < 0 ? 0 : tmpValue;
            }
            this.formatApplySum(tmpValue);
        },
        clearApplySum : function() {
        	var money = "";
        	this.formatApplySum(money);
        },
        changeApplySum : function(tmpValue) {
        	var money = $("#applysum").UITextField("value");
        	this.formatApplySum(money);
        },
        formatApplySum : function(applysum) {
        	$(".buy-big-write").html($.hsf.hsTools.chineseNum(applysum));
        	$("#applysum").UITextField("value", applysum);
        },
        operAddMoneyBtn : function(event) {
        	var _self = $(event.handleObj.selector);
			var changemoney = _self.find(".change-value").html();
			this.changeMoney(true , changemoney)
			return false;
        },
        operReduceMoneyBtn : function(event) {
        	var _self = $(event.handleObj.selector);
			var changemoney = _self.find(".change-value").html();
			this.changeMoney(false , changemoney)
			return false;
        },
        inputPassword : function() {
        	this.validForm.add("more", {origin: this.getApplySum(), target: 0}, "请输入金额");
        	if (this.validForm.valid()) {
        		this.demical2ApplySum();
        		$.UIPasswordKeyboard("show", {key: "金额:&nbsp;", 
        			value : $.hsf.hsTools.formatMoney(this.getApplySum())+"元"});
        	}
        	return false;
        },
        uiEvent : function() {
        	var that = this;
        	this.$cardTypeBox.UIPopOption({title: "请选择支付方式"});
			this.$cardTypeBox.UIPopOption("change", function(mid) {
				that.changeBankCard(mid);
			});
        }
	});
});
define("pages/trade-money-in-2", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		title : {
			left : {
				show : false
			},
			center : {
				text : "结果详情"
			}
		},
		el: "#trade-money-in-2",
		initialize : function(parent) {
			$("#date0").html($.hsf.hsTools.yyyy_mm_dd(parent.getParam("operdate")));
			$("#date1").html($.hsf.hsTools.yyyy_mm_dd(parent.getParam("startdate")));
			$("#date2").html($.hsf.hsTools.yyyy_mm_dd(parent.getParam("receivedate")));
			$("#confirmsum").html(parent.getParam("confirmsum"));
		}
	});
});
define("pages/trade-money-in", ['Backbone'], function(Backbone) {
	return $.bone('trade-money-in-1');
});
