﻿define("pages/trade-money-out-1", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		el: "#trade-money-out-1",
		$cardTypeBox : $("#cardTypeBox"),
		$applysum : $("#applysum"),
		_private :{},
		initialize: function(parent, platformApi) {
			var that = this;
			this.parent = parent;
			this.validForm = $.validForm();

            //lxf add start
            $.platform.getCache("logininfo", function(result) {
                if (result) {
                    var custRole = result.custtype;
                    if(custRole == "1"){//代销用户
                        $.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
                            if (o == "yes") {
                                $.hsf.hsOpen("account-openAcco-gdbdx.html");
                            }
                        });
                    }else{
                        if(custRole=="3"){
                            $.UIAlert("请先绑定一张银行卡", function(){
                                url = "account-openAcco-new.html";
                                url = url+"?custtype="+custRole+"&mobile="+result.Mobile+"&userid="+result.userid;
                                $.hsf.hsOpen(url);
                            });

                        }else{
                            that.packForm();
                            // this.initFundInfo();
                        }
                    }
                }else{

                }
            });
            $.platform.initPage&&$.platform.initPage();
            //lxf add end

			this.uiEvent();
			// this.packForm();  lxf delete
			this.renderTip("1");
			this.formGenerate = $.formGenerate();
			this.platformApi = platformApi;
			$.checkNullGroup([this.$applysum], $("#saleBtn"));
			$.UIPasswordKeyboard("init", {paying : "正在取现，请稍候…",
				inputComplete : function(pw, succ, fail) {
					var g = that.formGenerate;
					var saleStyle = that.getSaleStyle();
					g.add("transactionaccountid", that._private.transactionaccountid);
					g.add("tpasswd", pw);
					g.add("applicationamount", that.getApplySum());
					g.add("fastredeemflag", saleStyle.fastredeemflag);
					g.add("tradeway", saleStyle.tradeway);
					$.hsf.ajax.app("super/moneyOut/moneyOut", g.generate(), "moneyOutFormCallback", function(jsonResult) {
						if (jsonResult.successful) {
							succ();
							that.parent.setParam("confirmsum", that.getApplySum()+"元");
							that.parent.setParam("operdate", jsonResult.result.operdate);
							that.parent.setParam("opertime", jsonResult.result.opertime);
							that.parent.setParam("receivedate", jsonResult.result.receivedate);
							that.platformApi.triggerSucc && that.platformApi.triggerSucc();
							window.location.hash = "trade-money-out-2";
						} else {
							fail(jsonResult.message);
						}
					});
				}
			}, 60);
		},
		events : {
			"tap #bankcardSelect" : "toggleCardType",
			"tap #saleBtn[m-state!='disabled']" : "inputPassword"
		},
		toggleCardType : function() {
			$("input").blur();
			this.$cardTypeBox.UIPopOption("open");
		},
		packForm : function() {
			var that = this;
			$.hsf.startLoading();
			$.hsf.ajax.app("super/moneyOut/moneyOutForm", "", "moneyOutFormCallback", function(jsonResult) {
				if (jsonResult.successful) {
					that._private.bankCards = jsonResult.bankdata;
					that.packFirstPage(that._private.bankCards);
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		packFirstPage : function(bankCards) {
			if (bankCards.length > 0) {
				var that = this;
				// this.filterEmpty();
				$.doTemplate("banklist-template", this._private.bankCards);
				$("[m-role='UITableView']").UITableView("refresh");
				this.$cardTypeBox.UIPopOption("select", 0);
			} else {
				$.UIConfirm({"html":"您还没有可以交易的银行卡，是否添加?", "submitText":"确定","cancelText":"取消"}, function(result) {
					if (result == "yes") {
						$.hsf.hsOpen("add-bankcard.html");
					} else {
						$.hsf.hsBack();
					}
				});
			}
		},
		filterEmpty : function() {
			var cards = [];
			this._private.bankCards.forEach(function(bank) {
				if (parseFloat(bank.availabal) != 0 || parseFloat(bank.balfund) != 0) {
					cards.push(bank);
				}
			});
			this._private.bankCards = cards;
		},
		getApplySum : function() {
			return this.$applysum.UITextField("value");
		},
		demical2ApplySum : function() {
			var value = this.$applysum.UITextField("value");
			if (!isNaN(parseFloat(value))) {
				this.$applysum.UITextField("value", parseFloat(value).toFixed(2));
			}
		},
		getSaleStyle :  function() {
			return $("[m-name='sf-type']").UIRadio("value") == "0" ? {fastredeemflag: "0", tradeway:"04" } : {fastredeemflag: "1", tradeway:"01" };
		},
        inputPassword : function() {
        	var valid = function() {
        		this.validForm.add("more", {origin: this.getApplySum(), target : 0}, "请输入金额");
        		this.validForm.add("lessEqual", {origin: this.getApplySum(), target : this.getAvailableMoney()}, "最大可取现"+this.getAvailableMoney()+"元");
	        	if (this.getSaleStyle().fastredeemflag == "1") {
	        		this.validForm.add("lessEqual", {origin: this.getApplySum(), target : 500000}, "快速取现最高单笔金额为50万元");
	        		return this.validForm.valid();
	        	} else {
	        		return this.validForm.valid();
	        	}
			};
        	if (valid.call(this)) {
        		this.demical2ApplySum();
        		$.UIPasswordKeyboard("show", {key: "金额:&nbsp;", 
        			value : $.hsf.hsTools.formatMoney(this.getApplySum())+"元"});	
        	}
        },
        changeAvailableMoney : function() {
        	var bal = this.getAvailableMoney();
        	$("#applysum").UITextField("placeholder", "可取现"+bal+"元");
        	$("#applysum").attr("m-max", bal);
        },
        getAvailableMoney : function() {
        	var saleType = $("[m-name='sf-type']").UIRadio("value");
        	if (saleType == "0") {
        		return this._private.selectCard.balfund;
        	} else {
        		return this._private.selectCard.availabal;
        	}
        },
        changBankAvailaMoney : function(value) {
        	$(".availaMoney").each(function(i,n) {
				if (value == "1") {
					this.innerHTML = this.getAttribute("availabal");
				} else {
					this.innerHTML = this.getAttribute("balfund");
				}
        	})
        },
        uiEvent : function() {
        	var that = this;
        	$("[m-name='sf-type']").UIRadio("change", function(obj) {
        		that.renderTip(obj.value);
        		that.changeAvailableMoney();
        		that.changBankAvailaMoney(obj.value);
        	});
        	this.$cardTypeBox.UIPopOption();
			this.$cardTypeBox.UIPopOption("change", function(mid) {
				that.changeBankCard(mid);
			});
        },
        changeBankCard : function(index) {
			var card = this._private.bankCards[index];
			this._private.selectCard = card;
			this._private.transactionaccountid = card.transactionaccountid;
			$("#applysum").UITextField("clear");
			$("#selectedBankName").html(card.bankname);
			$("#selectedBankcardNo").html($.hsf.hsTools.maskCardCenter(card.depositacct));
			$("#selectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-"+card.alias);
			if (card.fastredeem == "1" && parseFloat(card.availabal) > 0) {
				$("[m-name='sf-type'][m-value='1']").show();
				$("[m-name='sf-type'][m-value='1']").trigger("tap");
			} else {
				$("[m-name='sf-type'][m-value='1']").hide();
				$("[m-name='sf-type'][m-value='0']").trigger("tap");
			}
			this.changeAvailableMoney();
		},
        renderTip : function(key) {
        	$.doTemplate("tip-template", key, "refresh");
        }
	});
});
define("pages/trade-money-out-2", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		title : {
			left : {
				show : false
			},
			center : {
				text : "结果详情"
			}
		},
		el: "#trade-money-out-2",
		initialize : function(parent) {
			var tool = $.hsf.hsTools;
			$("#date1").html(tool.dateToch(tool.yyyy_mm_dd(parent.getParam("operdate")))+" "+parent.getParam("opertime"));
			$("#date2").html(tool.dateToch(tool.yyyy_mm_dd(parent.getParam("receivedate"))));
			$("#confirmsum").html(parent.getParam("confirmsum"));
		}
	});
});
define("pages/trade-money-out", ['Backbone'], function(Backbone) {
	return {
		init : function() {
			$.bone('trade-money-out-1');
		}
	}
});
