﻿define("pages/trade-sale-1", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		el: "#trade-sale-1",
		$cardTypeBox : $("#cardTypeBox"),
		$applysum : $("#applysum"),
		fundcode : $.hsf.hsTools.getParam("fundcode"),
		fundname : $.hsf.hsTools.getParam("fundname"),
		sharemode :$.hsf.hsTools.getParam("sharemode"),
		transactionaccountid : $.hsf.hsTools.getParam("transactionaccountid"),
		_private :{},
		initialize: function(parent, platformApi) {
			var that = this;
			this.parent = parent;
			this.validForm = $.validForm();
			this.packForm();
			this.initFundInfo();
			this.formGenerate = $.formGenerate();
			this.platformApi = platformApi;
			$.checkNullGroup([this.$applysum], $("#saleBtn"));
			$.UIPasswordKeyboard("init", {paying : "正在赎回，请稍候…",
				inputComplete : function(pw, succ, fail) {
					var g = that.formGenerate;
					var saleStyle = that.getSaleStyle();
					g.add("transactionaccountid", that._private.transactionaccountid)
					.add("tpasswd", pw)
					.add("applicationamount", that.getApplySum())
					.add("saleway", that.getSaleway())
					.add("fundcode", that.fundcode);
					if (that.getSaleway() == "1") {//转余额宝
						g.add("tradeway", "06");
					} else {//普通基金赎回
						if (that._private.fundtype == "2") {
							g.add("fastredeemflag", saleStyle);
						} else {
							g.add("fastredeemflag", "0");
						}
					}
					$.hsf.ajax.app("trade/sale/sale", g.generate(), "moneyOutFormCallback", function(jsonResult) {
						if (jsonResult.successful) {
							succ();
							var r = jsonResult.result;
							that.parent.setParam("confirmsum", that.getApplySum()+"份")
										.setParam("operdate", r.operdate)
										.setParam("opertime", r.opertime)
										.setParam("confirmdate", r.confirmdate);
							that.platformApi.triggerSucc && that.platformApi.triggerSucc();
							window.location.hash = "trade-sale-2";
						} else {
							fail(jsonResult.message);
						}
					}, 60);
				}
			});
		},
		events : {
			"tap #saleBtn[m-state!='disabled']" : "inputPassword",
			"click #saleAll[m-state!='disabled']" : "saleAll",
		},
		toggleCardType : function() {
			$("input").blur();
			this.$cardTypeBox.UIPopOption("open");
		},
		packForm : function() {
			var that = this;
			$.hsf.startLoading();
			$.hsf.ajax.app("trade/sale/saleForm", "datasource=DS&fundcode="+this.fundcode+"&sharemode="+this.sharemode, "moneyOutFormCallback", function(jsonResult) {
				if (jsonResult.successful) {
					var r = jsonResult.result;
					if (r.fundstate.fundtype == "2") {
						$.doTemplate("xjb-fastredeemflag-template", r);
						$("[m-name='sf-type']").UIRadio();
						that.renderTip("1");
					}
					that.uiEvent();
					that._private.min = parseFloat(r.fundstate.per_min_24||0)
					that._private.fundtype = r.fundstate.fundtype;
					that._private.bankCards = r.data;
					that.packFirstPage(that._private.bankCards);
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		initFundInfo : function() {
			$.doTemplate("fundinfo-template", {fundcode: this.fundcode, fundname: this.fundname});
		},
		changeBankCard : function(index) {
			var card = this._private.bankCards[index];
			this._private.selectCard = card;
			this._private.transactionaccountid = card.JYZH;
			$("#applysum").UITextField("clear");
			$("#selectedBankName").html(card.bankname);
			$("#selectedBankcardNo").html($.hsf.hsTools.maskCardCenter(card.depositacct));
			$("#selectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-"+card.alias);
			if (card.fastredeem == "1") {
				$("[m-name='sf-type'][m-value='1']").show();
				$("[m-name='sf-type'][m-value='1']").trigger("tap");
			} else {
				$("[m-name='sf-type'][m-value='1']").hide();
				$("[m-name='sf-type'][m-value='0']").trigger("tap");
			}
			this.changeAvailableMoney();
		},
		packFirstPage : function(bankCards) {
			for (var i in bankCards) {
				if (bankCards[i].JYZH == this.transactionaccountid) {
					$.doTemplate("banklist-template", this._private.bankCards);
					$("[m-role='UITableView']").UITableView("refresh");
					this.changeBankCard(i);
				}
			};
		},
		getApplySum : function() {
			return this.$applysum.UITextField("value");
		},
		demical2ApplySum : function() {
			var value = this.$applysum.UITextField("value");
			if (!isNaN(parseFloat(value))) {
				this.$applysum.UITextField("value", parseFloat(value).toFixed(2));
			}
		},
		getSaleStyle :  function() {
			return $("[m-name='sf-type']").UIRadio("value");
		},
		getSaleway : function() {
			return $("[m-name='saleway']").UIRadio("value");
		},
        inputPassword : function() {
        	var valid = function() {
        		if (this.getAvailableMoney() <= this._private.min) {
        			this.validForm.add("equal", {origin: this.getApplySum(), target : this.getAvailableMoney()}, "请全部赎回");
        		} else {
        			this.validForm.add("moreEqual", {origin: this.getApplySum(), target : this._private.min}, "请大于最少赎回份额");
        			this.validForm.add("lessEqual", {origin: this.getApplySum(), target : this.getAvailableMoney()}, "请小于最大可用份额");
        		}
  	        	if (this.getSaleStyle() == "1") {
	        		this.validForm.add("lessEqual", {origin: this.getApplySum(), target : 500000}, "快速赎回最高单笔金额为50万份");
	        	}
	        	return this.validForm.valid();
			};
        	if (valid.call(this)) {
        		this.demical2ApplySum();
        		$.UIPasswordKeyboard("show", {key: "份额:&nbsp;", 
        			value : $.hsf.hsTools.formatMoney(this.getApplySum())+"份"});	
        	}
        },
		//全部赎回
		saleAll : function () {
			$("#saleAll").hide();
			var bal = this.getAvailableMoney();
			$("#applysum").UITextField("value",bal);
		},
        changeAvailableMoney : function() {
        	var bal = this.getAvailableMoney();
        	if (this._private.min >= bal) {
        		$("#applysum").UITextField("placeholder", "可全部赎回"+bal+"份");
        		$("#applysum").attr("m-min", bal);
        		$.doTemplate("tip-template2", "可全部赎回"+bal+"份");
        	} else {
        		$("#applysum").UITextField("placeholder", "可赎回"+bal+"份");
        		$("#applysum").attr("m-min", this._private.min);
        		$.doTemplate("tip-template2", "可赎回"+bal+"份");
        	}
        	$("#applysum").attr("m-max", bal);
        },
        getAvailableMoney : function() {
        	return this._private.selectCard.useableshare;
        },
        uiEvent : function() {
        	var that = this;
        	$("[m-name='sf-type']").UIRadio("change", function(obj) {
        		that.renderTip(obj.value);
        		that.changeAvailableMoney();
        	});
        	$("[m-name='saleway']").UIRadio("change", function(obj) {
        		$(".salewayToggle").toggle();
        		$("#sfTypeTable").toggle();
        	});
        	this.$cardTypeBox.UIPopOption();
			this.$cardTypeBox.UIPopOption("change", function(mid) {
				that.changeBankCard(mid);
			});
			$("#applysum").UITextField("change",function (obj) {
				console.log(obj);
				if (obj != ""){
					$("#saleAll").hide();
				}else {
					$("#saleAll").show();
				}
			});
        },
        renderTip : function(key) {
        	$.doTemplate("tip-template", key, "refresh");
        }
	});
});
define("pages/trade-sale-2", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		title : {
			left : {
				show : false
			},
			center : {
				text : "结果详情"
			}
		},
		el: "#trade-sale-2",
		initialize : function(parent) {
			var tool = $.hsf.hsTools;
			$("#confirmsum").html(parent.getParam("confirmsum"));
			if (parent.getParam("confirmdate")) {
				// $("#result-panel").show();
				// $("#date1").html(tool.dateToch(tool.yyyy_mm_dd(parent.getParam("operdate").replace(/\-/g,"")))+" "+parent.getParam("opertime"));
				// $("#date2").html(tool.dateToch(tool.yyyy_mm_dd(parent.getParam("confirmdate"))));
				var operdate = parent.getParam("operdate");
				var confirmdate = parent.getParam("confirmdate");
				if(operdate.indexOf("-") != -1){
					$("#date1").html(operdate);
				}else {
					$("#date1").html($.hsf.hsTools.yyyy_mm_dd(parent.getParam("operdate")));
				}
				if(confirmdate.indexOf("-") != -1){
					$("#date2").html(confirmdate);
				}else {
					$("#date2").html($.hsf.hsTools.yyyy_mm_dd(parent.getParam("confirmdate")));
				}
			}
		}
	});
});
define("pages/trade-sale", ['Backbone'], function(Backbone) {
	return {
		init : function() {
			$.bone('trade-sale-1');
		}
	}
});
