﻿define("pages/trade-trans-1", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		el: "#trade-trans-1",
		$cardTypeBox : $("#cardTypeBox"),
		$applysum : $("#applysum"),
		fundcode : $.hsf.hsTools.getParam("fundcode"),
		fundname : $.hsf.hsTools.getParam("fundname"),
		sharemode :$.hsf.hsTools.getParam("sharemode"),
		transactionaccountid : $.hsf.hsTools.getParam("transactionaccountid"),
		_private :{},
		initialize: function(parent, platformApi) {
			var that = this;
			this.parent = parent;
			this.validForm = $.validForm();
			this.packForm();
			this.initFundInfo();
			this.formGenerate = $.formGenerate();
			this.platformApi = platformApi;
			$.checkNullGroup([this.$applysum, $("#transfundlistTableView")], $("#saleBtn"));
			$.UIPasswordKeyboard("init", {paying : "正在转换，请稍候…",
				inputComplete : function(pw, succ, fail) {
					var g = that.formGenerate;
					var saleStyle = that.getSaleStyle();
					g.add("transactionaccountid", that._private.transactionaccountid)
					.add("tpasswd", pw)
					.add("applicationamount", that.getApplySum())
					.add("fundcode", that.fundcode)
					.add("targetfundcode", that._private.targetFundcode)
					.add("vastredeemflag", "0");
					$.hsf.ajax.app("trade/trans/trans", g.generate(), "transCallback", function(jsonResult) {
						if (jsonResult.successful) {
							succ();
							that.parent.setParam("confirmsum", that.getApplySum()+"份");
							that.parent.setParam("operdate", jsonResult.result.operdate);
							that.parent.setParam("opertime", jsonResult.result.opertime);
							that.parent.setParam("confirmdate", jsonResult.result.confirmdate);
							that.platformApi.triggerSucc && that.platformApi.triggerSucc();
							window.location.hash = "trade-trans-2";
						} else {
							fail(jsonResult.message);
						}
					}, 60);
				}
			});
			$.hsf.Event.addListener("transSelectComplete", function(obj) {
				var fundcode = obj.split("|")[0];
				var fundname = obj.split("|")[1];
				that._private.targetFundcode = fundcode;
				$("#targetFundcode").html(fundcode);
				$("#targetFundname").html(fundname);
			});
		},
		events : {
			"tap #saleBtn[m-state!='disabled']" : "inputPassword",
			"tap #targetSelectDD" : "showTargetFund"
		},
		toggleCardType : function() {
			$("input").blur();
			this.$cardTypeBox.UIPopOption("open");
		},
		showTargetFund : function() {
			window.location.hash = "trade-trans-3";
			return false;
		},
		packForm : function() {
			var that = this;
			$.hsf.startLoading();
			$.hsf.ajax.app("trade/trans/transForm", "datasource=DS&fundcode="+this.fundcode+"&sharemode="+this.sharemode, "moneyOutFormCallback", function(jsonResult) {
				if (jsonResult.successful) {
					that.uiEvent();
					that._private.min = parseFloat(jsonResult.result.fundstate.per_min_36||0)
					that._private.fundtype = jsonResult.result.fundstate.fundtype;
					that._private.bankCards = jsonResult.result.data;
					that.parent.setParam("transfundlist",jsonResult.result.transfundlist);
					that.packFirstPage(that._private.bankCards);
					$.doTemplate("tip-template", that._private.min);
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		initFundInfo : function() {
			$.doTemplate("fundinfo-template", {fundcode: this.fundcode, fundname: this.fundname});
		},
		changeBankCard : function(index) {
			var card = this._private.bankCards[index];
			this._private.selectCard = card;
			this._private.transactionaccountid = card.JYZH;
			$("#applysum").UITextField("clear");
			$("#selectedBankName").html(card.bankname);
			$("#selectedBankcardNo").html($.hsf.hsTools.maskCardCenter(card.depositacct));
			$("#selectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-"+card.alias);
			this.changeAvailableMoney();
		},
		packFirstPage : function(bankCards) {
			for (var i in bankCards) {
				if (bankCards[i].JYZH == this.transactionaccountid) {
					$.doTemplate("banklist-template", this._private.bankCards);
					$("[m-role='UITableView']").UITableView("refresh");
					this.changeBankCard(i);
				}
			};
		},
		getApplySum : function() {
			return this.$applysum.UITextField("value");
		},
		demical2ApplySum : function() {
			var value = this.$applysum.UITextField("value");
			if (!isNaN(parseFloat(value))) {
				this.$applysum.UITextField("value", parseFloat(value).toFixed(2));
			}
		},
		getSaleStyle :  function() {
			return $("[m-name='sf-type']").UIRadio("value");
		},
		getSaleway : function() {
			return $("[m-name='saleway']").UIRadio("value");
		},
        inputPassword : function() {
        	var valid = function() {
    			if (this.getAvailableMoney() <= this._private.min) {
        			this.validForm.add("equal", {origin: this.getApplySum(), target : this.getAvailableMoney()}, "请全部转换");
        		} else {
        			this.validForm.add("moreEqual", {origin: this.getApplySum(), target : this._private.min}, "请大于最少转换份额");
        			this.validForm.add("lessEqual", {origin: this.getApplySum(), target : this.getAvailableMoney()}, "请小于最大可用份额");
        		}
	        	return this.validForm.valid();
			};
        	if (valid.call(this)) {
        		this.demical2ApplySum();
        		$.UIPasswordKeyboard("show", {key: "份额:&nbsp;", 
        			value : $.hsf.hsTools.formatMoney(this.getApplySum())+"份"});	
        	}
        },
        changeAvailableMoney : function() {
        	var bal = this.getAvailableMoney();
        	if (this._private.min >= bal) {
        		$("#applysum").UITextField("placeholder", "可全部转换"+bal+"份");
        		$("#applysum").attr("m-min", bal);
        		$.doTemplate("tip-template2", bal);
        	} else {
        		$("#applysum").UITextField("placeholder", "可转换"+bal+"份");
        		$("#applysum").attr("m-min", this._private.min);
        		$.doTemplate("tip-template2", this._private.min);
        	}
        	$("#applysum").attr("m-max", bal);
        	
        },
        getAvailableMoney : function() {
        	return this._private.selectCard.useableshare;
        },
        uiEvent : function() {
        	var that = this;
			$("#targetfundSearchInput").UITextField("change", function(value) {
				if (value == "") {
					$("#transfundlistTableView dd").show();
				} else {
					$("#transfundlistTableView dd").hide();
					$("#transfundlistTableView dd[m-filter*='"+value+"']").show();
				}
				return false;
			});
        },
	});
});
define("pages/trade-trans-2", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		title : {
			left : {
				show : false
			},
			center : {
				text : "结果详情"
			}
		},
		el: "#trade-trans-2",
		initialize : function(parent) {
			var tool = $.hsf.hsTools;
			$("#confirmsum").html(parent.getParam("confirmsum"));
			if (parent.getParam("confirmdate")) {
				// $("#result-panel").show();

				// $("#date1").html(tool.dateToch(tool.yyyy_mm_dd(parent.getParam("operdate").replace(/\-/g,"")))+" "+parent.getParam("opertime"));
				// $("#date2").html(tool.dateToch(tool.yyyy_mm_dd(parent.getParam("confirmdate"))));

				var operdate = parent.getParam("operdate");
				var confirmdate = parent.getParam("confirmdate");
				if(operdate.indexOf("-") != -1){
					$("#date1").html(operdate);
				}else {
					$("#date1").html($.hsf.hsTools.yyyy_mm_dd(parent.getParam("operdate")));
				}
				if(confirmdate.indexOf("-") != -1){
					$("#date2").html(confirmdate);
				}else {
					$("#date2").html($.hsf.hsTools.yyyy_mm_dd(parent.getParam("confirmdate")));
				}
			}
		}
	});
});
define("pages/trade-trans-3", ["Backbone"], function() {
	return Backbone.View.extend({
		title : {
			center : {
				text : "转换基金"
			}
		},
		el: "#trade-trans-3",
		initialize : function(parent) {
			$.doTemplate("transfundlist-template", parent.getParam("transfundlist"));
			$("#transfundlistTableView").UITableView("refresh");
			this.uiEvent();
		},
		uiEvent : function() {
        	var that = this;
        	$("#transfundlistTableView").UITableView("mark", function(value) {
        		$.hsf.Event.trigger("transSelectComplete", null, value);
        		$.hsf.hsBack();
        	});
		},
		afterSwitchView : function() {
			$("body").scrollTop(0);
		}
	});
});
define("pages/trade-trans", ['Backbone'], function(Backbone) {
	return {
		init : function() {
			$.bone('trade-trans-1');
		}
	}
});
