﻿define(function(require) {
	var action = {
		constant : {
			weeks : {
				"2" : "周一",
				"3" : "周二",
				"4" : "周三",
				"5" : "周四",
				"6" : "周五"
			},
			xyh : $.hsf.hsTools.getParam("xyh")
		},
		init : function() {
			action.events();
			action.packForm();
		},
		packForm : function() {
			$.hsf.startLoading();
			$.hsf.ajax.app("valuavgr/fixdeclare/fixDeclareChangeForm", "xyh="+action.constant.xyh, "protocolList", function(jsonResult) {
				$.hsf.stopLoading();
				if (jsonResult.successful) {
					action.constant.result = jsonResult;
					$(".fundcode").html(jsonResult.fundcode);
					$(".fundname").html(jsonResult.fundname);
					if (jsonResult.cycleunit == "0") {
						$("input[name='periodStyle'][value='0']").attr("checked", "checked");
						$("#jyrq_0").show().UISelectField("value", jsonResult.jyrq);
					} else {
						$("#jyrq_1").show();
						if (jsonResult.jyzq == "1") {
							$("input[name='periodStyle'][value='1']").attr("checked", "checked");
						}
						if (jsonResult.jyzq == "2") {
							$("input[name='periodStyle'][value='2']").attr("checked", "checked");
						}
						$("#jyrq_01").show().UISelectField("value", jsonResult.jyrq);
					}
					$("#applysum").UITextField("value", jsonResult.applysum);
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		formatAvgrDate : function(cycleunit, jyzq, jyrq) {
			if ("0" === cycleunit) {
				jyzq = "每月";
				jyrq = jyrq+"日";
			} else if ("1" === cycleunit) {
				if ("1" === jyzq) {
					jyzq = "每周的";
					jyrq = action.constant.weeks[jyrq];
				} else if ("2" === jyzq) {
					jyzq = "每两周的";
					jyrq = action.constant.weeks[jyrq];
				}
			}
			return jyzq+jyrq;
		},
		events : function() {
			$("input[name='periodStyle']").bind("change", function() {
				if (this.getAttribute("value") == "0") {
					$("#jyrq_1").hide();
					$("#jyrq_0").show();
				} else {
					$("#jyrq_0").hide();
					$("#jyrq_1").show();
				}
				return false;
			});
			$("#secondBackBtn").bind("tap", function() {
				$("#second").hide();
				$("#first").show();
				return false;
			});
			$("#nextTo2Btn").bind("tap", function() {
				if (!action.formValidate()) {
					return ;
				} else {
					$(".confirmsum").html(action.getApplySum()+"元");
					var jyzq = $("input[name='periodStyle']:checked").val();
					if (jyzq == "0") {
						var jyrq = $("#jyrq_0").UISelectField("value");
						$(".dtdate").html(action.formatAvgrDate("0", "1", jyrq));
					} else if(jyzq == "1") {
						var jyrq = $("#jyrq_1").UISelectField("value");
						$(".dtdate").html(action.formatAvgrDate("1", "1", jyrq));
					} else if(jyzq == "2") {
						var jyrq = $("#jyrq_1").UISelectField("value");
						$(".dtdate").html(action.formatAvgrDate("1", "2", jyrq));
					}
					$("#first").hide();
					$("#second").show();
				}
				return false;
			});
			$("#thirdBackBtn").bind("tap", function() {
				$("#third").hide();
				$("#modify").show();
				return false;
			});
			$("#purchaseBtn").bind("tap", function() {
				if (action.formValidate2()) {
					$.hsf.startLoading("正在提交申请...");
					var tradepassword = $("#tradepassword").UITextField("value");
					var avgrParam = action.getAvgrParam();
					var data = "state=A&fundcode=" + action.constant.result.fundcode
					+ "&tradeacco=" + action.constant.result.tradeacco
					+ "&cycleunit=" + avgrParam[0] 
					+ "&jyzq=" + avgrParam[1]
					+ "&jyrq=" + avgrParam[2]
					+ "&applysum=" + action.getApplySum() 
					+ "&tradepassword=" + tradepassword
					+ "&xyh=" + action.constant.result.xyh
					+ "&xybm=";
					
	                $.hsf.ajax.app("valuavgr/fixdeclare/fixDeclareChange", data, "purchaseCallback", function(jsonResult) {
	                	$.hsf.stopLoading();
	                	if (jsonResult.successful) {
	                		$.UIAlert("转入修改成功", function(jsonResult) {
	                			$.hsf.hsOpen("xjb-avgr-list.html");
	                		})
	                		$.hsf.stopLoading();
	                	} else {
	                		$.hsf.callFailProcess(jsonResult);
	                	}
	                });
				}
				return false;
			});
		},
		formatAvgrDate : function(cycleunit, jyzq, jyrq) {
			if ("0" === cycleunit) {
				jyzq = "每月";
				jyrq = jyrq+"日";
			} else if ("1" === cycleunit) {
				if ("1" === jyzq) {
					jyzq = "每周的";
					jyrq = action.constant.weeks[jyrq];
				} else if ("2" === jyzq) {
					jyzq = "每两周的";
					jyrq = action.constant.weeks[jyrq];
				}
			}
			return jyzq+jyrq;
		},
		formValidate : function(){
            var applysum = action.getApplySum();
			if(""==applysum || parseFloat(applysum) == 0){
				$.UIPopup("请输入购买金额!");
				return false;
			}
			return true;
		},
        formValidate2 : function(){
        	var tradepassword = $("#tradepassword").UITextField("value");
        	if ("" == tradepassword) {
            	$.UIPopup("交易密码不能为空");
            	return false;
            }
			return true;
        },
        formDateToChinese : function(str) {
        	return str.substr(0,4)+"年"+str.substr(4,2)+"月"+str.substr(6,2)+"日";
        },
        getApplySum : function() {
			return $.hsf.hsTools.recoveryMoney($("#applysum").UITextField("value"));
		},
		getAvgrParam : function() {
			var jyzq = $("input[name='periodStyle']:checked").val();
			if (jyzq == "0") {
				var jyrq = $("#jyrq_0").UISelectField("value");
				return ["0", "1", jyrq];
			} else if(jyzq == "1") {
				var jyrq = $("#jyrq_1").UISelectField("value");
				return ["1", "1", jyrq];
			} else if(jyzq == "2") {
				var jyrq = $("#jyrq_1").UISelectField("value");
				return ["1", "2", jyrq];
			}
		},
		ddHtml : "<dd m-selectionstyle='no'> <div m-role='cell' m-mode='y'  m-layout='fit' class='dtlb-list'> <div m-role='cell' m-mode='x' m-layout='fit' m-valign='middle' class='btm-line'> <div m-role='cell' m-valign='middle' m-margin='0 1 0 1' m-padding='0 0 0 1'> <div class='pydt-ico ico1'></div> </div> <div m-role='cell' m-mode='y' m-layout='fit' m-margin='1 0 1 0'> <div m-role='cell' class='m-color-0 m-font-big m-font-bold'> <span class='fundname'></span> </div> <div m-role='cell' class='m-font-light m-font-small fundcode'></div> </div> <div m-role='cell' class='dtlb-edit' m-align='right' m-valign='middle' m-padding='0 1 0 0' m-margin='0 1 0 0'>编辑</div> </div> <div m-role='cell' m-mode='x' m-padding='1 1 0 1'  m-valign='middle' m-margin='1 1 1 1'> <div m-role='cell' m-valign='middle' class='w30'></div> <div m-role='cell' class='w80'> <span class='dtlb-txt'>银行卡</span> </div> <div m-role='cell'> <span class='bankacco'></span> </div> </div> <div m-role='cell' m-mode='x' m-padding='1 1 0 1'  m-valign='middle' m-margin='0 1 1 1'> <div m-role='cell' m-valign='middle' class='w30'></div> <div m-role='cell' class='w80'> <span class='dtlb-txt'>金额</span> </div> <div m-role='cell'> <span class='applysum'></span> </div> </div> <div m-role='cell' m-mode='x' m-padding='1 1 1 1'  m-valign='middle' m-margin='0 1 1 1'> <div m-role='cell' m-valign='middle' class='w30'></div> <div m-role='cell' class='w80'> <span class='dtlb-txt'>转入日期</span> </div> <div m-role='cell'> <span class='dtdate'></span> </div> </div> <div class='dtlb-opt'> <div m-role='cell' m-mode='x' m-valign='middle'> <div m-role='cell' m-align='center' class='dtlb-del' m-selectionstyle='yes'> <div class='dtlb-del-ico'></div> </div> <div m-role='cell' m-mode='x-equal' m-layout='fit'> <div m-role='cell' m-align='center' class='dtlb-pause right-line left-line' m-selectionstyle='yes'>暂停</div> <div m-role='cell' m-align='center' class='dtlb-modify' m-selectionstyle='yes'>修改</div> </div> </div> </div> </div> </dd>"
	};
	return action;
});