﻿define("pages/xjb-avgr-1", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		el: "#xjb-avgr-1",
		$cardTypeBox : $("#cardTypeBox"),
		$applysum : $("#applysum"),
		fundcode : '888888',
		fundname : '光大耀钱包',
		_private :{
			saveplanflag:"d",
			operway:0
		},
		initialize: function(parent,platformApi) {
			var that = this;
			this.parent = parent;
			this.validForm = $.validForm();
			//lxf add start
            $.platform.getCache("logininfo", function(result) {
                if (result) {
                    var custRole = result.custtype;
                    if(custRole == "1"){//代销用户
                        $.UIConfirm("您暂未绑定银行卡，现在立刻绑定，享受购基0费率！", function(o){
                            if (o == "yes") {
                                $.hsf.hsOpen("account-openAcco-gdbdx.html");
                            }
                        });
                    }else{
                        if(custRole=="3"){
                            $.UIAlert("请先绑定一张银行卡", function(){
                                url = "account-openAcco-new.html";
                                url = url+"?custtype="+custRole+"&mobile="+result.Mobile+"&userid="+result.userid;
                                $.hsf.hsOpen(url);
                            });

                        }else{
                            that.packForm();
                            that.initFundInfo();
                        }
                    }
                }else{

                }
            });
            $.platform.initPage&&$.platform.initPage();
            //lxf add end
            // this.packForm(); lxf delete
            // this.initFundInfo(); lxf delete
			this.formGenerate = $.formGenerate();
			this.platformApi = platformApi;
			this.uiEvent();
			$.checkNullGroup([this.$applysum], $("#purchaseBtn"));
			$.UIPasswordKeyboard("init", {
				inputComplete : function(pw, succ, fail) {
					var param = that.getAvgrParam();
					var g = that.formGenerate.add("fundcode", that.fundcode)
					.add("operway", that._private.operway)
					.add("saveplanflag", that._private.saveplanflag)
					.add("continueinvestamount", that.getApplySum())
					.add("investcycle", param[0])
					.add("investcyclevalue", param[1])
					.add("tpasswd", pw)
					.add("transactionaccountid", that._private.transactionaccountid);
					$.hsf.ajax.app("trade/valuavgr/modifyFixDeclare", g.generate(), "modifyFixDeclareCallback", function(jsonResult) {
						if (jsonResult.successful) {
							succ();
							that.parent.setParam("firstinvestdate", $.hsf.hsTools.yyyy_mm_dd(jsonResult.result.data[0].firstinvestdate));
							that.platformApi.triggerSucc && that.platformApi.triggerSucc();
							window.location.hash = "xjb-avgr-2";
						} else {
							fail(jsonResult.message);
						}
					});
				}
			});
		},
		initFundInfo : function() {
			$.doTemplate("fundinfo-template", {fundcode: this.fundcode, fundname: this.fundname});
		},
		events : {
			"tap #bankcardSelect" : "toggleCardType",
			"tap .m-select-box-opt" : "cardTypeSelectComplete",
			"tap #purchaseBtn[m-state!='disabled']" : "inputPassword"
		},
		toggleCardType : function() {
			$("input").blur();
			this.$cardTypeBox.UIPopOption("open");
		},
		packForm : function() {
			var that = this;
			var f = $.formGenerate()
			.add("fundcode", this.fundcode)
			.add("saveplanflag", this._private.saveplanflag)
			.add("operway", this._private.operway);
			$.hsf.startLoading();
			$.hsf.ajax.app("trade/valuavgr/modifyFixDeclareFrom", f.generate(), "modifyFixDeclareFromCallback", function(jsonResult) {
				if (jsonResult.successful) {
					that._private.bankCards = jsonResult.result.data;
					that.packFirstPage();
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		changeBankCard : function(index) {
			var card = this._private.bankCards[index];
			this._private.capsource = "0";
			this._private.transactionaccountid = card.transactionaccountid;
			$("#selectedBankName").html(card.bankname);
			$("#selectedBankcardNo").html($.hsf.hsTools.maskCardCenter(card.depositcard));
			$("#selectedBankcardIcon").removeAttr("class").addClass("bank-logo bank-"+card.alias);
		},
		changePay : function(mid) {
			var t = mid.split("_");
			if (t[0] == "0") {
				this.changeBankCard(t[1]);
			}
		},
		packFirstPage : function() {
			if (this._private.bankCards.length > 0) {
				$.doTemplate("banklist-template", this._private.bankCards);
				$("[m-role='UITableView']").UITableView("refresh");
				this.$cardTypeBox.UIPopOption("select", "0_0");
			} else {
				$.UIConfirm({"html":"您还没有可以交易的银行卡，是否添加?", "submitText":"确定","cancelText":"取消"}, function(result) {
					if (result == "yes") {
						$.hsf.hsOpen("add-bankcard.html");
					} else {
						$.hsf.hsBack();
					}
				});
			}
		},
		getApplySum : function() {
			return $.hsf.hsTools.recoveryMoney(this.$applysum.UITextField("value"));
		},
		demical2ApplySum : function() {
			var value = this.$applysum.UITextField("value");
			if (!isNaN(parseFloat(value))) {
				this.$applysum.UITextField("value", parseFloat(value).toFixed(2));
			}
		},
        inputPassword : function() {
        	this.validForm.add("more", {origin: this.getApplySum(), target: 0}, "请输入金额");
        	this.validForm.add("moreEqual", {origin: this.getApplySum(), target: this._private.min}, "最少购买"+this._private.min+"元");
        	if (this.validForm.valid()) {
        		this.demical2ApplySum();
        		$.UIPasswordKeyboard("show", {
        			key: "金额:",
        			value : $.hsf.hsTools.formatMoney(this.getApplySum())+"元"
        		});
        	}
        	return false;
        },
        uiEvent : function() {
        	var that = this;
        	this.$cardTypeBox.UIPopOption({title:"请选择支付方式"});
			this.$cardTypeBox.UIPopOption("change", function(mid) {
				that.changePay(mid);
			});
			$("[m-name='periodStyle']").UIRadio("change", function(e) {
				if (e.value == "0") {
					$("#jyrq_1").hide();
					$("#jyrq_0").show();
				} else {
					$("#jyrq_0").hide();
					$("#jyrq_1").show();
				}
				return false;
			});
       },
       getAvgrParam : function() {
			var jyzq = $("[m-name='periodStyle']").UIRadio("value");
			if (jyzq == "0") {
				var jyrq = $("#jyrq_0").UISelectField("value");
				return ["0", jyrq];
			} else if(jyzq == "1") {
				var jyrq = $("#jyrq_1").UISelectField("value");
				return ["1", jyrq];
			}
		},
	});
});
define("pages/xjb-avgr-2", ["require", "Backbone"], function(require) {
	return Backbone.View.extend({
		title : {
			left : {
				show : false
			},
			center : {
				text : "结果详情"
			}
		},
		el: "#xjb-avgr-2",
		initialize : function(parent) {
			$("#firstinvestdate").html(parent.getParam("firstinvestdate"));
		}
	});
});
define("pages/xjb-avgr", ['Backbone'], function(Backbone) {
	return $.bone('xjb-avgr-1');
});
