define([], function() {
	var action = {
		constant : {
			fundcode : $.hsf.hsTools.getParam("fundcode"),
			profit : $.hsf.hsTools.getParam("profit")
		},
		init : function() {
			action.profit(action.getPreMonthDay(1), action.getCurrentDay());
			action.events();
		},
		events: function() {
		},
		profit : function(startDate, endDate) {
			$.hsf.startLoading();
			
			$.hsf.ajax.app("atomicquery/fundinfo/hisProfit", "dosum=0&fundcode="+action.constant.fundcode+"&startdate=" 
					+ startDate.replace(new RegExp(/(-)/g),'') + "&enddate=" + endDate.replace(new RegExp(/(-)/g),'') + "&queryunit=0&applyrecordno=40", "getTotalIncomeAnalysisCallback", function(jsonResult) {
				if (jsonResult.successful) {
					var profitlist = jsonResult.returnList;
					var param = action.formatValue(profitlist);
					$(".xjb-sy-list").html(action.renderHtml(profitlist, param.maxvalue));
					$(".xjb-level-content").html(param.totalvalue);
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		
		renderHtml : function(data, maxValue) {
			var html = "", percentWidth;
			for(var i=0,j=data.length;i<j;i++) {
				percentWidth=(data[i].income/(maxValue*1.6666))*100+40+"%";
       html+= "<div class=\"sy-item\" m-role=\"cell\">"
       + "<div m-role=\"cell\" m-layout=\"fit\" m-padding=\"0 1 0 1\" m-margin=\"0 1 0 1\">"
       + "<div class=\"xjb-sy-progress\"  m-role=\"cell\" m-layout=\"fit\">"
       + "<div class=\"xjb-sy-value\" style=\"width:"+percentWidth+"\"  m-role=\"cell\" m-valign=\"middle\" m-align=\"right\" m-padding=\"1 1 1 1\">"
       + "<div m-role=\"cell\" m-margin=\"0 1 0 1\" m-align=\"left\">"+$.hsf.hsTools.yyyy_mm_dd(data[i].incomedate)+"</div>"
       + "<div m-role=\"cell\" m-align=\"right\" m-layout=\"fit\"><span>"+value+"</span></div>"
       + "     </div></div>"
       + "    </div></div>";

			}
			return html;
		},
		formatValue:function(data){
	        var valueList=[], maxValue, totalValue = 0.00;
	        for(var i=0,j=data.length;i<j;i++) {
	        	valueList.push(data[i].income);
	        	totalValue += parseFloat(data[i].income);
	        }
	        maxValue=Math.max.apply(this,valueList);
	        return {maxvalue:maxValue, totalvalue:parseFloat(action.constant.profit).toFixed(2)};
		},
		getPreMonthDay : function(i) {
			var now = new Date();
			now.setDate(now.getDate()-i*30);  
			var myyear = now.getFullYear();     
		    var mymonth = now.getMonth() + 1;     
		    var myweekday = now.getDate();      
		    if(mymonth < 10){     
		        mymonth = "0" + mymonth;     
		    }      
		    if(myweekday < 10){     
		        myweekday = "0" + myweekday;     
		    }     
		    return (myyear+"-"+mymonth + "-" + myweekday);   
		},
		getCurrentDay : function() {
			var now = new Date();
			var myyear = now.getFullYear();     
		    var mymonth = now.getMonth() + 1;     
		    var myweekday = now.getDate();      
		    if(mymonth < 10){     
		        mymonth = "0" + mymonth;     
		    }      
		    if(myweekday < 10){     
		        myweekday = "0" + myweekday;     
		    }     
		    return (myyear+"-"+mymonth + "-" + myweekday);   
		}
	};
	return action;
})