define([], function() {
	var action = {
		init : function() {
			action.profit(action.getPreMonthDay(1), action.getCurrentDay());
			action.events();
		},
		events: function() {
		},
		profit : function(startDate, endDate) {
			$.hsf.startLoading();
			$.hsf.ajax.app("product/product/superfundinfo", "startdate=" + startDate + "&enddate=" + endDate + "&pageno=1&pagesize=30", "getTotalIncomeAnalysisCallback", function(jsonResult) {
				if (jsonResult.successful) {
					var profitlist = jsonResult.result.data;
					if (profitlist.length > 0) {
						var param = action.formatValue(profitlist);
						$(".xjb-sy-list").html(action.renderHtml(profitlist, param.maxValue));
						$(".xjb-level-content").html(parseFloat(param.averageValue).toFixed(4)+"%");
					}
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		renderHtml : function(data, maxValue) {
			var html = "", percentWidth;
			for(var i=0,j=data.length;i<j;i++) {
				var value = parseFloat(data[i].growthrate).toFixed(4);
				percentWidth=$.hsf.hsTools.accurateMul((value/(maxValue*1.6666)), 100)+40+"%";
//       <div class=\"m-color-6 xjb-sy-date\" m-role=\"cell\" m-valign=\"middle\">"+$.hsf.hsTools.yyyy_mm_dd(data[i].date)+"</div>"
				html+= "<div class=\"sy-item\" m-role=\"cell\">"
       + "<div m-role=\"cell\" m-layout=\"fit\" m-padding=\"0 1 0 1\" m-margin=\"0 1 0 1\">"
       + "<div class=\"xjb-sy-progress\"  m-role=\"cell\" m-layout=\"fit\">"
       + "<div class=\"xjb-sy-value\" style=\"width:"+percentWidth+"\"  m-role=\"cell\" m-valign=\"middle\" m-align=\"right\" m-margin=\"0 0 0 0\">"
       + "<div m-role=\"cell\" m-margin=\"0 1 0 1\" m-align=\"left\">"+$.hsf.hsTools.yyyy_mm_dd(data[i].date)+"</div>"
       + "<div m-role=\"cell\" m-align=\"right\" m-layout=\"fit\"><span>"+value+"%</span></div>"
       + "     </div></div>"
       + "    </div></div>";
			}
			return html;
		},
		formatValue:function(data){
	        var valueList=[], maxValue, totalValue = 0.00;
	        for(var i=0,j=data.length;i<j;i++) {
	        	var value = data[i].growthrate = $.hsf.hsTools.accurateMul(data[i].growthrate, 100);
	        	valueList.push(value);
	        	totalValue += parseFloat(value);
	        }
	        maxValue=Math.max.apply(this,valueList);
	        return {maxValue:maxValue, averageValue : totalValue>0 ? totalValue/data.length: 0};
		},
		getPreMonthDay : function(i) {
			var now = new Date();
			now.setDate(now.getDate()-i*30);  
			var myyear = now.getFullYear();     
		    var mymonth = now.getMonth() + 1;     
		    var myweekday = now.getDate();      
		    if(mymonth < 10){     
		        mymonth = "0" + mymonth;     
		    }      
		    if(myweekday < 10){     
		        myweekday = "0" + myweekday;     
		    }     
		    return (myyear+"-"+mymonth + "-" + myweekday);   
		},
		getCurrentDay : function() {
			var now = new Date();
			var myyear = now.getFullYear();     
		    var mymonth = now.getMonth() + 1;     
		    var myweekday = now.getDate();      
		    if(mymonth < 10){     
		        mymonth = "0" + mymonth;     
		    }      
		    if(myweekday < 10){     
		        myweekday = "0" + myweekday;     
		    }     
		    return (myyear+"-"+mymonth + "-" + myweekday);   
		}
	};
	return action;
})