﻿define("pages/xjb-record-1", function(require) {
	return Backbone.View.extend({
		el: "#xjb-record-1",
		title : {
			center : {
				text: "耀钱包交易记录"
			}
		},
		initialize: function(parent) {
			this.parent = parent;
			this.loadMonthData();
		},
		afterSwitchView: function() {},
		constant: {
			pageNo :1,
			loadedNum :0,
			busintype: {
				"00": "存入",
				"01": "快速取现",
				"02": "消费",
				"03": "还款",
				"04": "普通取现",
				"05": "购买基金",
				"06": "赎回基金",
				"07": "定期存入",
				"08": "赠送(强增)",
				"09": "购买基金"
			},
			instatus: {
				"00": "未支付",
				"01": "支付处理中",
				"02": "支付成功",
				"03": "支付失败",
			},
			outstatus: {
				"0000": "成功"
			},
			result : {
			}
		},
		loadMonthData: function() {
			var $data = $("#data");
			var that = this;
			$.hsf.startLoading();
			$.hsf.ajax.app("query/tradeapply/superTradeApply", "pageno="+this.constant.pageNo+"&pagesize=10", "applyListCallback", function(jsonResult) {
				if (jsonResult.successful) {
					if (!jsonResult.result.totalpages || jsonResult.result.totalpages == 0) {
						var top = (document.documentElement.clientHeight - 44-200-38)/2;
						$("#nodata").css({"top":top}).show();
						$("#data").hide();
					} else {
						var result = jsonResult.result;
						var list = result.data;
						for (var index in list) {
							$dd = $(this.dd);
							var info = list[index];
							info.leftTop = that.constant.busintype[info.tradeway];
							info.leftBottom = $.hsf.hsTools.yyyy_mm_dd(info.operdate) + " " + info.opertime;
							if(info.cancelflag == "2"){
								if (info.tradeway == "06" && parseFloat(info.applicationamount) == 0) {
									info.rightTop  = "已撤单";
									info.rightBottom = "";
								} else {
									info.rightTop = (that.inOrOut(info.tradeway) > 0 ? "+" : "-") + info.applicationamount;
									info.rightBottom = "已撤单";
								}
							}else{
								if (info.tradeway == "06" && parseFloat(info.applicationamount) == 0) {
									info.rightTop  = "待确认";
									info.rightBottom = "";
								} else {
									info.rightTop = (that.inOrOut(info.tradeway) > 0 ? "+" : "-") + info.applicationamount;
									info.rightBottom = that.paystatus(info);
								}
							}

							info.icon = that.inOrOut(info.tradeway) > 0 ? "xjb-action-icon1" : "xjb-action-icon2";
							that.constant.result[info.appsheetserialno] = info;
						}
						$.doTemplate("data-template", result, "repeat");
						$("[m-role='UITableView']").UITableView("refresh");
						that.constant.pageNo++;
						that.constant.loadedNum += list.length;
						if (that.constant.loadedNum >= jsonResult.result.totalpages) {
							$("#moreBtn").hide();
						} else {
							$("#moreBtn").show();	
						}
					}
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		paystatus: function(entity) {
			if (entity.tradeway == "00") {
				return $.hsf.hsTools.defaultNull(this.constant.instatus[entity.paystatus], "");
			} else {
				return $.hsf.hsTools.defaultNull(this.constant.outstatus[entity.returncode], "失败");
			}
		},
		inOrOut: function(code) {
			if (code == "00" || code == "08" || code == "07" || code == "06") {
				return 1;
			} else {
				return -1;
			}
		},
		events : {"tap dd": "detail", "tap #moreBtn": "next"},
		detail : function(event) {
			this.parent.setParam("appsheetserialno", $(event.currentTarget).attr("appsheetserialno"));
			this.parent.setParam("result", this.constant.result);
			window.location.hash = "xjb-record-2";
		},
		next : function() {
			this.loadMonthData();
		}
	});
});
define("pages/xjb-record-2", function(require) {
	return Backbone.View.extend({
		el: "#xjb-record-2",
		title : {
			center : {
				text: "交易详情"
			}
		},
		initialize: function(parent) {
			this.parent = parent;
			var result = this.parent.getParam("result");
			var appsheetserialno = this.parent.getParam("appsheetserialno");
			$.UIPasswordKeyboard("init", {
				paying: "正在撤单，请稍候...",
				inputComplete : function(pw, succ, fail) {
					var g = $.formGenerate().add("originalappsheetno", appsheetserialno)
						.add("transactionaccountid", result[appsheetserialno].transactionaccountid)
						.add("tpasswd", pw)
					    .add("canceltype",1);//originalappsheetno  canceltype
					$.hsf.ajax.app("trade/canceltrade/canceltrade", g.generate(), "canceltradeCallback", function(jsonResult) {
						$("#withdrawBtn").remove();
						if (jsonResult.successful) {
							succ();
							$.UIPopup("撤单成功", function() {
								$.platform.triggerSucc && $.platform.triggerSucc(appsheetserialno);
								$.hsf.hsOpen("xjb-record.html");
							});
						} else {
							fail(jsonResult.message);
						}
					});
				}
			});
		},
		events : {
			"tap #cancelBtn" : "cancelBtn"
		},
		cancelBtn : function(){
			$.UIPasswordKeyboard("show", {});
		},
		afterSwitchView: function() {
			var result = this.parent.getParam("result");
			var no = this.parent.getParam("appsheetserialno");
			if (result[no].rightBottom.indexOf("失败")>=0) {
				result[no].moneyColor = "m-font-light";
			} else {
				if (result[no].leftTop=="存入"||result[no].leftTop=="赎回基金") {
					result[no].moneyColor = "m-color-green";
				} else {
					result[no].moneyColor= "m-color-red";
				}
			}
			$.doTemplate("xjb-detail-template", result[no], "refresh");
		}
	});
});
define("pages/xjb-record", function(require) {
	return $.bone("xjb-record-1");
});