define(["chartjs"], function(chartjs) {
	var action = {
		constant : {
			fundflag : 1
		},
		init : function() {
			$.platform.initPage();
			action.packForm();
			action.events();
		},
		packForm : function() {
			$.platform.getCache("xjb",function(jsonResult){
				if (jsonResult){
					action.loadXjb(jsonResult);
				}else{
					$.hsf.startLoading();
					$.hsf.ajax.app("query/share/moneyfundshareList", "", "checkLoginCode", function(jsonResult) {
						if (jsonResult.successful) {
							$.platform.putCache("xjb",jsonResult);
							action.jsonResult = jsonResult;
							action.loadXjb(jsonResult);
						} else {
							$.hsf.callFailProcess(jsonResult);
						}
					});
				}
			});
		},

		loadXjb : function(jsonResult){
			$("#zrsy").html(jsonResult.dayincome);
			$("#zsy").html(jsonResult.totalIncome);
			$("#zzc").html(jsonResult.totalMarketvalue);
			$("#qrnh").html(jsonResult.incomeratio);
			$("#wfsy").html(jsonResult.hfincomeratio);
			$("#yysy").html(jsonResult.monthIncome);
			if (parseFloat(jsonResult.totalMarketvalue) == 0.00) {
				$("#moneyOutBtn").attr("m-state", "disabled").bind("tap", function() {
					return false;
				})
			}
			$.each($(".xjbExtend"), function(i, n) {
				n.setAttribute("m-href", n.getAttribute("m-href")+"?fundcode="+jsonResult.fundcode);
			});
			$(".ljsya").attr("m-href", $(".ljsya").attr("m-href")+"&profit="+jsonResult.totalIncome);
			$(".yysya").attr("m-href", $(".yysya").attr("m-href")+"&profit="+jsonResult.monthIncome);
			action.draw(jsonResult.netvaluelist);
		},
		draw : function(netvaluelist) {
			var lineChartData = {
					labels : [],
					datasets : [
						{
							label: "My First dataset",
							fillColor : "rgba(220,220,220,0.2)",
							strokeColor : "darkorange",
							pointColor : "darkorange",
							pointStrokeColor : "darkorange",
							pointHighlightFill : "white",
							pointHighlightStroke : "darkorange",
							data : []
						}
					]
				};
				if (netvaluelist.length <=0) {
					lineChartData.labels.push('');
					lineChartData.datasets[0].data.push(0);
				}
				for (var index in netvaluelist) {
					var m = netvaluelist[index].navdate.substr(5,2);
					var d = netvaluelist[index].navdate.substr(8,2);
					lineChartData.labels.push(m+"-"+d);
					lineChartData.datasets[0].data.push(parseFloat(netvaluelist[index].incomeratio).toFixed(4));
					
				}
				lineChartData.labels = lineChartData.labels.reverse();
				lineChartData.datasets[0].data = lineChartData.datasets[0].data.reverse();
				var ctx = document.getElementById("myChart").getContext("2d");
				var myLine = new Chart(ctx).Line(lineChartData, {
					datasetStrokeWidth : 4,
					pointDot : true,
					showTooltips : false,
					tooltipFillColor : 'darkorange',
					tooltipFontColor : 'white',
					tooltipTemplate : "<%=value %>",
					pointDotOnlyEnd : true,
					pointDotStrokeWidth : 3,
				});
				$.hsf.stopLoading();
		},
		events : function() {
		}
	};
	return action;
})
