define(['jquery'], function($) {
    $(document).bind("deviceready", function () {
        baseapi.deviceReady = true;
        hybrid.core.addHybridBroadcastListener("forgetGesturePassword", function(jsresult) {
            $.hsf.ajax.app("account/login/logout","","logoutCallback",function(jsonResult) {
                baseapi.removeCache("login");
                baseapi.removeCache("gestureStatus");
                if(jsonResult.successful) {
                    window.location.reload();
                    hybrid.core.sendHybridBroadcast("closeGesturePassword",{"close":"true"});
                }
            });
        });
        hybrid.core.addHybridBroadcastListener("networkStatus", function(jsresult){
            if(jsresult.status==true || jsresult.status=="true") {
                $.hsf.network = "succ";
//                $.UIPopup("网络已连接！");
            } else {
                $.hsf.network = "fail";
                $.UIPopup("请检查网络连接");
            }
            return false;
        });
        hybrid.core.addHybridBroadcastListener("shareResult",function(jsresult){
            if(jsresult.result==true || jsresult.result == "true"){
//                                               alert("分享成功");
                window.frames[0].postMessage({"result":"true"},"*");
            }else{
//                                               alert("取消分享");
                window.frames[0].postMessage({"result":"false"},"*");
            }
            return false;
        });
    });
    var baseapi = {
        channel : "iphone",
        putCache : function(key , value) {
            var object={"key": key, "value" : value};
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            }
            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {
                console.log("我要打开iOS页面id:" );
                toNativeSave(stringifyJson(object));
            } else {
                console.log("我要打开android页面:");
                toNativeSave(stringifyJson(object));
            }

        },

        getCache : function(key, func) {
            var object={"key": key, "callback":'callCacheObject'};
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            };
            window.callCacheObject=function(ob){
                func(ob);
            };

            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {
                console.log("我要打开iOS页面id:" );
                toNativeLoad(stringifyJson(object));
            } else {
                console.log("我要打开android页面:");
                toNativeLoad(stringifyJson(object));
            }


        },
        removeCache : function(key) {
            hybrid && hybrid.core.execMethod("clear", key);
        },
        removeAllCache : function() {

        },
        tongji : function() {
            var dir= location.href.split('/');
            var page = dir[dir.length-1].split('.')[0]+".html";
            hybrid && hybrid.core.execMethod("baiduStatStart",{"pageName": page});
        },
        hsOpen : function(url, callBackEvent) {

            var openMethod = {
                "url": url,
                "isHideTitle":"yes",
                "method": "hsOpen",
                "callBackEvent":callBackEvent
            };
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            }

            // execNative(stringifyJson(openMethod));
            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {
                console.log("我要打开iOS页面id:" );
                execNative(stringifyJson(openMethod));
            } else {
                console.log("我要打开android页面:");
                handleNative.execNative(stringifyJson(openMethod));
            }
        },
        hsOpen_loc : function(url) {
            window.location.href = decodeURI(url);
        },
        hsBack : function(url, style) {
            var backMethod = {
                "url": url,
                "method": "hsBack"
            };
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            }
            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {
                console.log("我要打开iOS页面id:" );
                execNative(stringifyJson(backMethod));
            } else {
                console.log("我要打开android页面:");
                handleNative.execNative(stringifyJson(backMethod));
            }
        },
        hsOpenOutLink:function(url,isHideTitle){
            var method = {
                "url":url,
                "isHideTitle":isHideTitle,
                "method": "openOutLinke" //跳转外链网页
            };
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            }
            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {//获取iOS用户信息
                execNative(stringifyJson(method));
            } else {//获取android用户信息
                handleNative.execNative(stringifyJson(method));
            }
        },
        share : function( title, image_url, target_url, context) {
            // hybrid.core.execMethod("shareWay", {"url": url, "title": title, "text": text, "mediaUrl": murl});

            var method = {
                "title": title,
                "image_url":image_url,
                "target_url":target_url,
                "context":context,
                "method": "toNativeShare" //分享
            };
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            }
            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {//获取iOS用户信息
                execNative(stringifyJson(method));
            } else {//获取android用户信息
                handleNative.execNative(stringifyJson(method));
            }

        },
        //fdf打开
        hsOpenHSAppPage : function(param) {
            var tagPage = {
                "url": param,
                "method": "toNativePDF"
            };
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            }
            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {
                // console.log("我要打开iOS页面id:" + stringifyJson(tagPage));
                execNative(stringifyJson(tagPage));
            } else {
                // console.log("我要打开android页面:" + stringifyJson(tagPage));
                handleNative.execNative(stringifyJson(tagPage));
            }
        },
        //获取UserInfor
        getAppUserInfo:function(func){
            var tagMethod = {
                "url": "",
                "callback":'getUserInfo',
                "method": "custInfo"
            };
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            }

            window.getUserInfo=function (ob) {
              func(ob);
            };

            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {//获取iOS用户信息
                // setTimeout(function() {
                //     execNative(stringifyJson(tagMethod));
                // }, 200);
                execNative(stringifyJson(tagMethod));
            } else {//获取android用户信息
                // setTimeout(function() {
                //     handleNative.execNative(stringifyJson(tagMethod));
                // }, 200);
                handleNative.execNative(stringifyJson(tagMethod));
            }
        },
        hsOpenRisk:function(){
            var method = {
                "url": "",
                "method": "toNativeMyRiskLevelVC" //风险测评
            };
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            }
            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {//获取iOS用户信息
                execNative(stringifyJson(method));
            } else {//获取android用户信息
                handleNative.execNative(stringifyJson(method));
            }
        },

        hsOpenForgetpassword:function(){
            var method = {
                "url": "",
                "method": "toNativeGDSetPasswordVC" //风险测评
            };
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            }
            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {//获取iOS用户信息
                execNative(stringifyJson(method));
            } else {//获取android用户信息
                handleNative.execNative(stringifyJson(method));
            }
        },
        hsOpenDepositVC:function(transactionaccountid){
            var method = {
                "transactionaccountid": transactionaccountid,
                "method": "toNativeDepositVC" //打开原生耀钱包
            };
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            }
            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {//获取iOS用户信息
                execNative(stringifyJson(method));
            } else {//获取android用户信息
                handleNative.execNative(stringifyJson(method));
            }
        },
        blockAPI:function(ob){//block回调的方法

            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            };

            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {
                // console.log("我要打开iOS页面id:" + stringifyJson(tagPage));
                execNative(stringifyJson(ob));
            } else {
                // console.log("我要打开android页面:" + stringifyJson(tagPage));
                handleNative.execNative(stringifyJson(ob));
            }

        },
        //买入时（登录判断）
        hsbao_buy_Login:function(func){
            var method = {
                "url": "",
                "callback":'bao_buy_login',
                "method": "bao_buy_login" //登录判断
            };
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            }
            window.bao_buy_login=function (ob) {
                func(ob);
            };
            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {//获取iOS用户信息
                execNative(stringifyJson(method));
            } else {//获取android用户信息
                handleNative.execNative(stringifyJson(method));
            }
        },
        //通知事件
        noticeToEvent:function(eventStr){
            var method = {
                "url": "",
                "noticeEvent":eventStr,
                "method": "noticeEventMethod"

            };
            function stringifyJson(jsonObj) {
                if(JSON && typeof JSON.stringify=='function') return JSON.stringify(jsonObj);
                if (typeof jsonObj !== 'object') return "\"" + jsonObj + "\""
                var json = "{ ";
                var count = 0;
                for (var item in jsonObj) {
                    if (count > 0) {
                        json += ",";
                    }
                    json += "\"" + item + "\":" + stringifyJson(jsonObj[item]) + "";
                    count++;
                }
                json += " }";
                return json;
            };

            if(window.navigator.userAgent.match(/(iPhone|iPod|iPad)/)) {
                // console.log("我要打开iOS页面id:" + stringifyJson(tagPage));
                execNative(stringifyJson(method));
            } else {
                // console.log("我要打开android页面:" + stringifyJson(tagPage));
                handleNative.execNative(stringifyJson(method));
            }

        },


        deviceReady : false
    };

    var api = {
        "index" : {
            initPage : function() {
                $(".nativeSupport").show();
                hybrid.core.addHybridBroadcastListener("trade", function(jsresult){
                    $.hsf.Event.trigger("trade");
                });
                hybrid.core.addHybridBroadcastListener("withdraw", function(jsresult){
                    $.hsf.Event.trigger("trade");
                });
                hybrid.core.addHybridBroadcastListener("notify", function(jsresult){
                    $.hsf.Event.trigger("notify", null, jsresult);
                });
                hybrid.core.addHybridBroadcastListener("clearNotify", function(jsresult){
                    $.hsf.Event.trigger("clearNotify");
                });
            },
            initOpenId : function() {
                baseapi.getCache("openId", function(openIdResult) {
                    if (openIdResult) {
                        $.hsf.Event.trigger("openIdRead");
                    } else {
                        baseapi.getCache("deviceId", function(result) {
                            $.hsf.ajax.app("weixin/wxzt/firstOpen", "deviceId="+encodeURIComponent(result)+"&deviceType=1&originalId=app", "firstOpenCallback", function(jsonResult) {
                                if (jsonResult.successful) {
                                    baseapi.putCache("openId", jsonResult.result.openId);
                                    baseapi.putCache("deviceId", result);
                                }
                                $.hsf.Event.trigger("openIdRead");
                            });
                        })
                    }
                });
            }
        },
        "login-view" : {
            channel : "iphone",
            initPage : function(action) {
                $("#login [m-role=\"title\"]").html("登录");
                $("#loginButton").html("登录");
                hybrid.core.addHybridBroadcastListener("openaccoSucc", function(jsresult){
                    action.popDown();
                });
                hybrid.core.addHybridBroadcastListener("loginrefresh", function (jsresult) {
                    action.popDown();
                });
            },
            autoLogin : function(failProcess) {
                try {
                    var that = this;
                    baseapi.getCache("login", function(result) {
                        baseapi.getCache("deviceId", function(deviceId) {
                            if (result.certificate) {
                                var accountType = result.certificateType;
                                var account = result.certificate;
                                var pw = result.pw;
                                var accttype = result.accttype;
                                var data = "certificatetype=" + accountType
                                    + "&certificateno=" + account
                                    + "&lpasswd=" + pw
                                    + "&channel="+that.channel
                                    + "&accttype="+ accttype
                                    + "&deviceId="+encodeURIComponent(encodeURIComponent(deviceId));
                                $.hsf.ajax.app(that.loginUrl, data, "checkLoginCode", function(jsonResult) {
                                    if (jsonResult && jsonResult.successful) {
                                        $.hsf.Event.trigger("login");
                                        that.broadcast();
                                    } else {
                                        $.hsf.Event.muteTrigger("autoLoginFail");
                                    }
                                });
                            } else {
                                $.hsf.Event.muteTrigger("autoLoginFail");
                            }
                        });
                    });
                } catch (e) {
                    console.log(e);
                }
            },
            loginUrl : "account/login/login",
            loginSuccess : function(certificate, certificateType, pw, accttype) {
                try {
                    hybrid && hybrid.core.execMethod("save",  {"key": "login", "value" : {"certificate":certificate,"certificateType":certificateType, "pw":pw, "accttype":accttype}});//argv是一个json格式的字符串
                } catch (e) {
                    console.log(e);
                }
                this.broadcast();
            },
            broadcast : function() {
                hybrid.core.sendHybridBroadcast("loginrefresh", {"refresh":"true"});
            }
        },
        "account-openAcco-form" : {
            loginUrl : "account/login/login"
        },
        "account-openAcco-6": {
            triggerRefresh: function () {
                hybrid.core.sendHybridBroadcast("loginrefresh", {"refresh": "true"});
            },
            triggerSucc: function () {
                hybrid.core.sendHybridBroadcast("openaccoSucc", {});
            }
        },
        "account-openAcco-new-6": {
            triggerRefresh: function () {
                hybrid.core.sendHybridBroadcast("loginrefresh", {"refresh": "true"});
            },
            triggerSucc: function () {
                hybrid.core.sendHybridBroadcast("openaccoSucc", {});
            }
        },
        "account-openAcco-new-7": {
            triggerSucc: function () {
                hybrid.core.sendHybridBroadcast("openaccoSucc", {});
            }
        },
        "account-openAcco-new": {
            triggerRefresh: function () {
                hybrid.core.sendHybridBroadcast("loginrefresh", {"refresh": "true"});
            }
        },
        "reset-mobile-getcode": {
            triggerRefresh: function () {
                hybrid.core.sendHybridBroadcast("loginrefresh", {"refresh": "true"});
            }
        },

        "bind-mobile-unbind" : {
            triggerRefresh : function() {
                hybrid.core.sendHybridBroadcast("mobileStatus", {"":""});
            }
        },
        "bind-mobile-1" : {
            triggerRefresh : function() {
                hybrid.core.sendHybridBroadcast("mobileStatus", {"":""});
            }
        },
        "account-safe" : {
            initPage : function() {
                var that = this;
                hybrid && hybrid.core.execMethod("load","gestureStatus",function(result){
                    result = result || {status:0}
                    $.doTemplate("native-template", result.status);
                    $("[m-role='UISwitch']").UISwitch();
                    $("[m-role='UITableView']").UITableView();
                    $("#switch").UISwitch("change", function() {
                        that.switchFunc();
                    });
                    $("#gesture_password").bind("tap",that.showLock);
                    $(".nativeSupport").show();
                    hybrid.core.addHybridBroadcastListener("setGestureStatus",function(jsresult){
                        if(jsresult.status == "1"){
                            $("#switch").UISwitch("state","off","stopEvent");
                            var data = {"key":"gestureStatus","value":{"status":"0"}};
                            hybrid && hybrid.core.execMethod("save",data);
                        } else {
                            $("#switch").UISwitch("state","on","stopEvent");
                            var data = {"key":"gestureStatus","value":{"status":"1"}};
                            hybrid && hybrid.core.execMethod("save",data);
                        }
                    });
                });
                hybrid.core.addHybridBroadcastListener("GestureDone",function(jsresult){
                    if(jsresult.GestureStatus=="Open"){
                        $("#switch").UISwitch("state","on","stopEvent");
                        var data = {"key":"gestureStatus","value":{"status":"1"}};
                        hybrid && hybrid.core.execMethod("save",data);
                    }
                    if(jsresult.GestureStatus=="Close"){
                        $("#switch").UISwitch("state","off","stopEvent");
                        var data = {"key":"gestureStatus","value":{"status":"0"}};
                        hybrid && hybrid.core.execMethod("save",data);
                    }
                });
                hybrid.core.addHybridBroadcastListener("loginrefresh", function (jsresult) {
                    $.hsf.startLoading();
                    $.hsf.ajax.app("account/account/accountinfo", "", "checkLoginCode", function(jsonResult) {
                        if (jsonResult.successful) {
                            if(jsonResult.result.Mobile){
                                $("#bind-mobile").html("已绑定手机号码");
                                $("#mobile").html($.hsf.hsTools.maskMobile(jsonResult.result.Mobile) + "&nbsp;&nbsp;&nbsp;");
                            }else{
                                $("#bind-mobile").html("绑定手机号码");
                            }
                            $.hsf.stopLoading();
                        } else if (jsonResult.code == "ETS-5BP00001") {
                            $.hsf.stopLoading();
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                });
            },
            switchFunc : function(){
                var value = $("#switch").attr("m-value");
                if(value == 1){
                    hybrid && hybrid.core.execMethod("showLockVC","1");
                }else{
                    hybrid && hybrid.core.execMethod("showLockVC","3");
                }
            },
            showLock : function() {
                if(0 == $("#switch").attr("m-value")){
                    $.UIPopup("请先创建手势密码!");
                    return false;
                }
                try {
                    hybrid && hybrid.core.execMethod("showLockVC", "2");
                } catch (e) {
                    console.log(e);
                }
            },
            logoutRefresh : function() {
                hybrid.core.sendHybridBroadcast("logoutrefresh", {"refresh":"true"});
            },
            logoutRefresh : function() {
                hybrid.core.sendHybridBroadcast("logoutrefresh", {"refresh":"true"});
            }
        },
        "setting" : {
            initPage : function(m) {
                $(".nativeSupport").show();
                $("#share-btn").show();
                $("#callServer").show();
                hybrid.core.addHybridBroadcastListener("loginrefresh", function(jsresult) {
                    m.loadUserInfo();
                });
            },
            openChat : function() {
                hybrid && hybrid.core.execMethod("openChat", {});
            },
            callKf : function($cardTypeBox) {
                window.open("tel:4008202888");
                //$cardTypeBox.UIPopOption("open");
            }
        },
        "home" : {
            initPage : function(m) {
                hybrid.core.addHybridBroadcastListener("loginrefresh", function(jsresult) {
                    m.initRequestForm();
                });
            }
        },
        "asset" : {
            initPage : function (m) {
                hybrid.core.addHybridBroadcastListener("loginrefresh", function(jsresult) {
                    m.requestManager.invoke(m.initAsset);
                    m.requestManager.invoke(m.initMoneyFundInfo);
                });
            }
        },
        "fund-list":{
            initPage : function(){
                hybrid.core.addHybridBroadcastListener("focusfundrefresh", function(jsresult){
                    if(jsresult.fundcode){
                        $("#dd_"+jsresult.fundcode).find(".fund-fav-item2").toggleClass('on');
                    }
                });
            }
        },
        "fund-detail":{
            initPage : function() {
                $("#share-btn").show();
                $("[m-role='left']").css("width", "80");
            },
            changeFocusFund : function(fundcode, state) {
                hybrid.core.sendHybridBroadcast("focusfundrefresh", {"fundcode":fundcode, "state":state});
            }
        },
        "attention" : {
            initPage : function(action){
                hybrid.core.addHybridBroadcastListener("focusfundrefresh", function(jsresult){
                    action.reload();
                });
            }
        },
        "general":{
            submitScore : function(){
                var data = {"key":"submitScore","value":{"appUrl":"itms-apps://itunes.apple.com/app/id1014898879?mt=8"}};
                hybrid && hybrid.core.execMethod("submitScore",data);
            }
        },
        "about-us":{
            phoneCall : function(){
                var data = {"key":"phoneCall","value":{"phone":"40001606000"}};
                hybrid && hybrid.core.execMethod("phoneCall",data);
            },
            sendEmail : function(){
                var data = {"key":"sendEmail","value":{"email":"services@zrfunds.com.cn"}};
                hybrid && hybrid.core.execMethod("sendEmail",data);
            },
            openWebsite : function(){
                var data = {"key":"openWebsite","value":{"website":"http://www.zrfunds.com.cn"}};
                hybrid && hybrid.core.execMethod("openWebsite",data);
            }
        },
        "xjb" : {
            initPage : function(){}
        },
        "risk-test-1" : {
            changeRisk : function(info) {
                hybrid.core.sendHybridBroadcast("riskrefresh", {"riskinfo":info});
            }
        },
        "account-info" : {
            initPage : function() {
                hybrid.core.addHybridBroadcastListener("riskrefresh", function(jsresult){
                    $("#riskablityType").html(jsresult.riskinfo);
                });
            }
        },
        "money":{
            initPage:function () {
                hybrid.core.addHybridBroadcastListener("trade", function(jsresult){
                    $.hsf.Event.trigger("trade");
                });
            },
        },
        "trade-money-in-1" : {
            triggerSucc : function() {
                hybrid.core.sendHybridBroadcast("trade", {"succ":"succ"});
            }
        },
        "trade-money-out-1" : {
            triggerSucc : function() {
                hybrid.core.sendHybridBroadcast("trade", {"succ":"succ"});
            }
        },
        "add-bankcard" : {
            triggerSucc : function() {
                hybrid.core.sendHybridBroadcast("addBankCardSucc", {"succ":"succ"});
            }
        },
        "bankcard" : {
            initPage : function() {
                hybrid.core.addHybridBroadcastListener("addBankCardSucc", function(jsresult){
                    window.location.reload();
                });
            }
        },
        "trade-avgr-1" : {
            initPage: function () {
                hybrid.core.addHybridBroadcastListener("loginrefresh", function (jsresult) {
                    window.location.reload();
                });
            },
            triggerSucc : function() {
                hybrid.core.sendHybridBroadcast("tradeAvgr", {});
            }
        },
        "avgr-list" : {
            initPage : function() {
                hybrid.core.addHybridBroadcastListener("tradeAvgr", function(jsresult){
                    window.location.reload();
                });
                hybrid.core.addHybridBroadcastListener("tradeAvgrModify", function(jsresult){
                    window.location.reload();
                });
            }
        },
        "trade-avgr-modify-1" : {
            triggerSucc : function() {
                hybrid.core.sendHybridBroadcast("tradeAvgrModify", {});
            }
        },
        "trade-history-detail" : {
            triggerSucc : function(no) {
                hybrid.core.sendHybridBroadcast("withdraw", {no: no});
            }
        },
        "trade-history" : {
            initPage : function() {
                hybrid.core.addHybridBroadcastListener("withdraw", function(jsresult){
                    $.hsf.Event.trigger("withdraw", null, jsresult);
                });
            }
        },
        "trade-history-advanced" : {
            initPage : function() {
                hybrid.core.addHybridBroadcastListener("withdraw", function(jsresult){
                    $.hsf.Event.trigger("withdraw", null, jsresult);
                });
            }
        },
        "modify-login-pw" : {
            updatePw : function(pw) {
                baseapi.getCache("login", function(result) {
                    if (result) {
                        var accountType = result.certificateType;
                        var account = result.certificate;
                        var accttype = result.accttype;
                        hybrid && hybrid.core.execMethod("save",  {"key": "login", "value" : {"certificate":certificate,"certificateType":certificateType, "pw":pw, "accttype":accttype}});//argv是一个json格式的字符串
                    }
                    $.hsf.hsBack();
                });
            }
        },
        "asset-detail" : {
            initPage : function() {
                hybrid.core.addHybridBroadcastListener("trade", function(jsresult){
                    window.location.reload();
                });
            }
        },
        "trade-sale-1" : {
            triggerSucc : function() {
                hybrid.core.sendHybridBroadcast("trade", {});
            }
        },
        "trade-trans-1" : {
            triggerSucc : function() {
                hybrid.core.sendHybridBroadcast("trade", {});
            }
        },
        "trade-buy-1" : {
            initPage: function () {
                hybrid.core.addHybridBroadcastListener("loginrefresh", function (jsresult) {
                    window.location.reload();
                });
            },
            triggerSucc : function() {
                hybrid.core.sendHybridBroadcast("trade", {});
            }
        },
        "notify" : {
            clearNotify : function() {
                hybrid.core.sendHybridBroadcast("clearNotify", {});
            },
            triggerSucc : function() {
                hybrid.core.sendHybridBroadcast("trade", {});
            }
        },
        "general" : {
            version : "2.7"
        },
        "wpage" : {
            showShare : function() {
                $("#share-btn").show();
            }
        },
        "q-a" : {
            openChat : function() {
                hybrid && hybrid.core.execMethod("openChat", {});
            },
            callKf : function($cardTypeBox) {
                $cardTypeBox.UIPopOption("open");
            }
        }
    };
    return {api:api, baseapi: baseapi}
});

/*hybrid api*/
;(function(){var CORDOVA_JS_BUILD_LABEL='3.5.0';var require,define;(function(){var modules={},requireStack=[],inProgressModules={},SEPARATOR=".";function build(module){var factory=module.factory,localRequire=function(id){var resultantId=id;if(id.charAt(0)==="."){resultantId=module.id.slice(0,module.id.lastIndexOf(SEPARATOR))
+SEPARATOR+id.slice(2);}
    return require(resultantId);};module.exports={};delete module.factory;factory(localRequire,module.exports,module);return module.exports;}
    require=function(id){if(!modules[id]){throw"module "+id+" not found";}else if(id in inProgressModules){var cycle=requireStack.slice(inProgressModules[id]).join('->')
        +'->'+id;throw"Cycle in require graph: "+cycle;}
        if(modules[id].factory){try{inProgressModules[id]=requireStack.length;requireStack.push(id);return build(modules[id]);}
        finally{delete inProgressModules[id];requireStack.pop();}}
        return modules[id].exports;};define=function(id,factory){if(modules[id]){throw"module "+id+" already defined";}
        modules[id]={id:id,factory:factory};};define.remove=function(id){delete modules[id];};define.moduleMap=modules;})();if(typeof module==="object"&&typeof require==="function"){module.exports.require=require;module.exports.define=define;}
    define("cordova",function(require,exports,module){var channel=require('cordova/channel');var platform=require('cordova/platform');var m_document_addEventListener=document.addEventListener;var m_document_removeEventListener=document.removeEventListener;var m_window_addEventListener=window.addEventListener;var m_window_removeEventListener=window.removeEventListener;var documentEventHandlers={},windowEventHandlers={};document.addEventListener=function(evt,handler,capture){var e=evt.toLowerCase();if(typeof documentEventHandlers[e]!='undefined'){documentEventHandlers[e].subscribe(handler);}else{m_document_addEventListener.call(document,evt,handler,capture);}};window.addEventListener=function(evt,handler,capture){var e=evt.toLowerCase();if(typeof windowEventHandlers[e]!='undefined'){windowEventHandlers[e].subscribe(handler);}else{m_window_addEventListener.call(window,evt,handler,capture);}};document.removeEventListener=function(evt,handler,capture){var e=evt.toLowerCase();if(typeof documentEventHandlers[e]!="undefined"){documentEventHandlers[e].unsubscribe(handler);}else{m_document_removeEventListener.call(document,evt,handler,capture);}};window.removeEventListener=function(evt,handler,capture){var e=evt.toLowerCase();if(typeof windowEventHandlers[e]!="undefined"){windowEventHandlers[e].unsubscribe(handler);}else{m_window_removeEventListener.call(window,evt,handler,capture);}};function createEvent(type,data){var event=document.createEvent('Events');event.initEvent(type,false,false);if(data){for(var i in data){if(data.hasOwnProperty(i)){event[i]=data[i];}}}
        return event;}
        var cordova={define:define,require:require,version:CORDOVA_JS_BUILD_LABEL,platformId:platform.id,addWindowEventHandler:function(event){return(windowEventHandlers[event]=channel.create(event));},addStickyDocumentEventHandler:function(event){return(documentEventHandlers[event]=channel.createSticky(event));},addDocumentEventHandler:function(event){return(documentEventHandlers[event]=channel.create(event));},removeWindowEventHandler:function(event){delete windowEventHandlers[event];},removeDocumentEventHandler:function(event){delete documentEventHandlers[event];},getOriginalHandlers:function(){return{'document':{'addEventListener':m_document_addEventListener,'removeEventListener':m_document_removeEventListener},'window':{'addEventListener':m_window_addEventListener,'removeEventListener':m_window_removeEventListener}};},fireDocumentEvent:function(type,data,bNoDetach){var evt=createEvent(type,data);if(typeof documentEventHandlers[type]!='undefined'){if(bNoDetach){documentEventHandlers[type].fire(evt);}else{setTimeout(function(){if(type=='deviceready'){document.dispatchEvent(evt);}
            documentEventHandlers[type].fire(evt);},0);}}else{document.dispatchEvent(evt);}},fireWindowEvent:function(type,data){var evt=createEvent(type,data);if(typeof windowEventHandlers[type]!='undefined'){setTimeout(function(){windowEventHandlers[type].fire(evt);},0);}else{window.dispatchEvent(evt);}},callbackId:Math.floor(Math.random()*2000000000),callbacks:{},callbackStatus:{NO_RESULT:0,OK:1,CLASS_NOT_FOUND_EXCEPTION:2,ILLEGAL_ACCESS_EXCEPTION:3,INSTANTIATION_EXCEPTION:4,MALFORMED_URL_EXCEPTION:5,IO_EXCEPTION:6,INVALID_ACTION:7,JSON_EXCEPTION:8,ERROR:9},callbackSuccess:function(callbackId,args){try{cordova.callbackFromNative(callbackId,true,args.status,[args.message],args.keepCallback);}catch(e){console.log("Error in error callback: "+callbackId
        +" = "+e);}},callbackError:function(callbackId,args){try{cordova.callbackFromNative(callbackId,false,args.status,[args.message],args.keepCallback);}catch(e){console.log("Error in error callback: "+callbackId
        +" = "+e);}},callbackFromNative:function(callbackId,success,status,args,keepCallback){var callback=cordova.callbacks[callbackId];if(callback){if(success&&status==cordova.callbackStatus.OK){callback.success&&callback.success.apply(null,args);}else if(!success){callback.fail&&callback.fail.apply(null,args);}
            if(!keepCallback){delete cordova.callbacks[callbackId];}}},addConstructor:function(func){channel.onCordovaReady.subscribe(function(){try{func();}catch(e){console.log("Failed to run constructor: "+e);}});}};module.exports=cordova;});define("cordova/argscheck",function(require,exports,module){var exec=require('cordova/exec');var utils=require('cordova/utils');var moduleExports=module.exports;var typeMap={'A':'Array','D':'Date','N':'Number','S':'String','F':'Function','O':'Object'};function extractParamName(callee,argIndex){return(/.*?\((.*?)\)/).exec(callee)[1].split(', ')[argIndex];}
        function checkArgs(spec,functionName,args,opt_callee){if(!moduleExports.enableChecks){return;}
            var errMsg=null;var typeName;for(var i=0;i<spec.length;++i){var c=spec.charAt(i),cUpper=c.toUpperCase(),arg=args[i];if(c=='*'){continue;}
                typeName=utils.typeName(arg);if((arg===null||arg===undefined)&&c==cUpper){continue;}
                if(typeName!=typeMap[cUpper]){errMsg='Expected '+typeMap[cUpper];break;}}
            if(errMsg){errMsg+=', but got '+typeName+'.';errMsg='Wrong type for parameter "'
            +extractParamName(opt_callee||args.callee,i)
            +'" of '+functionName+': '+errMsg;if(typeof jasmine=='undefined'){console.error(errMsg);}
                throw TypeError(errMsg);}}
        function getValue(value,defaultValue){return value===undefined?defaultValue:value;}
        moduleExports.checkArgs=checkArgs;moduleExports.getValue=getValue;moduleExports.enableChecks=true;});define("cordova/base64",function(require,exports,module){var base64=exports;base64.fromArrayBuffer=function(arrayBuffer){var array=new Uint8Array(arrayBuffer);return uint8ToBase64(array);};base64.toArrayBuffer=function(str){var decodedStr=typeof atob!='undefined'?atob(str):new Buffer(str,'base64').toString('binary');var arrayBuffer=new ArrayBuffer(decodedStr.length);var array=new Uint8Array(arrayBuffer);for(var i=0,len=decodedStr.length;i<len;i++){array[i]=decodedStr.charCodeAt(i);}
        return arrayBuffer;};var b64_6bit="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";var b64_12bit;var b64_12bitTable=function(){b64_12bit=[];for(var i=0;i<64;i++){for(var j=0;j<64;j++){b64_12bit[i*64+j]=b64_6bit[i]+b64_6bit[j];}}
        b64_12bitTable=function(){return b64_12bit;};return b64_12bit;};function uint8ToBase64(rawData){var numBytes=rawData.byteLength;var output="";var segment;var table=b64_12bitTable();for(var i=0;i<numBytes-2;i+=3){segment=(rawData[i]<<16)+(rawData[i+1]<<8)
    +rawData[i+2];output+=table[segment>>12];output+=table[segment&0xfff];}
        if(numBytes-i==2){segment=(rawData[i]<<16)+(rawData[i+1]<<8);output+=table[segment>>12];output+=b64_6bit[(segment&0xfff)>>6];output+='=';}else if(numBytes-i==1){segment=(rawData[i]<<16);output+=table[segment>>12];output+='==';}
        return output;}});define("cordova/builder",function(require,exports,module){var utils=require('cordova/utils');function each(objects,func,context){for(var prop in objects){if(objects.hasOwnProperty(prop)){func.apply(context,[objects[prop],prop]);}}}
        function clobber(obj,key,value){exports.replaceHookForTesting(obj,key);obj[key]=value;if(obj[key]!==value){utils.defineGetter(obj,key,function(){return value;});}}
        function assignOrWrapInDeprecateGetter(obj,key,value,message){if(message){utils.defineGetter(obj,key,function(){console.log(message);delete obj[key];clobber(obj,key,value);return value;});}else{clobber(obj,key,value);}}
        function include(parent,objects,clobber,merge){each(objects,function(obj,key){try{var result=obj.path?require(obj.path):{};if(clobber){if(typeof parent[key]==='undefined'){assignOrWrapInDeprecateGetter(parent,key,result,obj.deprecated);}else if(typeof obj.path!=='undefined'){if(merge){recursiveMerge(parent[key],result);}else{assignOrWrapInDeprecateGetter(parent,key,result,obj.deprecated);}}
            result=parent[key];}else{if(typeof parent[key]=='undefined'){assignOrWrapInDeprecateGetter(parent,key,result,obj.deprecated);}else{result=parent[key];}}
            if(obj.children){include(result,obj.children,clobber,merge);}}catch(e){utils.alert('Exception building Cordova JS globals: '+e
        +' for key "'+key+'"');}});}
        function recursiveMerge(target,src){for(var prop in src){if(src.hasOwnProperty(prop)){if(target.prototype&&target.prototype.constructor===target){clobber(target.prototype,prop,src[prop]);}else{if(typeof src[prop]==='object'&&typeof target[prop]==='object'){recursiveMerge(target[prop],src[prop]);}else{clobber(target,prop,src[prop]);}}}}}
        exports.buildIntoButDoNotClobber=function(objects,target){include(target,objects,false,false);};exports.buildIntoAndClobber=function(objects,target){include(target,objects,true,false);};exports.buildIntoAndMerge=function(objects,target){include(target,objects,true,true);};exports.recursiveMerge=recursiveMerge;exports.assignOrWrapInDeprecateGetter=assignOrWrapInDeprecateGetter;exports.replaceHookForTesting=function(){};});define("cordova/channel",function(require,exports,module){var utils=require('cordova/utils'),nextGuid=1;var Channel=function(type,sticky){this.type=type;this.handlers={};this.state=sticky?1:0;this.fireArgs=null;this.numHandlers=0;this.onHasSubscribersChange=null;},channel={join:function(h,c){var len=c.length,i=len,f=function(){if(!(--i))
        h();};for(var j=0;j<len;j++){if(c[j].state===0){throw Error('Can only use join with sticky channels.');}
        c[j].subscribe(f);}
        if(!len)
            h();},create:function(type){return channel[type]=new Channel(type,false);},createSticky:function(type){return channel[type]=new Channel(type,true);},deviceReadyChannelsArray:[],deviceReadyChannelsMap:{},waitForInitialization:function(feature){if(feature){var c=channel[feature]||this.createSticky(feature);this.deviceReadyChannelsMap[feature]=c;this.deviceReadyChannelsArray.push(c);}},initializationComplete:function(feature){var c=this.deviceReadyChannelsMap[feature];if(c){c.fire();}}};function forceFunction(f){if(typeof f!='function')
        throw"Function required as first argument!";}
        Channel.prototype.subscribe=function(f,c){forceFunction(f);if(this.state==2){f.apply(c||this,this.fireArgs);return;}
            var func=f,guid=f.observer_guid;if(typeof c=="object"){func=utils.close(c,f);}
            if(!guid){guid=''+nextGuid++;}
            func.observer_guid=guid;f.observer_guid=guid;if(!this.handlers[guid]){this.handlers[guid]=func;this.numHandlers++;if(this.numHandlers==1){this.onHasSubscribersChange&&this.onHasSubscribersChange();}}};Channel.prototype.unsubscribe=function(f){forceFunction(f);var guid=f.observer_guid,handler=this.handlers[guid];if(handler){delete this.handlers[guid];this.numHandlers--;if(this.numHandlers===0){this.onHasSubscribersChange&&this.onHasSubscribersChange();}}};Channel.prototype.fire=function(e){var fail=false,fireArgs=Array.prototype.slice.call(arguments);if(this.state==1){this.state=2;this.fireArgs=fireArgs;}
            if(this.numHandlers){var toCall=[];for(var item in this.handlers){toCall.push(this.handlers[item]);}
                for(var i=0;i<toCall.length;++i){toCall[i].apply(this,fireArgs);}
                if(this.state==2&&this.numHandlers){this.numHandlers=0;this.handlers={};this.onHasSubscribersChange&&this.onHasSubscribersChange();}}};channel.createSticky('onDOMContentLoaded');channel.createSticky('onNativeReady');channel.createSticky('onCordovaReady');channel.createSticky('onPluginsReady');channel.createSticky('onDeviceReady');channel.create('onResume');channel.create('onPause');channel.createSticky('onDestroy');channel.waitForInitialization('onCordovaReady');channel.waitForInitialization('onDOMContentLoaded');module.exports=channel;});define("cordova/exec",function(require,exports,module){var cordova=require('cordova'),channel=require('cordova/channel'),utils=require('cordova/utils'),base64=require('cordova/base64'),jsToNativeModes={IFRAME_NAV:0,XHR_NO_PAYLOAD:1,XHR_WITH_PAYLOAD:2,XHR_OPTIONAL_PAYLOAD:3,IFRAME_HASH_NO_PAYLOAD:4,IFRAME_HASH_WITH_PAYLOAD:5},bridgeMode,execIframe,execHashIframe,hashToggle=1,execXhr,requestCount=0,vcHeaderValue=null,commandQueue=[],isInContextOfEvalJs=0;function createExecIframe(){var iframe=document.createElement("iframe");iframe.style.display='none';document.body.appendChild(iframe);return iframe;}
        function createHashIframe(){var ret=createExecIframe();ret.contentWindow.history.replaceState(null,null,'file:///#');return ret;}
        function shouldBundleCommandJson(){if(bridgeMode===jsToNativeModes.XHR_WITH_PAYLOAD){return true;}
            if(bridgeMode===jsToNativeModes.XHR_OPTIONAL_PAYLOAD){var payloadLength=0;for(var i=0;i<commandQueue.length;++i){payloadLength+=commandQueue[i].length;}
                return payloadLength<4500;}
            return false;}
        function massageArgsJsToNative(args){if(!args||utils.typeName(args)!='Array'){return args;}
            var ret=[];args.forEach(function(arg,i){if(utils.typeName(arg)=='ArrayBuffer'){ret.push({'CDVType':'ArrayBuffer','data':base64.fromArrayBuffer(arg)});}else{ret.push(arg);}});return ret;}
        function massageMessageNativeToJs(message){if(message.CDVType=='ArrayBuffer'){var stringToArrayBuffer=function(str){var ret=new Uint8Array(str.length);for(var i=0;i<str.length;i++){ret[i]=str.charCodeAt(i);}
            return ret.buffer;};var base64ToArrayBuffer=function(b64){return stringToArrayBuffer(atob(b64));};message=base64ToArrayBuffer(message.data);}
            return message;}
        function convertMessageToArgsNativeToJs(message){var args=[];if(!message||!message.hasOwnProperty('CDVType')){args.push(message);}else if(message.CDVType=='MultiPart'){message.messages.forEach(function(e){args.push(massageMessageNativeToJs(e));});}else{args.push(massageMessageNativeToJs(message));}
            return args;}
        function iOSExec(){if(bridgeMode===undefined){bridgeMode=navigator.userAgent.indexOf(' 5_')==-1?jsToNativeModes.IFRAME_NAV:jsToNativeModes.XHR_NO_PAYLOAD;}
            var successCallback,failCallback,service,action,actionArgs,splitCommand;var callbackId=null;if(typeof arguments[0]!=="string"){successCallback=arguments[0];failCallback=arguments[1];service=arguments[2];action=arguments[3];actionArgs=arguments[4];callbackId='INVALID';}else{try{splitCommand=arguments[0].split(".");action=splitCommand.pop();service=splitCommand.join(".");actionArgs=Array.prototype.splice.call(arguments,1);console.log('The old format of this exec call has been removed (deprecated since 2.1). Change to: '
            +"cordova.exec(null, null, \""
            +service
            +"\", \""
            +action
            +"\","
            +JSON.stringify(actionArgs)+");");return;}catch(e){}}
            actionArgs=actionArgs||[];if(successCallback||failCallback){callbackId=service+cordova.callbackId++;cordova.callbacks[callbackId]={success:successCallback,fail:failCallback};}
            actionArgs=massageArgsJsToNative(actionArgs);var command=[callbackId,service,action,actionArgs];commandQueue.push(JSON.stringify(command));if(!isInContextOfEvalJs&&commandQueue.length==1){switch(bridgeMode){case jsToNativeModes.XHR_NO_PAYLOAD:case jsToNativeModes.XHR_WITH_PAYLOAD:case jsToNativeModes.XHR_OPTIONAL_PAYLOAD:pokeNativeViaXhr();break;default:pokeNativeViaIframe();}}}
        function pokeNativeViaXhr(){if(execXhr&&execXhr.readyState!=4){execXhr=null;}
            execXhr=execXhr||new XMLHttpRequest();execXhr.open('HEAD',"/!gap_exec?"+(+new Date()),true);if(!vcHeaderValue){vcHeaderValue=/.*\((.*)\)/.exec(navigator.userAgent)[1];}
            execXhr.setRequestHeader('vc',vcHeaderValue);execXhr.setRequestHeader('rc',++requestCount);if(shouldBundleCommandJson()){execXhr.setRequestHeader('cmds',iOSExec.nativeFetchMessages());}
            execXhr.send(null);}
        function pokeNativeViaIframe(){if(!document.body){setTimeout(pokeNativeViaIframe);return;}
            if(bridgeMode===jsToNativeModes.IFRAME_HASH_NO_PAYLOAD||bridgeMode===jsToNativeModes.IFRAME_HASH_WITH_PAYLOAD){execHashIframe=execHashIframe||createHashIframe();if(!execHashIframe.contentWindow){execHashIframe=createHashIframe();}
                hashToggle=hashToggle^3;var hashValue='%0'+hashToggle;if(bridgeMode===jsToNativeModes.IFRAME_HASH_WITH_PAYLOAD){hashValue+=iOSExec.nativeFetchMessages();}
                execHashIframe.contentWindow.location.hash=hashValue;}else{execIframe=execIframe||createExecIframe();if(!execIframe.contentWindow){execIframe=createExecIframe();}
                execIframe.src="gap://ready";}}
        iOSExec.jsToNativeModes=jsToNativeModes;iOSExec.setJsToNativeBridgeMode=function(mode){if(execIframe){execIframe.parentNode.removeChild(execIframe);execIframe=null;}
            bridgeMode=mode;};iOSExec.nativeFetchMessages=function(){if(!commandQueue.length){return'';}
            var json='['+commandQueue.join(',')+']';commandQueue.length=0;return json;};iOSExec.nativeCallback=function(callbackId,status,message,keepCallback){return iOSExec.nativeEvalAndFetch(function(){var success=status===0||status===1;var args=convertMessageToArgsNativeToJs(message);cordova.callbackFromNative(callbackId,success,status,args,keepCallback);});};iOSExec.nativeEvalAndFetch=function(func){isInContextOfEvalJs++;try{func();return iOSExec.nativeFetchMessages();}
        finally{isInContextOfEvalJs--;}};module.exports=iOSExec;});define("cordova/exec/proxy",function(require,exports,module){var CommandProxyMap={};module.exports={add:function(id,proxyObj){console.log("adding proxy for "+id);CommandProxyMap[id]=proxyObj;return proxyObj;},remove:function(id){var proxy=CommandProxyMap[id];delete CommandProxyMap[id];CommandProxyMap[id]=null;return proxy;},get:function(service,action){return(CommandProxyMap[service]?CommandProxyMap[service][action]:null);}};});define("cordova/init",function(require,exports,module){var channel=require('cordova/channel');var cordova=require('cordova');var modulemapper=require('cordova/modulemapper');var platform=require('cordova/platform');var pluginloader=require('cordova/pluginloader');var platformInitChannelsArray=[channel.onNativeReady,channel.onPluginsReady];function logUnfiredChannels(arr){for(var i=0;i<arr.length;++i){if(arr[i].state!=2){console.log('Channel not fired: '+arr[i].type);}}}
        window.setTimeout(function(){if(channel.onDeviceReady.state!=2){console.log('deviceready has not fired after 5 seconds.');logUnfiredChannels(platformInitChannelsArray);logUnfiredChannels(channel.deviceReadyChannelsArray);}},5000);function replaceNavigator(origNavigator){var CordovaNavigator=function(){};CordovaNavigator.prototype=origNavigator;var newNavigator=new CordovaNavigator();if(CordovaNavigator.bind){for(var key in origNavigator){if(typeof origNavigator[key]=='function'){newNavigator[key]=origNavigator[key].bind(origNavigator);}}}
            return newNavigator;}
        if(window.navigator){window.navigator=replaceNavigator(window.navigator);}
        if(!window.console){window.console={log:function(){}};}
        if(!window.console.warn){window.console.warn=function(msg){this.log("warn: "+msg);};}
        channel.onPause=cordova.addDocumentEventHandler('pause');channel.onResume=cordova.addDocumentEventHandler('resume');channel.onDeviceReady=cordova.addStickyDocumentEventHandler('deviceready');if(document.readyState=='complete'||document.readyState=='interactive'){channel.onDOMContentLoaded.fire();}else{document.addEventListener('DOMContentLoaded',function(){channel.onDOMContentLoaded.fire();},false);}
        if(window._nativeReady){channel.onNativeReady.fire();}
        modulemapper.clobbers('cordova','cordova');modulemapper.clobbers('cordova/exec','cordova.exec');modulemapper.clobbers('cordova/exec','Cordova.exec');platform.bootstrap&&platform.bootstrap();setTimeout(function(){pluginloader.load(function(){channel.onPluginsReady.fire();});},0);channel.join(function(){modulemapper.mapModules(window);platform.initialize&&platform.initialize();channel.onCordovaReady.fire();channel.join(function(){require('cordova').fireDocumentEvent('deviceready');},channel.deviceReadyChannelsArray);},platformInitChannelsArray);});define("cordova/init_b",function(require,exports,module){var channel=require('cordova/channel');var cordova=require('cordova');var platform=require('cordova/platform');var platformInitChannelsArray=[channel.onDOMContentLoaded,channel.onNativeReady];cordova.exec=require('cordova/exec');function logUnfiredChannels(arr){for(var i=0;i<arr.length;++i){if(arr[i].state!=2){console.log('Channel not fired: '+arr[i].type);}}}
        window.setTimeout(function(){if(channel.onDeviceReady.state!=2){console.log('deviceready has not fired after 5 seconds.');logUnfiredChannels(platformInitChannelsArray);logUnfiredChannels(channel.deviceReadyChannelsArray);}},5000);function replaceNavigator(origNavigator){var CordovaNavigator=function(){};CordovaNavigator.prototype=origNavigator;var newNavigator=new CordovaNavigator();if(CordovaNavigator.bind){for(var key in origNavigator){if(typeof origNavigator[key]=='function'){newNavigator[key]=origNavigator[key].bind(origNavigator);}}}
            return newNavigator;}
        if(window.navigator){window.navigator=replaceNavigator(window.navigator);}
        if(!window.console){window.console={log:function(){}};}
        if(!window.console.warn){window.console.warn=function(msg){this.log("warn: "+msg);};}
        channel.onPause=cordova.addDocumentEventHandler('pause');channel.onResume=cordova.addDocumentEventHandler('resume');channel.onDeviceReady=cordova.addStickyDocumentEventHandler('deviceready');if(document.readyState=='complete'||document.readyState=='interactive'){channel.onDOMContentLoaded.fire();}else{document.addEventListener('DOMContentLoaded',function(){channel.onDOMContentLoaded.fire();},false);}
        if(window._nativeReady){channel.onNativeReady.fire();}
        platform.bootstrap&&platform.bootstrap();channel.join(function(){platform.initialize&&platform.initialize();channel.onCordovaReady.fire();channel.join(function(){require('cordova').fireDocumentEvent('deviceready');},channel.deviceReadyChannelsArray);},platformInitChannelsArray);});define("cordova/modulemapper",function(require,exports,module){var builder=require('cordova/builder'),moduleMap=define.moduleMap,symbolList,deprecationMap;exports.reset=function(){symbolList=[];deprecationMap={};};function addEntry(strategy,moduleName,symbolPath,opt_deprecationMessage){if(!(moduleName in moduleMap)){throw new Error('Module '+moduleName
    +' does not exist.');}
        symbolList.push(strategy,moduleName,symbolPath);if(opt_deprecationMessage){deprecationMap[symbolPath]=opt_deprecationMessage;}}
        exports.clobbers=function(moduleName,symbolPath,opt_deprecationMessage){addEntry('c',moduleName,symbolPath,opt_deprecationMessage);};exports.merges=function(moduleName,symbolPath,opt_deprecationMessage){addEntry('m',moduleName,symbolPath,opt_deprecationMessage);};exports.defaults=function(moduleName,symbolPath,opt_deprecationMessage){addEntry('d',moduleName,symbolPath,opt_deprecationMessage);};exports.runs=function(moduleName){addEntry('r',moduleName,null);};function prepareNamespace(symbolPath,context){if(!symbolPath){return context;}
            var parts=symbolPath.split('.');var cur=context;for(var i=0,part;part=parts[i];++i){cur=cur[part]=cur[part]||{};}
            return cur;}
        exports.mapModules=function(context){var origSymbols={};context.CDV_origSymbols=origSymbols;for(var i=0,len=symbolList.length;i<len;i+=3){var strategy=symbolList[i];var moduleName=symbolList[i+1];var module=require(moduleName);if(strategy=='r'){continue;}
            var symbolPath=symbolList[i+2];var lastDot=symbolPath.lastIndexOf('.');var namespace=symbolPath.substr(0,lastDot);var lastName=symbolPath.substr(lastDot+1);var deprecationMsg=symbolPath in deprecationMap?'Access made to deprecated symbol: '
            +symbolPath+'. '+deprecationMsg:null;var parentObj=prepareNamespace(namespace,context);var target=parentObj[lastName];if(strategy=='m'&&target){builder.recursiveMerge(target,module);}else if((strategy=='d'&&!target)||(strategy!='d')){if(!(symbolPath in origSymbols)){origSymbols[symbolPath]=target;}
                builder.assignOrWrapInDeprecateGetter(parentObj,lastName,module,deprecationMsg);}}};exports.getOriginalSymbol=function(context,symbolPath){var origSymbols=context.CDV_origSymbols;if(origSymbols&&(symbolPath in origSymbols)){return origSymbols[symbolPath];}
            var parts=symbolPath.split('.');var obj=context;for(var i=0;i<parts.length;++i){obj=obj&&obj[parts[i]];}
            return obj;};exports.reset();});define("cordova/platform",function(require,exports,module){module.exports={id:'ios',bootstrap:function(){require('cordova/channel').onNativeReady.fire();}};});define("cordova/pluginloader",function(require,exports,module){var modulemapper=require('cordova/modulemapper');var urlutil=require('cordova/urlutil');exports.injectScript=function(url,onload,onerror){var script=document.createElement("script");script.onload=onload;script.onerror=onerror;script.src=url;document.head.appendChild(script);};function injectIfNecessary(id,url,onload,onerror){onerror=onerror||onload;if(id in define.moduleMap){onload();}else{exports.injectScript(url,function(){if(id in define.moduleMap){onload();}else{onerror();}},onerror);}}
        function onScriptLoadingComplete(moduleList,finishPluginLoading){for(var i=0,module;module=moduleList[i];i++){if(module.clobbers&&module.clobbers.length){for(var j=0;j<module.clobbers.length;j++){modulemapper.clobbers(module.id,module.clobbers[j]);}}
            if(module.merges&&module.merges.length){for(var k=0;k<module.merges.length;k++){modulemapper.merges(module.id,module.merges[k]);}}
            if(module.runs){modulemapper.runs(module.id);}}
            finishPluginLoading();}
        function handlePluginsObject(path,moduleList,finishPluginLoading){var scriptCounter=moduleList.length;if(!scriptCounter){finishPluginLoading();return;}
            function scriptLoadedCallback(){if(!--scriptCounter){onScriptLoadingComplete(moduleList,finishPluginLoading);}}
            for(var i=0;i<moduleList.length;i++){injectIfNecessary(moduleList[i].id,path
            +moduleList[i].file,scriptLoadedCallback);}}
        function findCordovaPath(){return "../js/global/"}
        exports.load=function(callback){var pathPrefix=findCordovaPath();if(pathPrefix===null){console.log('Could not find cordova.js script tag. Plugin loading may fail.');pathPrefix='';}
            injectIfNecessary('cordova/plugin_list',pathPrefix
            +'cordova_plugins.js',function(){var moduleList=require("cordova/plugin_list");handlePluginsObject(pathPrefix,moduleList,callback);},callback);};});define("cordova/urlutil",function(require,exports,module){exports.makeAbsolute=function makeAbsolute(url){var anchorEl=document.createElement('a');anchorEl.href=url;return anchorEl.href;};});define("cordova/utils",function(require,exports,module){var utils=exports;utils.defineGetterSetter=function(obj,key,getFunc,opt_setFunc){if(Object.defineProperty){var desc={get:getFunc,configurable:true};if(opt_setFunc){desc.set=opt_setFunc;}
        Object.defineProperty(obj,key,desc);}else{obj.__defineGetter__(key,getFunc);if(opt_setFunc){obj.__defineSetter__(key,opt_setFunc);}}};utils.defineGetter=utils.defineGetterSetter;utils.arrayIndexOf=function(a,item){if(a.indexOf){return a.indexOf(item);}
        var len=a.length;for(var i=0;i<len;++i){if(a[i]==item){return i;}}
        return-1;};utils.arrayRemove=function(a,item){var index=utils.arrayIndexOf(a,item);if(index!=-1){a.splice(index,1);}
        return index!=-1;};utils.typeName=function(val){return Object.prototype.toString.call(val).slice(8,-1);};utils.isArray=function(a){return utils.typeName(a)=='Array';};utils.isDate=function(d){return utils.typeName(d)=='Date';};utils.clone=function(obj){if(!obj||typeof obj=='function'||utils.isDate(obj)||typeof obj!='object'){return obj;}
        var retVal,i;if(utils.isArray(obj)){retVal=[];for(i=0;i<obj.length;++i){retVal.push(utils.clone(obj[i]));}
            return retVal;}
        retVal={};for(i in obj){if(!(i in retVal)||retVal[i]!=obj[i]){retVal[i]=utils.clone(obj[i]);}}
        return retVal;};utils.close=function(context,func,params){if(typeof params=='undefined'){return function(){return func.apply(context,arguments);};}else{return function(){return func.apply(context,params);};}};utils.createUUID=function(){return UUIDcreatePart(4)+'-'+UUIDcreatePart(2)+'-'
        +UUIDcreatePart(2)+'-'+UUIDcreatePart(2)+'-'
        +UUIDcreatePart(6);};utils.extend=(function(){var F=function(){};return function(Child,Parent){F.prototype=Parent.prototype;Child.prototype=new F();Child.__super__=Parent.prototype;Child.prototype.constructor=Child;};}
    ());utils.alert=function(msg){if(window.alert){window.alert(msg);}else if(console&&console.log){console.log(msg);}};function UUIDcreatePart(length){var uuidpart="";for(var i=0;i<length;i++){var uuidchar=parseInt((Math.random()*256),10).toString(16);if(uuidchar.length==1){uuidchar="0"+uuidchar;}
        uuidpart+=uuidchar;}
        return uuidpart;}});window.cordova=require('cordova');require('cordova/init');})();var hybrid={initialize:function(){this.bindEvents();cordova.callbacks["Hybrid$EVENT$CALLBACK"]={success:function(args){if(args&&args.triggered===true){var name=args.name;var eventName=args.eventName;var fn=undefined;try{fn=eval(name+"_"+eventName);}catch(e){return;}
    if(typeof fn==="function"){fn.apply(this,arguments);}}}};},hybridExec:function(section,fun,params){Cordova.exec(null,null,"BridgeInterface","bridge",[section,fun,params]);},bindEvents:function(){document.addEventListener('deviceready',this.onDeviceReady,false);},onDeviceReady:function(){hybrid.receivedEvent('deviceready');},receivedEvent:function(id){var parentElement=document.getElementById(id);var listeningElement=parentElement.querySelector('.listening');var receivedElement=parentElement.querySelector('.received');listeningElement.setAttribute('style','display:none;');receivedElement.setAttribute('style','display:block;');console.log('Received Event: '+id);},top:{setTitle:function(param){hybrid.hybridExec("Hybrid.ui","top.settitle",param);},hide:function(){hybrid.hybridExec("Hybrid.ui","top.hide");},show:function(){hybrid.hybridExec("Hybrid.ui","top.show");}},hsopenpage:function(pageName,parames){Cordova.exec("BridgeInterface.bridge","openPage",pageName,parames);},hsopg:function(pageName,params){this.openPage(pageName,parames);},ui:{top:{setTitle:function(param,success_cb,fail_cb){Cordova.exec(success_cb,fail_cb,"com.hs.native.ui.top","setTitle",[param]);},hide:function(){hybrid.hybridExec("Hybrid.ui","top.hide");},show:function(){hybrid.hybridExec("Hybrid.ui","top.show");}},bottom:{switchToTabIndex:function(param){hybrid.hybridExec("Hybrid.ui","bottom.switchtotabindex",param);},setBadgeValue:function(badgeValue,menuIndex,success_cb,fail_cb){Cordova.exec(success_cb,fail_cb,"com.hs.native.ui","setBadgeValue",[badgeValue,menuIndex]);},}},core:{back:function(param){hybrid.hybridExec("Hybrid.core","core.back",param);},removePage:function(param){hybrid.hybridExec("Hybrid.core","core.removepage",param);},reloadStartPage:function(param,success_cb,fail_cb){Cordova.exec(success_cb,fail_cb,"com.hs.native.page","reloadStartPage",param);},getEncryptValue:function(paramKey,encryptKey,success_cb,fail_cb){Cordova.exec(success_cb,fail_cb,"com.hs.native.core","decryptValue",[paramKey,encryptKey]);},saveEncryptValue:function(paramKey,paramValue,encryptKey,success_cb,fail_cb){Cordova.exec(success_cb,fail_cb,"com.hs.native.core","encryptValue",[paramKey,paramValue,encryptKey]);},execMethod:function(methodName,param,callback){var params={"methodname":methodName};if(param!=undefined){params['param']=param;}
    if(callback!=undefined){Cordova.exec(callback,null,"com.hs.native.core","execmethod",[params]);}else{hybrid.hybridExec("Hybrid.core","core.execmethod",params);}},openPage:function(pageName,parames){Cordova.exec(null,null,"BridgeInterface","bridge",["openPage",pageName,parames]);},writeDataset:function(param){if(window.hybridConfig==undefined){window.hybridConfig={};}
    if(window.hybridConfig[param['set']]==undefined){window.hybridConfig[param['set']]={};}
    window.hybridConfig[param['set']][param['key']]=param['value'];hybrid.hybridExec("Hybrid.core","core.writedataset",param);},readDataset:function(param){if(window.hybridConfig==undefined){window.hybridConfig={};}
    return window.hybridConfig[param['set']][param['key']];},writeConfigData:function(param){if(window.hybridConfig==undefined){window.hybridConfig={};}
    if(window.hybridConfig['config']==undefined){window.hybridConfig['config']={};}
    window.hybridConfig['config'][param['key']]=param['value'];hybrid.hybridExec("Hybrid.core","core.writeconfigdata",param);},readConfigData:function(param){if(window.hybridConfig==undefined){window.hybridConfig={};}
    if(window.hybridConfig['config']==undefined){window.hybridConfig['config']={};}
    return window.hybridConfig['config'][param['key']];},switchToSkin:function(param){hybrid.hybridExec("Hybrid.core","core.switchToSkin",param);},changeTheme:function(param){hybrid.hybridExec("Hybrid.core","core.switchToSkin",param);},currentSkin:function(){return window.hybridConfig['skin']['currentSkin'];},getCurrentTheme:function(){return window.hybridConfig['skin']['currentSkin'];},skinList:function(){return window.hybridConfig['skin']['skinList'];},addHybridEventListener:function(eventName,listener){document.addEventListener(eventName,listener,false);},removeHybridEventListener:function(eventName,listener){document.removeEventListener(eventName,listener,false);},sendHybridBroadcast:function(eventName,param){var params={"eventName":eventName};if(param!=undefined){params['param']=param;}
    hybrid.hybridExec("Hybrid.core","core.sendNativeBroadcast",params);},addHybridBroadcastListener:function(eventName,listener){document.addEventListener(eventName,listener,false);},removeHybridBroadcastListener:function(eventName,listener){document.removeEventListener(eventName,listener,false);},}};


